
        mod __gl_imports {
            pub extern crate libc;
            pub use std::mem;
            pub use std::ptr;
            pub use std::os::raw;
            pub use std::process::exit;
        }
    

        fn metaloadfn<F>(mut loadfn: F,
                         symbol: &str,
                         fallbacks: &[&str]) -> *const *const __gl_imports::raw::c_void
                         where F: FnMut(&str) -> *const __gl_imports::raw::c_void {
            let mut ptr = loadfn(symbol);
            if ptr.is_null() {
                for &sym in fallbacks.iter() {
                    ptr = loadfn(sym);
                    if !ptr.is_null() { break; }
                }
            }
            ptr as *const *const __gl_imports::raw::c_void
        }
    

        pub mod types {
            #![allow(non_camel_case_types, non_snake_case, dead_code, missing_copy_implementations)]
    
// Common types from OpenGL 1.1
pub type GLenum = super::__gl_imports::raw::c_uint;
pub type GLboolean = super::__gl_imports::raw::c_uchar;
pub type GLbitfield = super::__gl_imports::raw::c_uint;
pub type GLvoid = super::__gl_imports::raw::c_void;
pub type GLbyte = super::__gl_imports::raw::c_char;
pub type GLshort = super::__gl_imports::raw::c_short;
pub type GLint = super::__gl_imports::raw::c_int;
pub type GLclampx = super::__gl_imports::raw::c_int;
pub type GLubyte = super::__gl_imports::raw::c_uchar;
pub type GLushort = super::__gl_imports::raw::c_ushort;
pub type GLuint = super::__gl_imports::raw::c_uint;
pub type GLsizei = super::__gl_imports::raw::c_int;
pub type GLfloat = super::__gl_imports::raw::c_float;
pub type GLclampf = super::__gl_imports::raw::c_float;
pub type GLdouble = super::__gl_imports::raw::c_double;
pub type GLclampd = super::__gl_imports::raw::c_double;
pub type GLeglImageOES = *const super::__gl_imports::raw::c_void;
pub type GLchar = super::__gl_imports::raw::c_char;
pub type GLcharARB = super::__gl_imports::raw::c_char;

#[cfg(target_os = "macos")]
pub type GLhandleARB = *const super::__gl_imports::raw::c_void;
#[cfg(not(target_os = "macos"))]
pub type GLhandleARB = super::__gl_imports::raw::c_uint;

pub type GLhalfARB = super::__gl_imports::raw::c_ushort;
pub type GLhalf = super::__gl_imports::raw::c_ushort;

// Must be 32 bits
pub type GLfixed = GLint;

pub type GLintptr = isize;
pub type GLsizeiptr = isize;
pub type GLint64 = i64;
pub type GLuint64 = u64;
pub type GLintptrARB = isize;
pub type GLsizeiptrARB = isize;
pub type GLint64EXT = i64;
pub type GLuint64EXT = u64;

pub enum __GLsync {}
pub type GLsync = *const __GLsync;

// compatible with OpenCL cl_context
pub enum _cl_context {}
pub enum _cl_event {}

pub type GLDEBUGPROC = extern "system" fn(source: GLenum,
                                          gltype: GLenum,
                                          id: GLuint,
                                          severity: GLenum,
                                          length: GLsizei,
                                          message: *const GLchar,
                                          userParam: *mut super::__gl_imports::raw::c_void);
pub type GLDEBUGPROCARB = extern "system" fn(source: GLenum,
                                             gltype: GLenum,
                                             id: GLuint,
                                             severity: GLenum,
                                             length: GLsizei,
                                             message: *const GLchar,
                                             userParam: *mut super::__gl_imports::raw::c_void);
pub type GLDEBUGPROCKHR = extern "system" fn(source: GLenum,
                                             gltype: GLenum,
                                             id: GLuint,
                                             severity: GLenum,
                                             length: GLsizei,
                                             message: *const GLchar,
                                             userParam: *mut super::__gl_imports::raw::c_void);

// GLES 1 types
// "pub type GLclampx = i32;",

// GLES 1/2 types (tagged for GLES 1)
// "pub type GLbyte = i8;",
// "pub type GLubyte = u8;",
// "pub type GLfloat = GLfloat;",
// "pub type GLclampf = GLfloat;",
// "pub type GLfixed = i32;",
// "pub type GLint64 = i64;",
// "pub type GLuint64 = u64;",
// "pub type GLintptr = intptr_t;",
// "pub type GLsizeiptr = ssize_t;",

// GLES 1/2 types (tagged for GLES 2 - attribute syntax is limited)
// "pub type GLbyte = i8;",
// "pub type GLubyte = u8;",
// "pub type GLfloat = GLfloat;",
// "pub type GLclampf = GLfloat;",
// "pub type GLfixed = i32;",
// "pub type GLint64 = i64;",
// "pub type GLuint64 = u64;",
// "pub type GLint64EXT = i64;",
// "pub type GLuint64EXT = u64;",
// "pub type GLintptr = intptr_t;",
// "pub type GLsizeiptr = ssize_t;",

// GLES 2 types (none currently)

// Vendor extension types
pub type GLDEBUGPROCAMD = extern "system" fn(id: GLuint,
                                             category: GLenum,
                                             severity: GLenum,
                                             length: GLsizei,
                                             message: *const GLchar,
                                             userParam: *mut super::__gl_imports::raw::c_void);
pub type GLhalfNV = super::__gl_imports::raw::c_ushort;
pub type GLvdpauSurfaceNV = GLintptr;


        }
    
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM: types::GLenum = 0x0100;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_ALPHA_BITS: types::GLenum = 0x0D5B;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_BLUE_BITS: types::GLenum = 0x0D5A;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_BUFFER_BIT: types::GLenum = 0x00000200;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_CLEAR_VALUE: types::GLenum = 0x0B80;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_GREEN_BITS: types::GLenum = 0x0D59;
#[allow(dead_code, non_upper_case_globals)] pub const ACCUM_RED_BITS: types::GLenum = 0x0D58;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92D9;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_ATTRIBUTES: types::GLenum = 0x8B89;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_ATTRIBUTE_MAX_LENGTH: types::GLenum = 0x8B8A;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_PROGRAM: types::GLenum = 0x8259;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_RESOURCES: types::GLenum = 0x92F5;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_SUBROUTINES: types::GLenum = 0x8DE5;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_SUBROUTINE_MAX_LENGTH: types::GLenum = 0x8E48;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_SUBROUTINE_UNIFORMS: types::GLenum = 0x8DE6;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS: types::GLenum = 0x8E47;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH: types::GLenum = 0x8E49;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_TEXTURE: types::GLenum = 0x84E0;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_UNIFORMS: types::GLenum = 0x8B86;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_UNIFORM_BLOCKS: types::GLenum = 0x8A36;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH: types::GLenum = 0x8A35;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_UNIFORM_MAX_LENGTH: types::GLenum = 0x8B87;
#[allow(dead_code, non_upper_case_globals)] pub const ACTIVE_VARIABLES: types::GLenum = 0x9305;
#[allow(dead_code, non_upper_case_globals)] pub const ADD: types::GLenum = 0x0104;
#[allow(dead_code, non_upper_case_globals)] pub const ADD_SIGNED: types::GLenum = 0x8574;
#[allow(dead_code, non_upper_case_globals)] pub const ALIASED_LINE_WIDTH_RANGE: types::GLenum = 0x846E;
#[allow(dead_code, non_upper_case_globals)] pub const ALIASED_POINT_SIZE_RANGE: types::GLenum = 0x846D;
#[allow(dead_code, non_upper_case_globals)] pub const ALL_ATTRIB_BITS: types::GLenum = 0xFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const ALL_BARRIER_BITS: types::GLenum = 0xFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const ALL_SHADER_BITS: types::GLenum = 0xFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA: types::GLenum = 0x1906;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA12: types::GLenum = 0x803D;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA16: types::GLenum = 0x803E;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA16F_ARB: types::GLenum = 0x881C;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA16I_EXT: types::GLenum = 0x8D8A;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA16UI_EXT: types::GLenum = 0x8D78;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA32F_ARB: types::GLenum = 0x8816;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA32I_EXT: types::GLenum = 0x8D84;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA32UI_EXT: types::GLenum = 0x8D72;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA4: types::GLenum = 0x803B;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA8: types::GLenum = 0x803C;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA8I_EXT: types::GLenum = 0x8D90;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA8UI_EXT: types::GLenum = 0x8D7E;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_BIAS: types::GLenum = 0x0D1D;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_BITS: types::GLenum = 0x0D55;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_INTEGER: types::GLenum = 0x8D97;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_INTEGER_EXT: types::GLenum = 0x8D97;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_SCALE: types::GLenum = 0x0D1C;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_TEST: types::GLenum = 0x0BC0;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_TEST_FUNC: types::GLenum = 0x0BC1;
#[allow(dead_code, non_upper_case_globals)] pub const ALPHA_TEST_REF: types::GLenum = 0x0BC2;
#[allow(dead_code, non_upper_case_globals)] pub const ALREADY_SIGNALED: types::GLenum = 0x911A;
#[allow(dead_code, non_upper_case_globals)] pub const ALREADY_SIGNALED_APPLE: types::GLenum = 0x911A;
#[allow(dead_code, non_upper_case_globals)] pub const ALWAYS: types::GLenum = 0x0207;
#[allow(dead_code, non_upper_case_globals)] pub const AMBIENT: types::GLenum = 0x1200;
#[allow(dead_code, non_upper_case_globals)] pub const AMBIENT_AND_DIFFUSE: types::GLenum = 0x1602;
#[allow(dead_code, non_upper_case_globals)] pub const AND: types::GLenum = 0x1501;
#[allow(dead_code, non_upper_case_globals)] pub const AND_INVERTED: types::GLenum = 0x1504;
#[allow(dead_code, non_upper_case_globals)] pub const AND_REVERSE: types::GLenum = 0x1502;
#[allow(dead_code, non_upper_case_globals)] pub const ANY_SAMPLES_PASSED: types::GLenum = 0x8C2F;
#[allow(dead_code, non_upper_case_globals)] pub const ANY_SAMPLES_PASSED_CONSERVATIVE: types::GLenum = 0x8D6A;
#[allow(dead_code, non_upper_case_globals)] pub const ANY_SAMPLES_PASSED_CONSERVATIVE_EXT: types::GLenum = 0x8D6A;
#[allow(dead_code, non_upper_case_globals)] pub const ANY_SAMPLES_PASSED_EXT: types::GLenum = 0x8C2F;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_BUFFER: types::GLenum = 0x8892;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_BUFFER_ARB: types::GLenum = 0x8892;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_BUFFER_BINDING: types::GLenum = 0x8894;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8894;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_SIZE: types::GLenum = 0x92FB;
#[allow(dead_code, non_upper_case_globals)] pub const ARRAY_STRIDE: types::GLenum = 0x92FE;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BARRIER_BIT: types::GLenum = 0x00001000;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER: types::GLenum = 0x92C0;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS: types::GLenum = 0x92C5;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES: types::GLenum = 0x92C6;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_BINDING: types::GLenum = 0x92C1;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_DATA_SIZE: types::GLenum = 0x92C4;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_INDEX: types::GLenum = 0x9301;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER: types::GLenum = 0x90ED;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER: types::GLenum = 0x92CB;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER: types::GLenum = 0x92CA;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER: types::GLenum = 0x92C8;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER: types::GLenum = 0x92C9;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER: types::GLenum = 0x92C7;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_SIZE: types::GLenum = 0x92C3;
#[allow(dead_code, non_upper_case_globals)] pub const ATOMIC_COUNTER_BUFFER_START: types::GLenum = 0x92C2;
#[allow(dead_code, non_upper_case_globals)] pub const ATTACHED_SHADERS: types::GLenum = 0x8B85;
#[allow(dead_code, non_upper_case_globals)] pub const ATTRIB_STACK_DEPTH: types::GLenum = 0x0BB0;
#[allow(dead_code, non_upper_case_globals)] pub const AUTO_GENERATE_MIPMAP: types::GLenum = 0x8295;
#[allow(dead_code, non_upper_case_globals)] pub const AUTO_NORMAL: types::GLenum = 0x0D80;
#[allow(dead_code, non_upper_case_globals)] pub const AUX0: types::GLenum = 0x0409;
#[allow(dead_code, non_upper_case_globals)] pub const AUX1: types::GLenum = 0x040A;
#[allow(dead_code, non_upper_case_globals)] pub const AUX2: types::GLenum = 0x040B;
#[allow(dead_code, non_upper_case_globals)] pub const AUX3: types::GLenum = 0x040C;
#[allow(dead_code, non_upper_case_globals)] pub const AUX_BUFFERS: types::GLenum = 0x0C00;
#[allow(dead_code, non_upper_case_globals)] pub const BACK: types::GLenum = 0x0405;
#[allow(dead_code, non_upper_case_globals)] pub const BACK_LEFT: types::GLenum = 0x0402;
#[allow(dead_code, non_upper_case_globals)] pub const BACK_RIGHT: types::GLenum = 0x0403;
#[allow(dead_code, non_upper_case_globals)] pub const BGR: types::GLenum = 0x80E0;
#[allow(dead_code, non_upper_case_globals)] pub const BGRA: types::GLenum = 0x80E1;
#[allow(dead_code, non_upper_case_globals)] pub const BGRA_INTEGER: types::GLenum = 0x8D9B;
#[allow(dead_code, non_upper_case_globals)] pub const BGRA_INTEGER_EXT: types::GLenum = 0x8D9B;
#[allow(dead_code, non_upper_case_globals)] pub const BGR_INTEGER: types::GLenum = 0x8D9A;
#[allow(dead_code, non_upper_case_globals)] pub const BGR_INTEGER_EXT: types::GLenum = 0x8D9A;
#[allow(dead_code, non_upper_case_globals)] pub const BITMAP: types::GLenum = 0x1A00;
#[allow(dead_code, non_upper_case_globals)] pub const BITMAP_TOKEN: types::GLenum = 0x0704;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND: types::GLenum = 0x0BE2;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_COLOR: types::GLenum = 0x8005;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_DST: types::GLenum = 0x0BE0;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_DST_ALPHA: types::GLenum = 0x80CA;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_DST_RGB: types::GLenum = 0x80C8;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_EQUATION: types::GLenum = 0x8009;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_EQUATION_ALPHA: types::GLenum = 0x883D;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_EQUATION_RGB: types::GLenum = 0x8009;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_SRC: types::GLenum = 0x0BE1;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_SRC_ALPHA: types::GLenum = 0x80CB;
#[allow(dead_code, non_upper_case_globals)] pub const BLEND_SRC_RGB: types::GLenum = 0x80C9;
#[allow(dead_code, non_upper_case_globals)] pub const BLOCK_INDEX: types::GLenum = 0x92FD;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE: types::GLenum = 0x1905;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE_BIAS: types::GLenum = 0x0D1B;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE_BITS: types::GLenum = 0x0D54;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE_INTEGER: types::GLenum = 0x8D96;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE_INTEGER_EXT: types::GLenum = 0x8D96;
#[allow(dead_code, non_upper_case_globals)] pub const BLUE_SCALE: types::GLenum = 0x0D1A;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL: types::GLenum = 0x8B56;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_ARB: types::GLenum = 0x8B56;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC2: types::GLenum = 0x8B57;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC2_ARB: types::GLenum = 0x8B57;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC3: types::GLenum = 0x8B58;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC3_ARB: types::GLenum = 0x8B58;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC4: types::GLenum = 0x8B59;
#[allow(dead_code, non_upper_case_globals)] pub const BOOL_VEC4_ARB: types::GLenum = 0x8B59;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER: types::GLenum = 0x82E0;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_ACCESS: types::GLenum = 0x88BB;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_ACCESS_ARB: types::GLenum = 0x88BB;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_ACCESS_FLAGS: types::GLenum = 0x911F;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_BINDING: types::GLenum = 0x9302;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_DATA_SIZE: types::GLenum = 0x9303;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_IMMUTABLE_STORAGE: types::GLenum = 0x821F;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_IMMUTABLE_STORAGE_EXT: types::GLenum = 0x821F;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_KHR: types::GLenum = 0x82E0;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAPPED: types::GLenum = 0x88BC;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAPPED_ARB: types::GLenum = 0x88BC;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAP_LENGTH: types::GLenum = 0x9120;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAP_OFFSET: types::GLenum = 0x9121;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAP_POINTER: types::GLenum = 0x88BD;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_MAP_POINTER_ARB: types::GLenum = 0x88BD;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_SIZE: types::GLenum = 0x8764;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_SIZE_ARB: types::GLenum = 0x8764;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_STORAGE_FLAGS: types::GLenum = 0x8220;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_STORAGE_FLAGS_EXT: types::GLenum = 0x8220;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_UPDATE_BARRIER_BIT: types::GLenum = 0x00000200;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_USAGE: types::GLenum = 0x8765;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_USAGE_ARB: types::GLenum = 0x8765;
#[allow(dead_code, non_upper_case_globals)] pub const BUFFER_VARIABLE: types::GLenum = 0x92E5;
#[allow(dead_code, non_upper_case_globals)] pub const BYTE: types::GLenum = 0x1400;
#[allow(dead_code, non_upper_case_globals)] pub const C3F_V3F: types::GLenum = 0x2A24;
#[allow(dead_code, non_upper_case_globals)] pub const C4F_N3F_V3F: types::GLenum = 0x2A26;
#[allow(dead_code, non_upper_case_globals)] pub const C4UB_V2F: types::GLenum = 0x2A22;
#[allow(dead_code, non_upper_case_globals)] pub const C4UB_V3F: types::GLenum = 0x2A23;
#[allow(dead_code, non_upper_case_globals)] pub const CAVEAT_SUPPORT: types::GLenum = 0x82B8;
#[allow(dead_code, non_upper_case_globals)] pub const CCW: types::GLenum = 0x0901;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP: types::GLenum = 0x2900;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP_FRAGMENT_COLOR: types::GLenum = 0x891B;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP_READ_COLOR: types::GLenum = 0x891C;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP_TO_BORDER: types::GLenum = 0x812D;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP_TO_EDGE: types::GLenum = 0x812F;
#[allow(dead_code, non_upper_case_globals)] pub const CLAMP_VERTEX_COLOR: types::GLenum = 0x891A;
#[allow(dead_code, non_upper_case_globals)] pub const CLEAR: types::GLenum = 0x1500;
#[allow(dead_code, non_upper_case_globals)] pub const CLEAR_BUFFER: types::GLenum = 0x82B4;
#[allow(dead_code, non_upper_case_globals)] pub const CLEAR_TEXTURE: types::GLenum = 0x9365;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_ACTIVE_TEXTURE: types::GLenum = 0x84E1;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_ALL_ATTRIB_BITS: types::GLenum = 0xFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_ATTRIB_STACK_DEPTH: types::GLenum = 0x0BB1;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_MAPPED_BUFFER_BARRIER_BIT: types::GLenum = 0x00004000;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT: types::GLenum = 0x00004000;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_PIXEL_STORE_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_STORAGE_BIT: types::GLenum = 0x0200;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_STORAGE_BIT_EXT: types::GLenum = 0x0200;
#[allow(dead_code, non_upper_case_globals)] pub const CLIENT_VERTEX_ARRAY_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DEPTH_MODE: types::GLenum = 0x935D;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE0: types::GLenum = 0x3000;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE1: types::GLenum = 0x3001;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE2: types::GLenum = 0x3002;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE3: types::GLenum = 0x3003;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE4: types::GLenum = 0x3004;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE5: types::GLenum = 0x3005;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE6: types::GLenum = 0x3006;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_DISTANCE7: types::GLenum = 0x3007;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_ORIGIN: types::GLenum = 0x935C;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE0: types::GLenum = 0x3000;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE1: types::GLenum = 0x3001;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE2: types::GLenum = 0x3002;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE3: types::GLenum = 0x3003;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE4: types::GLenum = 0x3004;
#[allow(dead_code, non_upper_case_globals)] pub const CLIP_PLANE5: types::GLenum = 0x3005;
#[allow(dead_code, non_upper_case_globals)] pub const COEFF: types::GLenum = 0x0A00;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR: types::GLenum = 0x1800;
#[allow(dead_code, non_upper_case_globals)] pub const COLORBURN: types::GLenum = 0x929A;
#[allow(dead_code, non_upper_case_globals)] pub const COLORDODGE: types::GLenum = 0x9299;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY: types::GLenum = 0x8076;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_BUFFER_BINDING: types::GLenum = 0x8898;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8898;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_POINTER: types::GLenum = 0x8090;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_SIZE: types::GLenum = 0x8081;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_STRIDE: types::GLenum = 0x8083;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ARRAY_TYPE: types::GLenum = 0x8082;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT0: types::GLenum = 0x8CE0;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT0_EXT: types::GLenum = 0x8CE0;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT1: types::GLenum = 0x8CE1;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT10: types::GLenum = 0x8CEA;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT10_EXT: types::GLenum = 0x8CEA;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT11: types::GLenum = 0x8CEB;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT11_EXT: types::GLenum = 0x8CEB;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT12: types::GLenum = 0x8CEC;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT12_EXT: types::GLenum = 0x8CEC;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT13: types::GLenum = 0x8CED;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT13_EXT: types::GLenum = 0x8CED;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT14: types::GLenum = 0x8CEE;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT14_EXT: types::GLenum = 0x8CEE;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT15: types::GLenum = 0x8CEF;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT15_EXT: types::GLenum = 0x8CEF;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT16: types::GLenum = 0x8CF0;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT17: types::GLenum = 0x8CF1;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT18: types::GLenum = 0x8CF2;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT19: types::GLenum = 0x8CF3;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT1_EXT: types::GLenum = 0x8CE1;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT2: types::GLenum = 0x8CE2;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT20: types::GLenum = 0x8CF4;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT21: types::GLenum = 0x8CF5;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT22: types::GLenum = 0x8CF6;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT23: types::GLenum = 0x8CF7;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT24: types::GLenum = 0x8CF8;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT25: types::GLenum = 0x8CF9;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT26: types::GLenum = 0x8CFA;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT27: types::GLenum = 0x8CFB;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT28: types::GLenum = 0x8CFC;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT29: types::GLenum = 0x8CFD;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT2_EXT: types::GLenum = 0x8CE2;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT3: types::GLenum = 0x8CE3;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT30: types::GLenum = 0x8CFE;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT31: types::GLenum = 0x8CFF;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT3_EXT: types::GLenum = 0x8CE3;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT4: types::GLenum = 0x8CE4;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT4_EXT: types::GLenum = 0x8CE4;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT5: types::GLenum = 0x8CE5;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT5_EXT: types::GLenum = 0x8CE5;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT6: types::GLenum = 0x8CE6;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT6_EXT: types::GLenum = 0x8CE6;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT7: types::GLenum = 0x8CE7;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT7_EXT: types::GLenum = 0x8CE7;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT8: types::GLenum = 0x8CE8;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT8_EXT: types::GLenum = 0x8CE8;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT9: types::GLenum = 0x8CE9;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ATTACHMENT9_EXT: types::GLenum = 0x8CE9;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_BUFFER_BIT: types::GLenum = 0x00004000;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_CLEAR_VALUE: types::GLenum = 0x0C22;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_COMPONENTS: types::GLenum = 0x8283;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_ENCODING: types::GLenum = 0x8296;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_INDEX: types::GLenum = 0x1900;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_INDEXES: types::GLenum = 0x1603;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_LOGIC_OP: types::GLenum = 0x0BF2;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_MATERIAL: types::GLenum = 0x0B57;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_MATERIAL_FACE: types::GLenum = 0x0B55;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_MATERIAL_PARAMETER: types::GLenum = 0x0B56;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_RENDERABLE: types::GLenum = 0x8286;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_SUM: types::GLenum = 0x8458;
#[allow(dead_code, non_upper_case_globals)] pub const COLOR_WRITEMASK: types::GLenum = 0x0C23;
#[allow(dead_code, non_upper_case_globals)] pub const COMBINE: types::GLenum = 0x8570;
#[allow(dead_code, non_upper_case_globals)] pub const COMBINE_ALPHA: types::GLenum = 0x8572;
#[allow(dead_code, non_upper_case_globals)] pub const COMBINE_RGB: types::GLenum = 0x8571;
#[allow(dead_code, non_upper_case_globals)] pub const COMMAND_BARRIER_BIT: types::GLenum = 0x00000040;
#[allow(dead_code, non_upper_case_globals)] pub const COMPARE_REF_DEPTH_TO_TEXTURE_EXT: types::GLenum = 0x884E;
#[allow(dead_code, non_upper_case_globals)] pub const COMPARE_REF_TO_TEXTURE: types::GLenum = 0x884E;
#[allow(dead_code, non_upper_case_globals)] pub const COMPARE_R_TO_TEXTURE: types::GLenum = 0x884E;
#[allow(dead_code, non_upper_case_globals)] pub const COMPATIBLE_SUBROUTINES: types::GLenum = 0x8E4B;
#[allow(dead_code, non_upper_case_globals)] pub const COMPILE: types::GLenum = 0x1300;
#[allow(dead_code, non_upper_case_globals)] pub const COMPILE_AND_EXECUTE: types::GLenum = 0x1301;
#[allow(dead_code, non_upper_case_globals)] pub const COMPILE_STATUS: types::GLenum = 0x8B81;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_ALPHA: types::GLenum = 0x84E9;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_INTENSITY: types::GLenum = 0x84EC;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_LUMINANCE: types::GLenum = 0x84EA;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_LUMINANCE_ALPHA: types::GLenum = 0x84EB;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_R11_EAC: types::GLenum = 0x9270;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RED: types::GLenum = 0x8225;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RED_RGTC1: types::GLenum = 0x8DBB;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RG: types::GLenum = 0x8226;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RG11_EAC: types::GLenum = 0x9272;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB: types::GLenum = 0x84ED;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB8_ETC2: types::GLenum = 0x9274;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2: types::GLenum = 0x9276;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA: types::GLenum = 0x84EE;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA8_ETC2_EAC: types::GLenum = 0x9278;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_10x10: types::GLenum = 0x93BB;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_10x5: types::GLenum = 0x93B8;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_10x6: types::GLenum = 0x93B9;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_10x8: types::GLenum = 0x93BA;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_12x10: types::GLenum = 0x93BC;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_12x12: types::GLenum = 0x93BD;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_4x4: types::GLenum = 0x93B0;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_5x4: types::GLenum = 0x93B1;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_5x5: types::GLenum = 0x93B2;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_6x5: types::GLenum = 0x93B3;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_6x6: types::GLenum = 0x93B4;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_8x5: types::GLenum = 0x93B5;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_8x6: types::GLenum = 0x93B6;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_ASTC_8x8: types::GLenum = 0x93B7;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_BPTC_UNORM: types::GLenum = 0x8E8C;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_S3TC_DXT1_EXT: types::GLenum = 0x83F1;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_S3TC_DXT3_EXT: types::GLenum = 0x83F2;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGBA_S3TC_DXT5_EXT: types::GLenum = 0x83F3;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB_BPTC_SIGNED_FLOAT: types::GLenum = 0x8E8E;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT: types::GLenum = 0x8E8F;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RGB_S3TC_DXT1_EXT: types::GLenum = 0x83F0;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_RG_RGTC2: types::GLenum = 0x8DBD;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SIGNED_R11_EAC: types::GLenum = 0x9271;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SIGNED_RED_RGTC1: types::GLenum = 0x8DBC;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SIGNED_RG11_EAC: types::GLenum = 0x9273;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SIGNED_RG_RGTC2: types::GLenum = 0x8DBE;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SLUMINANCE: types::GLenum = 0x8C4A;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SLUMINANCE_ALPHA: types::GLenum = 0x8C4B;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SLUMINANCE_ALPHA_EXT: types::GLenum = 0x8C4B;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SLUMINANCE_EXT: types::GLenum = 0x8C4A;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB: types::GLenum = 0x8C48;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_10x10: types::GLenum = 0x93DB;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_10x5: types::GLenum = 0x93D8;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_10x6: types::GLenum = 0x93D9;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_10x8: types::GLenum = 0x93DA;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_12x10: types::GLenum = 0x93DC;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_12x12: types::GLenum = 0x93DD;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_4x4: types::GLenum = 0x93D0;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_5x4: types::GLenum = 0x93D1;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_5x5: types::GLenum = 0x93D2;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_6x5: types::GLenum = 0x93D3;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_6x6: types::GLenum = 0x93D4;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_8x5: types::GLenum = 0x93D5;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_8x6: types::GLenum = 0x93D6;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ASTC_8x8: types::GLenum = 0x93D7;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ALPHA8_ETC2_EAC: types::GLenum = 0x9279;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_ETC2: types::GLenum = 0x9275;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2: types::GLenum = 0x9277;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA: types::GLenum = 0x8C49;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA_BPTC_UNORM: types::GLenum = 0x8E8D;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA_EXT: types::GLenum = 0x8C49;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT: types::GLenum = 0x8C4D;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT: types::GLenum = 0x8C4E;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT: types::GLenum = 0x8C4F;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_EXT: types::GLenum = 0x8C48;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_SRGB_S3TC_DXT1_EXT: types::GLenum = 0x8C4C;
#[allow(dead_code, non_upper_case_globals)] pub const COMPRESSED_TEXTURE_FORMATS: types::GLenum = 0x86A3;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_SHADER: types::GLenum = 0x91B9;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_SHADER_BIT: types::GLenum = 0x00000020;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_SUBROUTINE: types::GLenum = 0x92ED;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_SUBROUTINE_UNIFORM: types::GLenum = 0x92F3;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_TEXTURE: types::GLenum = 0x82A0;
#[allow(dead_code, non_upper_case_globals)] pub const COMPUTE_WORK_GROUP_SIZE: types::GLenum = 0x8267;
#[allow(dead_code, non_upper_case_globals)] pub const CONDITION_SATISFIED: types::GLenum = 0x911C;
#[allow(dead_code, non_upper_case_globals)] pub const CONDITION_SATISFIED_APPLE: types::GLenum = 0x911C;
#[allow(dead_code, non_upper_case_globals)] pub const CONFORMANT_NV: types::GLenum = 0x9374;
#[allow(dead_code, non_upper_case_globals)] pub const CONSTANT: types::GLenum = 0x8576;
#[allow(dead_code, non_upper_case_globals)] pub const CONSTANT_ALPHA: types::GLenum = 0x8003;
#[allow(dead_code, non_upper_case_globals)] pub const CONSTANT_ATTENUATION: types::GLenum = 0x1207;
#[allow(dead_code, non_upper_case_globals)] pub const CONSTANT_COLOR: types::GLenum = 0x8001;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_COMPATIBILITY_PROFILE_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_CORE_PROFILE_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAGS: types::GLenum = 0x821E;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAG_DEBUG_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAG_DEBUG_BIT_KHR: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAG_ROBUST_ACCESS_BIT: types::GLenum = 0x00000004;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB: types::GLenum = 0x00000004;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_LOST: types::GLenum = 0x0507;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_LOST_KHR: types::GLenum = 0x0507;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_PROFILE_MASK: types::GLenum = 0x9126;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_RELEASE_BEHAVIOR: types::GLenum = 0x82FB;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_RELEASE_BEHAVIOR_FLUSH: types::GLenum = 0x82FC;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_ROBUST_ACCESS: types::GLenum = 0x90F3;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_ROBUST_ACCESS_EXT: types::GLenum = 0x90F3;
#[allow(dead_code, non_upper_case_globals)] pub const CONTEXT_ROBUST_ACCESS_KHR: types::GLenum = 0x90F3;
#[allow(dead_code, non_upper_case_globals)] pub const COORD_REPLACE: types::GLenum = 0x8862;
#[allow(dead_code, non_upper_case_globals)] pub const COPY: types::GLenum = 0x1503;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_INVERTED: types::GLenum = 0x150C;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_PIXEL_TOKEN: types::GLenum = 0x0706;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_READ_BUFFER: types::GLenum = 0x8F36;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_READ_BUFFER_BINDING: types::GLenum = 0x8F36;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_READ_BUFFER_NV: types::GLenum = 0x8F36;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_WRITE_BUFFER: types::GLenum = 0x8F37;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_WRITE_BUFFER_BINDING: types::GLenum = 0x8F37;
#[allow(dead_code, non_upper_case_globals)] pub const COPY_WRITE_BUFFER_NV: types::GLenum = 0x8F37;
#[allow(dead_code, non_upper_case_globals)] pub const CULL_FACE: types::GLenum = 0x0B44;
#[allow(dead_code, non_upper_case_globals)] pub const CULL_FACE_MODE: types::GLenum = 0x0B45;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_COLOR: types::GLenum = 0x0B00;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_FOG_COORD: types::GLenum = 0x8453;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_FOG_COORDINATE: types::GLenum = 0x8453;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_INDEX: types::GLenum = 0x0B01;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_NORMAL: types::GLenum = 0x0B02;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_PROGRAM: types::GLenum = 0x8B8D;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_QUERY: types::GLenum = 0x8865;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_QUERY_ARB: types::GLenum = 0x8865;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_QUERY_EXT: types::GLenum = 0x8865;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_COLOR: types::GLenum = 0x0B04;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_DISTANCE: types::GLenum = 0x0B09;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_INDEX: types::GLenum = 0x0B05;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_POSITION: types::GLenum = 0x0B07;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_POSITION_VALID: types::GLenum = 0x0B08;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_SECONDARY_COLOR: types::GLenum = 0x845F;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_RASTER_TEXTURE_COORDS: types::GLenum = 0x0B06;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_SECONDARY_COLOR: types::GLenum = 0x8459;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_TEXTURE_COORDS: types::GLenum = 0x0B03;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_VERTEX_ATTRIB: types::GLenum = 0x8626;
#[allow(dead_code, non_upper_case_globals)] pub const CURRENT_VERTEX_ATTRIB_ARB: types::GLenum = 0x8626;
#[allow(dead_code, non_upper_case_globals)] pub const CW: types::GLenum = 0x0900;
#[allow(dead_code, non_upper_case_globals)] pub const DARKEN: types::GLenum = 0x9297;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_FUNCTION: types::GLenum = 0x8244;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_FUNCTION_ARB: types::GLenum = 0x8244;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_FUNCTION_KHR: types::GLenum = 0x8244;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_USER_PARAM: types::GLenum = 0x8245;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_USER_PARAM_ARB: types::GLenum = 0x8245;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_CALLBACK_USER_PARAM_KHR: types::GLenum = 0x8245;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_GROUP_STACK_DEPTH: types::GLenum = 0x826D;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_GROUP_STACK_DEPTH_KHR: types::GLenum = 0x826D;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_LOGGED_MESSAGES: types::GLenum = 0x9145;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_LOGGED_MESSAGES_ARB: types::GLenum = 0x9145;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_LOGGED_MESSAGES_KHR: types::GLenum = 0x9145;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_NEXT_LOGGED_MESSAGE_LENGTH: types::GLenum = 0x8243;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_ARB: types::GLenum = 0x8243;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_KHR: types::GLenum = 0x8243;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_OUTPUT: types::GLenum = 0x92E0;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_OUTPUT_KHR: types::GLenum = 0x92E0;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_OUTPUT_SYNCHRONOUS: types::GLenum = 0x8242;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_OUTPUT_SYNCHRONOUS_ARB: types::GLenum = 0x8242;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_OUTPUT_SYNCHRONOUS_KHR: types::GLenum = 0x8242;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_HIGH: types::GLenum = 0x9146;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_HIGH_ARB: types::GLenum = 0x9146;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_HIGH_KHR: types::GLenum = 0x9146;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_LOW: types::GLenum = 0x9148;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_LOW_ARB: types::GLenum = 0x9148;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_LOW_KHR: types::GLenum = 0x9148;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_MEDIUM: types::GLenum = 0x9147;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_MEDIUM_ARB: types::GLenum = 0x9147;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_MEDIUM_KHR: types::GLenum = 0x9147;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_NOTIFICATION: types::GLenum = 0x826B;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SEVERITY_NOTIFICATION_KHR: types::GLenum = 0x826B;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_API: types::GLenum = 0x8246;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_API_ARB: types::GLenum = 0x8246;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_API_KHR: types::GLenum = 0x8246;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_APPLICATION: types::GLenum = 0x824A;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_APPLICATION_ARB: types::GLenum = 0x824A;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_APPLICATION_KHR: types::GLenum = 0x824A;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_OTHER: types::GLenum = 0x824B;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_OTHER_ARB: types::GLenum = 0x824B;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_OTHER_KHR: types::GLenum = 0x824B;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_SHADER_COMPILER: types::GLenum = 0x8248;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_SHADER_COMPILER_ARB: types::GLenum = 0x8248;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_SHADER_COMPILER_KHR: types::GLenum = 0x8248;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_THIRD_PARTY: types::GLenum = 0x8249;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_THIRD_PARTY_ARB: types::GLenum = 0x8249;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_THIRD_PARTY_KHR: types::GLenum = 0x8249;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_WINDOW_SYSTEM: types::GLenum = 0x8247;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_WINDOW_SYSTEM_ARB: types::GLenum = 0x8247;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_SOURCE_WINDOW_SYSTEM_KHR: types::GLenum = 0x8247;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_DEPRECATED_BEHAVIOR: types::GLenum = 0x824D;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB: types::GLenum = 0x824D;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_DEPRECATED_BEHAVIOR_KHR: types::GLenum = 0x824D;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_ERROR: types::GLenum = 0x824C;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_ERROR_ARB: types::GLenum = 0x824C;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_ERROR_KHR: types::GLenum = 0x824C;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_MARKER: types::GLenum = 0x8268;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_MARKER_KHR: types::GLenum = 0x8268;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_OTHER: types::GLenum = 0x8251;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_OTHER_ARB: types::GLenum = 0x8251;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_OTHER_KHR: types::GLenum = 0x8251;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PERFORMANCE: types::GLenum = 0x8250;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PERFORMANCE_ARB: types::GLenum = 0x8250;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PERFORMANCE_KHR: types::GLenum = 0x8250;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_POP_GROUP: types::GLenum = 0x826A;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_POP_GROUP_KHR: types::GLenum = 0x826A;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PORTABILITY: types::GLenum = 0x824F;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PORTABILITY_ARB: types::GLenum = 0x824F;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PORTABILITY_KHR: types::GLenum = 0x824F;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PUSH_GROUP: types::GLenum = 0x8269;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_PUSH_GROUP_KHR: types::GLenum = 0x8269;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_UNDEFINED_BEHAVIOR: types::GLenum = 0x824E;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB: types::GLenum = 0x824E;
#[allow(dead_code, non_upper_case_globals)] pub const DEBUG_TYPE_UNDEFINED_BEHAVIOR_KHR: types::GLenum = 0x824E;
#[allow(dead_code, non_upper_case_globals)] pub const DECAL: types::GLenum = 0x2101;
#[allow(dead_code, non_upper_case_globals)] pub const DECR: types::GLenum = 0x1E03;
#[allow(dead_code, non_upper_case_globals)] pub const DECR_WRAP: types::GLenum = 0x8508;
#[allow(dead_code, non_upper_case_globals)] pub const DELETE_STATUS: types::GLenum = 0x8B80;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH: types::GLenum = 0x1801;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH24_STENCIL8: types::GLenum = 0x88F0;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH24_STENCIL8_EXT: types::GLenum = 0x88F0;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH24_STENCIL8_OES: types::GLenum = 0x88F0;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH32F_STENCIL8: types::GLenum = 0x8CAD;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_ATTACHMENT: types::GLenum = 0x8D00;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_ATTACHMENT_EXT: types::GLenum = 0x8D00;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_BIAS: types::GLenum = 0x0D1F;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_BITS: types::GLenum = 0x0D56;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_BUFFER_BIT: types::GLenum = 0x00000100;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_CLAMP: types::GLenum = 0x864F;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_CLAMP_FAR_AMD: types::GLenum = 0x901F;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_CLAMP_NEAR_AMD: types::GLenum = 0x901E;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_CLEAR_VALUE: types::GLenum = 0x0B73;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT: types::GLenum = 0x1902;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT16: types::GLenum = 0x81A5;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT16_ARB: types::GLenum = 0x81A5;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT24: types::GLenum = 0x81A6;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT24_ARB: types::GLenum = 0x81A6;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT32: types::GLenum = 0x81A7;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT32F: types::GLenum = 0x8CAC;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENT32_ARB: types::GLenum = 0x81A7;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_COMPONENTS: types::GLenum = 0x8284;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_FUNC: types::GLenum = 0x0B74;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_RANGE: types::GLenum = 0x0B70;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_RENDERABLE: types::GLenum = 0x8287;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_SCALE: types::GLenum = 0x0D1E;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_STENCIL: types::GLenum = 0x84F9;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_STENCIL_ATTACHMENT: types::GLenum = 0x821A;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_STENCIL_EXT: types::GLenum = 0x84F9;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_STENCIL_OES: types::GLenum = 0x84F9;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_STENCIL_TEXTURE_MODE: types::GLenum = 0x90EA;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_TEST: types::GLenum = 0x0B71;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_TEXTURE_MODE: types::GLenum = 0x884B;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_TEXTURE_MODE_ARB: types::GLenum = 0x884B;
#[allow(dead_code, non_upper_case_globals)] pub const DEPTH_WRITEMASK: types::GLenum = 0x0B72;
#[allow(dead_code, non_upper_case_globals)] pub const DIFFERENCE: types::GLenum = 0x929E;
#[allow(dead_code, non_upper_case_globals)] pub const DIFFUSE: types::GLenum = 0x1201;
#[allow(dead_code, non_upper_case_globals)] pub const DISPATCH_INDIRECT_BUFFER: types::GLenum = 0x90EE;
#[allow(dead_code, non_upper_case_globals)] pub const DISPATCH_INDIRECT_BUFFER_BINDING: types::GLenum = 0x90EF;
#[allow(dead_code, non_upper_case_globals)] pub const DISPLAY_LIST: types::GLenum = 0x82E7;
#[allow(dead_code, non_upper_case_globals)] pub const DITHER: types::GLenum = 0x0BD0;
#[allow(dead_code, non_upper_case_globals)] pub const DOMAIN: types::GLenum = 0x0A02;
#[allow(dead_code, non_upper_case_globals)] pub const DONT_CARE: types::GLenum = 0x1100;
#[allow(dead_code, non_upper_case_globals)] pub const DOT3_RGB: types::GLenum = 0x86AE;
#[allow(dead_code, non_upper_case_globals)] pub const DOT3_RGBA: types::GLenum = 0x86AF;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE: types::GLenum = 0x140A;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLEBUFFER: types::GLenum = 0x0C32;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT2: types::GLenum = 0x8F46;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT2x3: types::GLenum = 0x8F49;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT2x4: types::GLenum = 0x8F4A;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT3: types::GLenum = 0x8F47;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT3x2: types::GLenum = 0x8F4B;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT3x4: types::GLenum = 0x8F4C;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT4: types::GLenum = 0x8F48;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT4x2: types::GLenum = 0x8F4D;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_MAT4x3: types::GLenum = 0x8F4E;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_VEC2: types::GLenum = 0x8FFC;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_VEC3: types::GLenum = 0x8FFD;
#[allow(dead_code, non_upper_case_globals)] pub const DOUBLE_VEC4: types::GLenum = 0x8FFE;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER: types::GLenum = 0x0C01;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER0: types::GLenum = 0x8825;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER0_ARB: types::GLenum = 0x8825;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER0_ATI: types::GLenum = 0x8825;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER1: types::GLenum = 0x8826;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER10: types::GLenum = 0x882F;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER10_ARB: types::GLenum = 0x882F;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER10_ATI: types::GLenum = 0x882F;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER11: types::GLenum = 0x8830;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER11_ARB: types::GLenum = 0x8830;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER11_ATI: types::GLenum = 0x8830;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER12: types::GLenum = 0x8831;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER12_ARB: types::GLenum = 0x8831;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER12_ATI: types::GLenum = 0x8831;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER13: types::GLenum = 0x8832;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER13_ARB: types::GLenum = 0x8832;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER13_ATI: types::GLenum = 0x8832;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER14: types::GLenum = 0x8833;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER14_ARB: types::GLenum = 0x8833;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER14_ATI: types::GLenum = 0x8833;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER15: types::GLenum = 0x8834;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER15_ARB: types::GLenum = 0x8834;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER15_ATI: types::GLenum = 0x8834;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER1_ARB: types::GLenum = 0x8826;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER1_ATI: types::GLenum = 0x8826;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER2: types::GLenum = 0x8827;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER2_ARB: types::GLenum = 0x8827;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER2_ATI: types::GLenum = 0x8827;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER3: types::GLenum = 0x8828;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER3_ARB: types::GLenum = 0x8828;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER3_ATI: types::GLenum = 0x8828;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER4: types::GLenum = 0x8829;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER4_ARB: types::GLenum = 0x8829;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER4_ATI: types::GLenum = 0x8829;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER5: types::GLenum = 0x882A;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER5_ARB: types::GLenum = 0x882A;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER5_ATI: types::GLenum = 0x882A;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER6: types::GLenum = 0x882B;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER6_ARB: types::GLenum = 0x882B;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER6_ATI: types::GLenum = 0x882B;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER7: types::GLenum = 0x882C;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER7_ARB: types::GLenum = 0x882C;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER7_ATI: types::GLenum = 0x882C;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER8: types::GLenum = 0x882D;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER8_ARB: types::GLenum = 0x882D;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER8_ATI: types::GLenum = 0x882D;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER9: types::GLenum = 0x882E;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER9_ARB: types::GLenum = 0x882E;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_BUFFER9_ATI: types::GLenum = 0x882E;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER: types::GLenum = 0x8CA9;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER_APPLE: types::GLenum = 0x8CA9;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER_BINDING: types::GLenum = 0x8CA6;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER_BINDING_APPLE: types::GLenum = 0x8CA6;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER_BINDING_EXT: types::GLenum = 0x8CA6;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_FRAMEBUFFER_EXT: types::GLenum = 0x8CA9;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_INDIRECT_BUFFER: types::GLenum = 0x8F3F;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_INDIRECT_BUFFER_BINDING: types::GLenum = 0x8F43;
#[allow(dead_code, non_upper_case_globals)] pub const DRAW_PIXEL_TOKEN: types::GLenum = 0x0705;
#[allow(dead_code, non_upper_case_globals)] pub const DST_ALPHA: types::GLenum = 0x0304;
#[allow(dead_code, non_upper_case_globals)] pub const DST_COLOR: types::GLenum = 0x0306;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_COPY: types::GLenum = 0x88EA;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_COPY_ARB: types::GLenum = 0x88EA;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_DRAW: types::GLenum = 0x88E8;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_DRAW_ARB: types::GLenum = 0x88E8;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_READ: types::GLenum = 0x88E9;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_READ_ARB: types::GLenum = 0x88E9;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_STORAGE_BIT: types::GLenum = 0x0100;
#[allow(dead_code, non_upper_case_globals)] pub const DYNAMIC_STORAGE_BIT_EXT: types::GLenum = 0x0100;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG: types::GLenum = 0x0B43;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG_ARRAY: types::GLenum = 0x8079;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG_ARRAY_BUFFER_BINDING: types::GLenum = 0x889B;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889B;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG_ARRAY_POINTER: types::GLenum = 0x8093;
#[allow(dead_code, non_upper_case_globals)] pub const EDGE_FLAG_ARRAY_STRIDE: types::GLenum = 0x808C;
#[allow(dead_code, non_upper_case_globals)] pub const ELEMENT_ARRAY_BARRIER_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const ELEMENT_ARRAY_BUFFER: types::GLenum = 0x8893;
#[allow(dead_code, non_upper_case_globals)] pub const ELEMENT_ARRAY_BUFFER_ARB: types::GLenum = 0x8893;
#[allow(dead_code, non_upper_case_globals)] pub const ELEMENT_ARRAY_BUFFER_BINDING: types::GLenum = 0x8895;
#[allow(dead_code, non_upper_case_globals)] pub const ELEMENT_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8895;
#[allow(dead_code, non_upper_case_globals)] pub const EMISSION: types::GLenum = 0x1600;
#[allow(dead_code, non_upper_case_globals)] pub const ENABLE_BIT: types::GLenum = 0x00002000;
#[allow(dead_code, non_upper_case_globals)] pub const EQUAL: types::GLenum = 0x0202;
#[allow(dead_code, non_upper_case_globals)] pub const EQUIV: types::GLenum = 0x1509;
#[allow(dead_code, non_upper_case_globals)] pub const EVAL_BIT: types::GLenum = 0x00010000;
#[allow(dead_code, non_upper_case_globals)] pub const EXCLUSION: types::GLenum = 0x92A0;
#[allow(dead_code, non_upper_case_globals)] pub const EXP: types::GLenum = 0x0800;
#[allow(dead_code, non_upper_case_globals)] pub const EXP2: types::GLenum = 0x0801;
#[allow(dead_code, non_upper_case_globals)] pub const EXTENSIONS: types::GLenum = 0x1F03;
#[allow(dead_code, non_upper_case_globals)] pub const EYE_LINEAR: types::GLenum = 0x2400;
#[allow(dead_code, non_upper_case_globals)] pub const EYE_PLANE: types::GLenum = 0x2502;
#[allow(dead_code, non_upper_case_globals)] pub const FALSE: types::GLboolean = 0;
#[allow(dead_code, non_upper_case_globals)] pub const FASTEST: types::GLenum = 0x1101;
#[allow(dead_code, non_upper_case_globals)] pub const FEEDBACK: types::GLenum = 0x1C01;
#[allow(dead_code, non_upper_case_globals)] pub const FEEDBACK_BUFFER_POINTER: types::GLenum = 0x0DF0;
#[allow(dead_code, non_upper_case_globals)] pub const FEEDBACK_BUFFER_SIZE: types::GLenum = 0x0DF1;
#[allow(dead_code, non_upper_case_globals)] pub const FEEDBACK_BUFFER_TYPE: types::GLenum = 0x0DF2;
#[allow(dead_code, non_upper_case_globals)] pub const FILL: types::GLenum = 0x1B02;
#[allow(dead_code, non_upper_case_globals)] pub const FILTER: types::GLenum = 0x829A;
#[allow(dead_code, non_upper_case_globals)] pub const FIRST_VERTEX_CONVENTION: types::GLenum = 0x8E4D;
#[allow(dead_code, non_upper_case_globals)] pub const FIRST_VERTEX_CONVENTION_EXT: types::GLenum = 0x8E4D;
#[allow(dead_code, non_upper_case_globals)] pub const FIXED: types::GLenum = 0x140C;
#[allow(dead_code, non_upper_case_globals)] pub const FIXED_ONLY: types::GLenum = 0x891D;
#[allow(dead_code, non_upper_case_globals)] pub const FLAT: types::GLenum = 0x1D00;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT: types::GLenum = 0x1406;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_32_UNSIGNED_INT_24_8_REV: types::GLenum = 0x8DAD;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT2: types::GLenum = 0x8B5A;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT2_ARB: types::GLenum = 0x8B5A;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT2x3: types::GLenum = 0x8B65;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT2x4: types::GLenum = 0x8B66;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT3: types::GLenum = 0x8B5B;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT3_ARB: types::GLenum = 0x8B5B;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT3x2: types::GLenum = 0x8B67;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT3x4: types::GLenum = 0x8B68;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT4: types::GLenum = 0x8B5C;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT4_ARB: types::GLenum = 0x8B5C;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT4x2: types::GLenum = 0x8B69;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_MAT4x3: types::GLenum = 0x8B6A;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC2: types::GLenum = 0x8B50;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC2_ARB: types::GLenum = 0x8B50;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC3: types::GLenum = 0x8B51;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC3_ARB: types::GLenum = 0x8B51;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC4: types::GLenum = 0x8B52;
#[allow(dead_code, non_upper_case_globals)] pub const FLOAT_VEC4_ARB: types::GLenum = 0x8B52;
#[allow(dead_code, non_upper_case_globals)] pub const FOG: types::GLenum = 0x0B60;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_BIT: types::GLenum = 0x00000080;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COLOR: types::GLenum = 0x0B66;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD: types::GLenum = 0x8451;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE: types::GLenum = 0x8451;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY: types::GLenum = 0x8457;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY_BUFFER_BINDING: types::GLenum = 0x889D;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889D;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY_POINTER: types::GLenum = 0x8456;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY_STRIDE: types::GLenum = 0x8455;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_ARRAY_TYPE: types::GLenum = 0x8454;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORDINATE_SOURCE: types::GLenum = 0x8450;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_ARRAY: types::GLenum = 0x8457;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_ARRAY_BUFFER_BINDING: types::GLenum = 0x889D;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_ARRAY_POINTER: types::GLenum = 0x8456;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_ARRAY_STRIDE: types::GLenum = 0x8455;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_ARRAY_TYPE: types::GLenum = 0x8454;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_COORD_SRC: types::GLenum = 0x8450;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_DENSITY: types::GLenum = 0x0B62;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_END: types::GLenum = 0x0B64;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_HINT: types::GLenum = 0x0C54;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_INDEX: types::GLenum = 0x0B61;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_MODE: types::GLenum = 0x0B65;
#[allow(dead_code, non_upper_case_globals)] pub const FOG_START: types::GLenum = 0x0B63;
#[allow(dead_code, non_upper_case_globals)] pub const FRACTIONAL_EVEN: types::GLenum = 0x8E7C;
#[allow(dead_code, non_upper_case_globals)] pub const FRACTIONAL_ODD: types::GLenum = 0x8E7B;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_DEPTH: types::GLenum = 0x8452;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_INTERPOLATION_OFFSET_BITS: types::GLenum = 0x8E5D;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_SHADER: types::GLenum = 0x8B30;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_SHADER_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_SHADER_DERIVATIVE_HINT: types::GLenum = 0x8B8B;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_SUBROUTINE: types::GLenum = 0x92EC;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_SUBROUTINE_UNIFORM: types::GLenum = 0x92F2;
#[allow(dead_code, non_upper_case_globals)] pub const FRAGMENT_TEXTURE: types::GLenum = 0x829F;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER: types::GLenum = 0x8D40;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE: types::GLenum = 0x8215;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_BLUE_SIZE: types::GLenum = 0x8214;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING: types::GLenum = 0x8210;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE: types::GLenum = 0x8211;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE: types::GLenum = 0x8216;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_GREEN_SIZE: types::GLenum = 0x8213;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_LAYERED: types::GLenum = 0x8DA7;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_LAYERED_ARB: types::GLenum = 0x8DA7;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_OBJECT_NAME: types::GLenum = 0x8CD1;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT: types::GLenum = 0x8CD1;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE: types::GLenum = 0x8CD0;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT: types::GLenum = 0x8CD0;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_RED_SIZE: types::GLenum = 0x8212;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE: types::GLenum = 0x8217;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT: types::GLenum = 0x8CD4;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE: types::GLenum = 0x8CD3;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT: types::GLenum = 0x8CD3;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER: types::GLenum = 0x8CD4;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT: types::GLenum = 0x8CD4;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL: types::GLenum = 0x8CD2;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT: types::GLenum = 0x8CD2;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT: types::GLenum = 0x8D6C;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_BARRIER_BIT: types::GLenum = 0x00000400;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_BINDING: types::GLenum = 0x8CA6;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_BINDING_EXT: types::GLenum = 0x8CA6;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_BLEND: types::GLenum = 0x828B;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_COMPLETE: types::GLenum = 0x8CD5;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_COMPLETE_EXT: types::GLenum = 0x8CD5;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT: types::GLenum = 0x8218;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS: types::GLenum = 0x9314;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT_HEIGHT: types::GLenum = 0x9311;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT_LAYERS: types::GLenum = 0x9312;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT_SAMPLES: types::GLenum = 0x9313;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_DEFAULT_WIDTH: types::GLenum = 0x9310;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_EXT: types::GLenum = 0x8D40;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_ATTACHMENT: types::GLenum = 0x8CD6;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT: types::GLenum = 0x8CD6;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_DIMENSIONS: types::GLenum = 0x8CD9;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT: types::GLenum = 0x8CD9;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER: types::GLenum = 0x8CDB;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT: types::GLenum = 0x8CDB;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_FORMATS_EXT: types::GLenum = 0x8CDA;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB: types::GLenum = 0x8DA9;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS: types::GLenum = 0x8DA8;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB: types::GLenum = 0x8DA8;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: types::GLenum = 0x8CD7;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT: types::GLenum = 0x8CD7;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MULTISAMPLE: types::GLenum = 0x8D56;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_ANGLE: types::GLenum = 0x8D56;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_APPLE: types::GLenum = 0x8D56;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT: types::GLenum = 0x8D56;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_NV: types::GLenum = 0x8D56;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_READ_BUFFER: types::GLenum = 0x8CDC;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT: types::GLenum = 0x8CDC;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_RENDERABLE: types::GLenum = 0x8289;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_RENDERABLE_LAYERED: types::GLenum = 0x828A;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_SRGB: types::GLenum = 0x8DB9;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_SRGB_CAPABLE_EXT: types::GLenum = 0x8DBA;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_SRGB_EXT: types::GLenum = 0x8DB9;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_UNDEFINED: types::GLenum = 0x8219;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_UNSUPPORTED: types::GLenum = 0x8CDD;
#[allow(dead_code, non_upper_case_globals)] pub const FRAMEBUFFER_UNSUPPORTED_EXT: types::GLenum = 0x8CDD;
#[allow(dead_code, non_upper_case_globals)] pub const FRONT: types::GLenum = 0x0404;
#[allow(dead_code, non_upper_case_globals)] pub const FRONT_AND_BACK: types::GLenum = 0x0408;
#[allow(dead_code, non_upper_case_globals)] pub const FRONT_FACE: types::GLenum = 0x0B46;
#[allow(dead_code, non_upper_case_globals)] pub const FRONT_LEFT: types::GLenum = 0x0400;
#[allow(dead_code, non_upper_case_globals)] pub const FRONT_RIGHT: types::GLenum = 0x0401;
#[allow(dead_code, non_upper_case_globals)] pub const FULL_SUPPORT: types::GLenum = 0x82B7;
#[allow(dead_code, non_upper_case_globals)] pub const FUNC_ADD: types::GLenum = 0x8006;
#[allow(dead_code, non_upper_case_globals)] pub const FUNC_REVERSE_SUBTRACT: types::GLenum = 0x800B;
#[allow(dead_code, non_upper_case_globals)] pub const FUNC_SUBTRACT: types::GLenum = 0x800A;
#[allow(dead_code, non_upper_case_globals)] pub const GENERATE_MIPMAP: types::GLenum = 0x8191;
#[allow(dead_code, non_upper_case_globals)] pub const GENERATE_MIPMAP_HINT: types::GLenum = 0x8192;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_INPUT_TYPE: types::GLenum = 0x8917;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_INPUT_TYPE_ARB: types::GLenum = 0x8DDB;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_OUTPUT_TYPE: types::GLenum = 0x8918;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_OUTPUT_TYPE_ARB: types::GLenum = 0x8DDC;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SHADER: types::GLenum = 0x8DD9;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SHADER_ARB: types::GLenum = 0x8DD9;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SHADER_BIT: types::GLenum = 0x00000004;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SHADER_INVOCATIONS: types::GLenum = 0x887F;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SUBROUTINE: types::GLenum = 0x92EB;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_SUBROUTINE_UNIFORM: types::GLenum = 0x92F1;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_TEXTURE: types::GLenum = 0x829E;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_VERTICES_OUT: types::GLenum = 0x8916;
#[allow(dead_code, non_upper_case_globals)] pub const GEOMETRY_VERTICES_OUT_ARB: types::GLenum = 0x8DDA;
#[allow(dead_code, non_upper_case_globals)] pub const GEQUAL: types::GLenum = 0x0206;
#[allow(dead_code, non_upper_case_globals)] pub const GET_TEXTURE_IMAGE_FORMAT: types::GLenum = 0x8291;
#[allow(dead_code, non_upper_case_globals)] pub const GET_TEXTURE_IMAGE_TYPE: types::GLenum = 0x8292;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_DISJOINT_EXT: types::GLenum = 0x8FBB;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_MEMORY_INFO_CURRENT_AVAILABLE_VIDMEM_NVX: types::GLenum = 0x9049;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_MEMORY_INFO_DEDICATED_VIDMEM_NVX: types::GLenum = 0x9047;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_MEMORY_INFO_EVICTED_MEMORY_NVX: types::GLenum = 0x904B;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_MEMORY_INFO_EVICTION_COUNT_NVX: types::GLenum = 0x904A;
#[allow(dead_code, non_upper_case_globals)] pub const GPU_MEMORY_INFO_TOTAL_AVAILABLE_MEMORY_NVX: types::GLenum = 0x9048;
#[allow(dead_code, non_upper_case_globals)] pub const GREATER: types::GLenum = 0x0204;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN: types::GLenum = 0x1904;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN_BIAS: types::GLenum = 0x0D19;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN_BITS: types::GLenum = 0x0D53;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN_INTEGER: types::GLenum = 0x8D95;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN_INTEGER_EXT: types::GLenum = 0x8D95;
#[allow(dead_code, non_upper_case_globals)] pub const GREEN_SCALE: types::GLenum = 0x0D18;
#[allow(dead_code, non_upper_case_globals)] pub const GUILTY_CONTEXT_RESET: types::GLenum = 0x8253;
#[allow(dead_code, non_upper_case_globals)] pub const GUILTY_CONTEXT_RESET_ARB: types::GLenum = 0x8253;
#[allow(dead_code, non_upper_case_globals)] pub const GUILTY_CONTEXT_RESET_EXT: types::GLenum = 0x8253;
#[allow(dead_code, non_upper_case_globals)] pub const GUILTY_CONTEXT_RESET_KHR: types::GLenum = 0x8253;
#[allow(dead_code, non_upper_case_globals)] pub const HALF_FLOAT: types::GLenum = 0x140B;
#[allow(dead_code, non_upper_case_globals)] pub const HARDLIGHT: types::GLenum = 0x929B;
#[allow(dead_code, non_upper_case_globals)] pub const HIGH_FLOAT: types::GLenum = 0x8DF2;
#[allow(dead_code, non_upper_case_globals)] pub const HIGH_INT: types::GLenum = 0x8DF5;
#[allow(dead_code, non_upper_case_globals)] pub const HINT_BIT: types::GLenum = 0x00008000;
#[allow(dead_code, non_upper_case_globals)] pub const HSL_COLOR: types::GLenum = 0x92AF;
#[allow(dead_code, non_upper_case_globals)] pub const HSL_HUE: types::GLenum = 0x92AD;
#[allow(dead_code, non_upper_case_globals)] pub const HSL_LUMINOSITY: types::GLenum = 0x92B0;
#[allow(dead_code, non_upper_case_globals)] pub const HSL_SATURATION: types::GLenum = 0x92AE;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_1D: types::GLenum = 0x904C;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_1D_ARRAY: types::GLenum = 0x9052;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_2D: types::GLenum = 0x904D;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_2D_ARRAY: types::GLenum = 0x9053;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_2D_MULTISAMPLE: types::GLenum = 0x9055;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x9056;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_2D_RECT: types::GLenum = 0x904F;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_3D: types::GLenum = 0x904E;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_ACCESS: types::GLenum = 0x8F3E;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_FORMAT: types::GLenum = 0x906E;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_LAYER: types::GLenum = 0x8F3D;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_LAYERED: types::GLenum = 0x8F3C;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_LEVEL: types::GLenum = 0x8F3B;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BINDING_NAME: types::GLenum = 0x8F3A;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BUFFER: types::GLenum = 0x9051;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_BUFFER_OES: types::GLenum = 0x9051;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_10_10_10_2: types::GLenum = 0x82C3;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_11_11_10: types::GLenum = 0x82C2;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_1_X_16: types::GLenum = 0x82BE;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_1_X_32: types::GLenum = 0x82BB;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_1_X_8: types::GLenum = 0x82C1;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_2_X_16: types::GLenum = 0x82BD;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_2_X_32: types::GLenum = 0x82BA;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_2_X_8: types::GLenum = 0x82C0;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_4_X_16: types::GLenum = 0x82BC;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_4_X_32: types::GLenum = 0x82B9;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CLASS_4_X_8: types::GLenum = 0x82BF;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_COMPATIBILITY_CLASS: types::GLenum = 0x82A8;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CUBE: types::GLenum = 0x9050;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_CUBE_MAP_ARRAY: types::GLenum = 0x9054;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_FORMAT_COMPATIBILITY_BY_CLASS: types::GLenum = 0x90C9;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_FORMAT_COMPATIBILITY_BY_SIZE: types::GLenum = 0x90C8;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_FORMAT_COMPATIBILITY_TYPE: types::GLenum = 0x90C7;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_PIXEL_FORMAT: types::GLenum = 0x82A9;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_PIXEL_TYPE: types::GLenum = 0x82AA;
#[allow(dead_code, non_upper_case_globals)] pub const IMAGE_TEXEL_SIZE: types::GLenum = 0x82A7;
#[allow(dead_code, non_upper_case_globals)] pub const IMPLEMENTATION_COLOR_READ_FORMAT: types::GLenum = 0x8B9B;
#[allow(dead_code, non_upper_case_globals)] pub const IMPLEMENTATION_COLOR_READ_TYPE: types::GLenum = 0x8B9A;
#[allow(dead_code, non_upper_case_globals)] pub const INCR: types::GLenum = 0x1E02;
#[allow(dead_code, non_upper_case_globals)] pub const INCR_WRAP: types::GLenum = 0x8507;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX: types::GLenum = 0x8222;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY: types::GLenum = 0x8077;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY_BUFFER_BINDING: types::GLenum = 0x8899;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8899;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY_POINTER: types::GLenum = 0x8091;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY_STRIDE: types::GLenum = 0x8086;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_ARRAY_TYPE: types::GLenum = 0x8085;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_BITS: types::GLenum = 0x0D51;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_CLEAR_VALUE: types::GLenum = 0x0C20;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_LOGIC_OP: types::GLenum = 0x0BF1;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_MODE: types::GLenum = 0x0C30;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_OFFSET: types::GLenum = 0x0D13;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_SHIFT: types::GLenum = 0x0D12;
#[allow(dead_code, non_upper_case_globals)] pub const INDEX_WRITEMASK: types::GLenum = 0x0C21;
#[allow(dead_code, non_upper_case_globals)] pub const INFO_LOG_LENGTH: types::GLenum = 0x8B84;
#[allow(dead_code, non_upper_case_globals)] pub const INNOCENT_CONTEXT_RESET: types::GLenum = 0x8254;
#[allow(dead_code, non_upper_case_globals)] pub const INNOCENT_CONTEXT_RESET_ARB: types::GLenum = 0x8254;
#[allow(dead_code, non_upper_case_globals)] pub const INNOCENT_CONTEXT_RESET_EXT: types::GLenum = 0x8254;
#[allow(dead_code, non_upper_case_globals)] pub const INNOCENT_CONTEXT_RESET_KHR: types::GLenum = 0x8254;
#[allow(dead_code, non_upper_case_globals)] pub const INT: types::GLenum = 0x1404;
#[allow(dead_code, non_upper_case_globals)] pub const INT64_ARB: types::GLenum = 0x140E;
#[allow(dead_code, non_upper_case_globals)] pub const INT64_NV: types::GLenum = 0x140E;
#[allow(dead_code, non_upper_case_globals)] pub const INT64_VEC2_ARB: types::GLenum = 0x8FE9;
#[allow(dead_code, non_upper_case_globals)] pub const INT64_VEC3_ARB: types::GLenum = 0x8FEA;
#[allow(dead_code, non_upper_case_globals)] pub const INT64_VEC4_ARB: types::GLenum = 0x8FEB;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY: types::GLenum = 0x8049;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY12: types::GLenum = 0x804C;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY16: types::GLenum = 0x804D;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY16F_ARB: types::GLenum = 0x881D;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY16I_EXT: types::GLenum = 0x8D8B;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY16UI_EXT: types::GLenum = 0x8D79;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY32F_ARB: types::GLenum = 0x8817;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY32I_EXT: types::GLenum = 0x8D85;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY32UI_EXT: types::GLenum = 0x8D73;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY4: types::GLenum = 0x804A;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY8: types::GLenum = 0x804B;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY8I_EXT: types::GLenum = 0x8D91;
#[allow(dead_code, non_upper_case_globals)] pub const INTENSITY8UI_EXT: types::GLenum = 0x8D7F;
#[allow(dead_code, non_upper_case_globals)] pub const INTERLEAVED_ATTRIBS: types::GLenum = 0x8C8C;
#[allow(dead_code, non_upper_case_globals)] pub const INTERLEAVED_ATTRIBS_EXT: types::GLenum = 0x8C8C;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_ALPHA_SIZE: types::GLenum = 0x8274;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_ALPHA_TYPE: types::GLenum = 0x827B;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_BLUE_SIZE: types::GLenum = 0x8273;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_BLUE_TYPE: types::GLenum = 0x827A;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_DEPTH_SIZE: types::GLenum = 0x8275;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_DEPTH_TYPE: types::GLenum = 0x827C;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_GREEN_SIZE: types::GLenum = 0x8272;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_GREEN_TYPE: types::GLenum = 0x8279;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_PREFERRED: types::GLenum = 0x8270;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_RED_SIZE: types::GLenum = 0x8271;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_RED_TYPE: types::GLenum = 0x8278;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_SHARED_SIZE: types::GLenum = 0x8277;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_STENCIL_SIZE: types::GLenum = 0x8276;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_STENCIL_TYPE: types::GLenum = 0x827D;
#[allow(dead_code, non_upper_case_globals)] pub const INTERNALFORMAT_SUPPORTED: types::GLenum = 0x826F;
#[allow(dead_code, non_upper_case_globals)] pub const INTERPOLATE: types::GLenum = 0x8575;
#[allow(dead_code, non_upper_case_globals)] pub const INT_10_10_10_2_OES: types::GLenum = 0x8DF7;
#[allow(dead_code, non_upper_case_globals)] pub const INT_2_10_10_10_REV: types::GLenum = 0x8D9F;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_1D: types::GLenum = 0x9057;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_1D_ARRAY: types::GLenum = 0x905D;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_2D: types::GLenum = 0x9058;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_2D_ARRAY: types::GLenum = 0x905E;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_2D_MULTISAMPLE: types::GLenum = 0x9060;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x9061;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_2D_RECT: types::GLenum = 0x905A;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_3D: types::GLenum = 0x9059;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_BUFFER: types::GLenum = 0x905C;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_BUFFER_OES: types::GLenum = 0x905C;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_CUBE: types::GLenum = 0x905B;
#[allow(dead_code, non_upper_case_globals)] pub const INT_IMAGE_CUBE_MAP_ARRAY: types::GLenum = 0x905F;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_1D: types::GLenum = 0x8DC9;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_1D_ARRAY: types::GLenum = 0x8DCE;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_1D_ARRAY_EXT: types::GLenum = 0x8DCE;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_1D_EXT: types::GLenum = 0x8DC9;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D: types::GLenum = 0x8DCA;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_ARRAY: types::GLenum = 0x8DCF;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_ARRAY_EXT: types::GLenum = 0x8DCF;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_EXT: types::GLenum = 0x8DCA;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_MULTISAMPLE: types::GLenum = 0x9109;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x910C;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_RECT: types::GLenum = 0x8DCD;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_2D_RECT_EXT: types::GLenum = 0x8DCD;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_3D: types::GLenum = 0x8DCB;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_3D_EXT: types::GLenum = 0x8DCB;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_BUFFER: types::GLenum = 0x8DD0;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_BUFFER_EXT: types::GLenum = 0x8DD0;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_BUFFER_OES: types::GLenum = 0x8DD0;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_CUBE: types::GLenum = 0x8DCC;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_CUBE_EXT: types::GLenum = 0x8DCC;
#[allow(dead_code, non_upper_case_globals)] pub const INT_SAMPLER_CUBE_MAP_ARRAY: types::GLenum = 0x900E;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC2: types::GLenum = 0x8B53;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC2_ARB: types::GLenum = 0x8B53;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC3: types::GLenum = 0x8B54;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC3_ARB: types::GLenum = 0x8B54;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC4: types::GLenum = 0x8B55;
#[allow(dead_code, non_upper_case_globals)] pub const INT_VEC4_ARB: types::GLenum = 0x8B55;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_ENUM: types::GLenum = 0x0500;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_FRAMEBUFFER_OPERATION: types::GLenum = 0x0506;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_FRAMEBUFFER_OPERATION_EXT: types::GLenum = 0x0506;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_INDEX: types::GLuint = 0xFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_OPERATION: types::GLenum = 0x0502;
#[allow(dead_code, non_upper_case_globals)] pub const INVALID_VALUE: types::GLenum = 0x0501;
#[allow(dead_code, non_upper_case_globals)] pub const INVERT: types::GLenum = 0x150A;
#[allow(dead_code, non_upper_case_globals)] pub const ISOLINES: types::GLenum = 0x8E7A;
#[allow(dead_code, non_upper_case_globals)] pub const IS_PER_PATCH: types::GLenum = 0x92E7;
#[allow(dead_code, non_upper_case_globals)] pub const IS_ROW_MAJOR: types::GLenum = 0x9300;
#[allow(dead_code, non_upper_case_globals)] pub const KEEP: types::GLenum = 0x1E00;
#[allow(dead_code, non_upper_case_globals)] pub const LAST_VERTEX_CONVENTION: types::GLenum = 0x8E4E;
#[allow(dead_code, non_upper_case_globals)] pub const LAST_VERTEX_CONVENTION_EXT: types::GLenum = 0x8E4E;
#[allow(dead_code, non_upper_case_globals)] pub const LAYER_PROVOKING_VERTEX: types::GLenum = 0x825E;
#[allow(dead_code, non_upper_case_globals)] pub const LEFT: types::GLenum = 0x0406;
#[allow(dead_code, non_upper_case_globals)] pub const LEQUAL: types::GLenum = 0x0203;
#[allow(dead_code, non_upper_case_globals)] pub const LESS: types::GLenum = 0x0201;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT0: types::GLenum = 0x4000;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT1: types::GLenum = 0x4001;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT2: types::GLenum = 0x4002;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT3: types::GLenum = 0x4003;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT4: types::GLenum = 0x4004;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT5: types::GLenum = 0x4005;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT6: types::GLenum = 0x4006;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT7: types::GLenum = 0x4007;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHTEN: types::GLenum = 0x9298;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHTING: types::GLenum = 0x0B50;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHTING_BIT: types::GLenum = 0x00000040;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT_MODEL_AMBIENT: types::GLenum = 0x0B53;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT_MODEL_COLOR_CONTROL: types::GLenum = 0x81F8;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT_MODEL_LOCAL_VIEWER: types::GLenum = 0x0B51;
#[allow(dead_code, non_upper_case_globals)] pub const LIGHT_MODEL_TWO_SIDE: types::GLenum = 0x0B52;
#[allow(dead_code, non_upper_case_globals)] pub const LINE: types::GLenum = 0x1B01;
#[allow(dead_code, non_upper_case_globals)] pub const LINEAR: types::GLenum = 0x2601;
#[allow(dead_code, non_upper_case_globals)] pub const LINEAR_ATTENUATION: types::GLenum = 0x1208;
#[allow(dead_code, non_upper_case_globals)] pub const LINEAR_MIPMAP_LINEAR: types::GLenum = 0x2703;
#[allow(dead_code, non_upper_case_globals)] pub const LINEAR_MIPMAP_NEAREST: types::GLenum = 0x2701;
#[allow(dead_code, non_upper_case_globals)] pub const LINES: types::GLenum = 0x0001;
#[allow(dead_code, non_upper_case_globals)] pub const LINES_ADJACENCY: types::GLenum = 0x000A;
#[allow(dead_code, non_upper_case_globals)] pub const LINES_ADJACENCY_ARB: types::GLenum = 0x000A;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_BIT: types::GLenum = 0x00000004;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_LOOP: types::GLenum = 0x0002;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_RESET_TOKEN: types::GLenum = 0x0707;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_SMOOTH: types::GLenum = 0x0B20;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_SMOOTH_HINT: types::GLenum = 0x0C52;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STIPPLE: types::GLenum = 0x0B24;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STIPPLE_PATTERN: types::GLenum = 0x0B25;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STIPPLE_REPEAT: types::GLenum = 0x0B26;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STRIP: types::GLenum = 0x0003;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STRIP_ADJACENCY: types::GLenum = 0x000B;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_STRIP_ADJACENCY_ARB: types::GLenum = 0x000B;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_TOKEN: types::GLenum = 0x0702;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_WIDTH: types::GLenum = 0x0B21;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_WIDTH_GRANULARITY: types::GLenum = 0x0B23;
#[allow(dead_code, non_upper_case_globals)] pub const LINE_WIDTH_RANGE: types::GLenum = 0x0B22;
#[allow(dead_code, non_upper_case_globals)] pub const LINK_STATUS: types::GLenum = 0x8B82;
#[allow(dead_code, non_upper_case_globals)] pub const LIST_BASE: types::GLenum = 0x0B32;
#[allow(dead_code, non_upper_case_globals)] pub const LIST_BIT: types::GLenum = 0x00020000;
#[allow(dead_code, non_upper_case_globals)] pub const LIST_INDEX: types::GLenum = 0x0B33;
#[allow(dead_code, non_upper_case_globals)] pub const LIST_MODE: types::GLenum = 0x0B30;
#[allow(dead_code, non_upper_case_globals)] pub const LOAD: types::GLenum = 0x0101;
#[allow(dead_code, non_upper_case_globals)] pub const LOCATION: types::GLenum = 0x930E;
#[allow(dead_code, non_upper_case_globals)] pub const LOCATION_COMPONENT: types::GLenum = 0x934A;
#[allow(dead_code, non_upper_case_globals)] pub const LOCATION_INDEX: types::GLenum = 0x930F;
#[allow(dead_code, non_upper_case_globals)] pub const LOGIC_OP: types::GLenum = 0x0BF1;
#[allow(dead_code, non_upper_case_globals)] pub const LOGIC_OP_MODE: types::GLenum = 0x0BF0;
#[allow(dead_code, non_upper_case_globals)] pub const LOSE_CONTEXT_ON_RESET: types::GLenum = 0x8252;
#[allow(dead_code, non_upper_case_globals)] pub const LOSE_CONTEXT_ON_RESET_ARB: types::GLenum = 0x8252;
#[allow(dead_code, non_upper_case_globals)] pub const LOSE_CONTEXT_ON_RESET_EXT: types::GLenum = 0x8252;
#[allow(dead_code, non_upper_case_globals)] pub const LOSE_CONTEXT_ON_RESET_KHR: types::GLenum = 0x8252;
#[allow(dead_code, non_upper_case_globals)] pub const LOWER_LEFT: types::GLenum = 0x8CA1;
#[allow(dead_code, non_upper_case_globals)] pub const LOW_FLOAT: types::GLenum = 0x8DF0;
#[allow(dead_code, non_upper_case_globals)] pub const LOW_INT: types::GLenum = 0x8DF3;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE: types::GLenum = 0x1909;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE12: types::GLenum = 0x8041;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE12_ALPHA12: types::GLenum = 0x8047;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE12_ALPHA4: types::GLenum = 0x8046;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE16: types::GLenum = 0x8042;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE16F_ARB: types::GLenum = 0x881E;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE16I_EXT: types::GLenum = 0x8D8C;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE16UI_EXT: types::GLenum = 0x8D7A;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE16_ALPHA16: types::GLenum = 0x8048;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE32F_ARB: types::GLenum = 0x8818;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE32I_EXT: types::GLenum = 0x8D86;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE32UI_EXT: types::GLenum = 0x8D74;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE4: types::GLenum = 0x803F;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE4_ALPHA4: types::GLenum = 0x8043;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE6_ALPHA2: types::GLenum = 0x8044;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE8: types::GLenum = 0x8040;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE8I_EXT: types::GLenum = 0x8D92;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE8UI_EXT: types::GLenum = 0x8D80;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE8_ALPHA8: types::GLenum = 0x8045;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA: types::GLenum = 0x190A;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA16F_ARB: types::GLenum = 0x881F;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA16I_EXT: types::GLenum = 0x8D8D;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA16UI_EXT: types::GLenum = 0x8D7B;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA32F_ARB: types::GLenum = 0x8819;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA32I_EXT: types::GLenum = 0x8D87;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA32UI_EXT: types::GLenum = 0x8D75;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA8I_EXT: types::GLenum = 0x8D93;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA8UI_EXT: types::GLenum = 0x8D81;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_ALPHA_INTEGER_EXT: types::GLenum = 0x8D9D;
#[allow(dead_code, non_upper_case_globals)] pub const LUMINANCE_INTEGER_EXT: types::GLenum = 0x8D9C;
#[allow(dead_code, non_upper_case_globals)] pub const MAJOR_VERSION: types::GLenum = 0x821B;
#[allow(dead_code, non_upper_case_globals)] pub const MANUAL_GENERATE_MIPMAP: types::GLenum = 0x8294;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_COLOR_4: types::GLenum = 0x0D90;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_GRID_DOMAIN: types::GLenum = 0x0DD0;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_GRID_SEGMENTS: types::GLenum = 0x0DD1;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_INDEX: types::GLenum = 0x0D91;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_NORMAL: types::GLenum = 0x0D92;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_TEXTURE_COORD_1: types::GLenum = 0x0D93;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_TEXTURE_COORD_2: types::GLenum = 0x0D94;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_TEXTURE_COORD_3: types::GLenum = 0x0D95;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_TEXTURE_COORD_4: types::GLenum = 0x0D96;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_VERTEX_3: types::GLenum = 0x0D97;
#[allow(dead_code, non_upper_case_globals)] pub const MAP1_VERTEX_4: types::GLenum = 0x0D98;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_COLOR_4: types::GLenum = 0x0DB0;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_GRID_DOMAIN: types::GLenum = 0x0DD2;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_GRID_SEGMENTS: types::GLenum = 0x0DD3;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_INDEX: types::GLenum = 0x0DB1;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_NORMAL: types::GLenum = 0x0DB2;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_TEXTURE_COORD_1: types::GLenum = 0x0DB3;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_TEXTURE_COORD_2: types::GLenum = 0x0DB4;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_TEXTURE_COORD_3: types::GLenum = 0x0DB5;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_TEXTURE_COORD_4: types::GLenum = 0x0DB6;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_VERTEX_3: types::GLenum = 0x0DB7;
#[allow(dead_code, non_upper_case_globals)] pub const MAP2_VERTEX_4: types::GLenum = 0x0DB8;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_COHERENT_BIT: types::GLenum = 0x0080;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_COHERENT_BIT_EXT: types::GLenum = 0x0080;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_COLOR: types::GLenum = 0x0D10;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_FLUSH_EXPLICIT_BIT: types::GLenum = 0x0010;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_INVALIDATE_BUFFER_BIT: types::GLenum = 0x0008;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_INVALIDATE_RANGE_BIT: types::GLenum = 0x0004;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_PERSISTENT_BIT: types::GLenum = 0x0040;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_PERSISTENT_BIT_EXT: types::GLenum = 0x0040;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_READ_BIT: types::GLenum = 0x0001;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_STENCIL: types::GLenum = 0x0D11;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_UNSYNCHRONIZED_BIT: types::GLenum = 0x0020;
#[allow(dead_code, non_upper_case_globals)] pub const MAP_WRITE_BIT: types::GLenum = 0x0002;
#[allow(dead_code, non_upper_case_globals)] pub const MATRIX_MODE: types::GLenum = 0x0BA0;
#[allow(dead_code, non_upper_case_globals)] pub const MATRIX_STRIDE: types::GLenum = 0x92FF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX: types::GLenum = 0x8008;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_3D_TEXTURE_SIZE: types::GLenum = 0x8073;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ARRAY_TEXTURE_LAYERS: types::GLenum = 0x88FF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ARRAY_TEXTURE_LAYERS_EXT: types::GLenum = 0x88FF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ATOMIC_COUNTER_BUFFER_BINDINGS: types::GLenum = 0x92DC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ATOMIC_COUNTER_BUFFER_SIZE: types::GLenum = 0x92D8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ATTRIB_STACK_DEPTH: types::GLenum = 0x0D35;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_CLIENT_ATTRIB_STACK_DEPTH: types::GLenum = 0x0D3B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_CLIP_DISTANCES: types::GLenum = 0x0D32;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_CLIP_PLANES: types::GLenum = 0x0D32;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COLOR_ATTACHMENTS: types::GLenum = 0x8CDF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COLOR_ATTACHMENTS_EXT: types::GLenum = 0x8CDF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COLOR_TEXTURE_SAMPLES: types::GLenum = 0x910E;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_ATOMIC_COUNTERS: types::GLenum = 0x92D7;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92D1;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_CLIP_AND_CULL_DISTANCES: types::GLenum = 0x82FA;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS: types::GLenum = 0x8266;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_DIMENSIONS: types::GLenum = 0x8282;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS: types::GLenum = 0x8A33;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS: types::GLenum = 0x8A32;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_IMAGE_UNIFORMS: types::GLenum = 0x90CF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_IMAGE_UNITS_AND_FRAGMENT_OUTPUTS: types::GLenum = 0x8F39;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_SHADER_OUTPUT_RESOURCES: types::GLenum = 0x8F39;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90DC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_TESS_CONTROL_UNIFORM_COMPONENTS: types::GLenum = 0x8E1E;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_TESS_EVALUATION_UNIFORM_COMPONENTS: types::GLenum = 0x8E1F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8B4D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB: types::GLenum = 0x8B4D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_UNIFORM_BLOCKS: types::GLenum = 0x8A2E;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS: types::GLenum = 0x8A31;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_ATOMIC_COUNTERS: types::GLenum = 0x8265;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x8264;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_IMAGE_UNIFORMS: types::GLenum = 0x91BD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90DB;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_SHARED_MEMORY_SIZE: types::GLenum = 0x8262;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_TEXTURE_IMAGE_UNITS: types::GLenum = 0x91BC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_UNIFORM_BLOCKS: types::GLenum = 0x91BB;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_UNIFORM_COMPONENTS: types::GLenum = 0x8263;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_WORK_GROUP_COUNT: types::GLenum = 0x91BE;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_WORK_GROUP_INVOCATIONS: types::GLenum = 0x90EB;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_COMPUTE_WORK_GROUP_SIZE: types::GLenum = 0x91BF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_CUBE_MAP_TEXTURE_SIZE: types::GLenum = 0x851C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_CULL_DISTANCES: types::GLenum = 0x82F9;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_GROUP_STACK_DEPTH: types::GLenum = 0x826C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_GROUP_STACK_DEPTH_KHR: types::GLenum = 0x826C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_LOGGED_MESSAGES: types::GLenum = 0x9144;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_LOGGED_MESSAGES_ARB: types::GLenum = 0x9144;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_LOGGED_MESSAGES_KHR: types::GLenum = 0x9144;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_MESSAGE_LENGTH: types::GLenum = 0x9143;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_MESSAGE_LENGTH_ARB: types::GLenum = 0x9143;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEBUG_MESSAGE_LENGTH_KHR: types::GLenum = 0x9143;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEPTH: types::GLenum = 0x8280;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DEPTH_TEXTURE_SAMPLES: types::GLenum = 0x910F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DRAW_BUFFERS: types::GLenum = 0x8824;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DRAW_BUFFERS_ARB: types::GLenum = 0x8824;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DRAW_BUFFERS_ATI: types::GLenum = 0x8824;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_DUAL_SOURCE_DRAW_BUFFERS: types::GLenum = 0x88FC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ELEMENTS_INDICES: types::GLenum = 0x80E9;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ELEMENTS_VERTICES: types::GLenum = 0x80E8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_ELEMENT_INDEX: types::GLenum = 0x8D6B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_EVAL_ORDER: types::GLenum = 0x0D30;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_ATOMIC_COUNTERS: types::GLenum = 0x92D6;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92D0;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_IMAGE_UNIFORMS: types::GLenum = 0x90CE;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_INPUT_COMPONENTS: types::GLenum = 0x9125;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_INTERPOLATION_OFFSET: types::GLenum = 0x8E5C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90DA;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_UNIFORM_BLOCKS: types::GLenum = 0x8A2D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_UNIFORM_COMPONENTS: types::GLenum = 0x8B49;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAGMENT_UNIFORM_VECTORS: types::GLenum = 0x8DFD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAMEBUFFER_HEIGHT: types::GLenum = 0x9316;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAMEBUFFER_LAYERS: types::GLenum = 0x9317;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAMEBUFFER_SAMPLES: types::GLenum = 0x9318;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_FRAMEBUFFER_WIDTH: types::GLenum = 0x9315;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_ATOMIC_COUNTERS: types::GLenum = 0x92D5;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92CF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_IMAGE_UNIFORMS: types::GLenum = 0x90CD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_INPUT_COMPONENTS: types::GLenum = 0x9123;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_OUTPUT_COMPONENTS: types::GLenum = 0x9124;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_OUTPUT_VERTICES: types::GLenum = 0x8DE0;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_OUTPUT_VERTICES_ARB: types::GLenum = 0x8DE0;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_SHADER_INVOCATIONS: types::GLenum = 0x8E5A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90D7;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8C29;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB: types::GLenum = 0x8C29;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS: types::GLenum = 0x8DE1;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB: types::GLenum = 0x8DE1;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_UNIFORM_BLOCKS: types::GLenum = 0x8A2C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_UNIFORM_COMPONENTS: types::GLenum = 0x8DDF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB: types::GLenum = 0x8DDF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_GEOMETRY_VARYING_COMPONENTS_ARB: types::GLenum = 0x8DDD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_HEIGHT: types::GLenum = 0x827F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_IMAGE_SAMPLES: types::GLenum = 0x906D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_IMAGE_UNITS: types::GLenum = 0x8F38;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_INTEGER_SAMPLES: types::GLenum = 0x9110;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_LABEL_LENGTH: types::GLenum = 0x82E8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_LABEL_LENGTH_KHR: types::GLenum = 0x82E8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_LAYERS: types::GLenum = 0x8281;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_LIGHTS: types::GLenum = 0x0D31;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_LIST_NESTING: types::GLenum = 0x0B31;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_MODELVIEW_STACK_DEPTH: types::GLenum = 0x0D36;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_NAME_LENGTH: types::GLenum = 0x92F6;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_NAME_STACK_DEPTH: types::GLenum = 0x0D37;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_NUM_ACTIVE_VARIABLES: types::GLenum = 0x92F7;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_NUM_COMPATIBLE_SUBROUTINES: types::GLenum = 0x92F8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PATCH_VERTICES: types::GLenum = 0x8E7D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PIXEL_MAP_TABLE: types::GLenum = 0x0D34;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PROGRAM_TEXEL_OFFSET: types::GLenum = 0x8905;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PROGRAM_TEXEL_OFFSET_EXT: types::GLenum = 0x8905;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PROGRAM_TEXTURE_GATHER_OFFSET: types::GLenum = 0x8E5F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_PROJECTION_STACK_DEPTH: types::GLenum = 0x0D38;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_RECTANGLE_TEXTURE_SIZE: types::GLenum = 0x84F8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_RENDERBUFFER_SIZE: types::GLenum = 0x84E8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_RENDERBUFFER_SIZE_EXT: types::GLenum = 0x84E8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLES: types::GLenum = 0x8D57;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLES_ANGLE: types::GLenum = 0x8D57;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLES_APPLE: types::GLenum = 0x8D57;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLES_EXT: types::GLenum = 0x8D57;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLES_NV: types::GLenum = 0x8D57;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SAMPLE_MASK_WORDS: types::GLenum = 0x8E59;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SERVER_WAIT_TIMEOUT: types::GLenum = 0x9111;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SERVER_WAIT_TIMEOUT_APPLE: types::GLenum = 0x9111;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SHADER_STORAGE_BLOCK_SIZE: types::GLenum = 0x90DE;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SHADER_STORAGE_BUFFER_BINDINGS: types::GLenum = 0x90DD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SUBROUTINES: types::GLenum = 0x8DE7;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_SUBROUTINE_UNIFORM_LOCATIONS: types::GLenum = 0x8DE8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_ATOMIC_COUNTERS: types::GLenum = 0x92D3;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92CD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_IMAGE_UNIFORMS: types::GLenum = 0x90CB;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_INPUT_COMPONENTS: types::GLenum = 0x886C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_OUTPUT_COMPONENTS: types::GLenum = 0x8E83;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90D8;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8E81;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_TOTAL_OUTPUT_COMPONENTS: types::GLenum = 0x8E85;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_UNIFORM_BLOCKS: types::GLenum = 0x8E89;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_CONTROL_UNIFORM_COMPONENTS: types::GLenum = 0x8E7F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_ATOMIC_COUNTERS: types::GLenum = 0x92D4;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92CE;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_IMAGE_UNIFORMS: types::GLenum = 0x90CC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_INPUT_COMPONENTS: types::GLenum = 0x886D;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_OUTPUT_COMPONENTS: types::GLenum = 0x8E86;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90D9;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8E82;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_UNIFORM_BLOCKS: types::GLenum = 0x8E8A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_EVALUATION_UNIFORM_COMPONENTS: types::GLenum = 0x8E80;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_GEN_LEVEL: types::GLenum = 0x8E7E;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TESS_PATCH_COMPONENTS: types::GLenum = 0x8E84;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_BUFFER_SIZE: types::GLenum = 0x8C2B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_BUFFER_SIZE_ARB: types::GLenum = 0x8C2B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_BUFFER_SIZE_EXT: types::GLenum = 0x8C2B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_BUFFER_SIZE_OES: types::GLenum = 0x8C2B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_COORDS: types::GLenum = 0x8871;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_COORDS_ARB: types::GLenum = 0x8871;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8872;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_IMAGE_UNITS_ARB: types::GLenum = 0x8872;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_LOD_BIAS: types::GLenum = 0x84FD;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_MAX_ANISOTROPY_EXT: types::GLenum = 0x84FF;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_SIZE: types::GLenum = 0x0D33;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_STACK_DEPTH: types::GLenum = 0x0D39;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TEXTURE_UNITS: types::GLenum = 0x84E2;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_BUFFERS: types::GLenum = 0x8E70;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS: types::GLenum = 0x8C8A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT: types::GLenum = 0x8C8A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS: types::GLenum = 0x8C8B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT: types::GLenum = 0x8C8B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS: types::GLenum = 0x8C80;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT: types::GLenum = 0x8C80;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_UNIFORM_BLOCK_SIZE: types::GLenum = 0x8A30;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_UNIFORM_BUFFER_BINDINGS: types::GLenum = 0x8A2F;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_UNIFORM_LOCATIONS: types::GLenum = 0x826E;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VARYING_COMPONENTS: types::GLenum = 0x8B4B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VARYING_FLOATS: types::GLenum = 0x8B4B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VARYING_FLOATS_ARB: types::GLenum = 0x8B4B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VARYING_VECTORS: types::GLenum = 0x8DFC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATOMIC_COUNTERS: types::GLenum = 0x92D2;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATOMIC_COUNTER_BUFFERS: types::GLenum = 0x92CC;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATTRIBS: types::GLenum = 0x8869;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATTRIBS_ARB: types::GLenum = 0x8869;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATTRIB_BINDINGS: types::GLenum = 0x82DA;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATTRIB_RELATIVE_OFFSET: types::GLenum = 0x82D9;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_ATTRIB_STRIDE: types::GLenum = 0x82E5;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_IMAGE_UNIFORMS: types::GLenum = 0x90CA;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_OUTPUT_COMPONENTS: types::GLenum = 0x9122;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_SHADER_STORAGE_BLOCKS: types::GLenum = 0x90D6;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_STREAMS: types::GLenum = 0x8E71;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_TEXTURE_IMAGE_UNITS: types::GLenum = 0x8B4C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB: types::GLenum = 0x8B4C;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_UNIFORM_BLOCKS: types::GLenum = 0x8A2B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_UNIFORM_COMPONENTS: types::GLenum = 0x8B4A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_UNIFORM_COMPONENTS_ARB: types::GLenum = 0x8B4A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_UNIFORM_VECTORS: types::GLenum = 0x8DFB;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VERTEX_VARYING_COMPONENTS_ARB: types::GLenum = 0x8DDE;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VIEWPORTS: types::GLenum = 0x825B;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_VIEWPORT_DIMS: types::GLenum = 0x0D3A;
#[allow(dead_code, non_upper_case_globals)] pub const MAX_WIDTH: types::GLenum = 0x827E;
#[allow(dead_code, non_upper_case_globals)] pub const MEDIUM_FLOAT: types::GLenum = 0x8DF1;
#[allow(dead_code, non_upper_case_globals)] pub const MEDIUM_INT: types::GLenum = 0x8DF4;
#[allow(dead_code, non_upper_case_globals)] pub const MIN: types::GLenum = 0x8007;
#[allow(dead_code, non_upper_case_globals)] pub const MINOR_VERSION: types::GLenum = 0x821C;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_FRAGMENT_INTERPOLATION_OFFSET: types::GLenum = 0x8E5B;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_MAP_BUFFER_ALIGNMENT: types::GLenum = 0x90BC;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_PROGRAM_TEXEL_OFFSET: types::GLenum = 0x8904;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_PROGRAM_TEXEL_OFFSET_EXT: types::GLenum = 0x8904;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_PROGRAM_TEXTURE_GATHER_OFFSET: types::GLenum = 0x8E5E;
#[allow(dead_code, non_upper_case_globals)] pub const MIN_SAMPLE_SHADING_VALUE: types::GLenum = 0x8C37;
#[allow(dead_code, non_upper_case_globals)] pub const MIPMAP: types::GLenum = 0x8293;
#[allow(dead_code, non_upper_case_globals)] pub const MIRRORED_REPEAT: types::GLenum = 0x8370;
#[allow(dead_code, non_upper_case_globals)] pub const MIRROR_CLAMP_TO_EDGE: types::GLenum = 0x8743;
#[allow(dead_code, non_upper_case_globals)] pub const MODELVIEW: types::GLenum = 0x1700;
#[allow(dead_code, non_upper_case_globals)] pub const MODELVIEW_MATRIX: types::GLenum = 0x0BA6;
#[allow(dead_code, non_upper_case_globals)] pub const MODELVIEW_STACK_DEPTH: types::GLenum = 0x0BA3;
#[allow(dead_code, non_upper_case_globals)] pub const MODULATE: types::GLenum = 0x2100;
#[allow(dead_code, non_upper_case_globals)] pub const MULT: types::GLenum = 0x0103;
#[allow(dead_code, non_upper_case_globals)] pub const MULTIPLY: types::GLenum = 0x9294;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE: types::GLenum = 0x809D;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLES_NV: types::GLenum = 0x9371;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE_BIT: types::GLenum = 0x20000000;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE_LINE_WIDTH_GRANULARITY: types::GLenum = 0x9382;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE_LINE_WIDTH_GRANULARITY_ARB: types::GLenum = 0x9382;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE_LINE_WIDTH_RANGE: types::GLenum = 0x9381;
#[allow(dead_code, non_upper_case_globals)] pub const MULTISAMPLE_LINE_WIDTH_RANGE_ARB: types::GLenum = 0x9381;
#[allow(dead_code, non_upper_case_globals)] pub const N3F_V3F: types::GLenum = 0x2A25;
#[allow(dead_code, non_upper_case_globals)] pub const NAME_LENGTH: types::GLenum = 0x92F9;
#[allow(dead_code, non_upper_case_globals)] pub const NAME_STACK_DEPTH: types::GLenum = 0x0D70;
#[allow(dead_code, non_upper_case_globals)] pub const NAND: types::GLenum = 0x150E;
#[allow(dead_code, non_upper_case_globals)] pub const NEAREST: types::GLenum = 0x2600;
#[allow(dead_code, non_upper_case_globals)] pub const NEAREST_MIPMAP_LINEAR: types::GLenum = 0x2702;
#[allow(dead_code, non_upper_case_globals)] pub const NEAREST_MIPMAP_NEAREST: types::GLenum = 0x2700;
#[allow(dead_code, non_upper_case_globals)] pub const NEGATIVE_ONE_TO_ONE: types::GLenum = 0x935E;
#[allow(dead_code, non_upper_case_globals)] pub const NEVER: types::GLenum = 0x0200;
#[allow(dead_code, non_upper_case_globals)] pub const NICEST: types::GLenum = 0x1102;
#[allow(dead_code, non_upper_case_globals)] pub const NONE: types::GLenum = 0;
#[allow(dead_code, non_upper_case_globals)] pub const NOOP: types::GLenum = 0x1505;
#[allow(dead_code, non_upper_case_globals)] pub const NOR: types::GLenum = 0x1508;
#[allow(dead_code, non_upper_case_globals)] pub const NORMALIZE: types::GLenum = 0x0BA1;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY: types::GLenum = 0x8075;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY_BUFFER_BINDING: types::GLenum = 0x8897;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8897;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY_POINTER: types::GLenum = 0x808F;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY_STRIDE: types::GLenum = 0x807F;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_ARRAY_TYPE: types::GLenum = 0x807E;
#[allow(dead_code, non_upper_case_globals)] pub const NORMAL_MAP: types::GLenum = 0x8511;
#[allow(dead_code, non_upper_case_globals)] pub const NOTEQUAL: types::GLenum = 0x0205;
#[allow(dead_code, non_upper_case_globals)] pub const NO_ERROR: types::GLenum = 0;
#[allow(dead_code, non_upper_case_globals)] pub const NO_RESET_NOTIFICATION: types::GLenum = 0x8261;
#[allow(dead_code, non_upper_case_globals)] pub const NO_RESET_NOTIFICATION_ARB: types::GLenum = 0x8261;
#[allow(dead_code, non_upper_case_globals)] pub const NO_RESET_NOTIFICATION_EXT: types::GLenum = 0x8261;
#[allow(dead_code, non_upper_case_globals)] pub const NO_RESET_NOTIFICATION_KHR: types::GLenum = 0x8261;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_ACTIVE_VARIABLES: types::GLenum = 0x9304;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_COMPATIBLE_SUBROUTINES: types::GLenum = 0x8E4A;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_COMPRESSED_TEXTURE_FORMATS: types::GLenum = 0x86A2;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_EXTENSIONS: types::GLenum = 0x821D;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_PROGRAM_BINARY_FORMATS: types::GLenum = 0x87FE;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_SAMPLE_COUNTS: types::GLenum = 0x9380;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_SHADER_BINARY_FORMATS: types::GLenum = 0x8DF9;
#[allow(dead_code, non_upper_case_globals)] pub const NUM_SHADING_LANGUAGE_VERSIONS: types::GLenum = 0x82E9;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_ACTIVE_ATTRIBUTES_ARB: types::GLenum = 0x8B89;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB: types::GLenum = 0x8B8A;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_ACTIVE_UNIFORMS_ARB: types::GLenum = 0x8B86;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB: types::GLenum = 0x8B87;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_ATTACHED_OBJECTS_ARB: types::GLenum = 0x8B85;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_COMPILE_STATUS_ARB: types::GLenum = 0x8B81;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_DELETE_STATUS_ARB: types::GLenum = 0x8B80;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_INFO_LOG_LENGTH_ARB: types::GLenum = 0x8B84;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_LINEAR: types::GLenum = 0x2401;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_LINK_STATUS_ARB: types::GLenum = 0x8B82;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_PLANE: types::GLenum = 0x2501;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_SHADER_SOURCE_LENGTH_ARB: types::GLenum = 0x8B88;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_SUBTYPE_ARB: types::GLenum = 0x8B4F;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_TYPE: types::GLenum = 0x9112;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_TYPE_APPLE: types::GLenum = 0x9112;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_TYPE_ARB: types::GLenum = 0x8B4E;
#[allow(dead_code, non_upper_case_globals)] pub const OBJECT_VALIDATE_STATUS_ARB: types::GLenum = 0x8B83;
#[allow(dead_code, non_upper_case_globals)] pub const OFFSET: types::GLenum = 0x92FC;
#[allow(dead_code, non_upper_case_globals)] pub const ONE: types::GLenum = 1;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_CONSTANT_ALPHA: types::GLenum = 0x8004;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_CONSTANT_COLOR: types::GLenum = 0x8002;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_DST_ALPHA: types::GLenum = 0x0305;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_DST_COLOR: types::GLenum = 0x0307;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_SRC1_ALPHA: types::GLenum = 0x88FB;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_SRC1_COLOR: types::GLenum = 0x88FA;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_SRC_ALPHA: types::GLenum = 0x0303;
#[allow(dead_code, non_upper_case_globals)] pub const ONE_MINUS_SRC_COLOR: types::GLenum = 0x0301;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND0_ALPHA: types::GLenum = 0x8598;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND0_RGB: types::GLenum = 0x8590;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND1_ALPHA: types::GLenum = 0x8599;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND1_RGB: types::GLenum = 0x8591;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND2_ALPHA: types::GLenum = 0x859A;
#[allow(dead_code, non_upper_case_globals)] pub const OPERAND2_RGB: types::GLenum = 0x8592;
#[allow(dead_code, non_upper_case_globals)] pub const OR: types::GLenum = 0x1507;
#[allow(dead_code, non_upper_case_globals)] pub const ORDER: types::GLenum = 0x0A01;
#[allow(dead_code, non_upper_case_globals)] pub const OR_INVERTED: types::GLenum = 0x150D;
#[allow(dead_code, non_upper_case_globals)] pub const OR_REVERSE: types::GLenum = 0x150B;
#[allow(dead_code, non_upper_case_globals)] pub const OUT_OF_MEMORY: types::GLenum = 0x0505;
#[allow(dead_code, non_upper_case_globals)] pub const OVERLAY: types::GLenum = 0x9296;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_ALIGNMENT: types::GLenum = 0x0D05;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_COMPRESSED_BLOCK_DEPTH: types::GLenum = 0x912D;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_COMPRESSED_BLOCK_HEIGHT: types::GLenum = 0x912C;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_COMPRESSED_BLOCK_SIZE: types::GLenum = 0x912E;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_COMPRESSED_BLOCK_WIDTH: types::GLenum = 0x912B;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_IMAGE_HEIGHT: types::GLenum = 0x806C;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_LSB_FIRST: types::GLenum = 0x0D01;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_ROW_LENGTH: types::GLenum = 0x0D02;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_SKIP_IMAGES: types::GLenum = 0x806B;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_SKIP_PIXELS: types::GLenum = 0x0D04;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_SKIP_ROWS: types::GLenum = 0x0D03;
#[allow(dead_code, non_upper_case_globals)] pub const PACK_SWAP_BYTES: types::GLenum = 0x0D00;
#[allow(dead_code, non_upper_case_globals)] pub const PASS_THROUGH_TOKEN: types::GLenum = 0x0700;
#[allow(dead_code, non_upper_case_globals)] pub const PATCHES: types::GLenum = 0x000E;
#[allow(dead_code, non_upper_case_globals)] pub const PATCH_DEFAULT_INNER_LEVEL: types::GLenum = 0x8E73;
#[allow(dead_code, non_upper_case_globals)] pub const PATCH_DEFAULT_OUTER_LEVEL: types::GLenum = 0x8E74;
#[allow(dead_code, non_upper_case_globals)] pub const PATCH_VERTICES: types::GLenum = 0x8E72;
#[allow(dead_code, non_upper_case_globals)] pub const PERSPECTIVE_CORRECTION_HINT: types::GLenum = 0x0C50;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_BUFFER_BARRIER_BIT: types::GLenum = 0x00000080;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_A_TO_A: types::GLenum = 0x0C79;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_A_TO_A_SIZE: types::GLenum = 0x0CB9;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_B_TO_B: types::GLenum = 0x0C78;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_B_TO_B_SIZE: types::GLenum = 0x0CB8;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_G_TO_G: types::GLenum = 0x0C77;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_G_TO_G_SIZE: types::GLenum = 0x0CB7;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_A: types::GLenum = 0x0C75;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_A_SIZE: types::GLenum = 0x0CB5;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_B: types::GLenum = 0x0C74;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_B_SIZE: types::GLenum = 0x0CB4;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_G: types::GLenum = 0x0C73;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_G_SIZE: types::GLenum = 0x0CB3;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_I: types::GLenum = 0x0C70;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_I_SIZE: types::GLenum = 0x0CB0;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_R: types::GLenum = 0x0C72;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_I_TO_R_SIZE: types::GLenum = 0x0CB2;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_R_TO_R: types::GLenum = 0x0C76;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_R_TO_R_SIZE: types::GLenum = 0x0CB6;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_S_TO_S: types::GLenum = 0x0C71;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MAP_S_TO_S_SIZE: types::GLenum = 0x0CB1;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_MODE_BIT: types::GLenum = 0x00000020;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER: types::GLenum = 0x88EB;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER_ARB: types::GLenum = 0x88EB;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER_BINDING: types::GLenum = 0x88ED;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER_BINDING_ARB: types::GLenum = 0x88ED;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER_BINDING_NV: types::GLenum = 0x88ED;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_PACK_BUFFER_NV: types::GLenum = 0x88EB;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER: types::GLenum = 0x88EC;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER_ARB: types::GLenum = 0x88EC;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER_BINDING: types::GLenum = 0x88EF;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER_BINDING_ARB: types::GLenum = 0x88EF;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER_BINDING_NV: types::GLenum = 0x88EF;
#[allow(dead_code, non_upper_case_globals)] pub const PIXEL_UNPACK_BUFFER_NV: types::GLenum = 0x88EC;
#[allow(dead_code, non_upper_case_globals)] pub const POINT: types::GLenum = 0x1B00;
#[allow(dead_code, non_upper_case_globals)] pub const POINTS: types::GLenum = 0x0000;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_BIT: types::GLenum = 0x00000002;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_DISTANCE_ATTENUATION: types::GLenum = 0x8129;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_FADE_THRESHOLD_SIZE: types::GLenum = 0x8128;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SIZE: types::GLenum = 0x0B11;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SIZE_GRANULARITY: types::GLenum = 0x0B13;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SIZE_MAX: types::GLenum = 0x8127;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SIZE_MIN: types::GLenum = 0x8126;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SIZE_RANGE: types::GLenum = 0x0B12;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SMOOTH: types::GLenum = 0x0B10;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SMOOTH_HINT: types::GLenum = 0x0C51;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SPRITE: types::GLenum = 0x8861;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_SPRITE_COORD_ORIGIN: types::GLenum = 0x8CA0;
#[allow(dead_code, non_upper_case_globals)] pub const POINT_TOKEN: types::GLenum = 0x0701;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON: types::GLenum = 0x0009;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_BIT: types::GLenum = 0x00000008;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_MODE: types::GLenum = 0x0B40;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_OFFSET_FACTOR: types::GLenum = 0x8038;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_OFFSET_FILL: types::GLenum = 0x8037;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_OFFSET_LINE: types::GLenum = 0x2A02;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_OFFSET_POINT: types::GLenum = 0x2A01;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_OFFSET_UNITS: types::GLenum = 0x2A00;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_SMOOTH: types::GLenum = 0x0B41;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_SMOOTH_HINT: types::GLenum = 0x0C53;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_STIPPLE: types::GLenum = 0x0B42;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_STIPPLE_BIT: types::GLenum = 0x00000010;
#[allow(dead_code, non_upper_case_globals)] pub const POLYGON_TOKEN: types::GLenum = 0x0703;
#[allow(dead_code, non_upper_case_globals)] pub const POSITION: types::GLenum = 0x1203;
#[allow(dead_code, non_upper_case_globals)] pub const PREVIOUS: types::GLenum = 0x8578;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMARY_COLOR: types::GLenum = 0x8577;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVES_GENERATED: types::GLenum = 0x8C87;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVES_GENERATED_EXT: types::GLenum = 0x8C87;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_BOUNDING_BOX: types::GLenum = 0x92BE;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_BOUNDING_BOX_ARB: types::GLenum = 0x92BE;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_BOUNDING_BOX_EXT: types::GLenum = 0x92BE;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_BOUNDING_BOX_OES: types::GLenum = 0x92BE;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_RESTART: types::GLenum = 0x8F9D;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_RESTART_FIXED_INDEX: types::GLenum = 0x8D69;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_RESTART_FOR_PATCHES_SUPPORTED: types::GLenum = 0x8221;
#[allow(dead_code, non_upper_case_globals)] pub const PRIMITIVE_RESTART_INDEX: types::GLenum = 0x8F9E;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM: types::GLenum = 0x82E2;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_BINARY_FORMATS: types::GLenum = 0x87FF;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_BINARY_LENGTH: types::GLenum = 0x8741;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_BINARY_RETRIEVABLE_HINT: types::GLenum = 0x8257;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_INPUT: types::GLenum = 0x92E3;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_KHR: types::GLenum = 0x82E2;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_MATRIX_EXT: types::GLenum = 0x8E2D;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_MATRIX_STACK_DEPTH_EXT: types::GLenum = 0x8E2F;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_OBJECT_ARB: types::GLenum = 0x8B40;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_OUTPUT: types::GLenum = 0x92E4;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_PIPELINE: types::GLenum = 0x82E4;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_PIPELINE_BINDING: types::GLenum = 0x825A;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_PIPELINE_KHR: types::GLenum = 0x82E4;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_POINT_SIZE: types::GLenum = 0x8642;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_POINT_SIZE_ARB: types::GLenum = 0x8642;
#[allow(dead_code, non_upper_case_globals)] pub const PROGRAM_SEPARABLE: types::GLenum = 0x8258;
#[allow(dead_code, non_upper_case_globals)] pub const PROJECTION: types::GLenum = 0x1701;
#[allow(dead_code, non_upper_case_globals)] pub const PROJECTION_MATRIX: types::GLenum = 0x0BA7;
#[allow(dead_code, non_upper_case_globals)] pub const PROJECTION_STACK_DEPTH: types::GLenum = 0x0BA4;
#[allow(dead_code, non_upper_case_globals)] pub const PROVOKING_VERTEX: types::GLenum = 0x8E4F;
#[allow(dead_code, non_upper_case_globals)] pub const PROVOKING_VERTEX_EXT: types::GLenum = 0x8E4F;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_1D: types::GLenum = 0x8063;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_1D_ARRAY: types::GLenum = 0x8C19;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_1D_ARRAY_EXT: types::GLenum = 0x8C19;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_2D: types::GLenum = 0x8064;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_2D_ARRAY: types::GLenum = 0x8C1B;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_2D_ARRAY_EXT: types::GLenum = 0x8C1B;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_2D_MULTISAMPLE: types::GLenum = 0x9101;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x9103;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_3D: types::GLenum = 0x8070;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_CUBE_MAP: types::GLenum = 0x851B;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_CUBE_MAP_ARRAY: types::GLenum = 0x900B;
#[allow(dead_code, non_upper_case_globals)] pub const PROXY_TEXTURE_RECTANGLE: types::GLenum = 0x84F7;
#[allow(dead_code, non_upper_case_globals)] pub const Q: types::GLenum = 0x2003;
#[allow(dead_code, non_upper_case_globals)] pub const QUADRATIC_ATTENUATION: types::GLenum = 0x1209;
#[allow(dead_code, non_upper_case_globals)] pub const QUADS: types::GLenum = 0x0007;
#[allow(dead_code, non_upper_case_globals)] pub const QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION: types::GLenum = 0x8E4C;
#[allow(dead_code, non_upper_case_globals)] pub const QUADS_FOLLOW_PROVOKING_VERTEX_CONVENTION_EXT: types::GLenum = 0x8E4C;
#[allow(dead_code, non_upper_case_globals)] pub const QUAD_STRIP: types::GLenum = 0x0008;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY: types::GLenum = 0x82E3;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BUFFER: types::GLenum = 0x9192;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BUFFER_BARRIER_BIT: types::GLenum = 0x00008000;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BUFFER_BINDING: types::GLenum = 0x9193;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_NO_WAIT: types::GLenum = 0x8E16;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_NO_WAIT_INVERTED: types::GLenum = 0x8E1A;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_NO_WAIT_NV: types::GLenum = 0x8E16;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_WAIT: types::GLenum = 0x8E15;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_WAIT_INVERTED: types::GLenum = 0x8E19;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_BY_REGION_WAIT_NV: types::GLenum = 0x8E15;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_COUNTER_BITS: types::GLenum = 0x8864;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_COUNTER_BITS_ARB: types::GLenum = 0x8864;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_COUNTER_BITS_EXT: types::GLenum = 0x8864;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_KHR: types::GLenum = 0x82E3;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_NO_WAIT: types::GLenum = 0x8E14;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_NO_WAIT_INVERTED: types::GLenum = 0x8E18;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_NO_WAIT_NV: types::GLenum = 0x8E14;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT: types::GLenum = 0x8866;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_ARB: types::GLenum = 0x8866;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_AVAILABLE: types::GLenum = 0x8867;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_AVAILABLE_ARB: types::GLenum = 0x8867;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_AVAILABLE_EXT: types::GLenum = 0x8867;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_EXT: types::GLenum = 0x8866;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_RESULT_NO_WAIT: types::GLenum = 0x9194;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_TARGET: types::GLenum = 0x82EA;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_WAIT: types::GLenum = 0x8E13;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_WAIT_INVERTED: types::GLenum = 0x8E17;
#[allow(dead_code, non_upper_case_globals)] pub const QUERY_WAIT_NV: types::GLenum = 0x8E13;
#[allow(dead_code, non_upper_case_globals)] pub const R: types::GLenum = 0x2002;
#[allow(dead_code, non_upper_case_globals)] pub const R11F_G11F_B10F: types::GLenum = 0x8C3A;
#[allow(dead_code, non_upper_case_globals)] pub const R16: types::GLenum = 0x822A;
#[allow(dead_code, non_upper_case_globals)] pub const R16F: types::GLenum = 0x822D;
#[allow(dead_code, non_upper_case_globals)] pub const R16I: types::GLenum = 0x8233;
#[allow(dead_code, non_upper_case_globals)] pub const R16UI: types::GLenum = 0x8234;
#[allow(dead_code, non_upper_case_globals)] pub const R16_SNORM: types::GLenum = 0x8F98;
#[allow(dead_code, non_upper_case_globals)] pub const R32F: types::GLenum = 0x822E;
#[allow(dead_code, non_upper_case_globals)] pub const R32I: types::GLenum = 0x8235;
#[allow(dead_code, non_upper_case_globals)] pub const R32UI: types::GLenum = 0x8236;
#[allow(dead_code, non_upper_case_globals)] pub const R3_G3_B2: types::GLenum = 0x2A10;
#[allow(dead_code, non_upper_case_globals)] pub const R8: types::GLenum = 0x8229;
#[allow(dead_code, non_upper_case_globals)] pub const R8I: types::GLenum = 0x8231;
#[allow(dead_code, non_upper_case_globals)] pub const R8UI: types::GLenum = 0x8232;
#[allow(dead_code, non_upper_case_globals)] pub const R8_SNORM: types::GLenum = 0x8F94;
#[allow(dead_code, non_upper_case_globals)] pub const RASTERIZER_DISCARD: types::GLenum = 0x8C89;
#[allow(dead_code, non_upper_case_globals)] pub const RASTERIZER_DISCARD_EXT: types::GLenum = 0x8C89;
#[allow(dead_code, non_upper_case_globals)] pub const READ_BUFFER: types::GLenum = 0x0C02;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER: types::GLenum = 0x8CA8;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER_APPLE: types::GLenum = 0x8CA8;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER_BINDING: types::GLenum = 0x8CAA;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER_BINDING_APPLE: types::GLenum = 0x8CAA;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER_BINDING_EXT: types::GLenum = 0x8CAA;
#[allow(dead_code, non_upper_case_globals)] pub const READ_FRAMEBUFFER_EXT: types::GLenum = 0x8CA8;
#[allow(dead_code, non_upper_case_globals)] pub const READ_ONLY: types::GLenum = 0x88B8;
#[allow(dead_code, non_upper_case_globals)] pub const READ_ONLY_ARB: types::GLenum = 0x88B8;
#[allow(dead_code, non_upper_case_globals)] pub const READ_PIXELS: types::GLenum = 0x828C;
#[allow(dead_code, non_upper_case_globals)] pub const READ_PIXELS_FORMAT: types::GLenum = 0x828D;
#[allow(dead_code, non_upper_case_globals)] pub const READ_PIXELS_TYPE: types::GLenum = 0x828E;
#[allow(dead_code, non_upper_case_globals)] pub const READ_WRITE: types::GLenum = 0x88BA;
#[allow(dead_code, non_upper_case_globals)] pub const READ_WRITE_ARB: types::GLenum = 0x88BA;
#[allow(dead_code, non_upper_case_globals)] pub const RED: types::GLenum = 0x1903;
#[allow(dead_code, non_upper_case_globals)] pub const RED_BIAS: types::GLenum = 0x0D15;
#[allow(dead_code, non_upper_case_globals)] pub const RED_BITS: types::GLenum = 0x0D52;
#[allow(dead_code, non_upper_case_globals)] pub const RED_INTEGER: types::GLenum = 0x8D94;
#[allow(dead_code, non_upper_case_globals)] pub const RED_INTEGER_EXT: types::GLenum = 0x8D94;
#[allow(dead_code, non_upper_case_globals)] pub const RED_SCALE: types::GLenum = 0x0D14;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_COMPUTE_SHADER: types::GLenum = 0x930B;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_FRAGMENT_SHADER: types::GLenum = 0x930A;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_GEOMETRY_SHADER: types::GLenum = 0x9309;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_TESS_CONTROL_SHADER: types::GLenum = 0x9307;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_TESS_EVALUATION_SHADER: types::GLenum = 0x9308;
#[allow(dead_code, non_upper_case_globals)] pub const REFERENCED_BY_VERTEX_SHADER: types::GLenum = 0x9306;
#[allow(dead_code, non_upper_case_globals)] pub const REFLECTION_MAP: types::GLenum = 0x8512;
#[allow(dead_code, non_upper_case_globals)] pub const RENDER: types::GLenum = 0x1C00;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER: types::GLenum = 0x8D41;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_ALPHA_SIZE: types::GLenum = 0x8D53;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_ALPHA_SIZE_EXT: types::GLenum = 0x8D53;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_BINDING: types::GLenum = 0x8CA7;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_BINDING_EXT: types::GLenum = 0x8CA7;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_BLUE_SIZE: types::GLenum = 0x8D52;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_BLUE_SIZE_EXT: types::GLenum = 0x8D52;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_DEPTH_SIZE: types::GLenum = 0x8D54;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_DEPTH_SIZE_EXT: types::GLenum = 0x8D54;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_EXT: types::GLenum = 0x8D41;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_FREE_MEMORY_ATI: types::GLenum = 0x87FD;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_GREEN_SIZE: types::GLenum = 0x8D51;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_GREEN_SIZE_EXT: types::GLenum = 0x8D51;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_HEIGHT: types::GLenum = 0x8D43;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_HEIGHT_EXT: types::GLenum = 0x8D43;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_INTERNAL_FORMAT: types::GLenum = 0x8D44;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_INTERNAL_FORMAT_EXT: types::GLenum = 0x8D44;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_RED_SIZE: types::GLenum = 0x8D50;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_RED_SIZE_EXT: types::GLenum = 0x8D50;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_SAMPLES: types::GLenum = 0x8CAB;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_SAMPLES_ANGLE: types::GLenum = 0x8CAB;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_SAMPLES_APPLE: types::GLenum = 0x8CAB;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_SAMPLES_EXT: types::GLenum = 0x8CAB;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_SAMPLES_NV: types::GLenum = 0x8CAB;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_STENCIL_SIZE: types::GLenum = 0x8D55;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_STENCIL_SIZE_EXT: types::GLenum = 0x8D55;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_WIDTH: types::GLenum = 0x8D42;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERBUFFER_WIDTH_EXT: types::GLenum = 0x8D42;
#[allow(dead_code, non_upper_case_globals)] pub const RENDERER: types::GLenum = 0x1F01;
#[allow(dead_code, non_upper_case_globals)] pub const RENDER_MODE: types::GLenum = 0x0C40;
#[allow(dead_code, non_upper_case_globals)] pub const REPEAT: types::GLenum = 0x2901;
#[allow(dead_code, non_upper_case_globals)] pub const REPLACE: types::GLenum = 0x1E01;
#[allow(dead_code, non_upper_case_globals)] pub const RESCALE_NORMAL: types::GLenum = 0x803A;
#[allow(dead_code, non_upper_case_globals)] pub const RESET_NOTIFICATION_STRATEGY: types::GLenum = 0x8256;
#[allow(dead_code, non_upper_case_globals)] pub const RESET_NOTIFICATION_STRATEGY_ARB: types::GLenum = 0x8256;
#[allow(dead_code, non_upper_case_globals)] pub const RESET_NOTIFICATION_STRATEGY_EXT: types::GLenum = 0x8256;
#[allow(dead_code, non_upper_case_globals)] pub const RESET_NOTIFICATION_STRATEGY_KHR: types::GLenum = 0x8256;
#[allow(dead_code, non_upper_case_globals)] pub const RETURN: types::GLenum = 0x0102;
#[allow(dead_code, non_upper_case_globals)] pub const RG: types::GLenum = 0x8227;
#[allow(dead_code, non_upper_case_globals)] pub const RG16: types::GLenum = 0x822C;
#[allow(dead_code, non_upper_case_globals)] pub const RG16F: types::GLenum = 0x822F;
#[allow(dead_code, non_upper_case_globals)] pub const RG16I: types::GLenum = 0x8239;
#[allow(dead_code, non_upper_case_globals)] pub const RG16UI: types::GLenum = 0x823A;
#[allow(dead_code, non_upper_case_globals)] pub const RG16_SNORM: types::GLenum = 0x8F99;
#[allow(dead_code, non_upper_case_globals)] pub const RG32F: types::GLenum = 0x8230;
#[allow(dead_code, non_upper_case_globals)] pub const RG32I: types::GLenum = 0x823B;
#[allow(dead_code, non_upper_case_globals)] pub const RG32UI: types::GLenum = 0x823C;
#[allow(dead_code, non_upper_case_globals)] pub const RG8: types::GLenum = 0x822B;
#[allow(dead_code, non_upper_case_globals)] pub const RG8I: types::GLenum = 0x8237;
#[allow(dead_code, non_upper_case_globals)] pub const RG8UI: types::GLenum = 0x8238;
#[allow(dead_code, non_upper_case_globals)] pub const RG8_SNORM: types::GLenum = 0x8F95;
#[allow(dead_code, non_upper_case_globals)] pub const RGB: types::GLenum = 0x1907;
#[allow(dead_code, non_upper_case_globals)] pub const RGB10: types::GLenum = 0x8052;
#[allow(dead_code, non_upper_case_globals)] pub const RGB10_A2: types::GLenum = 0x8059;
#[allow(dead_code, non_upper_case_globals)] pub const RGB10_A2UI: types::GLenum = 0x906F;
#[allow(dead_code, non_upper_case_globals)] pub const RGB12: types::GLenum = 0x8053;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16: types::GLenum = 0x8054;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16F: types::GLenum = 0x881B;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16F_ARB: types::GLenum = 0x881B;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16I: types::GLenum = 0x8D89;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16I_EXT: types::GLenum = 0x8D89;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16UI: types::GLenum = 0x8D77;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16UI_EXT: types::GLenum = 0x8D77;
#[allow(dead_code, non_upper_case_globals)] pub const RGB16_SNORM: types::GLenum = 0x8F9A;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32F: types::GLenum = 0x8815;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32F_ARB: types::GLenum = 0x8815;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32I: types::GLenum = 0x8D83;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32I_EXT: types::GLenum = 0x8D83;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32UI: types::GLenum = 0x8D71;
#[allow(dead_code, non_upper_case_globals)] pub const RGB32UI_EXT: types::GLenum = 0x8D71;
#[allow(dead_code, non_upper_case_globals)] pub const RGB4: types::GLenum = 0x804F;
#[allow(dead_code, non_upper_case_globals)] pub const RGB5: types::GLenum = 0x8050;
#[allow(dead_code, non_upper_case_globals)] pub const RGB565: types::GLenum = 0x8D62;
#[allow(dead_code, non_upper_case_globals)] pub const RGB5_A1: types::GLenum = 0x8057;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8: types::GLenum = 0x8051;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8I: types::GLenum = 0x8D8F;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8I_EXT: types::GLenum = 0x8D8F;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8UI: types::GLenum = 0x8D7D;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8UI_EXT: types::GLenum = 0x8D7D;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8_OES: types::GLenum = 0x8051;
#[allow(dead_code, non_upper_case_globals)] pub const RGB8_SNORM: types::GLenum = 0x8F96;
#[allow(dead_code, non_upper_case_globals)] pub const RGB9_E5: types::GLenum = 0x8C3D;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA: types::GLenum = 0x1908;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA12: types::GLenum = 0x805A;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16: types::GLenum = 0x805B;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16F: types::GLenum = 0x881A;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16F_ARB: types::GLenum = 0x881A;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16I: types::GLenum = 0x8D88;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16I_EXT: types::GLenum = 0x8D88;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16UI: types::GLenum = 0x8D76;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16UI_EXT: types::GLenum = 0x8D76;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA16_SNORM: types::GLenum = 0x8F9B;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA2: types::GLenum = 0x8055;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32F: types::GLenum = 0x8814;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32F_ARB: types::GLenum = 0x8814;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32I: types::GLenum = 0x8D82;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32I_EXT: types::GLenum = 0x8D82;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32UI: types::GLenum = 0x8D70;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA32UI_EXT: types::GLenum = 0x8D70;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA4: types::GLenum = 0x8056;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8: types::GLenum = 0x8058;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8I: types::GLenum = 0x8D8E;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8I_EXT: types::GLenum = 0x8D8E;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8UI: types::GLenum = 0x8D7C;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8UI_EXT: types::GLenum = 0x8D7C;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8_OES: types::GLenum = 0x8058;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA8_SNORM: types::GLenum = 0x8F97;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA_INTEGER: types::GLenum = 0x8D99;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA_INTEGER_EXT: types::GLenum = 0x8D99;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA_INTEGER_MODE_EXT: types::GLenum = 0x8D9E;
#[allow(dead_code, non_upper_case_globals)] pub const RGBA_MODE: types::GLenum = 0x0C31;
#[allow(dead_code, non_upper_case_globals)] pub const RGB_INTEGER: types::GLenum = 0x8D98;
#[allow(dead_code, non_upper_case_globals)] pub const RGB_INTEGER_EXT: types::GLenum = 0x8D98;
#[allow(dead_code, non_upper_case_globals)] pub const RGB_SCALE: types::GLenum = 0x8573;
#[allow(dead_code, non_upper_case_globals)] pub const RG_INTEGER: types::GLenum = 0x8228;
#[allow(dead_code, non_upper_case_globals)] pub const RIGHT: types::GLenum = 0x0407;
#[allow(dead_code, non_upper_case_globals)] pub const S: types::GLenum = 0x2000;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER: types::GLenum = 0x82E6;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D: types::GLenum = 0x8B5D;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_ARB: types::GLenum = 0x8B5D;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_ARRAY: types::GLenum = 0x8DC0;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_ARRAY_EXT: types::GLenum = 0x8DC0;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_ARRAY_SHADOW: types::GLenum = 0x8DC3;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_ARRAY_SHADOW_EXT: types::GLenum = 0x8DC3;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_SHADOW: types::GLenum = 0x8B61;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_1D_SHADOW_ARB: types::GLenum = 0x8B61;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D: types::GLenum = 0x8B5E;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_ARB: types::GLenum = 0x8B5E;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_ARRAY: types::GLenum = 0x8DC1;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_ARRAY_EXT: types::GLenum = 0x8DC1;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_ARRAY_SHADOW: types::GLenum = 0x8DC4;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_ARRAY_SHADOW_EXT: types::GLenum = 0x8DC4;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_MULTISAMPLE: types::GLenum = 0x9108;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x910B;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_RECT: types::GLenum = 0x8B63;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_RECT_ARB: types::GLenum = 0x8B63;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_RECT_SHADOW: types::GLenum = 0x8B64;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_RECT_SHADOW_ARB: types::GLenum = 0x8B64;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_SHADOW: types::GLenum = 0x8B62;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_2D_SHADOW_ARB: types::GLenum = 0x8B62;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_3D: types::GLenum = 0x8B5F;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_3D_ARB: types::GLenum = 0x8B5F;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_BINDING: types::GLenum = 0x8919;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_BUFFER: types::GLenum = 0x8DC2;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_BUFFER_EXT: types::GLenum = 0x8DC2;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_BUFFER_OES: types::GLenum = 0x8DC2;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE: types::GLenum = 0x8B60;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE_ARB: types::GLenum = 0x8B60;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE_MAP_ARRAY: types::GLenum = 0x900C;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE_MAP_ARRAY_SHADOW: types::GLenum = 0x900D;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE_SHADOW: types::GLenum = 0x8DC5;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_CUBE_SHADOW_EXT: types::GLenum = 0x8DC5;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLER_KHR: types::GLenum = 0x82E6;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLES: types::GLenum = 0x80A9;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLES_PASSED: types::GLenum = 0x8914;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLES_PASSED_ARB: types::GLenum = 0x8914;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_ALPHA_TO_COVERAGE: types::GLenum = 0x809E;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_ALPHA_TO_ONE: types::GLenum = 0x809F;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_BUFFERS: types::GLenum = 0x80A8;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_COVERAGE: types::GLenum = 0x80A0;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_COVERAGE_INVERT: types::GLenum = 0x80AB;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_COVERAGE_VALUE: types::GLenum = 0x80AA;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_MASK: types::GLenum = 0x8E51;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_MASK_VALUE: types::GLenum = 0x8E52;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_POSITION: types::GLenum = 0x8E50;
#[allow(dead_code, non_upper_case_globals)] pub const SAMPLE_SHADING: types::GLenum = 0x8C36;
#[allow(dead_code, non_upper_case_globals)] pub const SCISSOR_BIT: types::GLenum = 0x00080000;
#[allow(dead_code, non_upper_case_globals)] pub const SCISSOR_BOX: types::GLenum = 0x0C10;
#[allow(dead_code, non_upper_case_globals)] pub const SCISSOR_TEST: types::GLenum = 0x0C11;
#[allow(dead_code, non_upper_case_globals)] pub const SCREEN: types::GLenum = 0x9295;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY: types::GLenum = 0x845E;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_BUFFER_BINDING: types::GLenum = 0x889C;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889C;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_POINTER: types::GLenum = 0x845D;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_SIZE: types::GLenum = 0x845A;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_STRIDE: types::GLenum = 0x845C;
#[allow(dead_code, non_upper_case_globals)] pub const SECONDARY_COLOR_ARRAY_TYPE: types::GLenum = 0x845B;
#[allow(dead_code, non_upper_case_globals)] pub const SELECT: types::GLenum = 0x1C02;
#[allow(dead_code, non_upper_case_globals)] pub const SELECTION_BUFFER_POINTER: types::GLenum = 0x0DF3;
#[allow(dead_code, non_upper_case_globals)] pub const SELECTION_BUFFER_SIZE: types::GLenum = 0x0DF4;
#[allow(dead_code, non_upper_case_globals)] pub const SEPARATE_ATTRIBS: types::GLenum = 0x8C8D;
#[allow(dead_code, non_upper_case_globals)] pub const SEPARATE_ATTRIBS_EXT: types::GLenum = 0x8C8D;
#[allow(dead_code, non_upper_case_globals)] pub const SEPARATE_SPECULAR_COLOR: types::GLenum = 0x81FA;
#[allow(dead_code, non_upper_case_globals)] pub const SET: types::GLenum = 0x150F;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER: types::GLenum = 0x82E1;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_BINARY_FORMATS: types::GLenum = 0x8DF8;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_COMPILER: types::GLenum = 0x8DFA;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_IMAGE_ACCESS_BARRIER_BIT: types::GLenum = 0x00000020;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_IMAGE_ATOMIC: types::GLenum = 0x82A6;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_IMAGE_LOAD: types::GLenum = 0x82A4;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_IMAGE_STORE: types::GLenum = 0x82A5;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_KHR: types::GLenum = 0x82E1;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_OBJECT_ARB: types::GLenum = 0x8B48;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_SOURCE_LENGTH: types::GLenum = 0x8B88;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BARRIER_BIT: types::GLenum = 0x00002000;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BLOCK: types::GLenum = 0x92E6;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BUFFER: types::GLenum = 0x90D2;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BUFFER_BINDING: types::GLenum = 0x90D3;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT: types::GLenum = 0x90DF;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BUFFER_SIZE: types::GLenum = 0x90D5;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_STORAGE_BUFFER_START: types::GLenum = 0x90D4;
#[allow(dead_code, non_upper_case_globals)] pub const SHADER_TYPE: types::GLenum = 0x8B4F;
#[allow(dead_code, non_upper_case_globals)] pub const SHADE_MODEL: types::GLenum = 0x0B54;
#[allow(dead_code, non_upper_case_globals)] pub const SHADING_LANGUAGE_VERSION: types::GLenum = 0x8B8C;
#[allow(dead_code, non_upper_case_globals)] pub const SHININESS: types::GLenum = 0x1601;
#[allow(dead_code, non_upper_case_globals)] pub const SHORT: types::GLenum = 0x1402;
#[allow(dead_code, non_upper_case_globals)] pub const SIGNALED: types::GLenum = 0x9119;
#[allow(dead_code, non_upper_case_globals)] pub const SIGNALED_APPLE: types::GLenum = 0x9119;
#[allow(dead_code, non_upper_case_globals)] pub const SIGNED_NORMALIZED: types::GLenum = 0x8F9C;
#[allow(dead_code, non_upper_case_globals)] pub const SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST: types::GLenum = 0x82AC;
#[allow(dead_code, non_upper_case_globals)] pub const SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE: types::GLenum = 0x82AE;
#[allow(dead_code, non_upper_case_globals)] pub const SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST: types::GLenum = 0x82AD;
#[allow(dead_code, non_upper_case_globals)] pub const SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE: types::GLenum = 0x82AF;
#[allow(dead_code, non_upper_case_globals)] pub const SINGLE_COLOR: types::GLenum = 0x81F9;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE: types::GLenum = 0x8C46;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE8: types::GLenum = 0x8C47;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE8_ALPHA8: types::GLenum = 0x8C45;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE8_ALPHA8_EXT: types::GLenum = 0x8C45;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE8_EXT: types::GLenum = 0x8C47;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE_ALPHA: types::GLenum = 0x8C44;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE_ALPHA_EXT: types::GLenum = 0x8C44;
#[allow(dead_code, non_upper_case_globals)] pub const SLUMINANCE_EXT: types::GLenum = 0x8C46;
#[allow(dead_code, non_upper_case_globals)] pub const SMOOTH: types::GLenum = 0x1D01;
#[allow(dead_code, non_upper_case_globals)] pub const SMOOTH_LINE_WIDTH_GRANULARITY: types::GLenum = 0x0B23;
#[allow(dead_code, non_upper_case_globals)] pub const SMOOTH_LINE_WIDTH_RANGE: types::GLenum = 0x0B22;
#[allow(dead_code, non_upper_case_globals)] pub const SMOOTH_POINT_SIZE_GRANULARITY: types::GLenum = 0x0B13;
#[allow(dead_code, non_upper_case_globals)] pub const SMOOTH_POINT_SIZE_RANGE: types::GLenum = 0x0B12;
#[allow(dead_code, non_upper_case_globals)] pub const SOFTLIGHT: types::GLenum = 0x929C;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE0_ALPHA: types::GLenum = 0x8588;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE0_RGB: types::GLenum = 0x8580;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE1_ALPHA: types::GLenum = 0x8589;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE1_RGB: types::GLenum = 0x8581;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE2_ALPHA: types::GLenum = 0x858A;
#[allow(dead_code, non_upper_case_globals)] pub const SOURCE2_RGB: types::GLenum = 0x8582;
#[allow(dead_code, non_upper_case_globals)] pub const SPECULAR: types::GLenum = 0x1202;
#[allow(dead_code, non_upper_case_globals)] pub const SPHERE_MAP: types::GLenum = 0x2402;
#[allow(dead_code, non_upper_case_globals)] pub const SPOT_CUTOFF: types::GLenum = 0x1206;
#[allow(dead_code, non_upper_case_globals)] pub const SPOT_DIRECTION: types::GLenum = 0x1204;
#[allow(dead_code, non_upper_case_globals)] pub const SPOT_EXPONENT: types::GLenum = 0x1205;
#[allow(dead_code, non_upper_case_globals)] pub const SRC0_ALPHA: types::GLenum = 0x8588;
#[allow(dead_code, non_upper_case_globals)] pub const SRC0_RGB: types::GLenum = 0x8580;
#[allow(dead_code, non_upper_case_globals)] pub const SRC1_ALPHA: types::GLenum = 0x8589;
#[allow(dead_code, non_upper_case_globals)] pub const SRC1_COLOR: types::GLenum = 0x88F9;
#[allow(dead_code, non_upper_case_globals)] pub const SRC1_RGB: types::GLenum = 0x8581;
#[allow(dead_code, non_upper_case_globals)] pub const SRC2_ALPHA: types::GLenum = 0x858A;
#[allow(dead_code, non_upper_case_globals)] pub const SRC2_RGB: types::GLenum = 0x8582;
#[allow(dead_code, non_upper_case_globals)] pub const SRC_ALPHA: types::GLenum = 0x0302;
#[allow(dead_code, non_upper_case_globals)] pub const SRC_ALPHA_SATURATE: types::GLenum = 0x0308;
#[allow(dead_code, non_upper_case_globals)] pub const SRC_COLOR: types::GLenum = 0x0300;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB: types::GLenum = 0x8C40;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB8: types::GLenum = 0x8C41;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB8_ALPHA8: types::GLenum = 0x8C43;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB8_ALPHA8_EXT: types::GLenum = 0x8C43;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB8_EXT: types::GLenum = 0x8C41;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB_ALPHA: types::GLenum = 0x8C42;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB_ALPHA_EXT: types::GLenum = 0x8C42;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB_EXT: types::GLenum = 0x8C40;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB_READ: types::GLenum = 0x8297;
#[allow(dead_code, non_upper_case_globals)] pub const SRGB_WRITE: types::GLenum = 0x8298;
#[allow(dead_code, non_upper_case_globals)] pub const STACK_OVERFLOW: types::GLenum = 0x0503;
#[allow(dead_code, non_upper_case_globals)] pub const STACK_OVERFLOW_KHR: types::GLenum = 0x0503;
#[allow(dead_code, non_upper_case_globals)] pub const STACK_UNDERFLOW: types::GLenum = 0x0504;
#[allow(dead_code, non_upper_case_globals)] pub const STACK_UNDERFLOW_KHR: types::GLenum = 0x0504;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_COPY: types::GLenum = 0x88E6;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_COPY_ARB: types::GLenum = 0x88E6;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_DRAW: types::GLenum = 0x88E4;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_DRAW_ARB: types::GLenum = 0x88E4;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_READ: types::GLenum = 0x88E5;
#[allow(dead_code, non_upper_case_globals)] pub const STATIC_READ_ARB: types::GLenum = 0x88E5;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL: types::GLenum = 0x1802;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_ATTACHMENT: types::GLenum = 0x8D20;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_ATTACHMENT_EXT: types::GLenum = 0x8D20;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_FAIL: types::GLenum = 0x8801;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_FUNC: types::GLenum = 0x8800;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_PASS_DEPTH_FAIL: types::GLenum = 0x8802;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_PASS_DEPTH_PASS: types::GLenum = 0x8803;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_REF: types::GLenum = 0x8CA3;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_VALUE_MASK: types::GLenum = 0x8CA4;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BACK_WRITEMASK: types::GLenum = 0x8CA5;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BITS: types::GLenum = 0x0D57;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_BUFFER_BIT: types::GLenum = 0x00000400;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_CLEAR_VALUE: types::GLenum = 0x0B91;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_COMPONENTS: types::GLenum = 0x8285;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_FAIL: types::GLenum = 0x0B94;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_FUNC: types::GLenum = 0x0B92;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX: types::GLenum = 0x1901;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX1: types::GLenum = 0x8D46;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX16: types::GLenum = 0x8D49;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX16_EXT: types::GLenum = 0x8D49;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX1_EXT: types::GLenum = 0x8D46;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX4: types::GLenum = 0x8D47;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX4_EXT: types::GLenum = 0x8D47;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX8: types::GLenum = 0x8D48;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_INDEX8_EXT: types::GLenum = 0x8D48;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_PASS_DEPTH_FAIL: types::GLenum = 0x0B95;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_PASS_DEPTH_PASS: types::GLenum = 0x0B96;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_REF: types::GLenum = 0x0B97;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_RENDERABLE: types::GLenum = 0x8288;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_TEST: types::GLenum = 0x0B90;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_VALUE_MASK: types::GLenum = 0x0B93;
#[allow(dead_code, non_upper_case_globals)] pub const STENCIL_WRITEMASK: types::GLenum = 0x0B98;
#[allow(dead_code, non_upper_case_globals)] pub const STEREO: types::GLenum = 0x0C33;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_COPY: types::GLenum = 0x88E2;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_COPY_ARB: types::GLenum = 0x88E2;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_DRAW: types::GLenum = 0x88E0;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_DRAW_ARB: types::GLenum = 0x88E0;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_READ: types::GLenum = 0x88E1;
#[allow(dead_code, non_upper_case_globals)] pub const STREAM_READ_ARB: types::GLenum = 0x88E1;
#[allow(dead_code, non_upper_case_globals)] pub const SUBPIXEL_BITS: types::GLenum = 0x0D50;
#[allow(dead_code, non_upper_case_globals)] pub const SUBTRACT: types::GLenum = 0x84E7;
#[allow(dead_code, non_upper_case_globals)] pub const SUPERSAMPLE_SCALE_X_NV: types::GLenum = 0x9372;
#[allow(dead_code, non_upper_case_globals)] pub const SUPERSAMPLE_SCALE_Y_NV: types::GLenum = 0x9373;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_CONDITION: types::GLenum = 0x9113;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_CONDITION_APPLE: types::GLenum = 0x9113;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FENCE: types::GLenum = 0x9116;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FENCE_APPLE: types::GLenum = 0x9116;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FLAGS: types::GLenum = 0x9115;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FLAGS_APPLE: types::GLenum = 0x9115;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FLUSH_COMMANDS_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_FLUSH_COMMANDS_BIT_APPLE: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_GPU_COMMANDS_COMPLETE: types::GLenum = 0x9117;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_GPU_COMMANDS_COMPLETE_APPLE: types::GLenum = 0x9117;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_OBJECT_APPLE: types::GLenum = 0x8A53;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_STATUS: types::GLenum = 0x9114;
#[allow(dead_code, non_upper_case_globals)] pub const SYNC_STATUS_APPLE: types::GLenum = 0x9114;
#[allow(dead_code, non_upper_case_globals)] pub const T: types::GLenum = 0x2001;
#[allow(dead_code, non_upper_case_globals)] pub const T2F_C3F_V3F: types::GLenum = 0x2A2A;
#[allow(dead_code, non_upper_case_globals)] pub const T2F_C4F_N3F_V3F: types::GLenum = 0x2A2C;
#[allow(dead_code, non_upper_case_globals)] pub const T2F_C4UB_V3F: types::GLenum = 0x2A29;
#[allow(dead_code, non_upper_case_globals)] pub const T2F_N3F_V3F: types::GLenum = 0x2A2B;
#[allow(dead_code, non_upper_case_globals)] pub const T2F_V3F: types::GLenum = 0x2A27;
#[allow(dead_code, non_upper_case_globals)] pub const T4F_C4F_N3F_V4F: types::GLenum = 0x2A2D;
#[allow(dead_code, non_upper_case_globals)] pub const T4F_V4F: types::GLenum = 0x2A28;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_OUTPUT_VERTICES: types::GLenum = 0x8E75;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_SHADER: types::GLenum = 0x8E88;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_SHADER_BIT: types::GLenum = 0x00000008;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_SUBROUTINE: types::GLenum = 0x92E9;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_SUBROUTINE_UNIFORM: types::GLenum = 0x92EF;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_CONTROL_TEXTURE: types::GLenum = 0x829C;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_EVALUATION_SHADER: types::GLenum = 0x8E87;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_EVALUATION_SHADER_BIT: types::GLenum = 0x00000010;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_EVALUATION_SUBROUTINE: types::GLenum = 0x92EA;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_EVALUATION_SUBROUTINE_UNIFORM: types::GLenum = 0x92F0;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_EVALUATION_TEXTURE: types::GLenum = 0x829D;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_GEN_MODE: types::GLenum = 0x8E76;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_GEN_POINT_MODE: types::GLenum = 0x8E79;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_GEN_SPACING: types::GLenum = 0x8E77;
#[allow(dead_code, non_upper_case_globals)] pub const TESS_GEN_VERTEX_ORDER: types::GLenum = 0x8E78;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE: types::GLenum = 0x1702;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE0: types::GLenum = 0x84C0;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE1: types::GLenum = 0x84C1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE10: types::GLenum = 0x84CA;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE11: types::GLenum = 0x84CB;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE12: types::GLenum = 0x84CC;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE13: types::GLenum = 0x84CD;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE14: types::GLenum = 0x84CE;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE15: types::GLenum = 0x84CF;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE16: types::GLenum = 0x84D0;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE17: types::GLenum = 0x84D1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE18: types::GLenum = 0x84D2;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE19: types::GLenum = 0x84D3;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE2: types::GLenum = 0x84C2;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE20: types::GLenum = 0x84D4;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE21: types::GLenum = 0x84D5;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE22: types::GLenum = 0x84D6;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE23: types::GLenum = 0x84D7;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE24: types::GLenum = 0x84D8;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE25: types::GLenum = 0x84D9;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE26: types::GLenum = 0x84DA;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE27: types::GLenum = 0x84DB;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE28: types::GLenum = 0x84DC;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE29: types::GLenum = 0x84DD;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE3: types::GLenum = 0x84C3;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE30: types::GLenum = 0x84DE;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE31: types::GLenum = 0x84DF;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE4: types::GLenum = 0x84C4;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE5: types::GLenum = 0x84C5;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE6: types::GLenum = 0x84C6;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE7: types::GLenum = 0x84C7;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE8: types::GLenum = 0x84C8;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE9: types::GLenum = 0x84C9;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_1D: types::GLenum = 0x0DE0;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_1D_ARRAY: types::GLenum = 0x8C18;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_1D_ARRAY_EXT: types::GLenum = 0x8C18;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_2D: types::GLenum = 0x0DE1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_2D_ARRAY: types::GLenum = 0x8C1A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_2D_ARRAY_EXT: types::GLenum = 0x8C1A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_2D_MULTISAMPLE: types::GLenum = 0x9100;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x9102;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_3D: types::GLenum = 0x806F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ALPHA_SIZE: types::GLenum = 0x805F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ALPHA_TYPE: types::GLenum = 0x8C13;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ALPHA_TYPE_ARB: types::GLenum = 0x8C13;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BASE_LEVEL: types::GLenum = 0x813C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_1D: types::GLenum = 0x8068;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_1D_ARRAY: types::GLenum = 0x8C1C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_1D_ARRAY_EXT: types::GLenum = 0x8C1C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_2D: types::GLenum = 0x8069;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_2D_ARRAY: types::GLenum = 0x8C1D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_2D_ARRAY_EXT: types::GLenum = 0x8C1D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_2D_MULTISAMPLE: types::GLenum = 0x9104;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x9105;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_3D: types::GLenum = 0x806A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_BUFFER: types::GLenum = 0x8C2C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_BUFFER_ARB: types::GLenum = 0x8C2C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_BUFFER_EXT: types::GLenum = 0x8C2C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_BUFFER_OES: types::GLenum = 0x8C2C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_CUBE_MAP: types::GLenum = 0x8514;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_CUBE_MAP_ARRAY: types::GLenum = 0x900A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BINDING_RECTANGLE: types::GLenum = 0x84F6;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BIT: types::GLenum = 0x00040000;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BLUE_SIZE: types::GLenum = 0x805E;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BLUE_TYPE: types::GLenum = 0x8C12;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BLUE_TYPE_ARB: types::GLenum = 0x8C12;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BORDER: types::GLenum = 0x1005;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BORDER_COLOR: types::GLenum = 0x1004;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_ARB: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_BINDING: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_BINDING_OES: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_DATA_STORE_BINDING: types::GLenum = 0x8C2D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_DATA_STORE_BINDING_ARB: types::GLenum = 0x8C2D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_DATA_STORE_BINDING_EXT: types::GLenum = 0x8C2D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_DATA_STORE_BINDING_OES: types::GLenum = 0x8C2D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_EXT: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_FORMAT_ARB: types::GLenum = 0x8C2E;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_FORMAT_EXT: types::GLenum = 0x8C2E;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_OES: types::GLenum = 0x8C2A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_OFFSET: types::GLenum = 0x919D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_OFFSET_ALIGNMENT: types::GLenum = 0x919F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_OFFSET_ALIGNMENT_OES: types::GLenum = 0x919F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_OFFSET_OES: types::GLenum = 0x919D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_SIZE: types::GLenum = 0x919E;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_BUFFER_SIZE_OES: types::GLenum = 0x919E;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPARE_FUNC: types::GLenum = 0x884D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPARE_MODE: types::GLenum = 0x884C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPONENTS: types::GLenum = 0x1003;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSED: types::GLenum = 0x86A1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSED_BLOCK_HEIGHT: types::GLenum = 0x82B2;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSED_BLOCK_SIZE: types::GLenum = 0x82B3;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSED_BLOCK_WIDTH: types::GLenum = 0x82B1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSED_IMAGE_SIZE: types::GLenum = 0x86A0;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COMPRESSION_HINT: types::GLenum = 0x84EF;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY: types::GLenum = 0x8078;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_BUFFER_BINDING: types::GLenum = 0x889A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_POINTER: types::GLenum = 0x8092;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_SIZE: types::GLenum = 0x8088;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_STRIDE: types::GLenum = 0x808A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_COORD_ARRAY_TYPE: types::GLenum = 0x8089;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP: types::GLenum = 0x8513;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_ARRAY: types::GLenum = 0x9009;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_NEGATIVE_X: types::GLenum = 0x8516;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_NEGATIVE_Y: types::GLenum = 0x8518;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_NEGATIVE_Z: types::GLenum = 0x851A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_POSITIVE_X: types::GLenum = 0x8515;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_POSITIVE_Y: types::GLenum = 0x8517;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_POSITIVE_Z: types::GLenum = 0x8519;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_CUBE_MAP_SEAMLESS: types::GLenum = 0x884F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_DEPTH: types::GLenum = 0x8071;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_DEPTH_SIZE: types::GLenum = 0x884A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_DEPTH_SIZE_ARB: types::GLenum = 0x884A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_DEPTH_TYPE: types::GLenum = 0x8C16;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_DEPTH_TYPE_ARB: types::GLenum = 0x8C16;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ENV: types::GLenum = 0x2300;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ENV_COLOR: types::GLenum = 0x2201;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_ENV_MODE: types::GLenum = 0x2200;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_FETCH_BARRIER_BIT: types::GLenum = 0x00000008;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_FILTER_CONTROL: types::GLenum = 0x8500;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_FIXED_SAMPLE_LOCATIONS: types::GLenum = 0x9107;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_FREE_MEMORY_ATI: types::GLenum = 0x87FC;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GATHER: types::GLenum = 0x82A2;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GATHER_SHADOW: types::GLenum = 0x82A3;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GEN_MODE: types::GLenum = 0x2500;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GEN_Q: types::GLenum = 0x0C63;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GEN_R: types::GLenum = 0x0C62;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GEN_S: types::GLenum = 0x0C60;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GEN_T: types::GLenum = 0x0C61;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GREEN_SIZE: types::GLenum = 0x805D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GREEN_TYPE: types::GLenum = 0x8C11;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_GREEN_TYPE_ARB: types::GLenum = 0x8C11;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_HEIGHT: types::GLenum = 0x1001;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_IMAGE_FORMAT: types::GLenum = 0x828F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_IMAGE_TYPE: types::GLenum = 0x8290;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_IMMUTABLE_FORMAT: types::GLenum = 0x912F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_IMMUTABLE_LEVELS: types::GLenum = 0x82DF;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_INTENSITY_SIZE: types::GLenum = 0x8061;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_INTENSITY_TYPE: types::GLenum = 0x8C15;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_INTENSITY_TYPE_ARB: types::GLenum = 0x8C15;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_INTERNAL_FORMAT: types::GLenum = 0x1003;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_LOD_BIAS: types::GLenum = 0x8501;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_LUMINANCE_SIZE: types::GLenum = 0x8060;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_LUMINANCE_TYPE: types::GLenum = 0x8C14;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_LUMINANCE_TYPE_ARB: types::GLenum = 0x8C14;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MAG_FILTER: types::GLenum = 0x2800;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MATRIX: types::GLenum = 0x0BA8;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MAX_ANISOTROPY_EXT: types::GLenum = 0x84FE;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MAX_LEVEL: types::GLenum = 0x813D;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MAX_LOD: types::GLenum = 0x813B;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MIN_FILTER: types::GLenum = 0x2801;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_MIN_LOD: types::GLenum = 0x813A;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_PRIORITY: types::GLenum = 0x8066;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_RECTANGLE: types::GLenum = 0x84F5;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_RED_SIZE: types::GLenum = 0x805C;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_RED_TYPE: types::GLenum = 0x8C10;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_RED_TYPE_ARB: types::GLenum = 0x8C10;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_RESIDENT: types::GLenum = 0x8067;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SAMPLES: types::GLenum = 0x9106;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SHADOW: types::GLenum = 0x82A1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SHARED_SIZE: types::GLenum = 0x8C3F;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_STACK_DEPTH: types::GLenum = 0x0BA5;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_STENCIL_SIZE: types::GLenum = 0x88F1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_STENCIL_SIZE_EXT: types::GLenum = 0x88F1;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SWIZZLE_A: types::GLenum = 0x8E45;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SWIZZLE_B: types::GLenum = 0x8E44;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SWIZZLE_G: types::GLenum = 0x8E43;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SWIZZLE_R: types::GLenum = 0x8E42;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_SWIZZLE_RGBA: types::GLenum = 0x8E46;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_TARGET: types::GLenum = 0x1006;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_UPDATE_BARRIER_BIT: types::GLenum = 0x00000100;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_VIEW: types::GLenum = 0x82B5;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_VIEW_MIN_LAYER: types::GLenum = 0x82DD;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_VIEW_MIN_LEVEL: types::GLenum = 0x82DB;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_VIEW_NUM_LAYERS: types::GLenum = 0x82DE;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_VIEW_NUM_LEVELS: types::GLenum = 0x82DC;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_WIDTH: types::GLenum = 0x1000;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_WRAP_R: types::GLenum = 0x8072;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_WRAP_S: types::GLenum = 0x2802;
#[allow(dead_code, non_upper_case_globals)] pub const TEXTURE_WRAP_T: types::GLenum = 0x2803;
#[allow(dead_code, non_upper_case_globals)] pub const TIMEOUT_EXPIRED: types::GLenum = 0x911B;
#[allow(dead_code, non_upper_case_globals)] pub const TIMEOUT_EXPIRED_APPLE: types::GLenum = 0x911B;
#[allow(dead_code, non_upper_case_globals)] pub const TIMEOUT_IGNORED: types::GLuint64 = 0xFFFFFFFFFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const TIMEOUT_IGNORED_APPLE: types::GLuint64 = 0xFFFFFFFFFFFFFFFF;
#[allow(dead_code, non_upper_case_globals)] pub const TIMESTAMP: types::GLenum = 0x8E28;
#[allow(dead_code, non_upper_case_globals)] pub const TIMESTAMP_EXT: types::GLenum = 0x8E28;
#[allow(dead_code, non_upper_case_globals)] pub const TIME_ELAPSED: types::GLenum = 0x88BF;
#[allow(dead_code, non_upper_case_globals)] pub const TIME_ELAPSED_EXT: types::GLenum = 0x88BF;
#[allow(dead_code, non_upper_case_globals)] pub const TOP_LEVEL_ARRAY_SIZE: types::GLenum = 0x930C;
#[allow(dead_code, non_upper_case_globals)] pub const TOP_LEVEL_ARRAY_STRIDE: types::GLenum = 0x930D;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_BIT: types::GLenum = 0x00001000;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK: types::GLenum = 0x8E22;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_ACTIVE: types::GLenum = 0x8E24;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BARRIER_BIT: types::GLenum = 0x00000800;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BINDING: types::GLenum = 0x8E25;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER: types::GLenum = 0x8C8E;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_ACTIVE: types::GLenum = 0x8E24;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_BINDING: types::GLenum = 0x8C8F;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT: types::GLenum = 0x8C8F;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_EXT: types::GLenum = 0x8C8E;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_INDEX: types::GLenum = 0x934B;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_MODE: types::GLenum = 0x8C7F;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_MODE_EXT: types::GLenum = 0x8C7F;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_PAUSED: types::GLenum = 0x8E23;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_SIZE: types::GLenum = 0x8C85;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT: types::GLenum = 0x8C85;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_START: types::GLenum = 0x8C84;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_START_EXT: types::GLenum = 0x8C84;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_BUFFER_STRIDE: types::GLenum = 0x934C;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_PAUSED: types::GLenum = 0x8E23;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN: types::GLenum = 0x8C88;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT: types::GLenum = 0x8C88;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_VARYING: types::GLenum = 0x92F4;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_VARYINGS: types::GLenum = 0x8C83;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_VARYINGS_EXT: types::GLenum = 0x8C83;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH: types::GLenum = 0x8C76;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT: types::GLenum = 0x8C76;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSPOSE_COLOR_MATRIX: types::GLenum = 0x84E6;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSPOSE_MODELVIEW_MATRIX: types::GLenum = 0x84E3;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSPOSE_PROGRAM_MATRIX_EXT: types::GLenum = 0x8E2E;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSPOSE_PROJECTION_MATRIX: types::GLenum = 0x84E4;
#[allow(dead_code, non_upper_case_globals)] pub const TRANSPOSE_TEXTURE_MATRIX: types::GLenum = 0x84E5;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLES: types::GLenum = 0x0004;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLES_ADJACENCY: types::GLenum = 0x000C;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLES_ADJACENCY_ARB: types::GLenum = 0x000C;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLE_FAN: types::GLenum = 0x0006;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLE_STRIP: types::GLenum = 0x0005;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLE_STRIP_ADJACENCY: types::GLenum = 0x000D;
#[allow(dead_code, non_upper_case_globals)] pub const TRIANGLE_STRIP_ADJACENCY_ARB: types::GLenum = 0x000D;
#[allow(dead_code, non_upper_case_globals)] pub const TRUE: types::GLboolean = 1;
#[allow(dead_code, non_upper_case_globals)] pub const TYPE: types::GLenum = 0x92FA;
#[allow(dead_code, non_upper_case_globals)] pub const UNDEFINED_VERTEX: types::GLenum = 0x8260;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM: types::GLenum = 0x92E1;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_ARRAY_STRIDE: types::GLenum = 0x8A3C;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX: types::GLenum = 0x92DA;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BARRIER_BIT: types::GLenum = 0x00000004;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK: types::GLenum = 0x92E2;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_ACTIVE_UNIFORMS: types::GLenum = 0x8A42;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES: types::GLenum = 0x8A43;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_BINDING: types::GLenum = 0x8A3F;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_DATA_SIZE: types::GLenum = 0x8A40;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_INDEX: types::GLenum = 0x8A3A;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_NAME_LENGTH: types::GLenum = 0x8A41;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER: types::GLenum = 0x90EC;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER: types::GLenum = 0x8A46;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER: types::GLenum = 0x8A45;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER: types::GLenum = 0x84F0;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER: types::GLenum = 0x84F1;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER: types::GLenum = 0x8A44;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BUFFER: types::GLenum = 0x8A11;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BUFFER_BINDING: types::GLenum = 0x8A28;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BUFFER_OFFSET_ALIGNMENT: types::GLenum = 0x8A34;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BUFFER_SIZE: types::GLenum = 0x8A2A;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_BUFFER_START: types::GLenum = 0x8A29;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_IS_ROW_MAJOR: types::GLenum = 0x8A3E;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_MATRIX_STRIDE: types::GLenum = 0x8A3D;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_NAME_LENGTH: types::GLenum = 0x8A39;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_OFFSET: types::GLenum = 0x8A3B;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_SIZE: types::GLenum = 0x8A38;
#[allow(dead_code, non_upper_case_globals)] pub const UNIFORM_TYPE: types::GLenum = 0x8A37;
#[allow(dead_code, non_upper_case_globals)] pub const UNKNOWN_CONTEXT_RESET: types::GLenum = 0x8255;
#[allow(dead_code, non_upper_case_globals)] pub const UNKNOWN_CONTEXT_RESET_ARB: types::GLenum = 0x8255;
#[allow(dead_code, non_upper_case_globals)] pub const UNKNOWN_CONTEXT_RESET_EXT: types::GLenum = 0x8255;
#[allow(dead_code, non_upper_case_globals)] pub const UNKNOWN_CONTEXT_RESET_KHR: types::GLenum = 0x8255;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_ALIGNMENT: types::GLenum = 0x0CF5;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_COMPRESSED_BLOCK_DEPTH: types::GLenum = 0x9129;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_COMPRESSED_BLOCK_HEIGHT: types::GLenum = 0x9128;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_COMPRESSED_BLOCK_SIZE: types::GLenum = 0x912A;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_COMPRESSED_BLOCK_WIDTH: types::GLenum = 0x9127;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_IMAGE_HEIGHT: types::GLenum = 0x806E;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_LSB_FIRST: types::GLenum = 0x0CF1;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_ROW_LENGTH: types::GLenum = 0x0CF2;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_SKIP_IMAGES: types::GLenum = 0x806D;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_SKIP_PIXELS: types::GLenum = 0x0CF4;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_SKIP_ROWS: types::GLenum = 0x0CF3;
#[allow(dead_code, non_upper_case_globals)] pub const UNPACK_SWAP_BYTES: types::GLenum = 0x0CF0;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNALED: types::GLenum = 0x9118;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNALED_APPLE: types::GLenum = 0x9118;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_BYTE: types::GLenum = 0x1401;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_BYTE_2_3_3_REV: types::GLenum = 0x8362;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_BYTE_3_3_2: types::GLenum = 0x8032;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT: types::GLenum = 0x1405;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT64_ARB: types::GLenum = 0x140F;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT64_NV: types::GLenum = 0x140F;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT64_VEC2_ARB: types::GLenum = 0x8FF5;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT64_VEC3_ARB: types::GLenum = 0x8FF6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT64_VEC4_ARB: types::GLenum = 0x8FF7;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_10F_11F_11F_REV: types::GLenum = 0x8C3B;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_10_10_10_2: types::GLenum = 0x8036;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_10_10_10_2_OES: types::GLenum = 0x8DF6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_24_8: types::GLenum = 0x84FA;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_24_8_EXT: types::GLenum = 0x84FA;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_24_8_OES: types::GLenum = 0x84FA;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_2_10_10_10_REV: types::GLenum = 0x8368;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_5_9_9_9_REV: types::GLenum = 0x8C3E;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_8_8_8_8: types::GLenum = 0x8035;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_8_8_8_8_REV: types::GLenum = 0x8367;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_ATOMIC_COUNTER: types::GLenum = 0x92DB;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_1D: types::GLenum = 0x9062;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_1D_ARRAY: types::GLenum = 0x9068;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_2D: types::GLenum = 0x9063;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_2D_ARRAY: types::GLenum = 0x9069;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_2D_MULTISAMPLE: types::GLenum = 0x906B;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x906C;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_2D_RECT: types::GLenum = 0x9065;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_3D: types::GLenum = 0x9064;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_BUFFER: types::GLenum = 0x9067;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_BUFFER_OES: types::GLenum = 0x9067;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_CUBE: types::GLenum = 0x9066;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY: types::GLenum = 0x906A;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_1D: types::GLenum = 0x8DD1;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_1D_ARRAY: types::GLenum = 0x8DD6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT: types::GLenum = 0x8DD6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_1D_EXT: types::GLenum = 0x8DD1;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D: types::GLenum = 0x8DD2;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_ARRAY: types::GLenum = 0x8DD7;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT: types::GLenum = 0x8DD7;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_EXT: types::GLenum = 0x8DD2;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE: types::GLenum = 0x910A;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: types::GLenum = 0x910D;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_RECT: types::GLenum = 0x8DD5;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_2D_RECT_EXT: types::GLenum = 0x8DD5;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_3D: types::GLenum = 0x8DD3;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_3D_EXT: types::GLenum = 0x8DD3;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_BUFFER: types::GLenum = 0x8DD8;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_BUFFER_EXT: types::GLenum = 0x8DD8;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_BUFFER_OES: types::GLenum = 0x8DD8;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_CUBE: types::GLenum = 0x8DD4;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_CUBE_EXT: types::GLenum = 0x8DD4;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY: types::GLenum = 0x900F;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC2: types::GLenum = 0x8DC6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC2_EXT: types::GLenum = 0x8DC6;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC3: types::GLenum = 0x8DC7;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC3_EXT: types::GLenum = 0x8DC7;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC4: types::GLenum = 0x8DC8;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_INT_VEC4_EXT: types::GLenum = 0x8DC8;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_NORMALIZED: types::GLenum = 0x8C17;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_NORMALIZED_ARB: types::GLenum = 0x8C17;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT: types::GLenum = 0x1403;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_1_5_5_5_REV: types::GLenum = 0x8366;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_4_4_4_4: types::GLenum = 0x8033;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_4_4_4_4_REV: types::GLenum = 0x8365;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_5_5_5_1: types::GLenum = 0x8034;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_5_6_5: types::GLenum = 0x8363;
#[allow(dead_code, non_upper_case_globals)] pub const UNSIGNED_SHORT_5_6_5_REV: types::GLenum = 0x8364;
#[allow(dead_code, non_upper_case_globals)] pub const UPPER_LEFT: types::GLenum = 0x8CA2;
#[allow(dead_code, non_upper_case_globals)] pub const V2F: types::GLenum = 0x2A20;
#[allow(dead_code, non_upper_case_globals)] pub const V3F: types::GLenum = 0x2A21;
#[allow(dead_code, non_upper_case_globals)] pub const VALIDATE_STATUS: types::GLenum = 0x8B83;
#[allow(dead_code, non_upper_case_globals)] pub const VBO_FREE_MEMORY_ATI: types::GLenum = 0x87FB;
#[allow(dead_code, non_upper_case_globals)] pub const VENDOR: types::GLenum = 0x1F00;
#[allow(dead_code, non_upper_case_globals)] pub const VERSION: types::GLenum = 0x1F02;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY: types::GLenum = 0x8074;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_BINDING: types::GLenum = 0x85B5;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_BINDING_APPLE: types::GLenum = 0x85B5;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_BINDING_OES: types::GLenum = 0x85B5;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_BUFFER_BINDING: types::GLenum = 0x8896;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x8896;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_KHR: types::GLenum = 0x8074;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_POINTER: types::GLenum = 0x808E;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_SIZE: types::GLenum = 0x807A;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_STRIDE: types::GLenum = 0x807C;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ARRAY_TYPE: types::GLenum = 0x807B;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_BARRIER_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: types::GLenum = 0x889F;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889F;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_DIVISOR: types::GLenum = 0x88FE;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_ENABLED: types::GLenum = 0x8622;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_ENABLED_ARB: types::GLenum = 0x8622;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_INTEGER: types::GLenum = 0x88FD;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_INTEGER_EXT: types::GLenum = 0x88FD;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_LONG: types::GLenum = 0x874E;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_NORMALIZED: types::GLenum = 0x886A;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB: types::GLenum = 0x886A;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_POINTER: types::GLenum = 0x8645;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_POINTER_ARB: types::GLenum = 0x8645;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_SIZE: types::GLenum = 0x8623;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_SIZE_ARB: types::GLenum = 0x8623;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_STRIDE: types::GLenum = 0x8624;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_STRIDE_ARB: types::GLenum = 0x8624;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_TYPE: types::GLenum = 0x8625;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_ARRAY_TYPE_ARB: types::GLenum = 0x8625;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_BINDING: types::GLenum = 0x82D4;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_ATTRIB_RELATIVE_OFFSET: types::GLenum = 0x82D5;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_BINDING_BUFFER: types::GLenum = 0x8F4F;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_BINDING_DIVISOR: types::GLenum = 0x82D6;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_BINDING_OFFSET: types::GLenum = 0x82D7;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_BINDING_STRIDE: types::GLenum = 0x82D8;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_PROGRAM_POINT_SIZE: types::GLenum = 0x8642;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_PROGRAM_POINT_SIZE_ARB: types::GLenum = 0x8642;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_PROGRAM_TWO_SIDE: types::GLenum = 0x8643;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_PROGRAM_TWO_SIDE_ARB: types::GLenum = 0x8643;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_SHADER: types::GLenum = 0x8B31;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_SHADER_ARB: types::GLenum = 0x8B31;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_SHADER_BIT: types::GLenum = 0x00000001;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_SUBROUTINE: types::GLenum = 0x92E8;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_SUBROUTINE_UNIFORM: types::GLenum = 0x92EE;
#[allow(dead_code, non_upper_case_globals)] pub const VERTEX_TEXTURE: types::GLenum = 0x829B;
#[allow(dead_code, non_upper_case_globals)] pub const VIEWPORT: types::GLenum = 0x0BA2;
#[allow(dead_code, non_upper_case_globals)] pub const VIEWPORT_BIT: types::GLenum = 0x00000800;
#[allow(dead_code, non_upper_case_globals)] pub const VIEWPORT_BOUNDS_RANGE: types::GLenum = 0x825D;
#[allow(dead_code, non_upper_case_globals)] pub const VIEWPORT_INDEX_PROVOKING_VERTEX: types::GLenum = 0x825F;
#[allow(dead_code, non_upper_case_globals)] pub const VIEWPORT_SUBPIXEL_BITS: types::GLenum = 0x825C;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_128_BITS: types::GLenum = 0x82C4;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_16_BITS: types::GLenum = 0x82CA;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_24_BITS: types::GLenum = 0x82C9;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_32_BITS: types::GLenum = 0x82C8;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_48_BITS: types::GLenum = 0x82C7;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_64_BITS: types::GLenum = 0x82C6;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_8_BITS: types::GLenum = 0x82CB;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_96_BITS: types::GLenum = 0x82C5;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_BPTC_FLOAT: types::GLenum = 0x82D3;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_BPTC_UNORM: types::GLenum = 0x82D2;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_RGTC1_RED: types::GLenum = 0x82D0;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_RGTC2_RG: types::GLenum = 0x82D1;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_S3TC_DXT1_RGB: types::GLenum = 0x82CC;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_S3TC_DXT1_RGBA: types::GLenum = 0x82CD;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_S3TC_DXT3_RGBA: types::GLenum = 0x82CE;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_CLASS_S3TC_DXT5_RGBA: types::GLenum = 0x82CF;
#[allow(dead_code, non_upper_case_globals)] pub const VIEW_COMPATIBILITY_CLASS: types::GLenum = 0x82B6;
#[allow(dead_code, non_upper_case_globals)] pub const WAIT_FAILED: types::GLenum = 0x911D;
#[allow(dead_code, non_upper_case_globals)] pub const WAIT_FAILED_APPLE: types::GLenum = 0x911D;
#[allow(dead_code, non_upper_case_globals)] pub const WEIGHT_ARRAY_BUFFER_BINDING: types::GLenum = 0x889E;
#[allow(dead_code, non_upper_case_globals)] pub const WEIGHT_ARRAY_BUFFER_BINDING_ARB: types::GLenum = 0x889E;
#[allow(dead_code, non_upper_case_globals)] pub const WRITE_ONLY: types::GLenum = 0x88B9;
#[allow(dead_code, non_upper_case_globals)] pub const WRITE_ONLY_ARB: types::GLenum = 0x88B9;
#[allow(dead_code, non_upper_case_globals)] pub const XOR: types::GLenum = 0x1506;
#[allow(dead_code, non_upper_case_globals)] pub const ZERO: types::GLenum = 0;
#[allow(dead_code, non_upper_case_globals)] pub const ZERO_TO_ONE: types::GLenum = 0x935F;
#[allow(dead_code, non_upper_case_globals)] pub const ZOOM_X: types::GLenum = 0x0D16;
#[allow(dead_code, non_upper_case_globals)] pub const ZOOM_Y: types::GLenum = 0x0D17;

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Accum(op: types::GLenum, value: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::Accum.pf)(op, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ActiveShaderProgram(pipeline: types::GLuint, program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::ActiveShaderProgram.pf)(pipeline, program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ActiveTexture(texture: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ActiveTexture.pf)(texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn AlphaFunc(func: types::GLenum, ref_: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::AlphaFunc.pf)(func, ref_)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn AreTexturesResident(n: types::GLsizei, textures: *const types::GLuint, residences: *mut types::GLboolean) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint, *mut types::GLboolean) -> types::GLboolean>
                    (*storage::AreTexturesResident.pf)(n, textures, residences)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ArrayElement(i: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint) -> ()>
                    (*storage::ArrayElement.pf)(i)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn AttachObjectARB(containerObj: types::GLhandleARB, obj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLhandleARB) -> ()>
                    (*storage::AttachObjectARB.pf)(containerObj, obj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn AttachShader(program: types::GLuint, shader: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::AttachShader.pf)(program, shader)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Begin(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::Begin.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginConditionalRender(id: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::BeginConditionalRender.pf)(id, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginConditionalRenderNV(id: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::BeginConditionalRenderNV.pf)(id, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginQuery(target: types::GLenum, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BeginQuery.pf)(target, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginQueryARB(target: types::GLenum, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BeginQueryARB.pf)(target, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginQueryEXT(target: types::GLenum, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BeginQueryEXT.pf)(target, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginQueryIndexed(target: types::GLenum, index: types::GLuint, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint) -> ()>
                    (*storage::BeginQueryIndexed.pf)(target, index, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginTransformFeedback(primitiveMode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::BeginTransformFeedback.pf)(primitiveMode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BeginTransformFeedbackEXT(primitiveMode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::BeginTransformFeedbackEXT.pf)(primitiveMode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindAttribLocation(program: types::GLuint, index: types::GLuint, name: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, *const types::GLchar) -> ()>
                    (*storage::BindAttribLocation.pf)(program, index, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindAttribLocationARB(programObj: types::GLhandleARB, index: types::GLuint, name: *const types::GLcharARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLuint, *const types::GLcharARB) -> ()>
                    (*storage::BindAttribLocationARB.pf)(programObj, index, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBuffer(target: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindBuffer.pf)(target, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferARB(target: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindBufferARB.pf)(target, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferBase(target: types::GLenum, index: types::GLuint, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint) -> ()>
                    (*storage::BindBufferBase.pf)(target, index, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferBaseEXT(target: types::GLenum, index: types::GLuint, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint) -> ()>
                    (*storage::BindBufferBaseEXT.pf)(target, index, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferOffsetEXT(target: types::GLenum, index: types::GLuint, buffer: types::GLuint, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLintptr) -> ()>
                    (*storage::BindBufferOffsetEXT.pf)(target, index, buffer, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferRange(target: types::GLenum, index: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::BindBufferRange.pf)(target, index, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBufferRangeEXT(target: types::GLenum, index: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::BindBufferRangeEXT.pf)(target, index, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBuffersBase(target: types::GLenum, first: types::GLuint, count: types::GLsizei, buffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::BindBuffersBase.pf)(target, first, count, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindBuffersRange(target: types::GLenum, first: types::GLuint, count: types::GLsizei, buffers: *const types::GLuint, offsets: *const types::GLintptr, sizes: *const types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLuint, *const types::GLintptr, *const types::GLsizeiptr) -> ()>
                    (*storage::BindBuffersRange.pf)(target, first, count, buffers, offsets, sizes)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindFragDataLocation(program: types::GLuint, color: types::GLuint, name: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, *const types::GLchar) -> ()>
                    (*storage::BindFragDataLocation.pf)(program, color, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindFragDataLocationEXT(program: types::GLuint, color: types::GLuint, name: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, *const types::GLchar) -> ()>
                    (*storage::BindFragDataLocationEXT.pf)(program, color, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindFragDataLocationIndexed(program: types::GLuint, colorNumber: types::GLuint, index: types::GLuint, name: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, *const types::GLchar) -> ()>
                    (*storage::BindFragDataLocationIndexed.pf)(program, colorNumber, index, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindFramebuffer(target: types::GLenum, framebuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindFramebuffer.pf)(target, framebuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindFramebufferEXT(target: types::GLenum, framebuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindFramebufferEXT.pf)(target, framebuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindImageTexture(unit: types::GLuint, texture: types::GLuint, level: types::GLint, layered: types::GLboolean, layer: types::GLint, access: types::GLenum, format: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLboolean, types::GLint, types::GLenum, types::GLenum) -> ()>
                    (*storage::BindImageTexture.pf)(unit, texture, level, layered, layer, access, format)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindImageTextures(first: types::GLuint, count: types::GLsizei, textures: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::BindImageTextures.pf)(first, count, textures)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindMultiTextureEXT(texunit: types::GLenum, target: types::GLenum, texture: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::BindMultiTextureEXT.pf)(texunit, target, texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindProgramPipeline(pipeline: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::BindProgramPipeline.pf)(pipeline)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindRenderbuffer(target: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindRenderbuffer.pf)(target, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindRenderbufferEXT(target: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindRenderbufferEXT.pf)(target, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindSampler(unit: types::GLuint, sampler: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::BindSampler.pf)(unit, sampler)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindSamplers(first: types::GLuint, count: types::GLsizei, samplers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::BindSamplers.pf)(first, count, samplers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindTexture(target: types::GLenum, texture: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindTexture.pf)(target, texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindTextureUnit(unit: types::GLuint, texture: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::BindTextureUnit.pf)(unit, texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindTextures(first: types::GLuint, count: types::GLsizei, textures: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::BindTextures.pf)(first, count, textures)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindTransformFeedback(target: types::GLenum, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::BindTransformFeedback.pf)(target, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindVertexArray(array: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::BindVertexArray.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindVertexArrayAPPLE(array: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::BindVertexArrayAPPLE.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindVertexArrayOES(array: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::BindVertexArrayOES.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindVertexBuffer(bindingindex: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLintptr, types::GLsizei) -> ()>
                    (*storage::BindVertexBuffer.pf)(bindingindex, buffer, offset, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BindVertexBuffers(first: types::GLuint, count: types::GLsizei, buffers: *const types::GLuint, offsets: *const types::GLintptr, strides: *const types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLuint, *const types::GLintptr, *const types::GLsizei) -> ()>
                    (*storage::BindVertexBuffers.pf)(first, count, buffers, offsets, strides)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Bitmap(width: types::GLsizei, height: types::GLsizei, xorig: types::GLfloat, yorig: types::GLfloat, xmove: types::GLfloat, ymove: types::GLfloat, bitmap: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, types::GLsizei, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, *const types::GLubyte) -> ()>
                    (*storage::Bitmap.pf)(width, height, xorig, yorig, xmove, ymove, bitmap)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendBarrier() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::BlendBarrier.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendColor(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat, alpha: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::BlendColor.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquation(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::BlendEquation.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquationSeparate(modeRGB: types::GLenum, modeAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendEquationSeparate.pf)(modeRGB, modeAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquationSeparatei(buf: types::GLuint, modeRGB: types::GLenum, modeAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendEquationSeparatei.pf)(buf, modeRGB, modeAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquationSeparateiARB(buf: types::GLuint, modeRGB: types::GLenum, modeAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendEquationSeparateiARB.pf)(buf, modeRGB, modeAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquationi(buf: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::BlendEquationi.pf)(buf, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendEquationiARB(buf: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::BlendEquationiARB.pf)(buf, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFunc(sfactor: types::GLenum, dfactor: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFunc.pf)(sfactor, dfactor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFuncSeparate(sfactorRGB: types::GLenum, dfactorRGB: types::GLenum, sfactorAlpha: types::GLenum, dfactorAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFuncSeparate.pf)(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFuncSeparatei(buf: types::GLuint, srcRGB: types::GLenum, dstRGB: types::GLenum, srcAlpha: types::GLenum, dstAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFuncSeparatei.pf)(buf, srcRGB, dstRGB, srcAlpha, dstAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFuncSeparateiARB(buf: types::GLuint, srcRGB: types::GLenum, dstRGB: types::GLenum, srcAlpha: types::GLenum, dstAlpha: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFuncSeparateiARB.pf)(buf, srcRGB, dstRGB, srcAlpha, dstAlpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFunci(buf: types::GLuint, src: types::GLenum, dst: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFunci.pf)(buf, src, dst)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlendFunciARB(buf: types::GLuint, src: types::GLenum, dst: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum) -> ()>
                    (*storage::BlendFunciARB.pf)(buf, src, dst)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlitFramebuffer(srcX0: types::GLint, srcY0: types::GLint, srcX1: types::GLint, srcY1: types::GLint, dstX0: types::GLint, dstY0: types::GLint, dstX1: types::GLint, dstY1: types::GLint, mask: types::GLbitfield, filter: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLbitfield, types::GLenum) -> ()>
                    (*storage::BlitFramebuffer.pf)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlitFramebufferEXT(srcX0: types::GLint, srcY0: types::GLint, srcX1: types::GLint, srcY1: types::GLint, dstX0: types::GLint, dstY0: types::GLint, dstX1: types::GLint, dstY1: types::GLint, mask: types::GLbitfield, filter: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLbitfield, types::GLenum) -> ()>
                    (*storage::BlitFramebufferEXT.pf)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BlitNamedFramebuffer(readFramebuffer: types::GLuint, drawFramebuffer: types::GLuint, srcX0: types::GLint, srcY0: types::GLint, srcX1: types::GLint, srcY1: types::GLint, dstX0: types::GLint, dstY0: types::GLint, dstX1: types::GLint, dstY1: types::GLint, mask: types::GLbitfield, filter: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLbitfield, types::GLenum) -> ()>
                    (*storage::BlitNamedFramebuffer.pf)(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferData(target: types::GLenum, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, usage: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLenum) -> ()>
                    (*storage::BufferData.pf)(target, size, data, usage)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferDataARB(target: types::GLenum, size: types::GLsizeiptrARB, data: *const __gl_imports::raw::c_void, usage: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizeiptrARB, *const __gl_imports::raw::c_void, types::GLenum) -> ()>
                    (*storage::BufferDataARB.pf)(target, size, data, usage)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferStorage(target: types::GLenum, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, flags: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLbitfield) -> ()>
                    (*storage::BufferStorage.pf)(target, size, data, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferStorageEXT(target: types::GLenum, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, flags: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLbitfield) -> ()>
                    (*storage::BufferStorageEXT.pf)(target, size, data, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferSubData(target: types::GLenum, offset: types::GLintptr, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptr, types::GLsizeiptr, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::BufferSubData.pf)(target, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn BufferSubDataARB(target: types::GLenum, offset: types::GLintptrARB, size: types::GLsizeiptrARB, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptrARB, types::GLsizeiptrARB, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::BufferSubDataARB.pf)(target, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CallList(list: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::CallList.pf)(list)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CallLists(n: types::GLsizei, type_: types::GLenum, lists: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CallLists.pf)(n, type_, lists)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CheckFramebufferStatus(target: types::GLenum) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLenum>
                    (*storage::CheckFramebufferStatus.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CheckFramebufferStatusEXT(target: types::GLenum) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLenum>
                    (*storage::CheckFramebufferStatusEXT.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CheckNamedFramebufferStatus(framebuffer: types::GLuint, target: types::GLenum) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> types::GLenum>
                    (*storage::CheckNamedFramebufferStatus.pf)(framebuffer, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CheckNamedFramebufferStatusEXT(framebuffer: types::GLuint, target: types::GLenum) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> types::GLenum>
                    (*storage::CheckNamedFramebufferStatusEXT.pf)(framebuffer, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClampColor(target: types::GLenum, clamp: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::ClampColor.pf)(target, clamp)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Clear(mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::Clear.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearAccum(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat, alpha: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ClearAccum.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferData(target: types::GLenum, internalformat: types::GLenum, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearBufferData.pf)(target, internalformat, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferSubData(target: types::GLenum, internalformat: types::GLenum, offset: types::GLintptr, size: types::GLsizeiptr, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLintptr, types::GLsizeiptr, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearBufferSubData.pf)(target, internalformat, offset, size, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferfi(buffer: types::GLenum, drawbuffer: types::GLint, depth: types::GLfloat, stencil: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLfloat, types::GLint) -> ()>
                    (*storage::ClearBufferfi.pf)(buffer, drawbuffer, depth, stencil)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferfv(buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, *const types::GLfloat) -> ()>
                    (*storage::ClearBufferfv.pf)(buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferiv(buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, *const types::GLint) -> ()>
                    (*storage::ClearBufferiv.pf)(buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearBufferuiv(buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, *const types::GLuint) -> ()>
                    (*storage::ClearBufferuiv.pf)(buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearColor(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat, alpha: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ClearColor.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearColorIiEXT(red: types::GLint, green: types::GLint, blue: types::GLint, alpha: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ClearColorIiEXT.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearColorIuiEXT(red: types::GLuint, green: types::GLuint, blue: types::GLuint, alpha: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ClearColorIuiEXT.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearDepth(depth: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble) -> ()>
                    (*storage::ClearDepth.pf)(depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearDepthf(d: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::ClearDepthf.pf)(d)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearIndex(c: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::ClearIndex.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedBufferData(buffer: types::GLuint, internalformat: types::GLenum, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearNamedBufferData.pf)(buffer, internalformat, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedBufferDataEXT(buffer: types::GLuint, internalformat: types::GLenum, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearNamedBufferDataEXT.pf)(buffer, internalformat, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedBufferSubData(buffer: types::GLuint, internalformat: types::GLenum, offset: types::GLintptr, size: types::GLsizeiptr, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLintptr, types::GLsizeiptr, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearNamedBufferSubData.pf)(buffer, internalformat, offset, size, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedBufferSubDataEXT(buffer: types::GLuint, internalformat: types::GLenum, offset: types::GLsizeiptr, size: types::GLsizeiptr, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizeiptr, types::GLsizeiptr, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearNamedBufferSubDataEXT.pf)(buffer, internalformat, offset, size, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedFramebufferfi(framebuffer: types::GLuint, buffer: types::GLenum, drawbuffer: types::GLint, depth: types::GLfloat, stencil: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLfloat, types::GLint) -> ()>
                    (*storage::ClearNamedFramebufferfi.pf)(framebuffer, buffer, drawbuffer, depth, stencil)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedFramebufferfv(framebuffer: types::GLuint, buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, *const types::GLfloat) -> ()>
                    (*storage::ClearNamedFramebufferfv.pf)(framebuffer, buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedFramebufferiv(framebuffer: types::GLuint, buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, *const types::GLint) -> ()>
                    (*storage::ClearNamedFramebufferiv.pf)(framebuffer, buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearNamedFramebufferuiv(framebuffer: types::GLuint, buffer: types::GLenum, drawbuffer: types::GLint, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, *const types::GLuint) -> ()>
                    (*storage::ClearNamedFramebufferuiv.pf)(framebuffer, buffer, drawbuffer, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearStencil(s: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint) -> ()>
                    (*storage::ClearStencil.pf)(s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearTexImage(texture: types::GLuint, level: types::GLint, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearTexImage.pf)(texture, level, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClearTexSubImage(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ClearTexSubImage.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClientActiveTexture(texture: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ClientActiveTexture.pf)(texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClientAttribDefaultEXT(mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::ClientAttribDefaultEXT.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClientWaitSync(sync: types::GLsync, flags: types::GLbitfield, timeout: types::GLuint64) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLbitfield, types::GLuint64) -> types::GLenum>
                    (*storage::ClientWaitSync.pf)(sync, flags, timeout)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClientWaitSyncAPPLE(sync: types::GLsync, flags: types::GLbitfield, timeout: types::GLuint64) -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLbitfield, types::GLuint64) -> types::GLenum>
                    (*storage::ClientWaitSyncAPPLE.pf)(sync, flags, timeout)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClipControl(origin: types::GLenum, depth: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::ClipControl.pf)(origin, depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ClipPlane(plane: types::GLenum, equation: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::ClipPlane.pf)(plane, equation)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3b(red: types::GLbyte, green: types::GLbyte, blue: types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbyte, types::GLbyte, types::GLbyte) -> ()>
                    (*storage::Color3b.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3bv(v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLbyte) -> ()>
                    (*storage::Color3bv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3d(red: types::GLdouble, green: types::GLdouble, blue: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Color3d.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Color3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3f(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Color3f.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Color3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3i(red: types::GLint, green: types::GLint, blue: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Color3i.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Color3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3s(red: types::GLshort, green: types::GLshort, blue: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Color3s.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Color3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3ub(red: types::GLubyte, green: types::GLubyte, blue: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLubyte, types::GLubyte, types::GLubyte) -> ()>
                    (*storage::Color3ub.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3ubv(v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLubyte) -> ()>
                    (*storage::Color3ubv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3ui(red: types::GLuint, green: types::GLuint, blue: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Color3ui.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3uiv(v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLuint) -> ()>
                    (*storage::Color3uiv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3us(red: types::GLushort, green: types::GLushort, blue: types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLushort, types::GLushort, types::GLushort) -> ()>
                    (*storage::Color3us.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color3usv(v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLushort) -> ()>
                    (*storage::Color3usv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4b(red: types::GLbyte, green: types::GLbyte, blue: types::GLbyte, alpha: types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbyte, types::GLbyte, types::GLbyte, types::GLbyte) -> ()>
                    (*storage::Color4b.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4bv(v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLbyte) -> ()>
                    (*storage::Color4bv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4d(red: types::GLdouble, green: types::GLdouble, blue: types::GLdouble, alpha: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Color4d.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Color4dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4f(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat, alpha: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Color4f.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Color4fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4i(red: types::GLint, green: types::GLint, blue: types::GLint, alpha: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Color4i.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Color4iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4s(red: types::GLshort, green: types::GLshort, blue: types::GLshort, alpha: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Color4s.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Color4sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4ub(red: types::GLubyte, green: types::GLubyte, blue: types::GLubyte, alpha: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLubyte, types::GLubyte, types::GLubyte, types::GLubyte) -> ()>
                    (*storage::Color4ub.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4ubv(v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLubyte) -> ()>
                    (*storage::Color4ubv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4ui(red: types::GLuint, green: types::GLuint, blue: types::GLuint, alpha: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Color4ui.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4uiv(v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLuint) -> ()>
                    (*storage::Color4uiv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4us(red: types::GLushort, green: types::GLushort, blue: types::GLushort, alpha: types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLushort, types::GLushort, types::GLushort, types::GLushort) -> ()>
                    (*storage::Color4us.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Color4usv(v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLushort) -> ()>
                    (*storage::Color4usv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorMask(red: types::GLboolean, green: types::GLboolean, blue: types::GLboolean, alpha: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLboolean, types::GLboolean, types::GLboolean, types::GLboolean) -> ()>
                    (*storage::ColorMask.pf)(red, green, blue, alpha)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorMaski(index: types::GLuint, r: types::GLboolean, g: types::GLboolean, b: types::GLboolean, a: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLboolean, types::GLboolean, types::GLboolean, types::GLboolean) -> ()>
                    (*storage::ColorMaski.pf)(index, r, g, b, a)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorMaterial(face: types::GLenum, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::ColorMaterial.pf)(face, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorP3ui(type_: types::GLenum, color: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::ColorP3ui.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorP3uiv(type_: types::GLenum, color: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::ColorP3uiv.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorP4ui(type_: types::GLenum, color: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::ColorP4ui.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorP4uiv(type_: types::GLenum, color: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::ColorP4uiv.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ColorPointer(size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::ColorPointer.pf)(size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompileShader(shader: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::CompileShader.pf)(shader)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompileShaderARB(shaderObj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB) -> ()>
                    (*storage::CompileShaderARB.pf)(shaderObj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexImage1DEXT.pf)(texunit, target, level, internalformat, width, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexImage2DEXT.pf)(texunit, target, level, internalformat, width, height, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexImage3DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexImage3DEXT.pf)(texunit, target, level, internalformat, width, height, depth, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexSubImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexSubImage1DEXT.pf)(texunit, target, level, xoffset, width, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexSubImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexSubImage2DEXT.pf)(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedMultiTexSubImage3DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedMultiTexSubImage3DEXT.pf)(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexImage1D(target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexImage1D.pf)(target, level, internalformat, width, border, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexImage2D(target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexImage2D.pf)(target, level, internalformat, width, height, border, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexImage3D(target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexImage3D.pf)(target, level, internalformat, width, height, depth, border, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexSubImage1D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexSubImage1D.pf)(target, level, xoffset, width, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexSubImage2D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexSubImage2D.pf)(target, level, xoffset, yoffset, width, height, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTexSubImage3D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTexSubImage3D.pf)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureImage1DEXT.pf)(texture, target, level, internalformat, width, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureImage2DEXT.pf)(texture, target, level, internalformat, width, height, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureImage3DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureImage3DEXT.pf)(texture, target, level, internalformat, width, height, depth, border, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage1D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage1D.pf)(texture, level, xoffset, width, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage1DEXT.pf)(texture, target, level, xoffset, width, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage2D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage2D.pf)(texture, level, xoffset, yoffset, width, height, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage2DEXT.pf)(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage3D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage3D.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CompressedTextureSubImage3DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, imageSize: types::GLsizei, bits: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::CompressedTextureSubImage3DEXT.pf)(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyBufferSubData(readTarget: types::GLenum, writeTarget: types::GLenum, readOffset: types::GLintptr, writeOffset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLintptr, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::CopyBufferSubData.pf)(readTarget, writeTarget, readOffset, writeOffset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyBufferSubDataNV(readTarget: types::GLenum, writeTarget: types::GLenum, readOffset: types::GLintptr, writeOffset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLintptr, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::CopyBufferSubDataNV.pf)(readTarget, writeTarget, readOffset, writeOffset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyImageSubData(srcName: types::GLuint, srcTarget: types::GLenum, srcLevel: types::GLint, srcX: types::GLint, srcY: types::GLint, srcZ: types::GLint, dstName: types::GLuint, dstTarget: types::GLenum, dstLevel: types::GLint, dstX: types::GLint, dstY: types::GLint, dstZ: types::GLint, srcWidth: types::GLsizei, srcHeight: types::GLsizei, srcDepth: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyImageSubData.pf)(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyMultiTexImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyMultiTexImage1DEXT.pf)(texunit, target, level, internalformat, x, y, width, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyMultiTexImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyMultiTexImage2DEXT.pf)(texunit, target, level, internalformat, x, y, width, height, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyMultiTexSubImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei) -> ()>
                    (*storage::CopyMultiTexSubImage1DEXT.pf)(texunit, target, level, xoffset, x, y, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyMultiTexSubImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyMultiTexSubImage2DEXT.pf)(texunit, target, level, xoffset, yoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyMultiTexSubImage3DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyMultiTexSubImage3DEXT.pf)(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyNamedBufferSubData(readBuffer: types::GLuint, writeBuffer: types::GLuint, readOffset: types::GLintptr, writeOffset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLintptr, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::CopyNamedBufferSubData.pf)(readBuffer, writeBuffer, readOffset, writeOffset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyPixels(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, type_: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum) -> ()>
                    (*storage::CopyPixels.pf)(x, y, width, height, type_)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTexImage1D(target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyTexImage1D.pf)(target, level, internalformat, x, y, width, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTexImage2D(target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyTexImage2D.pf)(target, level, internalformat, x, y, width, height, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTexSubImage1D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei) -> ()>
                    (*storage::CopyTexSubImage1D.pf)(target, level, xoffset, x, y, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTexSubImage2D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTexSubImage2D.pf)(target, level, xoffset, yoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTexSubImage3D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTexSubImage3D.pf)(target, level, xoffset, yoffset, zoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyTextureImage1DEXT.pf)(texture, target, level, internalformat, x, y, width, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint) -> ()>
                    (*storage::CopyTextureImage2DEXT.pf)(texture, target, level, internalformat, x, y, width, height, border)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage1D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage1D.pf)(texture, level, xoffset, x, y, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage1DEXT.pf)(texture, target, level, xoffset, x, y, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage2D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage2D.pf)(texture, level, xoffset, yoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage2DEXT.pf)(texture, target, level, xoffset, yoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage3D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage3D.pf)(texture, level, xoffset, yoffset, zoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CopyTextureSubImage3DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::CopyTextureSubImage3DEXT.pf)(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateBuffers(n: types::GLsizei, buffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateBuffers.pf)(n, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateFramebuffers(n: types::GLsizei, framebuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateFramebuffers.pf)(n, framebuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateProgram() -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLuint>
                    (*storage::CreateProgram.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateProgramObjectARB() -> types::GLhandleARB {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLhandleARB>
                    (*storage::CreateProgramObjectARB.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateProgramPipelines(n: types::GLsizei, pipelines: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateProgramPipelines.pf)(n, pipelines)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateQueries(target: types::GLenum, n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateQueries.pf)(target, n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateRenderbuffers(n: types::GLsizei, renderbuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateRenderbuffers.pf)(n, renderbuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateSamplers(n: types::GLsizei, samplers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateSamplers.pf)(n, samplers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateShader(type_: types::GLenum) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLuint>
                    (*storage::CreateShader.pf)(type_)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateShaderObjectARB(shaderType: types::GLenum) -> types::GLhandleARB {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLhandleARB>
                    (*storage::CreateShaderObjectARB.pf)(shaderType)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateShaderProgramv(type_: types::GLenum, count: types::GLsizei, strings: *const *const types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const *const types::GLchar) -> types::GLuint>
                    (*storage::CreateShaderProgramv.pf)(type_, count, strings)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateTextures(target: types::GLenum, n: types::GLsizei, textures: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateTextures.pf)(target, n, textures)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateTransformFeedbacks(n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateTransformFeedbacks.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CreateVertexArrays(n: types::GLsizei, arrays: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::CreateVertexArrays.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn CullFace(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::CullFace.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageCallback(callback: types::GLDEBUGPROC, userParam: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLDEBUGPROC, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DebugMessageCallback.pf)(callback, userParam)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageCallbackARB(callback: types::GLDEBUGPROCARB, userParam: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLDEBUGPROCARB, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DebugMessageCallbackARB.pf)(callback, userParam)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageCallbackKHR(callback: types::GLDEBUGPROCKHR, userParam: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLDEBUGPROCKHR, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DebugMessageCallbackKHR.pf)(callback, userParam)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageControl(source: types::GLenum, type_: types::GLenum, severity: types::GLenum, count: types::GLsizei, ids: *const types::GLuint, enabled: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *const types::GLuint, types::GLboolean) -> ()>
                    (*storage::DebugMessageControl.pf)(source, type_, severity, count, ids, enabled)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageControlARB(source: types::GLenum, type_: types::GLenum, severity: types::GLenum, count: types::GLsizei, ids: *const types::GLuint, enabled: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *const types::GLuint, types::GLboolean) -> ()>
                    (*storage::DebugMessageControlARB.pf)(source, type_, severity, count, ids, enabled)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageControlKHR(source: types::GLenum, type_: types::GLenum, severity: types::GLenum, count: types::GLsizei, ids: *const types::GLuint, enabled: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *const types::GLuint, types::GLboolean) -> ()>
                    (*storage::DebugMessageControlKHR.pf)(source, type_, severity, count, ids, enabled)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageInsert(source: types::GLenum, type_: types::GLenum, id: types::GLuint, severity: types::GLenum, length: types::GLsizei, buf: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLenum, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::DebugMessageInsert.pf)(source, type_, id, severity, length, buf)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageInsertARB(source: types::GLenum, type_: types::GLenum, id: types::GLuint, severity: types::GLenum, length: types::GLsizei, buf: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLenum, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::DebugMessageInsertARB.pf)(source, type_, id, severity, length, buf)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DebugMessageInsertKHR(source: types::GLenum, type_: types::GLenum, id: types::GLuint, severity: types::GLenum, length: types::GLsizei, buf: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLenum, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::DebugMessageInsertKHR.pf)(source, type_, id, severity, length, buf)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteBuffers(n: types::GLsizei, buffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteBuffers.pf)(n, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteBuffersARB(n: types::GLsizei, buffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteBuffersARB.pf)(n, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteFramebuffers(n: types::GLsizei, framebuffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteFramebuffers.pf)(n, framebuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteFramebuffersEXT(n: types::GLsizei, framebuffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteFramebuffersEXT.pf)(n, framebuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteLists(list: types::GLuint, range: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei) -> ()>
                    (*storage::DeleteLists.pf)(list, range)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteObjectARB(obj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB) -> ()>
                    (*storage::DeleteObjectARB.pf)(obj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteProgram(program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::DeleteProgram.pf)(program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteProgramPipelines(n: types::GLsizei, pipelines: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteProgramPipelines.pf)(n, pipelines)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteQueries(n: types::GLsizei, ids: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteQueries.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteQueriesARB(n: types::GLsizei, ids: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteQueriesARB.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteQueriesEXT(n: types::GLsizei, ids: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteQueriesEXT.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteRenderbuffers(n: types::GLsizei, renderbuffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteRenderbuffers.pf)(n, renderbuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteRenderbuffersEXT(n: types::GLsizei, renderbuffers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteRenderbuffersEXT.pf)(n, renderbuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteSamplers(count: types::GLsizei, samplers: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteSamplers.pf)(count, samplers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteShader(shader: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::DeleteShader.pf)(shader)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteSync(sync: types::GLsync) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync) -> ()>
                    (*storage::DeleteSync.pf)(sync)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteSyncAPPLE(sync: types::GLsync) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync) -> ()>
                    (*storage::DeleteSyncAPPLE.pf)(sync)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteTextures(n: types::GLsizei, textures: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteTextures.pf)(n, textures)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteTransformFeedbacks(n: types::GLsizei, ids: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteTransformFeedbacks.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteVertexArrays(n: types::GLsizei, arrays: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteVertexArrays.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteVertexArraysAPPLE(n: types::GLsizei, arrays: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteVertexArraysAPPLE.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DeleteVertexArraysOES(n: types::GLsizei, arrays: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::DeleteVertexArraysOES.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthFunc(func: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::DepthFunc.pf)(func)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthMask(flag: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLboolean) -> ()>
                    (*storage::DepthMask.pf)(flag)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthRange(near: types::GLdouble, far: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::DepthRange.pf)(near, far)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthRangeArrayv(first: types::GLuint, count: types::GLsizei, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::DepthRangeArrayv.pf)(first, count, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthRangeIndexed(index: types::GLuint, n: types::GLdouble, f: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::DepthRangeIndexed.pf)(index, n, f)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DepthRangef(n: types::GLfloat, f: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::DepthRangef.pf)(n, f)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DetachObjectARB(containerObj: types::GLhandleARB, attachedObj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLhandleARB) -> ()>
                    (*storage::DetachObjectARB.pf)(containerObj, attachedObj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DetachShader(program: types::GLuint, shader: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::DetachShader.pf)(program, shader)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Disable(cap: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::Disable.pf)(cap)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableClientState(array: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::DisableClientState.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableClientStateIndexedEXT(array: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::DisableClientStateIndexedEXT.pf)(array, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableClientStateiEXT(array: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::DisableClientStateiEXT.pf)(array, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableIndexedEXT(target: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::DisableIndexedEXT.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableVertexArrayAttrib(vaobj: types::GLuint, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::DisableVertexArrayAttrib.pf)(vaobj, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableVertexArrayAttribEXT(vaobj: types::GLuint, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::DisableVertexArrayAttribEXT.pf)(vaobj, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableVertexArrayEXT(vaobj: types::GLuint, array: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::DisableVertexArrayEXT.pf)(vaobj, array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableVertexAttribArray(index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::DisableVertexAttribArray.pf)(index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DisableVertexAttribArrayARB(index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::DisableVertexAttribArrayARB.pf)(index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Disablei(target: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::Disablei.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DispatchCompute(num_groups_x: types::GLuint, num_groups_y: types::GLuint, num_groups_z: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::DispatchCompute.pf)(num_groups_x, num_groups_y, num_groups_z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DispatchComputeIndirect(indirect: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLintptr) -> ()>
                    (*storage::DispatchComputeIndirect.pf)(indirect)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawArrays(mode: types::GLenum, first: types::GLint, count: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLsizei) -> ()>
                    (*storage::DrawArrays.pf)(mode, first, count)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawArraysIndirect(mode: types::GLenum, indirect: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DrawArraysIndirect.pf)(mode, indirect)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawArraysInstanced(mode: types::GLenum, first: types::GLint, count: types::GLsizei, instancecount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::DrawArraysInstanced.pf)(mode, first, count, instancecount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawArraysInstancedBaseInstance(mode: types::GLenum, first: types::GLint, count: types::GLsizei, instancecount: types::GLsizei, baseinstance: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLsizei, types::GLsizei, types::GLuint) -> ()>
                    (*storage::DrawArraysInstancedBaseInstance.pf)(mode, first, count, instancecount, baseinstance)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawBuffer(buf: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::DrawBuffer.pf)(buf)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawBuffers(n: types::GLsizei, bufs: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::DrawBuffers.pf)(n, bufs)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawBuffersARB(n: types::GLsizei, bufs: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::DrawBuffersARB.pf)(n, bufs)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawBuffersATI(n: types::GLsizei, bufs: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::DrawBuffersATI.pf)(n, bufs)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElements(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DrawElements.pf)(mode, count, type_, indices)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsBaseVertex(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLint) -> ()>
                    (*storage::DrawElementsBaseVertex.pf)(mode, count, type_, indices, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsBaseVertexOES(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLint) -> ()>
                    (*storage::DrawElementsBaseVertexOES.pf)(mode, count, type_, indices, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsIndirect(mode: types::GLenum, type_: types::GLenum, indirect: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DrawElementsIndirect.pf)(mode, type_, indirect)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsInstanced(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, instancecount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei) -> ()>
                    (*storage::DrawElementsInstanced.pf)(mode, count, type_, indices, instancecount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsInstancedBaseInstance(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, instancecount: types::GLsizei, baseinstance: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLuint) -> ()>
                    (*storage::DrawElementsInstancedBaseInstance.pf)(mode, count, type_, indices, instancecount, baseinstance)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsInstancedBaseVertex(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, instancecount: types::GLsizei, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLint) -> ()>
                    (*storage::DrawElementsInstancedBaseVertex.pf)(mode, count, type_, indices, instancecount, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsInstancedBaseVertexBaseInstance(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, instancecount: types::GLsizei, basevertex: types::GLint, baseinstance: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLint, types::GLuint) -> ()>
                    (*storage::DrawElementsInstancedBaseVertexBaseInstance.pf)(mode, count, type_, indices, instancecount, basevertex, baseinstance)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawElementsInstancedBaseVertexOES(mode: types::GLenum, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, instancecount: types::GLsizei, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLint) -> ()>
                    (*storage::DrawElementsInstancedBaseVertexOES.pf)(mode, count, type_, indices, instancecount, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawPixels(width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DrawPixels.pf)(width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawRangeElements(mode: types::GLenum, start: types::GLuint, end: types::GLuint, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::DrawRangeElements.pf)(mode, start, end, count, type_, indices)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawRangeElementsBaseVertex(mode: types::GLenum, start: types::GLuint, end: types::GLuint, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLint) -> ()>
                    (*storage::DrawRangeElementsBaseVertex.pf)(mode, start, end, count, type_, indices, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawRangeElementsBaseVertexOES(mode: types::GLenum, start: types::GLuint, end: types::GLuint, count: types::GLsizei, type_: types::GLenum, indices: *const __gl_imports::raw::c_void, basevertex: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLsizei, types::GLenum, *const __gl_imports::raw::c_void, types::GLint) -> ()>
                    (*storage::DrawRangeElementsBaseVertexOES.pf)(mode, start, end, count, type_, indices, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawTransformFeedback(mode: types::GLenum, id: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::DrawTransformFeedback.pf)(mode, id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawTransformFeedbackInstanced(mode: types::GLenum, id: types::GLuint, instancecount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei) -> ()>
                    (*storage::DrawTransformFeedbackInstanced.pf)(mode, id, instancecount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawTransformFeedbackStream(mode: types::GLenum, id: types::GLuint, stream: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint) -> ()>
                    (*storage::DrawTransformFeedbackStream.pf)(mode, id, stream)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn DrawTransformFeedbackStreamInstanced(mode: types::GLenum, id: types::GLuint, stream: types::GLuint, instancecount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLuint, types::GLsizei) -> ()>
                    (*storage::DrawTransformFeedbackStreamInstanced.pf)(mode, id, stream, instancecount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EdgeFlag(flag: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLboolean) -> ()>
                    (*storage::EdgeFlag.pf)(flag)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EdgeFlagPointer(stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::EdgeFlagPointer.pf)(stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EdgeFlagv(flag: *const types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLboolean) -> ()>
                    (*storage::EdgeFlagv.pf)(flag)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Enable(cap: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::Enable.pf)(cap)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableClientState(array: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::EnableClientState.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableClientStateIndexedEXT(array: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::EnableClientStateIndexedEXT.pf)(array, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableClientStateiEXT(array: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::EnableClientStateiEXT.pf)(array, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableIndexedEXT(target: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::EnableIndexedEXT.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableVertexArrayAttrib(vaobj: types::GLuint, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::EnableVertexArrayAttrib.pf)(vaobj, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableVertexArrayAttribEXT(vaobj: types::GLuint, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::EnableVertexArrayAttribEXT.pf)(vaobj, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableVertexArrayEXT(vaobj: types::GLuint, array: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::EnableVertexArrayEXT.pf)(vaobj, array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableVertexAttribArray(index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::EnableVertexAttribArray.pf)(index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EnableVertexAttribArrayARB(index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::EnableVertexAttribArrayARB.pf)(index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Enablei(target: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::Enablei.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn End() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::End.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndConditionalRender() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::EndConditionalRender.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndConditionalRenderNV() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::EndConditionalRenderNV.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndList() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::EndList.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndQuery(target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::EndQuery.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndQueryARB(target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::EndQueryARB.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndQueryEXT(target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::EndQueryEXT.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndQueryIndexed(target: types::GLenum, index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::EndQueryIndexed.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndTransformFeedback() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::EndTransformFeedback.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EndTransformFeedbackEXT() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::EndTransformFeedbackEXT.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord1d(u: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble) -> ()>
                    (*storage::EvalCoord1d.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord1dv(u: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::EvalCoord1dv.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord1f(u: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::EvalCoord1f.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord1fv(u: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::EvalCoord1fv.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord2d(u: types::GLdouble, v: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::EvalCoord2d.pf)(u, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord2dv(u: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::EvalCoord2dv.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord2f(u: types::GLfloat, v: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::EvalCoord2f.pf)(u, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalCoord2fv(u: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::EvalCoord2fv.pf)(u)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalMesh1(mode: types::GLenum, i1: types::GLint, i2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint) -> ()>
                    (*storage::EvalMesh1.pf)(mode, i1, i2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalMesh2(mode: types::GLenum, i1: types::GLint, i2: types::GLint, j1: types::GLint, j2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::EvalMesh2.pf)(mode, i1, i2, j1, j2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalPoint1(i: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint) -> ()>
                    (*storage::EvalPoint1.pf)(i)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn EvalPoint2(i: types::GLint, j: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::EvalPoint2.pf)(i, j)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FeedbackBuffer(size: types::GLsizei, type_: types::GLenum, buffer: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::FeedbackBuffer.pf)(size, type_, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FenceSync(condition: types::GLenum, flags: types::GLbitfield) -> types::GLsync {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLbitfield) -> types::GLsync>
                    (*storage::FenceSync.pf)(condition, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FenceSyncAPPLE(condition: types::GLenum, flags: types::GLbitfield) -> types::GLsync {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLbitfield) -> types::GLsync>
                    (*storage::FenceSyncAPPLE.pf)(condition, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Finish() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::Finish.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Flush() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::Flush.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FlushMappedBufferRange(target: types::GLenum, offset: types::GLintptr, length: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::FlushMappedBufferRange.pf)(target, offset, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FlushMappedNamedBufferRange(buffer: types::GLuint, offset: types::GLintptr, length: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::FlushMappedNamedBufferRange.pf)(buffer, offset, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FlushMappedNamedBufferRangeEXT(buffer: types::GLuint, offset: types::GLintptr, length: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::FlushMappedNamedBufferRangeEXT.pf)(buffer, offset, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FogCoordPointer(type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::FogCoordPointer.pf)(type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FogCoordd(coord: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble) -> ()>
                    (*storage::FogCoordd.pf)(coord)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FogCoorddv(coord: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::FogCoorddv.pf)(coord)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FogCoordf(coord: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::FogCoordf.pf)(coord)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FogCoordfv(coord: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::FogCoordfv.pf)(coord)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Fogf(pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::Fogf.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Fogfv(pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::Fogfv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Fogi(pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::Fogi.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Fogiv(pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::Fogiv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferDrawBufferEXT(framebuffer: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::FramebufferDrawBufferEXT.pf)(framebuffer, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferDrawBuffersEXT(framebuffer: types::GLuint, n: types::GLsizei, bufs: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::FramebufferDrawBuffersEXT.pf)(framebuffer, n, bufs)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferParameteri(target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::FramebufferParameteri.pf)(target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferReadBufferEXT(framebuffer: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::FramebufferReadBufferEXT.pf)(framebuffer, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferRenderbuffer(target: types::GLenum, attachment: types::GLenum, renderbuffertarget: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::FramebufferRenderbuffer.pf)(target, attachment, renderbuffertarget, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferRenderbufferEXT(target: types::GLenum, attachment: types::GLenum, renderbuffertarget: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::FramebufferRenderbufferEXT.pf)(target, attachment, renderbuffertarget, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTexture.pf)(target, attachment, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture1D(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTexture1D.pf)(target, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture1DEXT(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTexture1DEXT.pf)(target, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture2D(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTexture2D.pf)(target, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture2DEXT(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTexture2DEXT.pf)(target, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture2DMultisampleEXT(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint, samples: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLsizei) -> ()>
                    (*storage::FramebufferTexture2DMultisampleEXT.pf)(target, attachment, textarget, texture, level, samples)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture3D(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint, zoffset: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::FramebufferTexture3D.pf)(target, attachment, textarget, texture, level, zoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTexture3DEXT(target: types::GLenum, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint, zoffset: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::FramebufferTexture3DEXT.pf)(target, attachment, textarget, texture, level, zoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTextureARB(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::FramebufferTextureARB.pf)(target, attachment, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTextureFaceARB(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, face: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLenum) -> ()>
                    (*storage::FramebufferTextureFaceARB.pf)(target, attachment, texture, level, face)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTextureLayer(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, layer: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::FramebufferTextureLayer.pf)(target, attachment, texture, level, layer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTextureLayerARB(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, layer: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::FramebufferTextureLayerARB.pf)(target, attachment, texture, level, layer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FramebufferTextureLayerEXT(target: types::GLenum, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, layer: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::FramebufferTextureLayerEXT.pf)(target, attachment, texture, level, layer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn FrontFace(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::FrontFace.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Frustum(left: types::GLdouble, right: types::GLdouble, bottom: types::GLdouble, top: types::GLdouble, zNear: types::GLdouble, zFar: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Frustum.pf)(left, right, bottom, top, zNear, zFar)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenBuffers(n: types::GLsizei, buffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenBuffers.pf)(n, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenBuffersARB(n: types::GLsizei, buffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenBuffersARB.pf)(n, buffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenFramebuffers(n: types::GLsizei, framebuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenFramebuffers.pf)(n, framebuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenFramebuffersEXT(n: types::GLsizei, framebuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenFramebuffersEXT.pf)(n, framebuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenLists(range: types::GLsizei) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei) -> types::GLuint>
                    (*storage::GenLists.pf)(range)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenProgramPipelines(n: types::GLsizei, pipelines: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenProgramPipelines.pf)(n, pipelines)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenQueries(n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenQueries.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenQueriesARB(n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenQueriesARB.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenQueriesEXT(n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenQueriesEXT.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenRenderbuffers(n: types::GLsizei, renderbuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenRenderbuffers.pf)(n, renderbuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenRenderbuffersEXT(n: types::GLsizei, renderbuffers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenRenderbuffersEXT.pf)(n, renderbuffers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenSamplers(count: types::GLsizei, samplers: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenSamplers.pf)(count, samplers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenTextures(n: types::GLsizei, textures: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenTextures.pf)(n, textures)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenTransformFeedbacks(n: types::GLsizei, ids: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenTransformFeedbacks.pf)(n, ids)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenVertexArrays(n: types::GLsizei, arrays: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenVertexArrays.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenVertexArraysAPPLE(n: types::GLsizei, arrays: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenVertexArraysAPPLE.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenVertexArraysOES(n: types::GLsizei, arrays: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GenVertexArraysOES.pf)(n, arrays)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenerateMipmap(target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::GenerateMipmap.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenerateMipmapEXT(target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::GenerateMipmapEXT.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenerateMultiTexMipmapEXT(texunit: types::GLenum, target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::GenerateMultiTexMipmapEXT.pf)(texunit, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenerateTextureMipmap(texture: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::GenerateTextureMipmap.pf)(texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GenerateTextureMipmapEXT(texture: types::GLuint, target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::GenerateTextureMipmapEXT.pf)(texture, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveAtomicCounterBufferiv(program: types::GLuint, bufferIndex: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetActiveAtomicCounterBufferiv.pf)(program, bufferIndex, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveAttrib(program: types::GLuint, index: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLint, type_: *mut types::GLenum, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLint, *mut types::GLenum, *mut types::GLchar) -> ()>
                    (*storage::GetActiveAttrib.pf)(program, index, bufSize, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveAttribARB(programObj: types::GLhandleARB, index: types::GLuint, maxLength: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLint, type_: *mut types::GLenum, name: *mut types::GLcharARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLint, *mut types::GLenum, *mut types::GLcharARB) -> ()>
                    (*storage::GetActiveAttribARB.pf)(programObj, index, maxLength, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveSubroutineName(program: types::GLuint, shadertype: types::GLenum, index: types::GLuint, bufsize: types::GLsizei, length: *mut types::GLsizei, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetActiveSubroutineName.pf)(program, shadertype, index, bufsize, length, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveSubroutineUniformName(program: types::GLuint, shadertype: types::GLenum, index: types::GLuint, bufsize: types::GLsizei, length: *mut types::GLsizei, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetActiveSubroutineUniformName.pf)(program, shadertype, index, bufsize, length, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveSubroutineUniformiv(program: types::GLuint, shadertype: types::GLenum, index: types::GLuint, pname: types::GLenum, values: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetActiveSubroutineUniformiv.pf)(program, shadertype, index, pname, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniform(program: types::GLuint, index: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLint, type_: *mut types::GLenum, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLint, *mut types::GLenum, *mut types::GLchar) -> ()>
                    (*storage::GetActiveUniform.pf)(program, index, bufSize, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniformARB(programObj: types::GLhandleARB, index: types::GLuint, maxLength: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLint, type_: *mut types::GLenum, name: *mut types::GLcharARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLint, *mut types::GLenum, *mut types::GLcharARB) -> ()>
                    (*storage::GetActiveUniformARB.pf)(programObj, index, maxLength, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniformBlockName(program: types::GLuint, uniformBlockIndex: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, uniformBlockName: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetActiveUniformBlockName.pf)(program, uniformBlockIndex, bufSize, length, uniformBlockName)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniformBlockiv(program: types::GLuint, uniformBlockIndex: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetActiveUniformBlockiv.pf)(program, uniformBlockIndex, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniformName(program: types::GLuint, uniformIndex: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, uniformName: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetActiveUniformName.pf)(program, uniformIndex, bufSize, length, uniformName)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetActiveUniformsiv(program: types::GLuint, uniformCount: types::GLsizei, uniformIndices: *const types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetActiveUniformsiv.pf)(program, uniformCount, uniformIndices, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetAttachedObjectsARB(containerObj: types::GLhandleARB, maxCount: types::GLsizei, count: *mut types::GLsizei, obj: *mut types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLsizei, *mut types::GLsizei, *mut types::GLhandleARB) -> ()>
                    (*storage::GetAttachedObjectsARB.pf)(containerObj, maxCount, count, obj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetAttachedShaders(program: types::GLuint, maxCount: types::GLsizei, count: *mut types::GLsizei, shaders: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetAttachedShaders.pf)(program, maxCount, count, shaders)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetAttribLocation(program: types::GLuint, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLint>
                    (*storage::GetAttribLocation.pf)(program, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetAttribLocationARB(programObj: types::GLhandleARB, name: *const types::GLcharARB) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, *const types::GLcharARB) -> types::GLint>
                    (*storage::GetAttribLocationARB.pf)(programObj, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBooleanIndexedvEXT(target: types::GLenum, index: types::GLuint, data: *mut types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLboolean) -> ()>
                    (*storage::GetBooleanIndexedvEXT.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBooleani_v(target: types::GLenum, index: types::GLuint, data: *mut types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLboolean) -> ()>
                    (*storage::GetBooleani_v.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBooleanv(pname: types::GLenum, data: *mut types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLboolean) -> ()>
                    (*storage::GetBooleanv.pf)(pname, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferParameteri64v(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetBufferParameteri64v.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferParameteriv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetBufferParameteriv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferParameterivARB(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetBufferParameterivARB.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferPointerv(target: types::GLenum, pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetBufferPointerv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferPointervARB(target: types::GLenum, pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetBufferPointervARB.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferSubData(target: types::GLenum, offset: types::GLintptr, size: types::GLsizeiptr, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptr, types::GLsizeiptr, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetBufferSubData.pf)(target, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetBufferSubDataARB(target: types::GLenum, offset: types::GLintptrARB, size: types::GLsizeiptrARB, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptrARB, types::GLsizeiptrARB, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetBufferSubDataARB.pf)(target, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetClipPlane(plane: types::GLenum, equation: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetClipPlane.pf)(plane, equation)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetCompressedMultiTexImageEXT(texunit: types::GLenum, target: types::GLenum, lod: types::GLint, img: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetCompressedMultiTexImageEXT.pf)(texunit, target, lod, img)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetCompressedTexImage(target: types::GLenum, level: types::GLint, img: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetCompressedTexImage.pf)(target, level, img)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetCompressedTextureImage(texture: types::GLuint, level: types::GLint, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetCompressedTextureImage.pf)(texture, level, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetCompressedTextureImageEXT(texture: types::GLuint, target: types::GLenum, lod: types::GLint, img: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetCompressedTextureImageEXT.pf)(texture, target, lod, img)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetCompressedTextureSubImage(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetCompressedTextureSubImage.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDebugMessageLog(count: types::GLuint, bufSize: types::GLsizei, sources: *mut types::GLenum, types: *mut types::GLenum, ids: *mut types::GLuint, severities: *mut types::GLenum, lengths: *mut types::GLsizei, messageLog: *mut types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLenum, *mut types::GLenum, *mut types::GLuint, *mut types::GLenum, *mut types::GLsizei, *mut types::GLchar) -> types::GLuint>
                    (*storage::GetDebugMessageLog.pf)(count, bufSize, sources, types, ids, severities, lengths, messageLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDebugMessageLogARB(count: types::GLuint, bufSize: types::GLsizei, sources: *mut types::GLenum, types: *mut types::GLenum, ids: *mut types::GLuint, severities: *mut types::GLenum, lengths: *mut types::GLsizei, messageLog: *mut types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLenum, *mut types::GLenum, *mut types::GLuint, *mut types::GLenum, *mut types::GLsizei, *mut types::GLchar) -> types::GLuint>
                    (*storage::GetDebugMessageLogARB.pf)(count, bufSize, sources, types, ids, severities, lengths, messageLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDebugMessageLogKHR(count: types::GLuint, bufSize: types::GLsizei, sources: *mut types::GLenum, types: *mut types::GLenum, ids: *mut types::GLuint, severities: *mut types::GLenum, lengths: *mut types::GLsizei, messageLog: *mut types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLenum, *mut types::GLenum, *mut types::GLuint, *mut types::GLenum, *mut types::GLsizei, *mut types::GLchar) -> types::GLuint>
                    (*storage::GetDebugMessageLogKHR.pf)(count, bufSize, sources, types, ids, severities, lengths, messageLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDoubleIndexedvEXT(target: types::GLenum, index: types::GLuint, data: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLdouble) -> ()>
                    (*storage::GetDoubleIndexedvEXT.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDoublei_v(target: types::GLenum, index: types::GLuint, data: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLdouble) -> ()>
                    (*storage::GetDoublei_v.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDoublei_vEXT(pname: types::GLenum, index: types::GLuint, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLdouble) -> ()>
                    (*storage::GetDoublei_vEXT.pf)(pname, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetDoublev(pname: types::GLenum, data: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetDoublev.pf)(pname, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetError() -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLenum>
                    (*storage::GetError.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFloatIndexedvEXT(target: types::GLenum, index: types::GLuint, data: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLfloat) -> ()>
                    (*storage::GetFloatIndexedvEXT.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFloati_v(target: types::GLenum, index: types::GLuint, data: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLfloat) -> ()>
                    (*storage::GetFloati_v.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFloati_vEXT(pname: types::GLenum, index: types::GLuint, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLfloat) -> ()>
                    (*storage::GetFloati_vEXT.pf)(pname, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFloatv(pname: types::GLenum, data: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetFloatv.pf)(pname, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFragDataIndex(program: types::GLuint, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLint>
                    (*storage::GetFragDataIndex.pf)(program, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFragDataLocation(program: types::GLuint, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLint>
                    (*storage::GetFragDataLocation.pf)(program, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFragDataLocationEXT(program: types::GLuint, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLint>
                    (*storage::GetFragDataLocationEXT.pf)(program, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFramebufferAttachmentParameteriv(target: types::GLenum, attachment: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetFramebufferAttachmentParameteriv.pf)(target, attachment, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFramebufferAttachmentParameterivEXT(target: types::GLenum, attachment: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetFramebufferAttachmentParameterivEXT.pf)(target, attachment, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFramebufferParameteriv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetFramebufferParameteriv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetFramebufferParameterivEXT(framebuffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetFramebufferParameterivEXT.pf)(framebuffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetGraphicsResetStatus() -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLenum>
                    (*storage::GetGraphicsResetStatus.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetGraphicsResetStatusARB() -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLenum>
                    (*storage::GetGraphicsResetStatusARB.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetGraphicsResetStatusEXT() -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLenum>
                    (*storage::GetGraphicsResetStatusEXT.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetGraphicsResetStatusKHR() -> types::GLenum {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> types::GLenum>
                    (*storage::GetGraphicsResetStatusKHR.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetHandleARB(pname: types::GLenum) -> types::GLhandleARB {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLhandleARB>
                    (*storage::GetHandleARB.pf)(pname)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetImageHandleARB(texture: types::GLuint, level: types::GLint, layered: types::GLboolean, layer: types::GLint, format: types::GLenum) -> types::GLuint64 {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLboolean, types::GLint, types::GLenum) -> types::GLuint64>
                    (*storage::GetImageHandleARB.pf)(texture, level, layered, layer, format)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInfoLogARB(obj: types::GLhandleARB, maxLength: types::GLsizei, length: *mut types::GLsizei, infoLog: *mut types::GLcharARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLsizei, *mut types::GLsizei, *mut types::GLcharARB) -> ()>
                    (*storage::GetInfoLogARB.pf)(obj, maxLength, length, infoLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInteger64i_v(target: types::GLenum, index: types::GLuint, data: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLint64) -> ()>
                    (*storage::GetInteger64i_v.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInteger64v(pname: types::GLenum, data: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetInteger64v.pf)(pname, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInteger64vAPPLE(pname: types::GLenum, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetInteger64vAPPLE.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetIntegerIndexedvEXT(target: types::GLenum, index: types::GLuint, data: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLint) -> ()>
                    (*storage::GetIntegerIndexedvEXT.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetIntegeri_v(target: types::GLenum, index: types::GLuint, data: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLint) -> ()>
                    (*storage::GetIntegeri_v.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetIntegerv(pname: types::GLenum, data: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetIntegerv.pf)(pname, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInternalformatSampleivNV(target: types::GLenum, internalformat: types::GLenum, samples: types::GLsizei, pname: types::GLenum, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetInternalformatSampleivNV.pf)(target, internalformat, samples, pname, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInternalformati64v(target: types::GLenum, internalformat: types::GLenum, pname: types::GLenum, bufSize: types::GLsizei, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut types::GLint64) -> ()>
                    (*storage::GetInternalformati64v.pf)(target, internalformat, pname, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetInternalformativ(target: types::GLenum, internalformat: types::GLenum, pname: types::GLenum, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetInternalformativ.pf)(target, internalformat, pname, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetLightfv(light: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetLightfv.pf)(light, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetLightiv(light: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetLightiv.pf)(light, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMapdv(target: types::GLenum, query: types::GLenum, v: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetMapdv.pf)(target, query, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMapfv(target: types::GLenum, query: types::GLenum, v: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMapfv.pf)(target, query, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMapiv(target: types::GLenum, query: types::GLenum, v: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMapiv.pf)(target, query, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMaterialfv(face: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMaterialfv.pf)(face, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMaterialiv(face: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMaterialiv.pf)(face, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexEnvfvEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMultiTexEnvfvEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexEnvivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMultiTexEnvivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexGendvEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetMultiTexGendvEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexGenfvEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMultiTexGenfvEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexGenivEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMultiTexGenivEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexImageEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetMultiTexImageEXT.pf)(texunit, target, level, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexLevelParameterfvEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMultiTexLevelParameterfvEXT.pf)(texunit, target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexLevelParameterivEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMultiTexLevelParameterivEXT.pf)(texunit, target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexParameterIivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMultiTexParameterIivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexParameterIuivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetMultiTexParameterIuivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexParameterfvEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetMultiTexParameterfvEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultiTexParameterivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetMultiTexParameterivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetMultisamplefv(pname: types::GLenum, index: types::GLuint, val: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *mut types::GLfloat) -> ()>
                    (*storage::GetMultisamplefv.pf)(pname, index, val)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferParameteri64v(buffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetNamedBufferParameteri64v.pf)(buffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferParameteriv(buffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedBufferParameteriv.pf)(buffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferParameterivEXT(buffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedBufferParameterivEXT.pf)(buffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferPointerv(buffer: types::GLuint, pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetNamedBufferPointerv.pf)(buffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferPointervEXT(buffer: types::GLuint, pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetNamedBufferPointervEXT.pf)(buffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferSubData(buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetNamedBufferSubData.pf)(buffer, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedBufferSubDataEXT(buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetNamedBufferSubDataEXT.pf)(buffer, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedFramebufferAttachmentParameteriv(framebuffer: types::GLuint, attachment: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedFramebufferAttachmentParameteriv.pf)(framebuffer, attachment, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedFramebufferAttachmentParameterivEXT(framebuffer: types::GLuint, attachment: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedFramebufferAttachmentParameterivEXT.pf)(framebuffer, attachment, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedFramebufferParameteriv(framebuffer: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedFramebufferParameteriv.pf)(framebuffer, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedFramebufferParameterivEXT(framebuffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedFramebufferParameterivEXT.pf)(framebuffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramLocalParameterIivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLint) -> ()>
                    (*storage::GetNamedProgramLocalParameterIivEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramLocalParameterIuivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLuint) -> ()>
                    (*storage::GetNamedProgramLocalParameterIuivEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramLocalParameterdvEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLdouble) -> ()>
                    (*storage::GetNamedProgramLocalParameterdvEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramLocalParameterfvEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLfloat) -> ()>
                    (*storage::GetNamedProgramLocalParameterfvEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramStringEXT(program: types::GLuint, target: types::GLenum, pname: types::GLenum, string: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetNamedProgramStringEXT.pf)(program, target, pname, string)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedProgramivEXT(program: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedProgramivEXT.pf)(program, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedRenderbufferParameteriv(renderbuffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedRenderbufferParameteriv.pf)(renderbuffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetNamedRenderbufferParameterivEXT(renderbuffer: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetNamedRenderbufferParameterivEXT.pf)(renderbuffer, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectLabel(identifier: types::GLenum, name: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, label: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetObjectLabel.pf)(identifier, name, bufSize, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectLabelKHR(identifier: types::GLenum, name: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, label: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetObjectLabelKHR.pf)(identifier, name, bufSize, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectParameterfvARB(obj: types::GLhandleARB, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetObjectParameterfvARB.pf)(obj, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectParameterivARB(obj: types::GLhandleARB, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetObjectParameterivARB.pf)(obj, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectPtrLabel(ptr: *const __gl_imports::raw::c_void, bufSize: types::GLsizei, length: *mut types::GLsizei, label: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const __gl_imports::raw::c_void, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetObjectPtrLabel.pf)(ptr, bufSize, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetObjectPtrLabelKHR(ptr: *const __gl_imports::raw::c_void, bufSize: types::GLsizei, length: *mut types::GLsizei, label: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const __gl_imports::raw::c_void, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetObjectPtrLabelKHR.pf)(ptr, bufSize, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPixelMapfv(map: types::GLenum, values: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetPixelMapfv.pf)(map, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPixelMapuiv(map: types::GLenum, values: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetPixelMapuiv.pf)(map, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPixelMapusv(map: types::GLenum, values: *mut types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *mut types::GLushort) -> ()>
                    (*storage::GetPixelMapusv.pf)(map, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPointerIndexedvEXT(target: types::GLenum, index: types::GLuint, data: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetPointerIndexedvEXT.pf)(target, index, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPointeri_vEXT(pname: types::GLenum, index: types::GLuint, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetPointeri_vEXT.pf)(pname, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPointerv(pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetPointerv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPointervKHR(pname: types::GLenum, params: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetPointervKHR.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetPolygonStipple(mask: *mut types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*mut types::GLubyte) -> ()>
                    (*storage::GetPolygonStipple.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramBinary(program: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, binaryFormat: *mut types::GLenum, binary: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetProgramBinary.pf)(program, bufSize, length, binaryFormat, binary)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramInfoLog(program: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, infoLog: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetProgramInfoLog.pf)(program, bufSize, length, infoLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramInterfaceiv(program: types::GLuint, programInterface: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetProgramInterfaceiv.pf)(program, programInterface, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramPipelineInfoLog(pipeline: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, infoLog: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetProgramPipelineInfoLog.pf)(pipeline, bufSize, length, infoLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramPipelineiv(pipeline: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetProgramPipelineiv.pf)(pipeline, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramResourceIndex(program: types::GLuint, programInterface: types::GLenum, name: *const types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLchar) -> types::GLuint>
                    (*storage::GetProgramResourceIndex.pf)(program, programInterface, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramResourceLocation(program: types::GLuint, programInterface: types::GLenum, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLchar) -> types::GLint>
                    (*storage::GetProgramResourceLocation.pf)(program, programInterface, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramResourceLocationIndex(program: types::GLuint, programInterface: types::GLenum, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLchar) -> types::GLint>
                    (*storage::GetProgramResourceLocationIndex.pf)(program, programInterface, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramResourceName(program: types::GLuint, programInterface: types::GLenum, index: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetProgramResourceName.pf)(program, programInterface, index, bufSize, length, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramResourceiv(program: types::GLuint, programInterface: types::GLenum, index: types::GLuint, propCount: types::GLsizei, props: *const types::GLenum, bufSize: types::GLsizei, length: *mut types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *const types::GLenum, types::GLsizei, *mut types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetProgramResourceiv.pf)(program, programInterface, index, propCount, props, bufSize, length, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramStageiv(program: types::GLuint, shadertype: types::GLenum, pname: types::GLenum, values: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetProgramStageiv.pf)(program, shadertype, pname, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetProgramiv(program: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetProgramiv.pf)(program, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryBufferObjecti64v(id: types::GLuint, buffer: types::GLuint, pname: types::GLenum, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLintptr) -> ()>
                    (*storage::GetQueryBufferObjecti64v.pf)(id, buffer, pname, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryBufferObjectiv(id: types::GLuint, buffer: types::GLuint, pname: types::GLenum, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLintptr) -> ()>
                    (*storage::GetQueryBufferObjectiv.pf)(id, buffer, pname, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryBufferObjectui64v(id: types::GLuint, buffer: types::GLuint, pname: types::GLenum, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLintptr) -> ()>
                    (*storage::GetQueryBufferObjectui64v.pf)(id, buffer, pname, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryBufferObjectuiv(id: types::GLuint, buffer: types::GLuint, pname: types::GLenum, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLintptr) -> ()>
                    (*storage::GetQueryBufferObjectuiv.pf)(id, buffer, pname, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryIndexediv(target: types::GLenum, index: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryIndexediv.pf)(target, index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjecti64v(id: types::GLuint, pname: types::GLenum, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetQueryObjecti64v.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjecti64vEXT(id: types::GLuint, pname: types::GLenum, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetQueryObjecti64vEXT.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectiv(id: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryObjectiv.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectivARB(id: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryObjectivARB.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectivEXT(id: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryObjectivEXT.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectui64v(id: types::GLuint, pname: types::GLenum, params: *mut types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint64) -> ()>
                    (*storage::GetQueryObjectui64v.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectui64vEXT(id: types::GLuint, pname: types::GLenum, params: *mut types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint64) -> ()>
                    (*storage::GetQueryObjectui64vEXT.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectuiv(id: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetQueryObjectuiv.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectuivARB(id: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetQueryObjectuivARB.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryObjectuivEXT(id: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetQueryObjectuivEXT.pf)(id, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryiv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryiv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryivARB(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryivARB.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetQueryivEXT(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetQueryivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetRenderbufferParameteriv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetRenderbufferParameteriv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetRenderbufferParameterivEXT(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetRenderbufferParameterivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSamplerParameterIiv(sampler: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetSamplerParameterIiv.pf)(sampler, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSamplerParameterIuiv(sampler: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetSamplerParameterIuiv.pf)(sampler, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSamplerParameterfv(sampler: types::GLuint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetSamplerParameterfv.pf)(sampler, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSamplerParameteriv(sampler: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetSamplerParameteriv.pf)(sampler, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetShaderInfoLog(shader: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, infoLog: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetShaderInfoLog.pf)(shader, bufSize, length, infoLog)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetShaderPrecisionFormat(shadertype: types::GLenum, precisiontype: types::GLenum, range: *mut types::GLint, precision: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint, *mut types::GLint) -> ()>
                    (*storage::GetShaderPrecisionFormat.pf)(shadertype, precisiontype, range, precision)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetShaderSource(shader: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, source: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLchar) -> ()>
                    (*storage::GetShaderSource.pf)(shader, bufSize, length, source)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetShaderSourceARB(obj: types::GLhandleARB, maxLength: types::GLsizei, length: *mut types::GLsizei, source: *mut types::GLcharARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLsizei, *mut types::GLsizei, *mut types::GLcharARB) -> ()>
                    (*storage::GetShaderSourceARB.pf)(obj, maxLength, length, source)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetShaderiv(shader: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetShaderiv.pf)(shader, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetString(name: types::GLenum) -> *const types::GLubyte {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> *const types::GLubyte>
                    (*storage::GetString.pf)(name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetStringi(name: types::GLenum, index: types::GLuint) -> *const types::GLubyte {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> *const types::GLubyte>
                    (*storage::GetStringi.pf)(name, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSubroutineIndex(program: types::GLuint, shadertype: types::GLenum, name: *const types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLchar) -> types::GLuint>
                    (*storage::GetSubroutineIndex.pf)(program, shadertype, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSubroutineUniformLocation(program: types::GLuint, shadertype: types::GLenum, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLchar) -> types::GLint>
                    (*storage::GetSubroutineUniformLocation.pf)(program, shadertype, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSynciv(sync: types::GLsync, pname: types::GLenum, bufSize: types::GLsizei, length: *mut types::GLsizei, values: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLenum, types::GLsizei, *mut types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetSynciv.pf)(sync, pname, bufSize, length, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetSyncivAPPLE(sync: types::GLsync, pname: types::GLenum, bufSize: types::GLsizei, length: *mut types::GLsizei, values: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLenum, types::GLsizei, *mut types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetSyncivAPPLE.pf)(sync, pname, bufSize, length, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexEnvfv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTexEnvfv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexEnviv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexEnviv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexGendv(coord: types::GLenum, pname: types::GLenum, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetTexGendv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexGenfv(coord: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTexGenfv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexGeniv(coord: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexGeniv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexImage(target: types::GLenum, level: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetTexImage.pf)(target, level, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexLevelParameterfv(target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTexLevelParameterfv.pf)(target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexLevelParameteriv(target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexLevelParameteriv.pf)(target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameterIiv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexParameterIiv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameterIivEXT(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexParameterIivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameterIuiv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetTexParameterIuiv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameterIuivEXT(target: types::GLenum, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetTexParameterIuivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameterfv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTexParameterfv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTexParameteriv(target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTexParameteriv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureHandleARB(texture: types::GLuint) -> types::GLuint64 {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLuint64>
                    (*storage::GetTextureHandleARB.pf)(texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureImage(texture: types::GLuint, level: types::GLint, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetTextureImage.pf)(texture, level, format, type_, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureImageEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetTextureImageEXT.pf)(texture, target, level, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureLevelParameterfv(texture: types::GLuint, level: types::GLint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTextureLevelParameterfv.pf)(texture, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureLevelParameterfvEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTextureLevelParameterfvEXT.pf)(texture, target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureLevelParameteriv(texture: types::GLuint, level: types::GLint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureLevelParameteriv.pf)(texture, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureLevelParameterivEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureLevelParameterivEXT.pf)(texture, target, level, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterIiv(texture: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureParameterIiv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterIivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureParameterIivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterIuiv(texture: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetTextureParameterIuiv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterIuivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetTextureParameterIuivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterfv(texture: types::GLuint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTextureParameterfv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterfvEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetTextureParameterfvEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameteriv(texture: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureParameteriv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureParameterivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTextureParameterivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureSamplerHandleARB(texture: types::GLuint, sampler: types::GLuint) -> types::GLuint64 {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> types::GLuint64>
                    (*storage::GetTextureSamplerHandleARB.pf)(texture, sampler)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTextureSubImage(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetTextureSubImage.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTransformFeedbackVarying(program: types::GLuint, index: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLsizei, type_: *mut types::GLenum, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLsizei, *mut types::GLenum, *mut types::GLchar) -> ()>
                    (*storage::GetTransformFeedbackVarying.pf)(program, index, bufSize, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTransformFeedbackVaryingEXT(program: types::GLuint, index: types::GLuint, bufSize: types::GLsizei, length: *mut types::GLsizei, size: *mut types::GLsizei, type_: *mut types::GLenum, name: *mut types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *mut types::GLsizei, *mut types::GLsizei, *mut types::GLenum, *mut types::GLchar) -> ()>
                    (*storage::GetTransformFeedbackVaryingEXT.pf)(program, index, bufSize, length, size, type_, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTransformFeedbacki64_v(xfb: types::GLuint, pname: types::GLenum, index: types::GLuint, param: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLint64) -> ()>
                    (*storage::GetTransformFeedbacki64_v.pf)(xfb, pname, index, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTransformFeedbacki_v(xfb: types::GLuint, pname: types::GLenum, index: types::GLuint, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *mut types::GLint) -> ()>
                    (*storage::GetTransformFeedbacki_v.pf)(xfb, pname, index, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetTransformFeedbackiv(xfb: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetTransformFeedbackiv.pf)(xfb, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformBlockIndex(program: types::GLuint, uniformBlockName: *const types::GLchar) -> types::GLuint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLuint>
                    (*storage::GetUniformBlockIndex.pf)(program, uniformBlockName)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformIndices(program: types::GLuint, uniformCount: types::GLsizei, uniformNames: *const *const types::GLchar, uniformIndices: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const *const types::GLchar, *mut types::GLuint) -> ()>
                    (*storage::GetUniformIndices.pf)(program, uniformCount, uniformNames, uniformIndices)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformLocation(program: types::GLuint, name: *const types::GLchar) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLchar) -> types::GLint>
                    (*storage::GetUniformLocation.pf)(program, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformLocationARB(programObj: types::GLhandleARB, name: *const types::GLcharARB) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, *const types::GLcharARB) -> types::GLint>
                    (*storage::GetUniformLocationARB.pf)(programObj, name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformSubroutineuiv(shadertype: types::GLenum, location: types::GLint, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, *mut types::GLuint) -> ()>
                    (*storage::GetUniformSubroutineuiv.pf)(shadertype, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformdv(program: types::GLuint, location: types::GLint, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLdouble) -> ()>
                    (*storage::GetUniformdv.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformfv(program: types::GLuint, location: types::GLint, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLfloat) -> ()>
                    (*storage::GetUniformfv.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformfvARB(programObj: types::GLhandleARB, location: types::GLint, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLint, *mut types::GLfloat) -> ()>
                    (*storage::GetUniformfvARB.pf)(programObj, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformi64vARB(program: types::GLuint, location: types::GLint, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLint64) -> ()>
                    (*storage::GetUniformi64vARB.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformiv(program: types::GLuint, location: types::GLint, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLint) -> ()>
                    (*storage::GetUniformiv.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformivARB(programObj: types::GLhandleARB, location: types::GLint, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLint, *mut types::GLint) -> ()>
                    (*storage::GetUniformivARB.pf)(programObj, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformui64vARB(program: types::GLuint, location: types::GLint, params: *mut types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLuint64) -> ()>
                    (*storage::GetUniformui64vARB.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformuiv(program: types::GLuint, location: types::GLint, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLuint) -> ()>
                    (*storage::GetUniformuiv.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetUniformuivEXT(program: types::GLuint, location: types::GLint, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, *mut types::GLuint) -> ()>
                    (*storage::GetUniformuivEXT.pf)(program, location, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayIndexed64iv(vaobj: types::GLuint, index: types::GLuint, pname: types::GLenum, param: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *mut types::GLint64) -> ()>
                    (*storage::GetVertexArrayIndexed64iv.pf)(vaobj, index, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayIndexediv(vaobj: types::GLuint, index: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexArrayIndexediv.pf)(vaobj, index, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayIntegeri_vEXT(vaobj: types::GLuint, index: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexArrayIntegeri_vEXT.pf)(vaobj, index, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayIntegervEXT(vaobj: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexArrayIntegervEXT.pf)(vaobj, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayPointeri_vEXT(vaobj: types::GLuint, index: types::GLuint, pname: types::GLenum, param: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetVertexArrayPointeri_vEXT.pf)(vaobj, index, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayPointervEXT(vaobj: types::GLuint, pname: types::GLenum, param: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetVertexArrayPointervEXT.pf)(vaobj, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexArrayiv(vaobj: types::GLuint, pname: types::GLenum, param: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexArrayiv.pf)(vaobj, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribIiv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexAttribIiv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribIuiv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint) -> ()>
                    (*storage::GetVertexAttribIuiv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribLdv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetVertexAttribLdv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribLi64vNV(index: types::GLuint, pname: types::GLenum, params: *mut types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint64EXT) -> ()>
                    (*storage::GetVertexAttribLi64vNV.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribLui64vARB(index: types::GLuint, pname: types::GLenum, params: *mut types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint64EXT) -> ()>
                    (*storage::GetVertexAttribLui64vARB.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribLui64vNV(index: types::GLuint, pname: types::GLenum, params: *mut types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLuint64EXT) -> ()>
                    (*storage::GetVertexAttribLui64vNV.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribPointerv(index: types::GLuint, pname: types::GLenum, pointer: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetVertexAttribPointerv.pf)(index, pname, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribPointervARB(index: types::GLuint, pname: types::GLenum, pointer: *const *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetVertexAttribPointervARB.pf)(index, pname, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribdv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetVertexAttribdv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribdvARB(index: types::GLuint, pname: types::GLenum, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLdouble) -> ()>
                    (*storage::GetVertexAttribdvARB.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribfv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetVertexAttribfv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribfvARB(index: types::GLuint, pname: types::GLenum, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLfloat) -> ()>
                    (*storage::GetVertexAttribfvARB.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribiv(index: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexAttribiv.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetVertexAttribivARB(index: types::GLuint, pname: types::GLenum, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *mut types::GLint) -> ()>
                    (*storage::GetVertexAttribivARB.pf)(index, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnColorTable(target: types::GLenum, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, table: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnColorTable.pf)(target, format, type_, bufSize, table)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnColorTableARB(target: types::GLenum, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, table: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnColorTableARB.pf)(target, format, type_, bufSize, table)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnCompressedTexImage(target: types::GLenum, lod: types::GLint, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnCompressedTexImage.pf)(target, lod, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnCompressedTexImageARB(target: types::GLenum, lod: types::GLint, bufSize: types::GLsizei, img: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnCompressedTexImageARB.pf)(target, lod, bufSize, img)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnConvolutionFilter(target: types::GLenum, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, image: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnConvolutionFilter.pf)(target, format, type_, bufSize, image)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnConvolutionFilterARB(target: types::GLenum, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, image: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnConvolutionFilterARB.pf)(target, format, type_, bufSize, image)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnHistogram(target: types::GLenum, reset: types::GLboolean, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, values: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLboolean, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnHistogram.pf)(target, reset, format, type_, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnHistogramARB(target: types::GLenum, reset: types::GLboolean, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, values: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLboolean, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnHistogramARB.pf)(target, reset, format, type_, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapdv(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLdouble) -> ()>
                    (*storage::GetnMapdv.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapdvARB(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLdouble) -> ()>
                    (*storage::GetnMapdvARB.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapfv(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnMapfv.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapfvARB(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnMapfvARB.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapiv(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnMapiv.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMapivARB(target: types::GLenum, query: types::GLenum, bufSize: types::GLsizei, v: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnMapivARB.pf)(target, query, bufSize, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMinmax(target: types::GLenum, reset: types::GLboolean, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, values: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLboolean, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnMinmax.pf)(target, reset, format, type_, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnMinmaxARB(target: types::GLenum, reset: types::GLboolean, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, values: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLboolean, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnMinmaxARB.pf)(target, reset, format, type_, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapfv(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnPixelMapfv.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapfvARB(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnPixelMapfvARB.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapuiv(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetnPixelMapuiv.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapuivARB(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetnPixelMapuivARB.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapusv(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLushort) -> ()>
                    (*storage::GetnPixelMapusv.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPixelMapusvARB(map: types::GLenum, bufSize: types::GLsizei, values: *mut types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *mut types::GLushort) -> ()>
                    (*storage::GetnPixelMapusvARB.pf)(map, bufSize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPolygonStipple(bufSize: types::GLsizei, pattern: *mut types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLubyte) -> ()>
                    (*storage::GetnPolygonStipple.pf)(bufSize, pattern)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnPolygonStippleARB(bufSize: types::GLsizei, pattern: *mut types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLubyte) -> ()>
                    (*storage::GetnPolygonStippleARB.pf)(bufSize, pattern)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnSeparableFilter(target: types::GLenum, format: types::GLenum, type_: types::GLenum, rowBufSize: types::GLsizei, row: *mut __gl_imports::raw::c_void, columnBufSize: types::GLsizei, column: *mut __gl_imports::raw::c_void, span: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void, types::GLsizei, *mut __gl_imports::raw::c_void, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnSeparableFilter.pf)(target, format, type_, rowBufSize, row, columnBufSize, column, span)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnSeparableFilterARB(target: types::GLenum, format: types::GLenum, type_: types::GLenum, rowBufSize: types::GLsizei, row: *mut __gl_imports::raw::c_void, columnBufSize: types::GLsizei, column: *mut __gl_imports::raw::c_void, span: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void, types::GLsizei, *mut __gl_imports::raw::c_void, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnSeparableFilterARB.pf)(target, format, type_, rowBufSize, row, columnBufSize, column, span)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnTexImage(target: types::GLenum, level: types::GLint, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnTexImage.pf)(target, level, format, type_, bufSize, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnTexImageARB(target: types::GLenum, level: types::GLint, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, img: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::GetnTexImageARB.pf)(target, level, format, type_, bufSize, img)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformdv(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLdouble) -> ()>
                    (*storage::GetnUniformdv.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformdvARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLdouble) -> ()>
                    (*storage::GetnUniformdvARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformfv(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnUniformfv.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformfvARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnUniformfvARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformfvEXT(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnUniformfvEXT.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformfvKHR(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLfloat) -> ()>
                    (*storage::GetnUniformfvKHR.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformi64vARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLint64) -> ()>
                    (*storage::GetnUniformi64vARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformiv(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnUniformiv.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformivARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnUniformivARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformivEXT(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnUniformivEXT.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformivKHR(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLint) -> ()>
                    (*storage::GetnUniformivKHR.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformui64vARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLuint64) -> ()>
                    (*storage::GetnUniformui64vARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformuiv(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetnUniformuiv.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformuivARB(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetnUniformuivARB.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn GetnUniformuivKHR(program: types::GLuint, location: types::GLint, bufSize: types::GLsizei, params: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::GetnUniformuivKHR.pf)(program, location, bufSize, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Hint(target: types::GLenum, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::Hint.pf)(target, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IndexMask(mask: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::IndexMask.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IndexPointer(type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::IndexPointer.pf)(type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexd(c: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble) -> ()>
                    (*storage::Indexd.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexdv(c: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Indexdv.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexf(c: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::Indexf.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexfv(c: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Indexfv.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexi(c: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint) -> ()>
                    (*storage::Indexi.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexiv(c: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Indexiv.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexs(c: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort) -> ()>
                    (*storage::Indexs.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexsv(c: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Indexsv.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexub(c: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLubyte) -> ()>
                    (*storage::Indexub.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Indexubv(c: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLubyte) -> ()>
                    (*storage::Indexubv.pf)(c)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InitNames() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::InitNames.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InterleavedArrays(format: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::InterleavedArrays.pf)(format, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateBufferData(buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::InvalidateBufferData.pf)(buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateBufferSubData(buffer: types::GLuint, offset: types::GLintptr, length: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::InvalidateBufferSubData.pf)(buffer, offset, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateFramebuffer(target: types::GLenum, numAttachments: types::GLsizei, attachments: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::InvalidateFramebuffer.pf)(target, numAttachments, attachments)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateNamedFramebufferData(framebuffer: types::GLuint, numAttachments: types::GLsizei, attachments: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::InvalidateNamedFramebufferData.pf)(framebuffer, numAttachments, attachments)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateNamedFramebufferSubData(framebuffer: types::GLuint, numAttachments: types::GLsizei, attachments: *const types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::InvalidateNamedFramebufferSubData.pf)(framebuffer, numAttachments, attachments, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateSubFramebuffer(target: types::GLenum, numAttachments: types::GLsizei, attachments: *const types::GLenum, x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::InvalidateSubFramebuffer.pf)(target, numAttachments, attachments, x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateTexImage(texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint) -> ()>
                    (*storage::InvalidateTexImage.pf)(texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn InvalidateTexSubImage(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::InvalidateTexSubImage.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsBuffer(buffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsBuffer.pf)(buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsBufferARB(buffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsBufferARB.pf)(buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsEnabled(cap: types::GLenum) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLboolean>
                    (*storage::IsEnabled.pf)(cap)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsEnabledIndexedEXT(target: types::GLenum, index: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> types::GLboolean>
                    (*storage::IsEnabledIndexedEXT.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsEnabledi(target: types::GLenum, index: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> types::GLboolean>
                    (*storage::IsEnabledi.pf)(target, index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsFramebuffer(framebuffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsFramebuffer.pf)(framebuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsFramebufferEXT(framebuffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsFramebufferEXT.pf)(framebuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsImageHandleResidentARB(handle: types::GLuint64) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64) -> types::GLboolean>
                    (*storage::IsImageHandleResidentARB.pf)(handle)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsList(list: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsList.pf)(list)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsProgram(program: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsProgram.pf)(program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsProgramPipeline(pipeline: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsProgramPipeline.pf)(pipeline)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsQuery(id: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsQuery.pf)(id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsQueryARB(id: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsQueryARB.pf)(id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsQueryEXT(id: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsQueryEXT.pf)(id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsRenderbuffer(renderbuffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsRenderbuffer.pf)(renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsRenderbufferEXT(renderbuffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsRenderbufferEXT.pf)(renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsSampler(sampler: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsSampler.pf)(sampler)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsShader(shader: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsShader.pf)(shader)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsSync(sync: types::GLsync) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync) -> types::GLboolean>
                    (*storage::IsSync.pf)(sync)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsSyncAPPLE(sync: types::GLsync) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync) -> types::GLboolean>
                    (*storage::IsSyncAPPLE.pf)(sync)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsTexture(texture: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsTexture.pf)(texture)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsTextureHandleResidentARB(handle: types::GLuint64) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64) -> types::GLboolean>
                    (*storage::IsTextureHandleResidentARB.pf)(handle)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsTransformFeedback(id: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsTransformFeedback.pf)(id)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsVertexArray(array: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsVertexArray.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsVertexArrayAPPLE(array: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsVertexArrayAPPLE.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn IsVertexArrayOES(array: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::IsVertexArrayOES.pf)(array)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LightModelf(pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::LightModelf.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LightModelfv(pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::LightModelfv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LightModeli(pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::LightModeli.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LightModeliv(pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::LightModeliv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Lightf(light: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::Lightf.pf)(light, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Lightfv(light: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::Lightfv.pf)(light, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Lighti(light: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::Lighti.pf)(light, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Lightiv(light: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::Lightiv.pf)(light, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LineStipple(factor: types::GLint, pattern: types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLushort) -> ()>
                    (*storage::LineStipple.pf)(factor, pattern)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LineWidth(width: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::LineWidth.pf)(width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LinkProgram(program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::LinkProgram.pf)(program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LinkProgramARB(programObj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB) -> ()>
                    (*storage::LinkProgramARB.pf)(programObj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ListBase(base: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::ListBase.pf)(base)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadIdentity() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::LoadIdentity.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadMatrixd(m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::LoadMatrixd.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadMatrixf(m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::LoadMatrixf.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadName(name: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::LoadName.pf)(name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadTransposeMatrixd(m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::LoadTransposeMatrixd.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LoadTransposeMatrixf(m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::LoadTransposeMatrixf.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn LogicOp(opcode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::LogicOp.pf)(opcode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MakeImageHandleNonResidentARB(handle: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64) -> ()>
                    (*storage::MakeImageHandleNonResidentARB.pf)(handle)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MakeImageHandleResidentARB(handle: types::GLuint64, access: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64, types::GLenum) -> ()>
                    (*storage::MakeImageHandleResidentARB.pf)(handle, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MakeTextureHandleNonResidentARB(handle: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64) -> ()>
                    (*storage::MakeTextureHandleNonResidentARB.pf)(handle)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MakeTextureHandleResidentARB(handle: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint64) -> ()>
                    (*storage::MakeTextureHandleResidentARB.pf)(handle)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Map1d(target: types::GLenum, u1: types::GLdouble, u2: types::GLdouble, stride: types::GLint, order: types::GLint, points: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLint, types::GLint, *const types::GLdouble) -> ()>
                    (*storage::Map1d.pf)(target, u1, u2, stride, order, points)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Map1f(target: types::GLenum, u1: types::GLfloat, u2: types::GLfloat, stride: types::GLint, order: types::GLint, points: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLint, types::GLint, *const types::GLfloat) -> ()>
                    (*storage::Map1f.pf)(target, u1, u2, stride, order, points)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Map2d(target: types::GLenum, u1: types::GLdouble, u2: types::GLdouble, ustride: types::GLint, uorder: types::GLint, v1: types::GLdouble, v2: types::GLdouble, vstride: types::GLint, vorder: types::GLint, points: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLint, types::GLint, types::GLdouble, types::GLdouble, types::GLint, types::GLint, *const types::GLdouble) -> ()>
                    (*storage::Map2d.pf)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Map2f(target: types::GLenum, u1: types::GLfloat, u2: types::GLfloat, ustride: types::GLint, uorder: types::GLint, v1: types::GLfloat, v2: types::GLfloat, vstride: types::GLint, vorder: types::GLint, points: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLint, types::GLint, types::GLfloat, types::GLfloat, types::GLint, types::GLint, *const types::GLfloat) -> ()>
                    (*storage::Map2f.pf)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapBuffer(target: types::GLenum, access: types::GLenum) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapBuffer.pf)(target, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapBufferARB(target: types::GLenum, access: types::GLenum) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapBufferARB.pf)(target, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapBufferRange(target: types::GLenum, offset: types::GLintptr, length: types::GLsizeiptr, access: types::GLbitfield) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLintptr, types::GLsizeiptr, types::GLbitfield) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapBufferRange.pf)(target, offset, length, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapGrid1d(un: types::GLint, u1: types::GLdouble, u2: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MapGrid1d.pf)(un, u1, u2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapGrid1f(un: types::GLint, u1: types::GLfloat, u2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MapGrid1f.pf)(un, u1, u2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapGrid2d(un: types::GLint, u1: types::GLdouble, u2: types::GLdouble, vn: types::GLint, v1: types::GLdouble, v2: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble, types::GLdouble, types::GLint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MapGrid2d.pf)(un, u1, u2, vn, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapGrid2f(un: types::GLint, u1: types::GLfloat, u2: types::GLfloat, vn: types::GLint, v1: types::GLfloat, v2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat, types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MapGrid2f.pf)(un, u1, u2, vn, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapNamedBuffer(buffer: types::GLuint, access: types::GLenum) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapNamedBuffer.pf)(buffer, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapNamedBufferEXT(buffer: types::GLuint, access: types::GLenum) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapNamedBufferEXT.pf)(buffer, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapNamedBufferRange(buffer: types::GLuint, offset: types::GLintptr, length: types::GLsizeiptr, access: types::GLbitfield) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, types::GLbitfield) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapNamedBufferRange.pf)(buffer, offset, length, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MapNamedBufferRangeEXT(buffer: types::GLuint, offset: types::GLintptr, length: types::GLsizeiptr, access: types::GLbitfield) -> *mut __gl_imports::raw::c_void {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, types::GLbitfield) -> *mut __gl_imports::raw::c_void>
                    (*storage::MapNamedBufferRangeEXT.pf)(buffer, offset, length, access)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Materialf(face: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::Materialf.pf)(face, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Materialfv(face: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::Materialfv.pf)(face, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Materiali(face: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::Materiali.pf)(face, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Materialiv(face: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::Materialiv.pf)(face, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixFrustumEXT(mode: types::GLenum, left: types::GLdouble, right: types::GLdouble, bottom: types::GLdouble, top: types::GLdouble, zNear: types::GLdouble, zFar: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MatrixFrustumEXT.pf)(mode, left, right, bottom, top, zNear, zFar)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixLoadIdentityEXT(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::MatrixLoadIdentityEXT.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixLoadTransposedEXT(mode: types::GLenum, m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MatrixLoadTransposedEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixLoadTransposefEXT(mode: types::GLenum, m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MatrixLoadTransposefEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixLoaddEXT(mode: types::GLenum, m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MatrixLoaddEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixLoadfEXT(mode: types::GLenum, m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MatrixLoadfEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixMode(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::MatrixMode.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixMultTransposedEXT(mode: types::GLenum, m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MatrixMultTransposedEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixMultTransposefEXT(mode: types::GLenum, m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MatrixMultTransposefEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixMultdEXT(mode: types::GLenum, m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MatrixMultdEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixMultfEXT(mode: types::GLenum, m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MatrixMultfEXT.pf)(mode, m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixOrthoEXT(mode: types::GLenum, left: types::GLdouble, right: types::GLdouble, bottom: types::GLdouble, top: types::GLdouble, zNear: types::GLdouble, zFar: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MatrixOrthoEXT.pf)(mode, left, right, bottom, top, zNear, zFar)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixPopEXT(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::MatrixPopEXT.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixPushEXT(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::MatrixPushEXT.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixRotatedEXT(mode: types::GLenum, angle: types::GLdouble, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MatrixRotatedEXT.pf)(mode, angle, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixRotatefEXT(mode: types::GLenum, angle: types::GLfloat, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MatrixRotatefEXT.pf)(mode, angle, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixScaledEXT(mode: types::GLenum, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MatrixScaledEXT.pf)(mode, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixScalefEXT(mode: types::GLenum, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MatrixScalefEXT.pf)(mode, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixTranslatedEXT(mode: types::GLenum, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MatrixTranslatedEXT.pf)(mode, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MatrixTranslatefEXT(mode: types::GLenum, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MatrixTranslatefEXT.pf)(mode, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MemoryBarrier(barriers: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::MemoryBarrier.pf)(barriers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MemoryBarrierByRegion(barriers: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::MemoryBarrierByRegion.pf)(barriers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MinSampleShading(value: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::MinSampleShading.pf)(value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultMatrixd(m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::MultMatrixd.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultMatrixf(m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::MultMatrixf.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultTransposeMatrixd(m: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::MultTransposeMatrixd.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultTransposeMatrixf(m: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::MultTransposeMatrixf.pf)(m)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawArrays(mode: types::GLenum, first: *const types::GLint, count: *const types::GLsizei, drawcount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint, *const types::GLsizei, types::GLsizei) -> ()>
                    (*storage::MultiDrawArrays.pf)(mode, first, count, drawcount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawArraysIndirect(mode: types::GLenum, indirect: *const __gl_imports::raw::c_void, drawcount: types::GLsizei, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::MultiDrawArraysIndirect.pf)(mode, indirect, drawcount, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawArraysIndirectEXT(mode: types::GLenum, indirect: *const __gl_imports::raw::c_void, drawcount: types::GLsizei, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::MultiDrawArraysIndirectEXT.pf)(mode, indirect, drawcount, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawElements(mode: types::GLenum, count: *const types::GLsizei, type_: types::GLenum, indices: *const *const __gl_imports::raw::c_void, drawcount: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLsizei, types::GLenum, *const *const __gl_imports::raw::c_void, types::GLsizei) -> ()>
                    (*storage::MultiDrawElements.pf)(mode, count, type_, indices, drawcount)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawElementsBaseVertex(mode: types::GLenum, count: *const types::GLsizei, type_: types::GLenum, indices: *const *const __gl_imports::raw::c_void, drawcount: types::GLsizei, basevertex: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLsizei, types::GLenum, *const *const __gl_imports::raw::c_void, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::MultiDrawElementsBaseVertex.pf)(mode, count, type_, indices, drawcount, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawElementsBaseVertexEXT(mode: types::GLenum, count: *const types::GLsizei, type_: types::GLenum, indices: *const *const __gl_imports::raw::c_void, primcount: types::GLsizei, basevertex: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLsizei, types::GLenum, *const *const __gl_imports::raw::c_void, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::MultiDrawElementsBaseVertexEXT.pf)(mode, count, type_, indices, primcount, basevertex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawElementsIndirect(mode: types::GLenum, type_: types::GLenum, indirect: *const __gl_imports::raw::c_void, drawcount: types::GLsizei, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::MultiDrawElementsIndirect.pf)(mode, type_, indirect, drawcount, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiDrawElementsIndirectEXT(mode: types::GLenum, type_: types::GLenum, indirect: *const __gl_imports::raw::c_void, drawcount: types::GLsizei, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::MultiDrawElementsIndirectEXT.pf)(mode, type_, indirect, drawcount, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexBufferEXT(texunit: types::GLenum, target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexBufferEXT.pf)(texunit, target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1d(target: types::GLenum, s: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble) -> ()>
                    (*storage::MultiTexCoord1d.pf)(target, s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1dv(target: types::GLenum, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MultiTexCoord1dv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1f(target: types::GLenum, s: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::MultiTexCoord1f.pf)(target, s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1fv(target: types::GLenum, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexCoord1fv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1i(target: types::GLenum, s: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::MultiTexCoord1i.pf)(target, s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1iv(target: types::GLenum, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexCoord1iv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1s(target: types::GLenum, s: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLshort) -> ()>
                    (*storage::MultiTexCoord1s.pf)(target, s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord1sv(target: types::GLenum, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLshort) -> ()>
                    (*storage::MultiTexCoord1sv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2d(target: types::GLenum, s: types::GLdouble, t: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MultiTexCoord2d.pf)(target, s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2dv(target: types::GLenum, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MultiTexCoord2dv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2f(target: types::GLenum, s: types::GLfloat, t: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MultiTexCoord2f.pf)(target, s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2fv(target: types::GLenum, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexCoord2fv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2i(target: types::GLenum, s: types::GLint, t: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint) -> ()>
                    (*storage::MultiTexCoord2i.pf)(target, s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2iv(target: types::GLenum, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexCoord2iv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2s(target: types::GLenum, s: types::GLshort, t: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLshort, types::GLshort) -> ()>
                    (*storage::MultiTexCoord2s.pf)(target, s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord2sv(target: types::GLenum, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLshort) -> ()>
                    (*storage::MultiTexCoord2sv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3d(target: types::GLenum, s: types::GLdouble, t: types::GLdouble, r: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MultiTexCoord3d.pf)(target, s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3dv(target: types::GLenum, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MultiTexCoord3dv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3f(target: types::GLenum, s: types::GLfloat, t: types::GLfloat, r: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MultiTexCoord3f.pf)(target, s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3fv(target: types::GLenum, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexCoord3fv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3i(target: types::GLenum, s: types::GLint, t: types::GLint, r: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::MultiTexCoord3i.pf)(target, s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3iv(target: types::GLenum, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexCoord3iv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3s(target: types::GLenum, s: types::GLshort, t: types::GLshort, r: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::MultiTexCoord3s.pf)(target, s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord3sv(target: types::GLenum, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLshort) -> ()>
                    (*storage::MultiTexCoord3sv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4d(target: types::GLenum, s: types::GLdouble, t: types::GLdouble, r: types::GLdouble, q: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::MultiTexCoord4d.pf)(target, s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4dv(target: types::GLenum, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MultiTexCoord4dv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4f(target: types::GLenum, s: types::GLfloat, t: types::GLfloat, r: types::GLfloat, q: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::MultiTexCoord4f.pf)(target, s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4fv(target: types::GLenum, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexCoord4fv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4i(target: types::GLenum, s: types::GLint, t: types::GLint, r: types::GLint, q: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::MultiTexCoord4i.pf)(target, s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4iv(target: types::GLenum, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexCoord4iv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4s(target: types::GLenum, s: types::GLshort, t: types::GLshort, r: types::GLshort, q: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::MultiTexCoord4s.pf)(target, s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoord4sv(target: types::GLenum, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLshort) -> ()>
                    (*storage::MultiTexCoord4sv.pf)(target, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP1ui(texture: types::GLenum, type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexCoordP1ui.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP1uiv(texture: types::GLenum, type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::MultiTexCoordP1uiv.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP2ui(texture: types::GLenum, type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexCoordP2ui.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP2uiv(texture: types::GLenum, type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::MultiTexCoordP2uiv.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP3ui(texture: types::GLenum, type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexCoordP3ui.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP3uiv(texture: types::GLenum, type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::MultiTexCoordP3uiv.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP4ui(texture: types::GLenum, type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexCoordP4ui.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordP4uiv(texture: types::GLenum, type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::MultiTexCoordP4uiv.pf)(texture, type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexCoordPointerEXT(texunit: types::GLenum, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexCoordPointerEXT.pf)(texunit, size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexEnvfEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::MultiTexEnvfEXT.pf)(texunit, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexEnvfvEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexEnvfvEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexEnviEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::MultiTexEnviEXT.pf)(texunit, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexEnvivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexEnvivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGendEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, param: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLdouble) -> ()>
                    (*storage::MultiTexGendEXT.pf)(texunit, coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGendvEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::MultiTexGendvEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGenfEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::MultiTexGenfEXT.pf)(texunit, coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGenfvEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexGenfvEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGeniEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::MultiTexGeniEXT.pf)(texunit, coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexGenivEXT(texunit: types::GLenum, coord: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexGenivEXT.pf)(texunit, coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexImage1DEXT.pf)(texunit, target, level, internalformat, width, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexImage2DEXT.pf)(texunit, target, level, internalformat, width, height, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexImage3DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexImage3DEXT.pf)(texunit, target, level, internalformat, width, height, depth, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameterIivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexParameterIivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameterIuivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::MultiTexParameterIuivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameterfEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::MultiTexParameterfEXT.pf)(texunit, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameterfvEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::MultiTexParameterfvEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameteriEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::MultiTexParameteriEXT.pf)(texunit, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexParameterivEXT(texunit: types::GLenum, target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::MultiTexParameterivEXT.pf)(texunit, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexRenderbufferEXT(texunit: types::GLenum, target: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::MultiTexRenderbufferEXT.pf)(texunit, target, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexSubImage1DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexSubImage1DEXT.pf)(texunit, target, level, xoffset, width, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexSubImage2DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexSubImage2DEXT.pf)(texunit, target, level, xoffset, yoffset, width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn MultiTexSubImage3DEXT(texunit: types::GLenum, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::MultiTexSubImage3DEXT.pf)(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferData(buffer: types::GLuint, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, usage: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLenum) -> ()>
                    (*storage::NamedBufferData.pf)(buffer, size, data, usage)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferDataEXT(buffer: types::GLuint, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, usage: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLenum) -> ()>
                    (*storage::NamedBufferDataEXT.pf)(buffer, size, data, usage)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferStorage(buffer: types::GLuint, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, flags: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLbitfield) -> ()>
                    (*storage::NamedBufferStorage.pf)(buffer, size, data, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferStorageEXT(buffer: types::GLuint, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void, flags: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizeiptr, *const __gl_imports::raw::c_void, types::GLbitfield) -> ()>
                    (*storage::NamedBufferStorageEXT.pf)(buffer, size, data, flags)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferSubData(buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::NamedBufferSubData.pf)(buffer, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedBufferSubDataEXT(buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr, data: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLintptr, types::GLsizeiptr, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::NamedBufferSubDataEXT.pf)(buffer, offset, size, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedCopyBufferSubDataEXT(readBuffer: types::GLuint, writeBuffer: types::GLuint, readOffset: types::GLintptr, writeOffset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLintptr, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::NamedCopyBufferSubDataEXT.pf)(readBuffer, writeBuffer, readOffset, writeOffset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferDrawBuffer(framebuffer: types::GLuint, buf: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::NamedFramebufferDrawBuffer.pf)(framebuffer, buf)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferDrawBuffers(framebuffer: types::GLuint, n: types::GLsizei, bufs: *const types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLenum) -> ()>
                    (*storage::NamedFramebufferDrawBuffers.pf)(framebuffer, n, bufs)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferParameteri(framebuffer: types::GLuint, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::NamedFramebufferParameteri.pf)(framebuffer, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferParameteriEXT(framebuffer: types::GLuint, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::NamedFramebufferParameteriEXT.pf)(framebuffer, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferReadBuffer(framebuffer: types::GLuint, src: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::NamedFramebufferReadBuffer.pf)(framebuffer, src)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferRenderbuffer(framebuffer: types::GLuint, attachment: types::GLenum, renderbuffertarget: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::NamedFramebufferRenderbuffer.pf)(framebuffer, attachment, renderbuffertarget, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferRenderbufferEXT(framebuffer: types::GLuint, attachment: types::GLenum, renderbuffertarget: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::NamedFramebufferRenderbufferEXT.pf)(framebuffer, attachment, renderbuffertarget, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTexture(framebuffer: types::GLuint, attachment: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTexture.pf)(framebuffer, attachment, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTexture1DEXT(framebuffer: types::GLuint, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTexture1DEXT.pf)(framebuffer, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTexture2DEXT(framebuffer: types::GLuint, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTexture2DEXT.pf)(framebuffer, attachment, textarget, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTexture3DEXT(framebuffer: types::GLuint, attachment: types::GLenum, textarget: types::GLenum, texture: types::GLuint, level: types::GLint, zoffset: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTexture3DEXT.pf)(framebuffer, attachment, textarget, texture, level, zoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTextureEXT(framebuffer: types::GLuint, attachment: types::GLenum, texture: types::GLuint, level: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTextureEXT.pf)(framebuffer, attachment, texture, level)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTextureFaceEXT(framebuffer: types::GLuint, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, face: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint, types::GLenum) -> ()>
                    (*storage::NamedFramebufferTextureFaceEXT.pf)(framebuffer, attachment, texture, level, face)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTextureLayer(framebuffer: types::GLuint, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, layer: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTextureLayer.pf)(framebuffer, attachment, texture, level, layer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedFramebufferTextureLayerEXT(framebuffer: types::GLuint, attachment: types::GLenum, texture: types::GLuint, level: types::GLint, layer: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::NamedFramebufferTextureLayerEXT.pf)(framebuffer, attachment, texture, level, layer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameter4dEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::NamedProgramLocalParameter4dEXT.pf)(program, target, index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameter4dvEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::NamedProgramLocalParameter4dvEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameter4fEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat, w: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::NamedProgramLocalParameter4fEXT.pf)(program, target, index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameter4fvEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::NamedProgramLocalParameter4fvEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameterI4iEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, x: types::GLint, y: types::GLint, z: types::GLint, w: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::NamedProgramLocalParameterI4iEXT.pf)(program, target, index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameterI4ivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *const types::GLint) -> ()>
                    (*storage::NamedProgramLocalParameterI4ivEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameterI4uiEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, x: types::GLuint, y: types::GLuint, z: types::GLuint, w: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::NamedProgramLocalParameterI4uiEXT.pf)(program, target, index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameterI4uivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, *const types::GLuint) -> ()>
                    (*storage::NamedProgramLocalParameterI4uivEXT.pf)(program, target, index, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParameters4fvEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, count: types::GLsizei, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::NamedProgramLocalParameters4fvEXT.pf)(program, target, index, count, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParametersI4ivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, count: types::GLsizei, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::NamedProgramLocalParametersI4ivEXT.pf)(program, target, index, count, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramLocalParametersI4uivEXT(program: types::GLuint, target: types::GLenum, index: types::GLuint, count: types::GLsizei, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::NamedProgramLocalParametersI4uivEXT.pf)(program, target, index, count, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedProgramStringEXT(program: types::GLuint, target: types::GLenum, format: types::GLenum, len: types::GLsizei, string: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::NamedProgramStringEXT.pf)(program, target, format, len, string)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedRenderbufferStorage(renderbuffer: types::GLuint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::NamedRenderbufferStorage.pf)(renderbuffer, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedRenderbufferStorageEXT(renderbuffer: types::GLuint, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::NamedRenderbufferStorageEXT.pf)(renderbuffer, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedRenderbufferStorageMultisample(renderbuffer: types::GLuint, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::NamedRenderbufferStorageMultisample.pf)(renderbuffer, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedRenderbufferStorageMultisampleCoverageEXT(renderbuffer: types::GLuint, coverageSamples: types::GLsizei, colorSamples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::NamedRenderbufferStorageMultisampleCoverageEXT.pf)(renderbuffer, coverageSamples, colorSamples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NamedRenderbufferStorageMultisampleEXT(renderbuffer: types::GLuint, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::NamedRenderbufferStorageMultisampleEXT.pf)(renderbuffer, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NewList(list: types::GLuint, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::NewList.pf)(list, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3b(nx: types::GLbyte, ny: types::GLbyte, nz: types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbyte, types::GLbyte, types::GLbyte) -> ()>
                    (*storage::Normal3b.pf)(nx, ny, nz)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3bv(v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLbyte) -> ()>
                    (*storage::Normal3bv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3d(nx: types::GLdouble, ny: types::GLdouble, nz: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Normal3d.pf)(nx, ny, nz)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Normal3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3f(nx: types::GLfloat, ny: types::GLfloat, nz: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Normal3f.pf)(nx, ny, nz)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Normal3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3i(nx: types::GLint, ny: types::GLint, nz: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Normal3i.pf)(nx, ny, nz)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Normal3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3s(nx: types::GLshort, ny: types::GLshort, nz: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Normal3s.pf)(nx, ny, nz)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Normal3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Normal3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NormalP3ui(type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::NormalP3ui.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NormalP3uiv(type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::NormalP3uiv.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn NormalPointer(type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::NormalPointer.pf)(type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ObjectLabel(identifier: types::GLenum, name: types::GLuint, length: types::GLsizei, label: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::ObjectLabel.pf)(identifier, name, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ObjectLabelKHR(identifier: types::GLenum, name: types::GLuint, length: types::GLsizei, label: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::ObjectLabelKHR.pf)(identifier, name, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ObjectPtrLabel(ptr: *const __gl_imports::raw::c_void, length: types::GLsizei, label: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const __gl_imports::raw::c_void, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::ObjectPtrLabel.pf)(ptr, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ObjectPtrLabelKHR(ptr: *const __gl_imports::raw::c_void, length: types::GLsizei, label: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const __gl_imports::raw::c_void, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::ObjectPtrLabelKHR.pf)(ptr, length, label)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Ortho(left: types::GLdouble, right: types::GLdouble, bottom: types::GLdouble, top: types::GLdouble, zNear: types::GLdouble, zFar: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Ortho.pf)(left, right, bottom, top, zNear, zFar)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PassThrough(token: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::PassThrough.pf)(token)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PatchParameterfv(pname: types::GLenum, values: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::PatchParameterfv.pf)(pname, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PatchParameteri(pname: types::GLenum, value: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::PatchParameteri.pf)(pname, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PauseTransformFeedback() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PauseTransformFeedback.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelMapfv(map: types::GLenum, mapsize: types::GLsizei, values: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::PixelMapfv.pf)(map, mapsize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelMapuiv(map: types::GLenum, mapsize: types::GLsizei, values: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::PixelMapuiv.pf)(map, mapsize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelMapusv(map: types::GLenum, mapsize: types::GLsizei, values: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLushort) -> ()>
                    (*storage::PixelMapusv.pf)(map, mapsize, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelStoref(pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::PixelStoref.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelStorei(pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::PixelStorei.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelTransferf(pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::PixelTransferf.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelTransferi(pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::PixelTransferi.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PixelZoom(xfactor: types::GLfloat, yfactor: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PixelZoom.pf)(xfactor, yfactor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PointParameterf(pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLfloat) -> ()>
                    (*storage::PointParameterf.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PointParameterfv(pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::PointParameterfv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PointParameteri(pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint) -> ()>
                    (*storage::PointParameteri.pf)(pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PointParameteriv(pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLint) -> ()>
                    (*storage::PointParameteriv.pf)(pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PointSize(size: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::PointSize.pf)(size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PolygonMode(face: types::GLenum, mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum) -> ()>
                    (*storage::PolygonMode.pf)(face, mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PolygonOffset(factor: types::GLfloat, units: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PolygonOffset.pf)(factor, units)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PolygonStipple(mask: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLubyte) -> ()>
                    (*storage::PolygonStipple.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopAttrib() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopAttrib.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopClientAttrib() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopClientAttrib.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopDebugGroup() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopDebugGroup.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopDebugGroupKHR() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopDebugGroupKHR.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopMatrix() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopMatrix.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PopName() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PopName.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrimitiveBoundingBox(minX: types::GLfloat, minY: types::GLfloat, minZ: types::GLfloat, minW: types::GLfloat, maxX: types::GLfloat, maxY: types::GLfloat, maxZ: types::GLfloat, maxW: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PrimitiveBoundingBox.pf)(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrimitiveBoundingBoxARB(minX: types::GLfloat, minY: types::GLfloat, minZ: types::GLfloat, minW: types::GLfloat, maxX: types::GLfloat, maxY: types::GLfloat, maxZ: types::GLfloat, maxW: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PrimitiveBoundingBoxARB.pf)(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrimitiveBoundingBoxEXT(minX: types::GLfloat, minY: types::GLfloat, minZ: types::GLfloat, minW: types::GLfloat, maxX: types::GLfloat, maxY: types::GLfloat, maxZ: types::GLfloat, maxW: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PrimitiveBoundingBoxEXT.pf)(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrimitiveBoundingBoxOES(minX: types::GLfloat, minY: types::GLfloat, minZ: types::GLfloat, minW: types::GLfloat, maxX: types::GLfloat, maxY: types::GLfloat, maxZ: types::GLfloat, maxW: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::PrimitiveBoundingBoxOES.pf)(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrimitiveRestartIndex(index: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::PrimitiveRestartIndex.pf)(index)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PrioritizeTextures(n: types::GLsizei, textures: *const types::GLuint, priorities: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::PrioritizeTextures.pf)(n, textures, priorities)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramBinary(program: types::GLuint, binaryFormat: types::GLenum, binary: *const __gl_imports::raw::c_void, length: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei) -> ()>
                    (*storage::ProgramBinary.pf)(program, binaryFormat, binary, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramParameteri(program: types::GLuint, pname: types::GLenum, value: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::ProgramParameteri.pf)(program, pname, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramParameteriARB(program: types::GLuint, pname: types::GLenum, value: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::ProgramParameteriARB.pf)(program, pname, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1d(program: types::GLuint, location: types::GLint, v0: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble) -> ()>
                    (*storage::ProgramUniform1d.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1dEXT(program: types::GLuint, location: types::GLint, x: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble) -> ()>
                    (*storage::ProgramUniform1dEXT.pf)(program, location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform1dv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform1dvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1f(program: types::GLuint, location: types::GLint, v0: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat) -> ()>
                    (*storage::ProgramUniform1f.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1fEXT(program: types::GLuint, location: types::GLint, v0: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat) -> ()>
                    (*storage::ProgramUniform1fEXT.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform1fv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform1fvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1i(program: types::GLuint, location: types::GLint, v0: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform1i.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1i64ARB(program: types::GLuint, location: types::GLint, x: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint64) -> ()>
                    (*storage::ProgramUniform1i64ARB.pf)(program, location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1i64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::ProgramUniform1i64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1iEXT(program: types::GLuint, location: types::GLint, v0: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform1iEXT.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1iv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform1iv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1ivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform1ivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1ui(program: types::GLuint, location: types::GLint, v0: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint) -> ()>
                    (*storage::ProgramUniform1ui.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1ui64ARB(program: types::GLuint, location: types::GLint, x: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint64) -> ()>
                    (*storage::ProgramUniform1ui64ARB.pf)(program, location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1ui64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::ProgramUniform1ui64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1uiEXT(program: types::GLuint, location: types::GLint, v0: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint) -> ()>
                    (*storage::ProgramUniform1uiEXT.pf)(program, location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1uiv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform1uiv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform1uivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform1uivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2d(program: types::GLuint, location: types::GLint, v0: types::GLdouble, v1: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform2d.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2dEXT(program: types::GLuint, location: types::GLint, x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform2dEXT.pf)(program, location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform2dv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform2dvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2f(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform2f.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2fEXT(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform2fEXT.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform2fv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform2fvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2i(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform2i.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2i64ARB(program: types::GLuint, location: types::GLint, x: types::GLint64, y: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint64, types::GLint64) -> ()>
                    (*storage::ProgramUniform2i64ARB.pf)(program, location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2i64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::ProgramUniform2i64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2iEXT(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform2iEXT.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2iv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform2iv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2ivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform2ivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2ui(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform2ui.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2ui64ARB(program: types::GLuint, location: types::GLint, x: types::GLuint64, y: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::ProgramUniform2ui64ARB.pf)(program, location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2ui64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::ProgramUniform2ui64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2uiEXT(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform2uiEXT.pf)(program, location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2uiv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform2uiv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform2uivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform2uivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3d(program: types::GLuint, location: types::GLint, v0: types::GLdouble, v1: types::GLdouble, v2: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform3d.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3dEXT(program: types::GLuint, location: types::GLint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform3dEXT.pf)(program, location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform3dv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform3dvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3f(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform3f.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3fEXT(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform3fEXT.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform3fv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform3fvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3i(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform3i.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3i64ARB(program: types::GLuint, location: types::GLint, x: types::GLint64, y: types::GLint64, z: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint64, types::GLint64, types::GLint64) -> ()>
                    (*storage::ProgramUniform3i64ARB.pf)(program, location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3i64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::ProgramUniform3i64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3iEXT(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform3iEXT.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3iv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform3iv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3ivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform3ivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3ui(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform3ui.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3ui64ARB(program: types::GLuint, location: types::GLint, x: types::GLuint64, y: types::GLuint64, z: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint64, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::ProgramUniform3ui64ARB.pf)(program, location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3ui64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::ProgramUniform3ui64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3uiEXT(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform3uiEXT.pf)(program, location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3uiv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform3uiv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform3uivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform3uivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4d(program: types::GLuint, location: types::GLint, v0: types::GLdouble, v1: types::GLdouble, v2: types::GLdouble, v3: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform4d.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4dEXT(program: types::GLuint, location: types::GLint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::ProgramUniform4dEXT.pf)(program, location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform4dv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniform4dvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4f(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat, v3: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform4f.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4fEXT(program: types::GLuint, location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat, v3: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ProgramUniform4fEXT.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform4fv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniform4fvEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4i(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint, v3: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform4i.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4i64ARB(program: types::GLuint, location: types::GLint, x: types::GLint64, y: types::GLint64, z: types::GLint64, w: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint64, types::GLint64, types::GLint64, types::GLint64) -> ()>
                    (*storage::ProgramUniform4i64ARB.pf)(program, location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4i64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::ProgramUniform4i64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4iEXT(program: types::GLuint, location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint, v3: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::ProgramUniform4iEXT.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4iv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform4iv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4ivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ProgramUniform4ivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4ui(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint, v3: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform4ui.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4ui64ARB(program: types::GLuint, location: types::GLint, x: types::GLuint64, y: types::GLuint64, z: types::GLuint64, w: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint64, types::GLuint64, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::ProgramUniform4ui64ARB.pf)(program, location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4ui64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::ProgramUniform4ui64vARB.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4uiEXT(program: types::GLuint, location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint, v3: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ProgramUniform4uiEXT.pf)(program, location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4uiv(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform4uiv.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniform4uivEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::ProgramUniform4uivEXT.pf)(program, location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformHandleui64ARB(program: types::GLuint, location: types::GLint, value: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLuint64) -> ()>
                    (*storage::ProgramUniformHandleui64ARB.pf)(program, location, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformHandleui64vARB(program: types::GLuint, location: types::GLint, count: types::GLsizei, values: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::ProgramUniformHandleui64vARB.pf)(program, location, count, values)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x3dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2x3dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x3dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2x3dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x3fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2x3fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x3fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2x3fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x4dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2x4dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x4dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix2x4dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x4fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2x4fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix2x4fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix2x4fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x2dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3x2dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x2dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3x2dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x2fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3x2fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x2fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3x2fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x4dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3x4dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x4dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix3x4dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x4fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3x4fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix3x4fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix3x4fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x2dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4x2dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x2dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4x2dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x2fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4x2fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x2fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4x2fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x3dv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4x3dv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x3dvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::ProgramUniformMatrix4x3dvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x3fv(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4x3fv.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProgramUniformMatrix4x3fvEXT(program: types::GLuint, location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::ProgramUniformMatrix4x3fvEXT.pf)(program, location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProvokingVertex(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ProvokingVertex.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ProvokingVertexEXT(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ProvokingVertexEXT.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushAttrib(mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::PushAttrib.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushClientAttrib(mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::PushClientAttrib.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushClientAttribDefaultEXT(mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbitfield) -> ()>
                    (*storage::PushClientAttribDefaultEXT.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushDebugGroup(source: types::GLenum, id: types::GLuint, length: types::GLsizei, message: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::PushDebugGroup.pf)(source, id, length, message)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushDebugGroupKHR(source: types::GLenum, id: types::GLuint, length: types::GLsizei, message: *const types::GLchar) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint, types::GLsizei, *const types::GLchar) -> ()>
                    (*storage::PushDebugGroupKHR.pf)(source, id, length, message)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushMatrix() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::PushMatrix.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn PushName(name: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::PushName.pf)(name)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn QueryCounter(id: types::GLuint, target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::QueryCounter.pf)(id, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn QueryCounterEXT(id: types::GLuint, target: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum) -> ()>
                    (*storage::QueryCounterEXT.pf)(id, target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2d(x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::RasterPos2d.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::RasterPos2dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2f(x: types::GLfloat, y: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::RasterPos2f.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::RasterPos2fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2i(x: types::GLint, y: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::RasterPos2i.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::RasterPos2iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2s(x: types::GLshort, y: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort) -> ()>
                    (*storage::RasterPos2s.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos2sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::RasterPos2sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3d(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::RasterPos3d.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::RasterPos3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3f(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::RasterPos3f.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::RasterPos3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3i(x: types::GLint, y: types::GLint, z: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::RasterPos3i.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::RasterPos3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3s(x: types::GLshort, y: types::GLshort, z: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::RasterPos3s.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::RasterPos3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4d(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::RasterPos4d.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::RasterPos4dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4f(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat, w: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::RasterPos4f.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::RasterPos4fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4i(x: types::GLint, y: types::GLint, z: types::GLint, w: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::RasterPos4i.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::RasterPos4iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4s(x: types::GLshort, y: types::GLshort, z: types::GLshort, w: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::RasterPos4s.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RasterPos4sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::RasterPos4sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadBuffer(src: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ReadBuffer.pf)(src)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadPixels(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::ReadPixels.pf)(x, y, width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadnPixels(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::ReadnPixels.pf)(x, y, width, height, format, type_, bufSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadnPixelsARB(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::ReadnPixelsARB.pf)(x, y, width, height, format, type_, bufSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadnPixelsEXT(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::ReadnPixelsEXT.pf)(x, y, width, height, format, type_, bufSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReadnPixelsKHR(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, bufSize: types::GLsizei, data: *mut __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, types::GLsizei, *mut __gl_imports::raw::c_void) -> ()>
                    (*storage::ReadnPixelsKHR.pf)(x, y, width, height, format, type_, bufSize, data)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectd(x1: types::GLdouble, y1: types::GLdouble, x2: types::GLdouble, y2: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Rectd.pf)(x1, y1, x2, y2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectdv(v1: *const types::GLdouble, v2: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble, *const types::GLdouble) -> ()>
                    (*storage::Rectdv.pf)(v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectf(x1: types::GLfloat, y1: types::GLfloat, x2: types::GLfloat, y2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Rectf.pf)(x1, y1, x2, y2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectfv(v1: *const types::GLfloat, v2: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat, *const types::GLfloat) -> ()>
                    (*storage::Rectfv.pf)(v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Recti(x1: types::GLint, y1: types::GLint, x2: types::GLint, y2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Recti.pf)(x1, y1, x2, y2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectiv(v1: *const types::GLint, v2: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint, *const types::GLint) -> ()>
                    (*storage::Rectiv.pf)(v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rects(x1: types::GLshort, y1: types::GLshort, x2: types::GLshort, y2: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Rects.pf)(x1, y1, x2, y2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rectsv(v1: *const types::GLshort, v2: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort, *const types::GLshort) -> ()>
                    (*storage::Rectsv.pf)(v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ReleaseShaderCompiler() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::ReleaseShaderCompiler.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderMode(mode: types::GLenum) -> types::GLint {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLint>
                    (*storage::RenderMode.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorage(target: types::GLenum, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorage.pf)(target, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageEXT(target: types::GLenum, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageEXT.pf)(target, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageMultisample(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageMultisample.pf)(target, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageMultisampleANGLE(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageMultisampleANGLE.pf)(target, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageMultisampleAPPLE(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageMultisampleAPPLE.pf)(target, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageMultisampleEXT(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageMultisampleEXT.pf)(target, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn RenderbufferStorageMultisampleNV(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::RenderbufferStorageMultisampleNV.pf)(target, samples, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ResolveMultisampleFramebufferAPPLE() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::ResolveMultisampleFramebufferAPPLE.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ResumeTransformFeedback() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::ResumeTransformFeedback.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rotated(angle: types::GLdouble, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Rotated.pf)(angle, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Rotatef(angle: types::GLfloat, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Rotatef.pf)(angle, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SampleCoverage(value: types::GLfloat, invert: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLboolean) -> ()>
                    (*storage::SampleCoverage.pf)(value, invert)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SampleMaski(maskNumber: types::GLuint, mask: types::GLbitfield) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLbitfield) -> ()>
                    (*storage::SampleMaski.pf)(maskNumber, mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameterIiv(sampler: types::GLuint, pname: types::GLenum, param: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLint) -> ()>
                    (*storage::SamplerParameterIiv.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameterIuiv(sampler: types::GLuint, pname: types::GLenum, param: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::SamplerParameterIuiv.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameterf(sampler: types::GLuint, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLfloat) -> ()>
                    (*storage::SamplerParameterf.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameterfv(sampler: types::GLuint, pname: types::GLenum, param: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::SamplerParameterfv.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameteri(sampler: types::GLuint, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::SamplerParameteri.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SamplerParameteriv(sampler: types::GLuint, pname: types::GLenum, param: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLint) -> ()>
                    (*storage::SamplerParameteriv.pf)(sampler, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Scaled(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Scaled.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Scalef(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Scalef.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Scissor(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::Scissor.pf)(x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ScissorArrayv(first: types::GLuint, count: types::GLsizei, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::ScissorArrayv.pf)(first, count, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ScissorIndexed(index: types::GLuint, left: types::GLint, bottom: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::ScissorIndexed.pf)(index, left, bottom, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ScissorIndexedv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::ScissorIndexedv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3b(red: types::GLbyte, green: types::GLbyte, blue: types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLbyte, types::GLbyte, types::GLbyte) -> ()>
                    (*storage::SecondaryColor3b.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3bv(v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLbyte) -> ()>
                    (*storage::SecondaryColor3bv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3d(red: types::GLdouble, green: types::GLdouble, blue: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::SecondaryColor3d.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::SecondaryColor3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3f(red: types::GLfloat, green: types::GLfloat, blue: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::SecondaryColor3f.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::SecondaryColor3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3i(red: types::GLint, green: types::GLint, blue: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::SecondaryColor3i.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::SecondaryColor3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3s(red: types::GLshort, green: types::GLshort, blue: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::SecondaryColor3s.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::SecondaryColor3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3ub(red: types::GLubyte, green: types::GLubyte, blue: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLubyte, types::GLubyte, types::GLubyte) -> ()>
                    (*storage::SecondaryColor3ub.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3ubv(v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLubyte) -> ()>
                    (*storage::SecondaryColor3ubv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3ui(red: types::GLuint, green: types::GLuint, blue: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::SecondaryColor3ui.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3uiv(v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLuint) -> ()>
                    (*storage::SecondaryColor3uiv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3us(red: types::GLushort, green: types::GLushort, blue: types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLushort, types::GLushort, types::GLushort) -> ()>
                    (*storage::SecondaryColor3us.pf)(red, green, blue)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColor3usv(v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLushort) -> ()>
                    (*storage::SecondaryColor3usv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColorP3ui(type_: types::GLenum, color: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::SecondaryColorP3ui.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColorP3uiv(type_: types::GLenum, color: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::SecondaryColorP3uiv.pf)(type_, color)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SecondaryColorPointer(size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::SecondaryColorPointer.pf)(size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn SelectBuffer(size: types::GLsizei, buffer: *mut types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *mut types::GLuint) -> ()>
                    (*storage::SelectBuffer.pf)(size, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ShadeModel(mode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> ()>
                    (*storage::ShadeModel.pf)(mode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ShaderBinary(count: types::GLsizei, shaders: *const types::GLuint, binaryformat: types::GLenum, binary: *const __gl_imports::raw::c_void, length: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const types::GLuint, types::GLenum, *const __gl_imports::raw::c_void, types::GLsizei) -> ()>
                    (*storage::ShaderBinary.pf)(count, shaders, binaryformat, binary, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ShaderSource(shader: types::GLuint, count: types::GLsizei, string: *const *const types::GLchar, length: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const *const types::GLchar, *const types::GLint) -> ()>
                    (*storage::ShaderSource.pf)(shader, count, string, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ShaderSourceARB(shaderObj: types::GLhandleARB, count: types::GLsizei, string: *const *const types::GLcharARB, length: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB, types::GLsizei, *const *const types::GLcharARB, *const types::GLint) -> ()>
                    (*storage::ShaderSourceARB.pf)(shaderObj, count, string, length)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ShaderStorageBlockBinding(program: types::GLuint, storageBlockIndex: types::GLuint, storageBlockBinding: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::ShaderStorageBlockBinding.pf)(program, storageBlockIndex, storageBlockBinding)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilFunc(func: types::GLenum, ref_: types::GLint, mask: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLuint) -> ()>
                    (*storage::StencilFunc.pf)(func, ref_, mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilFuncSeparate(face: types::GLenum, func: types::GLenum, ref_: types::GLint, mask: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint, types::GLuint) -> ()>
                    (*storage::StencilFuncSeparate.pf)(face, func, ref_, mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilMask(mask: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::StencilMask.pf)(mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilMaskSeparate(face: types::GLenum, mask: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::StencilMaskSeparate.pf)(face, mask)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilOp(fail: types::GLenum, zfail: types::GLenum, zpass: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum) -> ()>
                    (*storage::StencilOp.pf)(fail, zfail, zpass)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StencilOpSeparate(face: types::GLenum, sfail: types::GLenum, dpfail: types::GLenum, dppass: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLenum, types::GLenum) -> ()>
                    (*storage::StencilOpSeparate.pf)(face, sfail, dpfail, dppass)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn StringMarkerGREMEDY(len: types::GLsizei, string: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::StringMarkerGREMEDY.pf)(len, string)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBuffer(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::TexBuffer.pf)(target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBufferARB(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::TexBufferARB.pf)(target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBufferEXT(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::TexBufferEXT.pf)(target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBufferOES(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::TexBufferOES.pf)(target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBufferRange(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::TexBufferRange.pf)(target, internalformat, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexBufferRangeOES(target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::TexBufferRangeOES.pf)(target, internalformat, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1d(s: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble) -> ()>
                    (*storage::TexCoord1d.pf)(s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::TexCoord1dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1f(s: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat) -> ()>
                    (*storage::TexCoord1f.pf)(s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::TexCoord1fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1i(s: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint) -> ()>
                    (*storage::TexCoord1i.pf)(s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::TexCoord1iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1s(s: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort) -> ()>
                    (*storage::TexCoord1s.pf)(s)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord1sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::TexCoord1sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2d(s: types::GLdouble, t: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::TexCoord2d.pf)(s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::TexCoord2dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2f(s: types::GLfloat, t: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::TexCoord2f.pf)(s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::TexCoord2fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2i(s: types::GLint, t: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::TexCoord2i.pf)(s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::TexCoord2iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2s(s: types::GLshort, t: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort) -> ()>
                    (*storage::TexCoord2s.pf)(s, t)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord2sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::TexCoord2sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3d(s: types::GLdouble, t: types::GLdouble, r: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::TexCoord3d.pf)(s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::TexCoord3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3f(s: types::GLfloat, t: types::GLfloat, r: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::TexCoord3f.pf)(s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::TexCoord3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3i(s: types::GLint, t: types::GLint, r: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::TexCoord3i.pf)(s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::TexCoord3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3s(s: types::GLshort, t: types::GLshort, r: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::TexCoord3s.pf)(s, t, r)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::TexCoord3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4d(s: types::GLdouble, t: types::GLdouble, r: types::GLdouble, q: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::TexCoord4d.pf)(s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::TexCoord4dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4f(s: types::GLfloat, t: types::GLfloat, r: types::GLfloat, q: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::TexCoord4f.pf)(s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::TexCoord4fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4i(s: types::GLint, t: types::GLint, r: types::GLint, q: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::TexCoord4i.pf)(s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::TexCoord4iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4s(s: types::GLshort, t: types::GLshort, r: types::GLshort, q: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::TexCoord4s.pf)(s, t, r, q)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoord4sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::TexCoord4sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP1ui(type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::TexCoordP1ui.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP1uiv(type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexCoordP1uiv.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP2ui(type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::TexCoordP2ui.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP2uiv(type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexCoordP2uiv.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP3ui(type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::TexCoordP3ui.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP3uiv(type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexCoordP3uiv.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP4ui(type_: types::GLenum, coords: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::TexCoordP4ui.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordP4uiv(type_: types::GLenum, coords: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexCoordP4uiv.pf)(type_, coords)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexCoordPointer(size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexCoordPointer.pf)(size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexEnvf(target: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::TexEnvf.pf)(target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexEnvfv(target: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::TexEnvfv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexEnvi(target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::TexEnvi.pf)(target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexEnviv(target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TexEnviv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGend(coord: types::GLenum, pname: types::GLenum, param: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLdouble) -> ()>
                    (*storage::TexGend.pf)(coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGendv(coord: types::GLenum, pname: types::GLenum, params: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLdouble) -> ()>
                    (*storage::TexGendv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGenf(coord: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::TexGenf.pf)(coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGenfv(coord: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::TexGenfv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGeni(coord: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::TexGeni.pf)(coord, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexGeniv(coord: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TexGeniv.pf)(coord, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexImage1D(target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexImage1D.pf)(target, level, internalformat, width, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexImage2D(target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexImage2D.pf)(target, level, internalformat, width, height, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexImage2DMultisample(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TexImage2DMultisample.pf)(target, samples, internalformat, width, height, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexImage3D(target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexImage3D.pf)(target, level, internalformat, width, height, depth, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexImage3DMultisample(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TexImage3DMultisample.pf)(target, samples, internalformat, width, height, depth, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterIiv(target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TexParameterIiv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterIivEXT(target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TexParameterIivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterIuiv(target: types::GLenum, pname: types::GLenum, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexParameterIuiv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterIuivEXT(target: types::GLenum, pname: types::GLenum, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TexParameterIuivEXT.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterf(target: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::TexParameterf.pf)(target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameterfv(target: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::TexParameterfv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameteri(target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::TexParameteri.pf)(target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexParameteriv(target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TexParameteriv.pf)(target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexStorage1D(target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei) -> ()>
                    (*storage::TexStorage1D.pf)(target, levels, internalformat, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexStorage2D(target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TexStorage2D.pf)(target, levels, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexStorage2DMultisample(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TexStorage2DMultisample.pf)(target, samples, internalformat, width, height, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexStorage3D(target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TexStorage3D.pf)(target, levels, internalformat, width, height, depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexStorage3DMultisample(target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TexStorage3DMultisample.pf)(target, samples, internalformat, width, height, depth, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexSubImage1D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexSubImage1D.pf)(target, level, xoffset, width, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexSubImage2D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexSubImage2D.pf)(target, level, xoffset, yoffset, width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexSubImage3D(target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TexSubImage3D.pf)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureBarrier() -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn() -> ()>
                    (*storage::TextureBarrier.pf)()
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureBuffer(texture: types::GLuint, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint) -> ()>
                    (*storage::TextureBuffer.pf)(texture, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureBufferEXT(texture: types::GLuint, target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint) -> ()>
                    (*storage::TextureBufferEXT.pf)(texture, target, internalformat, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureBufferRange(texture: types::GLuint, internalformat: types::GLenum, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::TextureBufferRange.pf)(texture, internalformat, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureBufferRangeEXT(texture: types::GLuint, target: types::GLenum, internalformat: types::GLenum, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::TextureBufferRangeEXT.pf)(texture, target, internalformat, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureImage1DEXT.pf)(texture, target, level, internalformat, width, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureImage2DEXT.pf)(texture, target, level, internalformat, width, height, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureImage3DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, internalformat: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, border: types::GLint, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLint, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureImage3DEXT.pf)(texture, target, level, internalformat, width, height, depth, border, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TexturePageCommitmentEXT(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, commit: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TexturePageCommitmentEXT.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, commit)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterIiv(texture: types::GLuint, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TextureParameterIiv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterIivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TextureParameterIivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterIuiv(texture: types::GLuint, pname: types::GLenum, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TextureParameterIuiv.pf)(texture, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterIuivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *const types::GLuint) -> ()>
                    (*storage::TextureParameterIuivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterf(texture: types::GLuint, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLfloat) -> ()>
                    (*storage::TextureParameterf.pf)(texture, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterfEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, param: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLfloat) -> ()>
                    (*storage::TextureParameterfEXT.pf)(texture, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterfv(texture: types::GLuint, pname: types::GLenum, param: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::TextureParameterfv.pf)(texture, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterfvEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *const types::GLfloat) -> ()>
                    (*storage::TextureParameterfvEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameteri(texture: types::GLuint, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint) -> ()>
                    (*storage::TextureParameteri.pf)(texture, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameteriEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, param: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, types::GLint) -> ()>
                    (*storage::TextureParameteriEXT.pf)(texture, target, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameteriv(texture: types::GLuint, pname: types::GLenum, param: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TextureParameteriv.pf)(texture, pname, param)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureParameterivEXT(texture: types::GLuint, target: types::GLenum, pname: types::GLenum, params: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLenum, *const types::GLint) -> ()>
                    (*storage::TextureParameterivEXT.pf)(texture, target, pname, params)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureRenderbufferEXT(texture: types::GLuint, target: types::GLenum, renderbuffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint) -> ()>
                    (*storage::TextureRenderbufferEXT.pf)(texture, target, renderbuffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage1D(texture: types::GLuint, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei) -> ()>
                    (*storage::TextureStorage1D.pf)(texture, levels, internalformat, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage1DEXT(texture: types::GLuint, target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei) -> ()>
                    (*storage::TextureStorage1DEXT.pf)(texture, target, levels, internalformat, width)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage2D(texture: types::GLuint, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TextureStorage2D.pf)(texture, levels, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage2DEXT(texture: types::GLuint, target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TextureStorage2DEXT.pf)(texture, target, levels, internalformat, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage2DMultisample(texture: types::GLuint, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TextureStorage2DMultisample.pf)(texture, samples, internalformat, width, height, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage2DMultisampleEXT(texture: types::GLuint, target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TextureStorage2DMultisampleEXT.pf)(texture, target, samples, internalformat, width, height, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage3D(texture: types::GLuint, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TextureStorage3D.pf)(texture, levels, internalformat, width, height, depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage3DEXT(texture: types::GLuint, target: types::GLenum, levels: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::TextureStorage3DEXT.pf)(texture, target, levels, internalformat, width, height, depth)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage3DMultisample(texture: types::GLuint, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TextureStorage3DMultisample.pf)(texture, samples, internalformat, width, height, depth, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureStorage3DMultisampleEXT(texture: types::GLuint, target: types::GLenum, samples: types::GLsizei, internalformat: types::GLenum, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, fixedsamplelocations: types::GLboolean) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLsizei, types::GLenum, types::GLsizei, types::GLsizei, types::GLsizei, types::GLboolean) -> ()>
                    (*storage::TextureStorage3DMultisampleEXT.pf)(texture, target, samples, internalformat, width, height, depth, fixedsamplelocations)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage1D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage1D.pf)(texture, level, xoffset, width, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage1DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, width: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage1DEXT.pf)(texture, target, level, xoffset, width, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage2D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage2D.pf)(texture, level, xoffset, yoffset, width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage2DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage2DEXT.pf)(texture, target, level, xoffset, yoffset, width, height, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage3D(texture: types::GLuint, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage3D.pf)(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureSubImage3DEXT(texture: types::GLuint, target: types::GLenum, level: types::GLint, xoffset: types::GLint, yoffset: types::GLint, zoffset: types::GLint, width: types::GLsizei, height: types::GLsizei, depth: types::GLsizei, format: types::GLenum, type_: types::GLenum, pixels: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLint, types::GLint, types::GLint, types::GLint, types::GLsizei, types::GLsizei, types::GLsizei, types::GLenum, types::GLenum, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::TextureSubImage3DEXT.pf)(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type_, pixels)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TextureView(texture: types::GLuint, target: types::GLenum, origtexture: types::GLuint, internalformat: types::GLenum, minlevel: types::GLuint, numlevels: types::GLuint, minlayer: types::GLuint, numlayers: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLuint, types::GLenum, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::TextureView.pf)(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TransformFeedbackBufferBase(xfb: types::GLuint, index: types::GLuint, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::TransformFeedbackBufferBase.pf)(xfb, index, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TransformFeedbackBufferRange(xfb: types::GLuint, index: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, size: types::GLsizeiptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLintptr, types::GLsizeiptr) -> ()>
                    (*storage::TransformFeedbackBufferRange.pf)(xfb, index, buffer, offset, size)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TransformFeedbackVaryings(program: types::GLuint, count: types::GLsizei, varyings: *const *const types::GLchar, bufferMode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const *const types::GLchar, types::GLenum) -> ()>
                    (*storage::TransformFeedbackVaryings.pf)(program, count, varyings, bufferMode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn TransformFeedbackVaryingsEXT(program: types::GLuint, count: types::GLsizei, varyings: *const *const types::GLchar, bufferMode: types::GLenum) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const *const types::GLchar, types::GLenum) -> ()>
                    (*storage::TransformFeedbackVaryingsEXT.pf)(program, count, varyings, bufferMode)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Translated(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Translated.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Translatef(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Translatef.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1d(location: types::GLint, x: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble) -> ()>
                    (*storage::Uniform1d.pf)(location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1dv(location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::Uniform1dv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1f(location: types::GLint, v0: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat) -> ()>
                    (*storage::Uniform1f.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1fARB(location: types::GLint, v0: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat) -> ()>
                    (*storage::Uniform1fARB.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1fv(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform1fv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1fvARB(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform1fvARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1i(location: types::GLint, v0: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::Uniform1i.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1i64ARB(location: types::GLint, x: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint64) -> ()>
                    (*storage::Uniform1i64ARB.pf)(location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1i64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::Uniform1i64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1iARB(location: types::GLint, v0: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::Uniform1iARB.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1iv(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform1iv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1ivARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform1ivARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1ui(location: types::GLint, v0: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint) -> ()>
                    (*storage::Uniform1ui.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1ui64ARB(location: types::GLint, x: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint64) -> ()>
                    (*storage::Uniform1ui64ARB.pf)(location, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1ui64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::Uniform1ui64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1uiEXT(location: types::GLint, v0: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint) -> ()>
                    (*storage::Uniform1uiEXT.pf)(location, v0)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1uiv(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform1uiv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform1uivEXT(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform1uivEXT.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2d(location: types::GLint, x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Uniform2d.pf)(location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2dv(location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::Uniform2dv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2f(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform2f.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2fARB(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform2fARB.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2fv(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform2fv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2fvARB(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform2fvARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2i(location: types::GLint, v0: types::GLint, v1: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform2i.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2i64ARB(location: types::GLint, x: types::GLint64, y: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint64, types::GLint64) -> ()>
                    (*storage::Uniform2i64ARB.pf)(location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2i64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::Uniform2i64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2iARB(location: types::GLint, v0: types::GLint, v1: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform2iARB.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2iv(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform2iv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2ivARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform2ivARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2ui(location: types::GLint, v0: types::GLuint, v1: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform2ui.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2ui64ARB(location: types::GLint, x: types::GLuint64, y: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::Uniform2ui64ARB.pf)(location, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2ui64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::Uniform2ui64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2uiEXT(location: types::GLint, v0: types::GLuint, v1: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform2uiEXT.pf)(location, v0, v1)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2uiv(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform2uiv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform2uivEXT(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform2uivEXT.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3d(location: types::GLint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Uniform3d.pf)(location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3dv(location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::Uniform3dv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3f(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform3f.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3fARB(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform3fARB.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3fv(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform3fv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3fvARB(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform3fvARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3i(location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform3i.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3i64ARB(location: types::GLint, x: types::GLint64, y: types::GLint64, z: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint64, types::GLint64, types::GLint64) -> ()>
                    (*storage::Uniform3i64ARB.pf)(location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3i64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::Uniform3i64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3iARB(location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform3iARB.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3iv(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform3iv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3ivARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform3ivARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3ui(location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform3ui.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3ui64ARB(location: types::GLint, x: types::GLuint64, y: types::GLuint64, z: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint64, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::Uniform3ui64ARB.pf)(location, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3ui64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::Uniform3ui64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3uiEXT(location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform3uiEXT.pf)(location, v0, v1, v2)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3uiv(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform3uiv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform3uivEXT(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform3uivEXT.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4d(location: types::GLint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Uniform4d.pf)(location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4dv(location: types::GLint, count: types::GLsizei, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLdouble) -> ()>
                    (*storage::Uniform4dv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4f(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat, v3: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform4f.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4fARB(location: types::GLint, v0: types::GLfloat, v1: types::GLfloat, v2: types::GLfloat, v3: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Uniform4fARB.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4fv(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform4fv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4fvARB(location: types::GLint, count: types::GLsizei, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::Uniform4fvARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4i(location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint, v3: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform4i.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4i64ARB(location: types::GLint, x: types::GLint64, y: types::GLint64, z: types::GLint64, w: types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint64, types::GLint64, types::GLint64, types::GLint64) -> ()>
                    (*storage::Uniform4i64ARB.pf)(location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4i64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint64) -> ()>
                    (*storage::Uniform4i64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4iARB(location: types::GLint, v0: types::GLint, v1: types::GLint, v2: types::GLint, v3: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Uniform4iARB.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4iv(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform4iv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4ivARB(location: types::GLint, count: types::GLsizei, value: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLint) -> ()>
                    (*storage::Uniform4ivARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4ui(location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint, v3: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform4ui.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4ui64ARB(location: types::GLint, x: types::GLuint64, y: types::GLuint64, z: types::GLuint64, w: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint64, types::GLuint64, types::GLuint64, types::GLuint64) -> ()>
                    (*storage::Uniform4ui64ARB.pf)(location, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4ui64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::Uniform4ui64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4uiEXT(location: types::GLint, v0: types::GLuint, v1: types::GLuint, v2: types::GLuint, v3: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::Uniform4uiEXT.pf)(location, v0, v1, v2, v3)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4uiv(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform4uiv.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Uniform4uivEXT(location: types::GLint, count: types::GLsizei, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::Uniform4uivEXT.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformBlockBinding(program: types::GLuint, uniformBlockIndex: types::GLuint, uniformBlockBinding: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::UniformBlockBinding.pf)(program, uniformBlockIndex, uniformBlockBinding)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformHandleui64ARB(location: types::GLint, value: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLuint64) -> ()>
                    (*storage::UniformHandleui64ARB.pf)(location, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformHandleui64vARB(location: types::GLint, count: types::GLsizei, value: *const types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, *const types::GLuint64) -> ()>
                    (*storage::UniformHandleui64vARB.pf)(location, count, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix2dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix2fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2fvARB(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix2fvARB.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2x3dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix2x3dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2x3fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix2x3fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2x4dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix2x4dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix2x4fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix2x4fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix3dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix3fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3fvARB(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix3fvARB.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3x2dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix3x2dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3x2fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix3x2fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3x4dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix3x4dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix3x4fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix3x4fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix4dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix4fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4fvARB(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix4fvARB.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4x2dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix4x2dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4x2fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix4x2fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4x3dv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLdouble) -> ()>
                    (*storage::UniformMatrix4x3dv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformMatrix4x3fv(location: types::GLint, count: types::GLsizei, transpose: types::GLboolean, value: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLsizei, types::GLboolean, *const types::GLfloat) -> ()>
                    (*storage::UniformMatrix4x3fv.pf)(location, count, transpose, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UniformSubroutinesuiv(shadertype: types::GLenum, count: types::GLsizei, indices: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLsizei, *const types::GLuint) -> ()>
                    (*storage::UniformSubroutinesuiv.pf)(shadertype, count, indices)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UnmapBuffer(target: types::GLenum) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLboolean>
                    (*storage::UnmapBuffer.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UnmapBufferARB(target: types::GLenum) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum) -> types::GLboolean>
                    (*storage::UnmapBufferARB.pf)(target)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UnmapNamedBuffer(buffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::UnmapNamedBuffer.pf)(buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UnmapNamedBufferEXT(buffer: types::GLuint) -> types::GLboolean {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> types::GLboolean>
                    (*storage::UnmapNamedBufferEXT.pf)(buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UseProgram(program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::UseProgram.pf)(program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UseProgramObjectARB(programObj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB) -> ()>
                    (*storage::UseProgramObjectARB.pf)(programObj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn UseProgramStages(pipeline: types::GLuint, stages: types::GLbitfield, program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLbitfield, types::GLuint) -> ()>
                    (*storage::UseProgramStages.pf)(pipeline, stages, program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ValidateProgram(program: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::ValidateProgram.pf)(program)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ValidateProgramARB(programObj: types::GLhandleARB) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLhandleARB) -> ()>
                    (*storage::ValidateProgramARB.pf)(programObj)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ValidateProgramPipeline(pipeline: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint) -> ()>
                    (*storage::ValidateProgramPipeline.pf)(pipeline)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2d(x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Vertex2d.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Vertex2dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2f(x: types::GLfloat, y: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Vertex2f.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Vertex2fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2i(x: types::GLint, y: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::Vertex2i.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Vertex2iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2s(x: types::GLshort, y: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort) -> ()>
                    (*storage::Vertex2s.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex2sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Vertex2sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3d(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Vertex3d.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Vertex3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3f(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Vertex3f.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Vertex3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3i(x: types::GLint, y: types::GLint, z: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Vertex3i.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Vertex3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3s(x: types::GLshort, y: types::GLshort, z: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Vertex3s.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Vertex3sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4d(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::Vertex4d.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::Vertex4dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4f(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat, w: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::Vertex4f.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::Vertex4fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4i(x: types::GLint, y: types::GLint, z: types::GLint, w: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::Vertex4i.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::Vertex4iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4s(x: types::GLshort, y: types::GLshort, z: types::GLshort, w: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::Vertex4s.pf)(x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Vertex4sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::Vertex4sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayAttribBinding(vaobj: types::GLuint, attribindex: types::GLuint, bindingindex: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayAttribBinding.pf)(vaobj, attribindex, bindingindex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayAttribFormat(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexArrayAttribFormat.pf)(vaobj, attribindex, size, type_, normalized, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayAttribIFormat(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexArrayAttribIFormat.pf)(vaobj, attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayAttribLFormat(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexArrayAttribLFormat.pf)(vaobj, attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayBindVertexBufferEXT(vaobj: types::GLuint, bindingindex: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLintptr, types::GLsizei) -> ()>
                    (*storage::VertexArrayBindVertexBufferEXT.pf)(vaobj, bindingindex, buffer, offset, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayBindingDivisor(vaobj: types::GLuint, bindingindex: types::GLuint, divisor: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayBindingDivisor.pf)(vaobj, bindingindex, divisor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayColorOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayColorOffsetEXT.pf)(vaobj, buffer, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayEdgeFlagOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayEdgeFlagOffsetEXT.pf)(vaobj, buffer, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayElementBuffer(vaobj: types::GLuint, buffer: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayElementBuffer.pf)(vaobj, buffer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayFogCoordOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayFogCoordOffsetEXT.pf)(vaobj, buffer, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayIndexOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayIndexOffsetEXT.pf)(vaobj, buffer, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayMultiTexCoordOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, texunit: types::GLenum, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayMultiTexCoordOffsetEXT.pf)(vaobj, buffer, texunit, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayNormalOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayNormalOffsetEXT.pf)(vaobj, buffer, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArraySecondaryColorOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArraySecondaryColorOffsetEXT.pf)(vaobj, buffer, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayTexCoordOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayTexCoordOffsetEXT.pf)(vaobj, buffer, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribBindingEXT(vaobj: types::GLuint, attribindex: types::GLuint, bindingindex: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexAttribBindingEXT.pf)(vaobj, attribindex, bindingindex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribDivisorEXT(vaobj: types::GLuint, index: types::GLuint, divisor: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexAttribDivisorEXT.pf)(vaobj, index, divisor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribFormatEXT(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexAttribFormatEXT.pf)(vaobj, attribindex, size, type_, normalized, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribIFormatEXT(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexAttribIFormatEXT.pf)(vaobj, attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribIOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, index: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayVertexAttribIOffsetEXT.pf)(vaobj, buffer, index, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribLFormatEXT(vaobj: types::GLuint, attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexAttribLFormatEXT.pf)(vaobj, attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribLOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, index: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayVertexAttribLOffsetEXT.pf)(vaobj, buffer, index, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexAttribOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, index: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayVertexAttribOffsetEXT.pf)(vaobj, buffer, index, size, type_, normalized, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexBindingDivisorEXT(vaobj: types::GLuint, bindingindex: types::GLuint, divisor: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexArrayVertexBindingDivisorEXT.pf)(vaobj, bindingindex, divisor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexBuffer(vaobj: types::GLuint, bindingindex: types::GLuint, buffer: types::GLuint, offset: types::GLintptr, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLintptr, types::GLsizei) -> ()>
                    (*storage::VertexArrayVertexBuffer.pf)(vaobj, bindingindex, buffer, offset, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexBuffers(vaobj: types::GLuint, first: types::GLuint, count: types::GLsizei, buffers: *const types::GLuint, offsets: *const types::GLintptr, strides: *const types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLsizei, *const types::GLuint, *const types::GLintptr, *const types::GLsizei) -> ()>
                    (*storage::VertexArrayVertexBuffers.pf)(vaobj, first, count, buffers, offsets, strides)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexArrayVertexOffsetEXT(vaobj: types::GLuint, buffer: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, offset: types::GLintptr) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLint, types::GLenum, types::GLsizei, types::GLintptr) -> ()>
                    (*storage::VertexArrayVertexOffsetEXT.pf)(vaobj, buffer, size, type_, stride, offset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1d(index: types::GLuint, x: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble) -> ()>
                    (*storage::VertexAttrib1d.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1dARB(index: types::GLuint, x: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble) -> ()>
                    (*storage::VertexAttrib1dARB.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib1dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1dvARB(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib1dvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1f(index: types::GLuint, x: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat) -> ()>
                    (*storage::VertexAttrib1f.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1fARB(index: types::GLuint, x: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat) -> ()>
                    (*storage::VertexAttrib1fARB.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1fv(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib1fv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1fvARB(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib1fvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1s(index: types::GLuint, x: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort) -> ()>
                    (*storage::VertexAttrib1s.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1sARB(index: types::GLuint, x: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort) -> ()>
                    (*storage::VertexAttrib1sARB.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1sv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib1sv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib1svARB(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib1svARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib2d.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2dARB(index: types::GLuint, x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib2dARB.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib2dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2dvARB(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib2dvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2f(index: types::GLuint, x: types::GLfloat, y: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib2f.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2fARB(index: types::GLuint, x: types::GLfloat, y: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib2fARB.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2fv(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib2fv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2fvARB(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib2fvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2s(index: types::GLuint, x: types::GLshort, y: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib2s.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2sARB(index: types::GLuint, x: types::GLshort, y: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib2sARB.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2sv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib2sv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib2svARB(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib2svARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib3d.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3dARB(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib3dARB.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib3dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3dvARB(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib3dvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3f(index: types::GLuint, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib3f.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3fARB(index: types::GLuint, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib3fARB.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3fv(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib3fv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3fvARB(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib3fvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3s(index: types::GLuint, x: types::GLshort, y: types::GLshort, z: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib3s.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3sARB(index: types::GLuint, x: types::GLshort, y: types::GLshort, z: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib3sARB.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3sv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib3sv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib3svARB(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib3svARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nbv(index: types::GLuint, v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLbyte) -> ()>
                    (*storage::VertexAttrib4Nbv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NbvARB(index: types::GLuint, v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLbyte) -> ()>
                    (*storage::VertexAttrib4NbvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Niv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttrib4Niv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NivARB(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttrib4NivARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nsv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib4Nsv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NsvARB(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib4NsvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nub(index: types::GLuint, x: types::GLubyte, y: types::GLubyte, z: types::GLubyte, w: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLubyte, types::GLubyte, types::GLubyte, types::GLubyte) -> ()>
                    (*storage::VertexAttrib4Nub.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NubARB(index: types::GLuint, x: types::GLubyte, y: types::GLubyte, z: types::GLubyte, w: types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLubyte, types::GLubyte, types::GLubyte, types::GLubyte) -> ()>
                    (*storage::VertexAttrib4NubARB.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nubv(index: types::GLuint, v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLubyte) -> ()>
                    (*storage::VertexAttrib4Nubv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NubvARB(index: types::GLuint, v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLubyte) -> ()>
                    (*storage::VertexAttrib4NubvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nuiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttrib4Nuiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NuivARB(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttrib4NuivARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4Nusv(index: types::GLuint, v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLushort) -> ()>
                    (*storage::VertexAttrib4Nusv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4NusvARB(index: types::GLuint, v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLushort) -> ()>
                    (*storage::VertexAttrib4NusvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4bv(index: types::GLuint, v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLbyte) -> ()>
                    (*storage::VertexAttrib4bv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4bvARB(index: types::GLuint, v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLbyte) -> ()>
                    (*storage::VertexAttrib4bvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib4d.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4dARB(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttrib4dARB.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib4dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4dvARB(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttrib4dvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4f(index: types::GLuint, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat, w: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib4f.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4fARB(index: types::GLuint, x: types::GLfloat, y: types::GLfloat, z: types::GLfloat, w: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::VertexAttrib4fARB.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4fv(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib4fv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4fvARB(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::VertexAttrib4fvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4iv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttrib4iv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4ivARB(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttrib4ivARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4s(index: types::GLuint, x: types::GLshort, y: types::GLshort, z: types::GLshort, w: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib4s.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4sARB(index: types::GLuint, x: types::GLshort, y: types::GLshort, z: types::GLshort, w: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLshort, types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::VertexAttrib4sARB.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4sv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib4sv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4svARB(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttrib4svARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4ubv(index: types::GLuint, v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLubyte) -> ()>
                    (*storage::VertexAttrib4ubv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4ubvARB(index: types::GLuint, v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLubyte) -> ()>
                    (*storage::VertexAttrib4ubvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4uiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttrib4uiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4uivARB(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttrib4uivARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4usv(index: types::GLuint, v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLushort) -> ()>
                    (*storage::VertexAttrib4usv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttrib4usvARB(index: types::GLuint, v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLushort) -> ()>
                    (*storage::VertexAttrib4usvARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribBinding(attribindex: types::GLuint, bindingindex: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribBinding.pf)(attribindex, bindingindex)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribDivisor(index: types::GLuint, divisor: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribDivisor.pf)(index, divisor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribFormat(attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexAttribFormat.pf)(attribindex, size, type_, normalized, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI1i(index: types::GLuint, x: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint) -> ()>
                    (*storage::VertexAttribI1i.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI1iv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttribI1iv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI1ui(index: types::GLuint, x: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribI1ui.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI1uiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttribI1uiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI2i(index: types::GLuint, x: types::GLint, y: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint) -> ()>
                    (*storage::VertexAttribI2i.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI2iv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttribI2iv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI2ui(index: types::GLuint, x: types::GLuint, y: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribI2ui.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI2uiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttribI2uiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI3i(index: types::GLuint, x: types::GLint, y: types::GLint, z: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::VertexAttribI3i.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI3iv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttribI3iv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI3ui(index: types::GLuint, x: types::GLuint, y: types::GLuint, z: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribI3ui.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI3uiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttribI3uiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4bv(index: types::GLuint, v: *const types::GLbyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLbyte) -> ()>
                    (*storage::VertexAttribI4bv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4i(index: types::GLuint, x: types::GLint, y: types::GLint, z: types::GLint, w: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::VertexAttribI4i.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4iv(index: types::GLuint, v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint) -> ()>
                    (*storage::VertexAttribI4iv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4sv(index: types::GLuint, v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLshort) -> ()>
                    (*storage::VertexAttribI4sv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4ubv(index: types::GLuint, v: *const types::GLubyte) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLubyte) -> ()>
                    (*storage::VertexAttribI4ubv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4ui(index: types::GLuint, x: types::GLuint, y: types::GLuint, z: types::GLuint, w: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint, types::GLuint, types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexAttribI4ui.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4uiv(index: types::GLuint, v: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint) -> ()>
                    (*storage::VertexAttribI4uiv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribI4usv(index: types::GLuint, v: *const types::GLushort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLushort) -> ()>
                    (*storage::VertexAttribI4usv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribIFormat(attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexAttribIFormat.pf)(attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribIPointer(index: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::VertexAttribIPointer.pf)(index, size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1d(index: types::GLuint, x: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble) -> ()>
                    (*storage::VertexAttribL1d.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttribL1dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1i64NV(index: types::GLuint, x: types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL1i64NV.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1i64vNV(index: types::GLuint, v: *const types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL1i64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1ui64ARB(index: types::GLuint, x: types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL1ui64ARB.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1ui64NV(index: types::GLuint, x: types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL1ui64NV.pf)(index, x)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1ui64vARB(index: types::GLuint, v: *const types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL1ui64vARB.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL1ui64vNV(index: types::GLuint, v: *const types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL1ui64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttribL2d.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttribL2dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2i64NV(index: types::GLuint, x: types::GLint64EXT, y: types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint64EXT, types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL2i64NV.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2i64vNV(index: types::GLuint, v: *const types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL2i64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2ui64NV(index: types::GLuint, x: types::GLuint64EXT, y: types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint64EXT, types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL2ui64NV.pf)(index, x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL2ui64vNV(index: types::GLuint, v: *const types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL2ui64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttribL3d.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttribL3dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3i64NV(index: types::GLuint, x: types::GLint64EXT, y: types::GLint64EXT, z: types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint64EXT, types::GLint64EXT, types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL3i64NV.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3i64vNV(index: types::GLuint, v: *const types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL3i64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3ui64NV(index: types::GLuint, x: types::GLuint64EXT, y: types::GLuint64EXT, z: types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint64EXT, types::GLuint64EXT, types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL3ui64NV.pf)(index, x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL3ui64vNV(index: types::GLuint, v: *const types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL3ui64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4d(index: types::GLuint, x: types::GLdouble, y: types::GLdouble, z: types::GLdouble, w: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLdouble, types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::VertexAttribL4d.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4dv(index: types::GLuint, v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLdouble) -> ()>
                    (*storage::VertexAttribL4dv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4i64NV(index: types::GLuint, x: types::GLint64EXT, y: types::GLint64EXT, z: types::GLint64EXT, w: types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint64EXT, types::GLint64EXT, types::GLint64EXT, types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL4i64NV.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4i64vNV(index: types::GLuint, v: *const types::GLint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLint64EXT) -> ()>
                    (*storage::VertexAttribL4i64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4ui64NV(index: types::GLuint, x: types::GLuint64EXT, y: types::GLuint64EXT, z: types::GLuint64EXT, w: types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint64EXT, types::GLuint64EXT, types::GLuint64EXT, types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL4ui64NV.pf)(index, x, y, z, w)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribL4ui64vNV(index: types::GLuint, v: *const types::GLuint64EXT) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLuint64EXT) -> ()>
                    (*storage::VertexAttribL4ui64vNV.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribLFormat(attribindex: types::GLuint, size: types::GLint, type_: types::GLenum, relativeoffset: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexAttribLFormat.pf)(attribindex, size, type_, relativeoffset)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribLFormatNV(index: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLsizei) -> ()>
                    (*storage::VertexAttribLFormatNV.pf)(index, size, type_, stride)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribLPointer(index: types::GLuint, size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::VertexAttribLPointer.pf)(index, size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP1ui(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexAttribP1ui.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP1uiv(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, *const types::GLuint) -> ()>
                    (*storage::VertexAttribP1uiv.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP2ui(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexAttribP2ui.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP2uiv(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, *const types::GLuint) -> ()>
                    (*storage::VertexAttribP2uiv.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP3ui(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexAttribP3ui.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP3uiv(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, *const types::GLuint) -> ()>
                    (*storage::VertexAttribP3uiv.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP4ui(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, types::GLuint) -> ()>
                    (*storage::VertexAttribP4ui.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribP4uiv(index: types::GLuint, type_: types::GLenum, normalized: types::GLboolean, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLenum, types::GLboolean, *const types::GLuint) -> ()>
                    (*storage::VertexAttribP4uiv.pf)(index, type_, normalized, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribPointer(index: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::VertexAttribPointer.pf)(index, size, type_, normalized, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexAttribPointerARB(index: types::GLuint, size: types::GLint, type_: types::GLenum, normalized: types::GLboolean, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLint, types::GLenum, types::GLboolean, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::VertexAttribPointerARB.pf)(index, size, type_, normalized, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexBindingDivisor(bindingindex: types::GLuint, divisor: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLuint) -> ()>
                    (*storage::VertexBindingDivisor.pf)(bindingindex, divisor)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP2ui(type_: types::GLenum, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexP2ui.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP2uiv(type_: types::GLenum, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::VertexP2uiv.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP3ui(type_: types::GLenum, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexP3ui.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP3uiv(type_: types::GLenum, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::VertexP3uiv.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP4ui(type_: types::GLenum, value: types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, types::GLuint) -> ()>
                    (*storage::VertexP4ui.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexP4uiv(type_: types::GLenum, value: *const types::GLuint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLenum, *const types::GLuint) -> ()>
                    (*storage::VertexP4uiv.pf)(type_, value)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn VertexPointer(size: types::GLint, type_: types::GLenum, stride: types::GLsizei, pointer: *const __gl_imports::raw::c_void) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLenum, types::GLsizei, *const __gl_imports::raw::c_void) -> ()>
                    (*storage::VertexPointer.pf)(size, type_, stride, pointer)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn Viewport(x: types::GLint, y: types::GLint, width: types::GLsizei, height: types::GLsizei) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLsizei, types::GLsizei) -> ()>
                    (*storage::Viewport.pf)(x, y, width, height)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ViewportArrayv(first: types::GLuint, count: types::GLsizei, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLsizei, *const types::GLfloat) -> ()>
                    (*storage::ViewportArrayv.pf)(first, count, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ViewportIndexedf(index: types::GLuint, x: types::GLfloat, y: types::GLfloat, w: types::GLfloat, h: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, types::GLfloat, types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::ViewportIndexedf.pf)(index, x, y, w, h)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn ViewportIndexedfv(index: types::GLuint, v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLuint, *const types::GLfloat) -> ()>
                    (*storage::ViewportIndexedfv.pf)(index, v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WaitSync(sync: types::GLsync, flags: types::GLbitfield, timeout: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLbitfield, types::GLuint64) -> ()>
                    (*storage::WaitSync.pf)(sync, flags, timeout)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WaitSyncAPPLE(sync: types::GLsync, flags: types::GLbitfield, timeout: types::GLuint64) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLsync, types::GLbitfield, types::GLuint64) -> ()>
                    (*storage::WaitSyncAPPLE.pf)(sync, flags, timeout)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2d(x: types::GLdouble, y: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble) -> ()>
                    (*storage::WindowPos2d.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::WindowPos2dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2f(x: types::GLfloat, y: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat) -> ()>
                    (*storage::WindowPos2f.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::WindowPos2fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2i(x: types::GLint, y: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint) -> ()>
                    (*storage::WindowPos2i.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::WindowPos2iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2s(x: types::GLshort, y: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort) -> ()>
                    (*storage::WindowPos2s.pf)(x, y)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos2sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::WindowPos2sv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3d(x: types::GLdouble, y: types::GLdouble, z: types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLdouble, types::GLdouble, types::GLdouble) -> ()>
                    (*storage::WindowPos3d.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3dv(v: *const types::GLdouble) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLdouble) -> ()>
                    (*storage::WindowPos3dv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3f(x: types::GLfloat, y: types::GLfloat, z: types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLfloat, types::GLfloat, types::GLfloat) -> ()>
                    (*storage::WindowPos3f.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3fv(v: *const types::GLfloat) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLfloat) -> ()>
                    (*storage::WindowPos3fv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3i(x: types::GLint, y: types::GLint, z: types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLint, types::GLint, types::GLint) -> ()>
                    (*storage::WindowPos3i.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3iv(v: *const types::GLint) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLint) -> ()>
                    (*storage::WindowPos3iv.pf)(v)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3s(x: types::GLshort, y: types::GLshort, z: types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(types::GLshort, types::GLshort, types::GLshort) -> ()>
                    (*storage::WindowPos3s.pf)(x, y, z)
            }

            #[allow(non_snake_case, unused_variables, dead_code)] #[inline]
            pub unsafe fn WindowPos3sv(v: *const types::GLshort) -> () {
                __gl_imports::mem::transmute::<_, extern "system" fn(*const types::GLshort) -> ()>
                    (*storage::WindowPos3sv.pf)(v)
            }

        #[allow(missing_copy_implementations)]
        pub struct FnPtr {
            /// Pointer to the entry in libepoxy's dispatch table
            pf: *const *const __gl_imports::raw::c_void,
            /// True if the pointer points to a real function, false if points to an error fn
            is_loaded: bool,
        }
        impl FnPtr {
            /// Creates a `FnPtr` from a load attempt.
            pub fn new(ptr: *const *const __gl_imports::raw::c_void) -> FnPtr {
                if ptr.is_null() {
                    FnPtr {
                        pf: &PMISSING_FN_EXIT,
                        is_loaded: false,
                    }
                } else {
                    FnPtr { pf: ptr, is_loaded: true }
                }
            }
        }
    
mod storage {
            #![allow(non_snake_case, non_upper_case_globals)]
            use super::PMISSING_FN_EXIT;
            use super::FnPtr;
pub static mut Accum: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ActiveShaderProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ActiveTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut AlphaFunc: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut AreTexturesResident: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ArrayElement: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut AttachObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut AttachShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Begin: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginConditionalRender: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginConditionalRenderNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginQuery: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginQueryARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginQueryEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginQueryIndexed: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BeginTransformFeedbackEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindAttribLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindAttribLocationARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferBase: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferBaseEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBufferRangeEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBuffersBase: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindBuffersRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindFragDataLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindFragDataLocationEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindFragDataLocationIndexed: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindFramebufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindImageTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindImageTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindMultiTextureEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindProgramPipeline: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindRenderbuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindSampler: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindSamplers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindTextureUnit: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindVertexArray: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindVertexArrayAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindVertexArrayOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindVertexBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BindVertexBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Bitmap: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendBarrier: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendColor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquationSeparate: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquationSeparatei: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquationSeparateiARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquationi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendEquationiARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFunc: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFuncSeparate: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFuncSeparatei: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFuncSeparateiARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFunci: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlendFunciARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlitFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlitFramebufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BlitNamedFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferDataARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferStorage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferStorageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut BufferSubDataARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CallList: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CallLists: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CheckFramebufferStatus: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CheckFramebufferStatusEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CheckNamedFramebufferStatus: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CheckNamedFramebufferStatusEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClampColor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Clear: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearAccum: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferfi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearBufferuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearColor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearColorIiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearColorIuiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearDepth: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearDepthf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedBufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedBufferDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedBufferSubDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedFramebufferfi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedFramebufferfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedFramebufferiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearNamedFramebufferuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearStencil: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClearTexSubImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClientActiveTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClientAttribDefaultEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClientWaitSync: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClientWaitSyncAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClipControl: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ClipPlane: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3b: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3ub: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3ubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3us: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color3usv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4b: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4ub: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4ubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4us: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Color4usv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorMask: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorMaski: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorMaterial: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorP4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorP4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ColorPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompileShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompileShaderARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedMultiTexSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTexSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CompressedTextureSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyBufferSubDataNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyImageSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyMultiTexImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyMultiTexImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyMultiTexSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyMultiTexSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyMultiTexSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyNamedBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyPixels: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTexImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTexImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTexSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTexSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTexSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CopyTextureSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateFramebuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateProgramObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateProgramPipelines: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateQueries: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateRenderbuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateSamplers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateShaderObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateShaderProgramv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateTransformFeedbacks: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CreateVertexArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut CullFace: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageCallback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageCallbackARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageCallbackKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageControl: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageControlARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageControlKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageInsert: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageInsertARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DebugMessageInsertKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteBuffersARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteFramebuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteFramebuffersEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteLists: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteProgramPipelines: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteQueries: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteQueriesARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteQueriesEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteRenderbuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteRenderbuffersEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteSamplers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteSync: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteSyncAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteTransformFeedbacks: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteVertexArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteVertexArraysAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DeleteVertexArraysOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthFunc: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthMask: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthRangeArrayv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthRangeIndexed: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DepthRangef: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DetachObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DetachShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Disable: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableClientState: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableClientStateIndexedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableClientStateiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableIndexedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableVertexArrayAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableVertexArrayAttribEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableVertexArrayEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableVertexAttribArray: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DisableVertexAttribArrayARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Disablei: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DispatchCompute: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DispatchComputeIndirect: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawArraysIndirect: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawArraysInstanced: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawArraysInstancedBaseInstance: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawBuffersARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawBuffersATI: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElements: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsBaseVertex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsBaseVertexOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsIndirect: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsInstanced: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsInstancedBaseInstance: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsInstancedBaseVertex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsInstancedBaseVertexBaseInstance: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawElementsInstancedBaseVertexOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawPixels: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawRangeElements: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawRangeElementsBaseVertex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawRangeElementsBaseVertexOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawTransformFeedbackInstanced: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawTransformFeedbackStream: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut DrawTransformFeedbackStreamInstanced: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EdgeFlag: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EdgeFlagPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EdgeFlagv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Enable: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableClientState: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableClientStateIndexedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableClientStateiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableIndexedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableVertexArrayAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableVertexArrayAttribEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableVertexArrayEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableVertexAttribArray: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EnableVertexAttribArrayARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Enablei: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut End: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndConditionalRender: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndConditionalRenderNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndList: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndQuery: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndQueryARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndQueryEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndQueryIndexed: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EndTransformFeedbackEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalCoord2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalMesh1: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalMesh2: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalPoint1: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut EvalPoint2: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FeedbackBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FenceSync: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FenceSyncAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Finish: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Flush: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FlushMappedBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FlushMappedNamedBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FlushMappedNamedBufferRangeEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FogCoordPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FogCoordd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FogCoorddv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FogCoordf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FogCoordfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Fogf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Fogfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Fogi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Fogiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferDrawBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferDrawBuffersEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferReadBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferRenderbuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture2DMultisampleEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTexture3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTextureARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTextureFaceARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTextureLayer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTextureLayerARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FramebufferTextureLayerEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut FrontFace: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Frustum: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenBuffersARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenFramebuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenFramebuffersEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenLists: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenProgramPipelines: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenQueries: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenQueriesARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenQueriesEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenRenderbuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenRenderbuffersEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenSamplers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenTransformFeedbacks: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenVertexArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenVertexArraysAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenVertexArraysOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenerateMipmap: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenerateMipmapEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenerateMultiTexMipmapEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenerateTextureMipmap: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GenerateTextureMipmapEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveAtomicCounterBufferiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveAttribARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveSubroutineName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveSubroutineUniformName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveSubroutineUniformiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniform: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniformARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniformBlockName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniformBlockiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniformName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetActiveUniformsiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetAttachedObjectsARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetAttachedShaders: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetAttribLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetAttribLocationARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBooleanIndexedvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBooleani_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBooleanv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferParameteri64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferParameterivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferPointerv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferPointervARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetBufferSubDataARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetClipPlane: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetCompressedMultiTexImageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetCompressedTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetCompressedTextureImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetCompressedTextureImageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetCompressedTextureSubImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDebugMessageLog: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDebugMessageLogARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDebugMessageLogKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDoubleIndexedvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDoublei_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDoublei_vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetDoublev: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetError: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFloatIndexedvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFloati_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFloati_vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFloatv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFragDataIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFragDataLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFragDataLocationEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFramebufferAttachmentParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFramebufferAttachmentParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFramebufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetFramebufferParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetGraphicsResetStatus: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetGraphicsResetStatusARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetGraphicsResetStatusEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetGraphicsResetStatusKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetHandleARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetImageHandleARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInfoLogARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInteger64i_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInteger64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInteger64vAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetIntegerIndexedvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetIntegeri_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetIntegerv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInternalformatSampleivNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInternalformati64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetInternalformativ: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetLightfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetLightiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMapdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMapfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMapiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMaterialfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMaterialiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexEnvfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexEnvivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexGendvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexGenfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexGenivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexImageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexLevelParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexLevelParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultiTexParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetMultisamplefv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferParameteri64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferPointerv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferPointervEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedBufferSubDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedFramebufferAttachmentParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedFramebufferAttachmentParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedFramebufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedFramebufferParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramLocalParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramLocalParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramLocalParameterdvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramLocalParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramStringEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedProgramivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedRenderbufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetNamedRenderbufferParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectLabel: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectLabelKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectParameterfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectParameterivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectPtrLabel: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetObjectPtrLabelKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPixelMapfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPixelMapuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPixelMapusv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPointerIndexedvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPointeri_vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPointerv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPointervKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetPolygonStipple: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramBinary: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramInfoLog: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramInterfaceiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramPipelineInfoLog: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramPipelineiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramResourceIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramResourceLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramResourceLocationIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramResourceName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramResourceiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramStageiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetProgramiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryBufferObjecti64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryBufferObjectiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryBufferObjectui64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryBufferObjectuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryIndexediv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjecti64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjecti64vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectui64v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectui64vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectuivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryObjectuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetQueryivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetRenderbufferParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetRenderbufferParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSamplerParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSamplerParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSamplerParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSamplerParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetShaderInfoLog: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetShaderPrecisionFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetShaderSource: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetShaderSourceARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetShaderiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetString: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetStringi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSubroutineIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSubroutineUniformLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSynciv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetSyncivAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexEnvfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexEnviv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexGendv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexGenfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexGeniv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexLevelParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexLevelParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTexParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureHandleARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureImageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureLevelParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureLevelParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureLevelParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureLevelParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureSamplerHandleARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTextureSubImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTransformFeedbackVarying: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTransformFeedbackVaryingEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTransformFeedbacki64_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTransformFeedbacki_v: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetTransformFeedbackiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformBlockIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformIndices: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformLocation: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformLocationARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformSubroutineuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformi64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetUniformuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayIndexed64iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayIndexediv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayIntegeri_vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayIntegervEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayPointeri_vEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayPointervEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexArrayiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribLdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribLi64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribLui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribLui64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribPointerv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribPointervARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribdvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetVertexAttribivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnColorTable: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnColorTableARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnCompressedTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnCompressedTexImageARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnConvolutionFilter: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnConvolutionFilterARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnHistogram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnHistogramARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapdvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMapivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMinmax: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnMinmaxARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapuivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapusv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPixelMapusvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPolygonStipple: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnPolygonStippleARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnSeparableFilter: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnSeparableFilterARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnTexImageARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformdvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformfvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformfvKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformi64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformivKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformuivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut GetnUniformuivKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Hint: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IndexMask: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IndexPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexs: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexsv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexub: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Indexubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InitNames: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InterleavedArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateBufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateNamedFramebufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateNamedFramebufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateSubFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateTexImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut InvalidateTexSubImage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsBufferARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsEnabled: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsEnabledIndexedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsEnabledi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsFramebuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsFramebufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsImageHandleResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsList: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsProgramPipeline: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsQuery: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsQueryARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsQueryEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsRenderbuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsSampler: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsShader: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsSync: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsSyncAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsTextureHandleResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsVertexArray: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsVertexArrayAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut IsVertexArrayOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LightModelf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LightModelfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LightModeli: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LightModeliv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Lightf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Lightfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Lighti: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Lightiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LineStipple: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LineWidth: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LinkProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LinkProgramARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ListBase: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadIdentity: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadMatrixd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadMatrixf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadTransposeMatrixd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LoadTransposeMatrixf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut LogicOp: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MakeImageHandleNonResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MakeImageHandleResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MakeTextureHandleNonResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MakeTextureHandleResidentARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Map1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Map1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Map2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Map2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapBufferARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapGrid1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapGrid1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapGrid2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapGrid2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapNamedBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapNamedBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapNamedBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MapNamedBufferRangeEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Materialf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Materialfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Materiali: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Materialiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixFrustumEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixLoadIdentityEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixLoadTransposedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixLoadTransposefEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixLoaddEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixLoadfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixMode: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixMultTransposedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixMultTransposefEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixMultdEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixMultfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixOrthoEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixPopEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixPushEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixRotatedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixRotatefEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixScaledEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixScalefEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixTranslatedEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MatrixTranslatefEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MemoryBarrier: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MemoryBarrierByRegion: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MinSampleShading: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultMatrixd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultMatrixf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultTransposeMatrixd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultTransposeMatrixf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawArrays: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawArraysIndirect: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawArraysIndirectEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawElements: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawElementsBaseVertex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawElementsBaseVertexEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawElementsIndirect: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiDrawElementsIndirectEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord1sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoord4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordP4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexCoordPointerEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexEnvfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexEnvfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexEnviEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexEnvivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGendEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGendvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGenfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGenfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGeniEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexGenivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameterfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameteriEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut MultiTexSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferStorage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferStorageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferSubData: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedBufferSubDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedCopyBufferSubDataEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferDrawBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferDrawBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferParameteriEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferReadBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferRenderbuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTexture: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTexture1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTexture2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTexture3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTextureEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTextureFaceEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTextureLayer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedFramebufferTextureLayerEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameter4dEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameter4dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameter4fEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameter4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameterI4iEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameterI4ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameterI4uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameterI4uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParameters4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParametersI4ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramLocalParametersI4uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedProgramStringEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedRenderbufferStorage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedRenderbufferStorageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedRenderbufferStorageMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedRenderbufferStorageMultisampleCoverageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NamedRenderbufferStorageMultisampleEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NewList: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3b: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Normal3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NormalP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NormalP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut NormalPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ObjectLabel: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ObjectLabelKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ObjectPtrLabel: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ObjectPtrLabelKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Ortho: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PassThrough: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PatchParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PatchParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PauseTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelMapfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelMapuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelMapusv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelStoref: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelStorei: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelTransferf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelTransferi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PixelZoom: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PointParameterf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PointParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PointParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PointParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PointSize: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PolygonMode: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PolygonOffset: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PolygonStipple: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopClientAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopDebugGroup: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopDebugGroupKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopMatrix: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PopName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrimitiveBoundingBox: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrimitiveBoundingBoxARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrimitiveBoundingBoxEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrimitiveBoundingBoxOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrimitiveRestartIndex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PrioritizeTextures: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramBinary: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramParameteriARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1dEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1fEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1iEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform1uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2dEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2fEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2iEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform2uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3dEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3fEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3iEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform3uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4dEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4fEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4iEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4ivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniform4uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformHandleui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformHandleui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x3dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x3fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x4dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix2x4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x2dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x2fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x4dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix3x4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x2dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x2fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x3dvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProgramUniformMatrix4x3fvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProvokingVertex: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ProvokingVertexEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushClientAttrib: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushClientAttribDefaultEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushDebugGroup: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushDebugGroupKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushMatrix: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut PushName: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut QueryCounter: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut QueryCounterEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RasterPos4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadPixels: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadnPixels: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadnPixelsARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadnPixelsEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReadnPixelsKHR: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectd: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectdv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Recti: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rects: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rectsv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ReleaseShaderCompiler: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderMode: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageMultisampleANGLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageMultisampleAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageMultisampleEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut RenderbufferStorageMultisampleNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ResolveMultisampleFramebufferAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ResumeTransformFeedback: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rotated: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Rotatef: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SampleCoverage: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SampleMaski: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameterf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SamplerParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Scaled: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Scalef: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Scissor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ScissorArrayv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ScissorIndexed: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ScissorIndexedv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3b: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3ub: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3ubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3us: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColor3usv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColorP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColorP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SecondaryColorPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut SelectBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ShadeModel: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ShaderBinary: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ShaderSource: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ShaderSourceARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ShaderStorageBlockBinding: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilFunc: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilFuncSeparate: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilMask: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilMaskSeparate: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilOp: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StencilOpSeparate: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut StringMarkerGREMEDY: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBufferARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBufferOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexBufferRangeOES: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord1sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoord4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordP4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexCoordPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexEnvf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexEnvfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexEnvi: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexEnviv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGend: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGendv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGenf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGenfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGeni: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexGeniv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexImage2DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexImage3DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexStorage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexStorage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexStorage2DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexStorage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexStorage3DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureBarrier: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureBufferRangeEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TexturePageCommitmentEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterIiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterIivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterIuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterIuivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterfEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterfvEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameteri: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameteriEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameteriv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureParameterivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureRenderbufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage2DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage2DMultisampleEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage3DMultisample: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureStorage3DMultisampleEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage1D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage1DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage2D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage2DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage3D: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureSubImage3DEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TextureView: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TransformFeedbackBufferBase: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TransformFeedbackBufferRange: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TransformFeedbackVaryings: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut TransformFeedbackVaryingsEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Translated: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Translatef: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1iARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1ivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform1uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2iARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2ivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform2uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3iARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3ivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform3uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4i64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4i64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4iARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4ivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4uiEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Uniform4uivEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformBlockBinding: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformHandleui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformHandleui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2x3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2x3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2x4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix2x4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3x2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3x2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3x4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix3x4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4x2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4x2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4x3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformMatrix4x3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UniformSubroutinesuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UnmapBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UnmapBufferARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UnmapNamedBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UnmapNamedBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UseProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UseProgramObjectARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut UseProgramStages: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ValidateProgram: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ValidateProgramARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ValidateProgramPipeline: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Vertex4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayAttribBinding: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayAttribFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayAttribIFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayAttribLFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayBindVertexBufferEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayBindingDivisor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayColorOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayEdgeFlagOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayElementBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayFogCoordOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayIndexOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayMultiTexCoordOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayNormalOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArraySecondaryColorOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayTexCoordOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribBindingEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribDivisorEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribFormatEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribIFormatEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribIOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribLFormatEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribLOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexAttribOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexBindingDivisorEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexBuffer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexBuffers: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexArrayVertexOffsetEXT: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1dARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1dvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1sARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib1svARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2dARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2dvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2sARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib2svARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3dARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3dvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3sARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib3svARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nbv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NbvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Niv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nsv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NsvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nub: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NubARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NubvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nuiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NuivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4Nusv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4NusvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4bvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4dARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4dvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4fARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4fvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4ivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4sARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4svARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4ubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4ubvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4uivARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4usv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttrib4usvARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribBinding: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribDivisor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI1i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI1iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4bv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4ubv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribI4usv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribIFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribIPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1i64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1i64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1ui64ARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1ui64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1ui64vARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL1ui64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2i64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2i64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2ui64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL2ui64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3i64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3i64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3ui64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL3ui64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4i64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4i64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4ui64NV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribL4ui64vNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribLFormat: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribLFormatNV: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribLPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP1ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP1uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribP4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexAttribPointerARB: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexBindingDivisor: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP2ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP2uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP3ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP3uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP4ui: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexP4uiv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut VertexPointer: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut Viewport: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ViewportArrayv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ViewportIndexedf: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut ViewportIndexedfv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WaitSync: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WaitSyncAPPLE: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos2sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3d: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3dv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3f: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3fv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3i: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3iv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3s: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
pub static mut WindowPos3sv: FnPtr = FnPtr {
                pf: &PMISSING_FN_EXIT,
                is_loaded: false,
            };
}

            #[allow(non_snake_case)]
            pub mod Accum {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Accum.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Accum = FnPtr::new(metaloadfn(loadfn, "epoxy_glAccum", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ActiveShaderProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ActiveShaderProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ActiveShaderProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glActiveShaderProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ActiveTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ActiveTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ActiveTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glActiveTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod AlphaFunc {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::AlphaFunc.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::AlphaFunc = FnPtr::new(metaloadfn(loadfn, "epoxy_glAlphaFunc", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod AreTexturesResident {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::AreTexturesResident.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::AreTexturesResident = FnPtr::new(metaloadfn(loadfn, "epoxy_glAreTexturesResident", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ArrayElement {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ArrayElement.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ArrayElement = FnPtr::new(metaloadfn(loadfn, "epoxy_glArrayElement", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod AttachObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::AttachObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::AttachObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glAttachObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod AttachShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::AttachShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::AttachShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glAttachShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Begin {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Begin.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Begin = FnPtr::new(metaloadfn(loadfn, "epoxy_glBegin", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginConditionalRender {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginConditionalRender.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginConditionalRender = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginConditionalRender", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginConditionalRenderNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginConditionalRenderNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginConditionalRenderNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginConditionalRenderNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginQuery {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginQuery.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginQuery = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginQuery", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginQueryARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginQueryARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginQueryARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginQueryARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginQueryEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginQueryEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginQueryEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginQueryEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginQueryIndexed {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginQueryIndexed.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginQueryIndexed = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginQueryIndexed", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BeginTransformFeedbackEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BeginTransformFeedbackEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BeginTransformFeedbackEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBeginTransformFeedbackEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindAttribLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindAttribLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindAttribLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindAttribLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindAttribLocationARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindAttribLocationARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindAttribLocationARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindAttribLocationARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferBase {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferBase.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferBase = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferBase", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferBaseEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferBaseEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferBaseEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferBaseEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBufferRangeEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBufferRangeEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBufferRangeEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBufferRangeEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBuffersBase {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBuffersBase.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBuffersBase = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBuffersBase", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindBuffersRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindBuffersRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindBuffersRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindBuffersRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindFragDataLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindFragDataLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindFragDataLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindFragDataLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindFragDataLocationEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindFragDataLocationEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindFragDataLocationEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindFragDataLocationEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindFragDataLocationIndexed {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindFragDataLocationIndexed.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindFragDataLocationIndexed = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindFragDataLocationIndexed", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindFramebufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindFramebufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindFramebufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindFramebufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindImageTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindImageTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindImageTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindImageTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindImageTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindImageTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindImageTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindImageTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindMultiTextureEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindMultiTextureEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindMultiTextureEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindMultiTextureEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindProgramPipeline {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindProgramPipeline.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindProgramPipeline = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindProgramPipeline", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindRenderbuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindRenderbuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindRenderbuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindRenderbuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindSampler {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindSampler.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindSampler = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindSampler", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindSamplers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindSamplers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindSamplers = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindSamplers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindTextureUnit {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindTextureUnit.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindTextureUnit = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindTextureUnit", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindVertexArray {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindVertexArray.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindVertexArray = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindVertexArray", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindVertexArrayAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindVertexArrayAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindVertexArrayAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindVertexArrayAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindVertexArrayOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindVertexArrayOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindVertexArrayOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindVertexArrayOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindVertexBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindVertexBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindVertexBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindVertexBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BindVertexBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BindVertexBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BindVertexBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glBindVertexBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Bitmap {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Bitmap.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Bitmap = FnPtr::new(metaloadfn(loadfn, "epoxy_glBitmap", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendBarrier {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendBarrier.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendBarrier = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendBarrier", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendColor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendColor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendColor = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendColor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquation = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquationSeparate {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquationSeparate.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquationSeparate = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquationSeparate", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquationSeparatei {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquationSeparatei.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquationSeparatei = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquationSeparatei", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquationSeparateiARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquationSeparateiARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquationSeparateiARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquationSeparateiARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquationi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquationi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquationi = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquationi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendEquationiARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendEquationiARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendEquationiARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendEquationiARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFunc {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFunc.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFunc = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFunc", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFuncSeparate {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFuncSeparate.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFuncSeparate = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFuncSeparate", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFuncSeparatei {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFuncSeparatei.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFuncSeparatei = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFuncSeparatei", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFuncSeparateiARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFuncSeparateiARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFuncSeparateiARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFuncSeparateiARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFunci {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFunci.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFunci = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFunci", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlendFunciARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlendFunciARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlendFunciARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlendFunciARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlitFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlitFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlitFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlitFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlitFramebufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlitFramebufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlitFramebufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlitFramebufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BlitNamedFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BlitNamedFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BlitNamedFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glBlitNamedFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferDataARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferDataARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferDataARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferDataARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferStorage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferStorage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferStorage = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferStorage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferStorageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferStorageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferStorageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferStorageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod BufferSubDataARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::BufferSubDataARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::BufferSubDataARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glBufferSubDataARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CallList {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CallList.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CallList = FnPtr::new(metaloadfn(loadfn, "epoxy_glCallList", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CallLists {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CallLists.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CallLists = FnPtr::new(metaloadfn(loadfn, "epoxy_glCallLists", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CheckFramebufferStatus {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CheckFramebufferStatus.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CheckFramebufferStatus = FnPtr::new(metaloadfn(loadfn, "epoxy_glCheckFramebufferStatus", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CheckFramebufferStatusEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CheckFramebufferStatusEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CheckFramebufferStatusEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCheckFramebufferStatusEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CheckNamedFramebufferStatus {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CheckNamedFramebufferStatus.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CheckNamedFramebufferStatus = FnPtr::new(metaloadfn(loadfn, "epoxy_glCheckNamedFramebufferStatus", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CheckNamedFramebufferStatusEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CheckNamedFramebufferStatusEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CheckNamedFramebufferStatusEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCheckNamedFramebufferStatusEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClampColor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClampColor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClampColor = FnPtr::new(metaloadfn(loadfn, "epoxy_glClampColor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Clear {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Clear.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Clear = FnPtr::new(metaloadfn(loadfn, "epoxy_glClear", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearAccum {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearAccum.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearAccum = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearAccum", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferfi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferfi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferfi = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferfi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearBufferuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearBufferuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearBufferuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearBufferuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearColor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearColor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearColor = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearColor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearColorIiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearColorIiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearColorIiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearColorIiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearColorIuiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearColorIuiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearColorIuiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearColorIuiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearDepth {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearDepth.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearDepth = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearDepth", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearDepthf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearDepthf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearDepthf = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearDepthf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedBufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedBufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedBufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedBufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedBufferDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedBufferDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedBufferDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedBufferDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedBufferSubDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedBufferSubDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedBufferSubDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedBufferSubDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedFramebufferfi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedFramebufferfi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedFramebufferfi = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedFramebufferfi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedFramebufferfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedFramebufferfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedFramebufferfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedFramebufferfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedFramebufferiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedFramebufferiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedFramebufferiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedFramebufferiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearNamedFramebufferuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearNamedFramebufferuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearNamedFramebufferuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearNamedFramebufferuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearStencil {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearStencil.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearStencil = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearStencil", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClearTexSubImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClearTexSubImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClearTexSubImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glClearTexSubImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClientActiveTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClientActiveTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClientActiveTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glClientActiveTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClientAttribDefaultEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClientAttribDefaultEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClientAttribDefaultEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glClientAttribDefaultEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClientWaitSync {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClientWaitSync.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClientWaitSync = FnPtr::new(metaloadfn(loadfn, "epoxy_glClientWaitSync", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClientWaitSyncAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClientWaitSyncAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClientWaitSyncAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glClientWaitSyncAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClipControl {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClipControl.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClipControl = FnPtr::new(metaloadfn(loadfn, "epoxy_glClipControl", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ClipPlane {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ClipPlane.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ClipPlane = FnPtr::new(metaloadfn(loadfn, "epoxy_glClipPlane", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3b {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3b.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3b = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3b", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3ub {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3ub.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3ub = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3ub", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3ubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3ubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3ubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3ubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3us {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3us.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3us = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3us", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color3usv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color3usv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color3usv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor3usv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4b {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4b.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4b = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4b", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4ub {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4ub.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4ub = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4ub", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4ubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4ubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4ubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4ubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4us {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4us.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4us = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4us", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Color4usv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Color4usv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Color4usv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColor4usv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorMask {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorMask.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorMask = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorMask", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorMaski {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorMaski.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorMaski = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorMaski", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorMaterial {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorMaterial.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorMaterial = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorMaterial", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorP4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorP4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorP4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorP4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorP4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorP4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorP4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorP4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ColorPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ColorPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ColorPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glColorPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompileShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompileShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompileShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompileShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompileShaderARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompileShaderARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompileShaderARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompileShaderARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedMultiTexSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedMultiTexSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedMultiTexSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedMultiTexSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTexSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTexSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTexSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTexSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CompressedTextureSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CompressedTextureSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CompressedTextureSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCompressedTextureSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyBufferSubDataNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyBufferSubDataNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyBufferSubDataNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyBufferSubDataNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyImageSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyImageSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyImageSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyImageSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyMultiTexImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyMultiTexImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyMultiTexImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyMultiTexImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyMultiTexImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyMultiTexImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyMultiTexImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyMultiTexImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyMultiTexSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyMultiTexSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyMultiTexSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyMultiTexSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyMultiTexSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyMultiTexSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyMultiTexSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyMultiTexSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyMultiTexSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyMultiTexSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyMultiTexSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyMultiTexSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyNamedBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyNamedBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyNamedBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyNamedBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyPixels {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyPixels.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyPixels = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyPixels", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTexImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTexImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTexImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTexImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTexImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTexImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTexImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTexImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTexSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTexSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTexSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTexSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTexSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTexSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTexSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTexSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTexSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTexSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTexSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTexSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CopyTextureSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CopyTextureSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CopyTextureSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glCopyTextureSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateFramebuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateFramebuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateFramebuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateFramebuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateProgramObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateProgramObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateProgramObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateProgramObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateProgramPipelines {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateProgramPipelines.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateProgramPipelines = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateProgramPipelines", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateQueries {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateQueries.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateQueries = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateQueries", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateRenderbuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateRenderbuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateRenderbuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateRenderbuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateSamplers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateSamplers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateSamplers = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateSamplers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateShaderObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateShaderObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateShaderObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateShaderObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateShaderProgramv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateShaderProgramv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateShaderProgramv = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateShaderProgramv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateTransformFeedbacks {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateTransformFeedbacks.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateTransformFeedbacks = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateTransformFeedbacks", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CreateVertexArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CreateVertexArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CreateVertexArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glCreateVertexArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod CullFace {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::CullFace.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::CullFace = FnPtr::new(metaloadfn(loadfn, "epoxy_glCullFace", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageCallback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageCallback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageCallback = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageCallback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageCallbackARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageCallbackARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageCallbackARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageCallbackARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageCallbackKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageCallbackKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageCallbackKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageCallbackKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageControl {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageControl.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageControl = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageControl", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageControlARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageControlARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageControlARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageControlARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageControlKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageControlKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageControlKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageControlKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageInsert {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageInsert.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageInsert = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageInsert", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageInsertARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageInsertARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageInsertARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageInsertARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DebugMessageInsertKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DebugMessageInsertKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DebugMessageInsertKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glDebugMessageInsertKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteBuffersARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteBuffersARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteBuffersARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteBuffersARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteFramebuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteFramebuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteFramebuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteFramebuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteFramebuffersEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteFramebuffersEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteFramebuffersEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteFramebuffersEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteLists {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteLists.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteLists = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteLists", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteProgramPipelines {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteProgramPipelines.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteProgramPipelines = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteProgramPipelines", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteQueries {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteQueries.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteQueries = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteQueries", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteQueriesARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteQueriesARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteQueriesARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteQueriesARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteQueriesEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteQueriesEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteQueriesEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteQueriesEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteRenderbuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteRenderbuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteRenderbuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteRenderbuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteRenderbuffersEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteRenderbuffersEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteRenderbuffersEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteRenderbuffersEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteSamplers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteSamplers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteSamplers = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteSamplers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteSync {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteSync.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteSync = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteSync", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteSyncAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteSyncAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteSyncAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteSyncAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteTransformFeedbacks {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteTransformFeedbacks.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteTransformFeedbacks = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteTransformFeedbacks", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteVertexArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteVertexArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteVertexArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteVertexArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteVertexArraysAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteVertexArraysAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteVertexArraysAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteVertexArraysAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DeleteVertexArraysOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DeleteVertexArraysOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DeleteVertexArraysOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glDeleteVertexArraysOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthFunc {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthFunc.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthFunc = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthFunc", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthMask {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthMask.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthMask = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthMask", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthRangeArrayv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthRangeArrayv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthRangeArrayv = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthRangeArrayv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthRangeIndexed {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthRangeIndexed.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthRangeIndexed = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthRangeIndexed", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DepthRangef {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DepthRangef.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DepthRangef = FnPtr::new(metaloadfn(loadfn, "epoxy_glDepthRangef", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DetachObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DetachObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DetachObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDetachObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DetachShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DetachShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DetachShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glDetachShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Disable {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Disable.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Disable = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisable", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableClientState {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableClientState.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableClientState = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableClientState", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableClientStateIndexedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableClientStateIndexedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableClientStateIndexedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableClientStateIndexedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableClientStateiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableClientStateiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableClientStateiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableClientStateiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableIndexedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableIndexedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableIndexedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableIndexedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableVertexArrayAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableVertexArrayAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableVertexArrayAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableVertexArrayAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableVertexArrayAttribEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableVertexArrayAttribEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableVertexArrayAttribEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableVertexArrayAttribEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableVertexArrayEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableVertexArrayEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableVertexArrayEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableVertexArrayEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableVertexAttribArray {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableVertexAttribArray.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableVertexAttribArray = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableVertexAttribArray", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DisableVertexAttribArrayARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DisableVertexAttribArrayARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DisableVertexAttribArrayARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisableVertexAttribArrayARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Disablei {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Disablei.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Disablei = FnPtr::new(metaloadfn(loadfn, "epoxy_glDisablei", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DispatchCompute {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DispatchCompute.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DispatchCompute = FnPtr::new(metaloadfn(loadfn, "epoxy_glDispatchCompute", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DispatchComputeIndirect {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DispatchComputeIndirect.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DispatchComputeIndirect = FnPtr::new(metaloadfn(loadfn, "epoxy_glDispatchComputeIndirect", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawArraysIndirect {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawArraysIndirect.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawArraysIndirect = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawArraysIndirect", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawArraysInstanced {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawArraysInstanced.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawArraysInstanced = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawArraysInstanced", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawArraysInstancedBaseInstance {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawArraysInstancedBaseInstance.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawArraysInstancedBaseInstance = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawArraysInstancedBaseInstance", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawBuffersARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawBuffersARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawBuffersARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawBuffersARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawBuffersATI {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawBuffersATI.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawBuffersATI = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawBuffersATI", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElements {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElements.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElements = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElements", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsBaseVertex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsBaseVertex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsBaseVertex = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsBaseVertex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsBaseVertexOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsBaseVertexOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsBaseVertexOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsBaseVertexOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsIndirect {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsIndirect.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsIndirect = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsIndirect", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsInstanced {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsInstanced.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsInstanced = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsInstanced", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsInstancedBaseInstance {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsInstancedBaseInstance.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsInstancedBaseInstance = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsInstancedBaseInstance", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsInstancedBaseVertex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsInstancedBaseVertex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsInstancedBaseVertex = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsInstancedBaseVertex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsInstancedBaseVertexBaseInstance {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsInstancedBaseVertexBaseInstance.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsInstancedBaseVertexBaseInstance = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsInstancedBaseVertexBaseInstance", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawElementsInstancedBaseVertexOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawElementsInstancedBaseVertexOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawElementsInstancedBaseVertexOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawElementsInstancedBaseVertexOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawPixels {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawPixels.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawPixels = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawPixels", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawRangeElements {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawRangeElements.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawRangeElements = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawRangeElements", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawRangeElementsBaseVertex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawRangeElementsBaseVertex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawRangeElementsBaseVertex = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawRangeElementsBaseVertex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawRangeElementsBaseVertexOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawRangeElementsBaseVertexOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawRangeElementsBaseVertexOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawRangeElementsBaseVertexOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawTransformFeedbackInstanced {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawTransformFeedbackInstanced.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawTransformFeedbackInstanced = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawTransformFeedbackInstanced", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawTransformFeedbackStream {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawTransformFeedbackStream.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawTransformFeedbackStream = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawTransformFeedbackStream", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod DrawTransformFeedbackStreamInstanced {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::DrawTransformFeedbackStreamInstanced.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::DrawTransformFeedbackStreamInstanced = FnPtr::new(metaloadfn(loadfn, "epoxy_glDrawTransformFeedbackStreamInstanced", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EdgeFlag {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EdgeFlag.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EdgeFlag = FnPtr::new(metaloadfn(loadfn, "epoxy_glEdgeFlag", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EdgeFlagPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EdgeFlagPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EdgeFlagPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glEdgeFlagPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EdgeFlagv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EdgeFlagv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EdgeFlagv = FnPtr::new(metaloadfn(loadfn, "epoxy_glEdgeFlagv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Enable {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Enable.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Enable = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnable", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableClientState {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableClientState.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableClientState = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableClientState", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableClientStateIndexedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableClientStateIndexedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableClientStateIndexedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableClientStateIndexedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableClientStateiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableClientStateiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableClientStateiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableClientStateiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableIndexedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableIndexedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableIndexedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableIndexedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableVertexArrayAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableVertexArrayAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableVertexArrayAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableVertexArrayAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableVertexArrayAttribEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableVertexArrayAttribEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableVertexArrayAttribEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableVertexArrayAttribEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableVertexArrayEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableVertexArrayEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableVertexArrayEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableVertexArrayEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableVertexAttribArray {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableVertexAttribArray.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableVertexAttribArray = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableVertexAttribArray", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EnableVertexAttribArrayARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EnableVertexAttribArrayARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EnableVertexAttribArrayARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnableVertexAttribArrayARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Enablei {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Enablei.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Enablei = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnablei", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod End {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::End.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::End = FnPtr::new(metaloadfn(loadfn, "epoxy_glEnd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndConditionalRender {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndConditionalRender.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndConditionalRender = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndConditionalRender", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndConditionalRenderNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndConditionalRenderNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndConditionalRenderNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndConditionalRenderNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndList {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndList.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndList = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndList", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndQuery {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndQuery.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndQuery = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndQuery", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndQueryARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndQueryARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndQueryARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndQueryARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndQueryEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndQueryEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndQueryEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndQueryEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndQueryIndexed {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndQueryIndexed.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndQueryIndexed = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndQueryIndexed", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EndTransformFeedbackEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EndTransformFeedbackEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EndTransformFeedbackEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glEndTransformFeedbackEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalCoord2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalCoord2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalCoord2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalCoord2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalMesh1 {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalMesh1.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalMesh1 = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalMesh1", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalMesh2 {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalMesh2.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalMesh2 = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalMesh2", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalPoint1 {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalPoint1.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalPoint1 = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalPoint1", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod EvalPoint2 {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::EvalPoint2.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::EvalPoint2 = FnPtr::new(metaloadfn(loadfn, "epoxy_glEvalPoint2", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FeedbackBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FeedbackBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FeedbackBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glFeedbackBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FenceSync {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FenceSync.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FenceSync = FnPtr::new(metaloadfn(loadfn, "epoxy_glFenceSync", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FenceSyncAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FenceSyncAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FenceSyncAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glFenceSyncAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Finish {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Finish.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Finish = FnPtr::new(metaloadfn(loadfn, "epoxy_glFinish", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Flush {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Flush.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Flush = FnPtr::new(metaloadfn(loadfn, "epoxy_glFlush", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FlushMappedBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FlushMappedBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FlushMappedBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glFlushMappedBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FlushMappedNamedBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FlushMappedNamedBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FlushMappedNamedBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glFlushMappedNamedBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FlushMappedNamedBufferRangeEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FlushMappedNamedBufferRangeEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FlushMappedNamedBufferRangeEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFlushMappedNamedBufferRangeEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FogCoordPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FogCoordPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FogCoordPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogCoordPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FogCoordd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FogCoordd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FogCoordd = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogCoordd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FogCoorddv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FogCoorddv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FogCoorddv = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogCoorddv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FogCoordf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FogCoordf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FogCoordf = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogCoordf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FogCoordfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FogCoordfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FogCoordfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogCoordfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Fogf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Fogf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Fogf = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Fogfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Fogfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Fogfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Fogi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Fogi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Fogi = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Fogiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Fogiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Fogiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glFogiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferDrawBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferDrawBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferDrawBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferDrawBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferDrawBuffersEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferDrawBuffersEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferDrawBuffersEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferDrawBuffersEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferReadBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferReadBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferReadBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferReadBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferRenderbuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferRenderbuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferRenderbuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferRenderbuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture2DMultisampleEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture2DMultisampleEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture2DMultisampleEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture2DMultisampleEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTexture3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTexture3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTexture3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTexture3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTextureARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTextureARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTextureARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTextureARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTextureFaceARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTextureFaceARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTextureFaceARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTextureFaceARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTextureLayer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTextureLayer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTextureLayer = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTextureLayer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTextureLayerARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTextureLayerARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTextureLayerARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTextureLayerARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FramebufferTextureLayerEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FramebufferTextureLayerEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FramebufferTextureLayerEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glFramebufferTextureLayerEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod FrontFace {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::FrontFace.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::FrontFace = FnPtr::new(metaloadfn(loadfn, "epoxy_glFrontFace", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Frustum {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Frustum.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Frustum = FnPtr::new(metaloadfn(loadfn, "epoxy_glFrustum", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenBuffersARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenBuffersARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenBuffersARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenBuffersARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenFramebuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenFramebuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenFramebuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenFramebuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenFramebuffersEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenFramebuffersEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenFramebuffersEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenFramebuffersEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenLists {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenLists.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenLists = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenLists", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenProgramPipelines {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenProgramPipelines.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenProgramPipelines = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenProgramPipelines", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenQueries {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenQueries.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenQueries = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenQueries", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenQueriesARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenQueriesARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenQueriesARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenQueriesARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenQueriesEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenQueriesEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenQueriesEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenQueriesEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenRenderbuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenRenderbuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenRenderbuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenRenderbuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenRenderbuffersEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenRenderbuffersEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenRenderbuffersEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenRenderbuffersEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenSamplers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenSamplers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenSamplers = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenSamplers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenTransformFeedbacks {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenTransformFeedbacks.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenTransformFeedbacks = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenTransformFeedbacks", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenVertexArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenVertexArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenVertexArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenVertexArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenVertexArraysAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenVertexArraysAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenVertexArraysAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenVertexArraysAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenVertexArraysOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenVertexArraysOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenVertexArraysOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenVertexArraysOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenerateMipmap {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenerateMipmap.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenerateMipmap = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenerateMipmap", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenerateMipmapEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenerateMipmapEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenerateMipmapEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenerateMipmapEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenerateMultiTexMipmapEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenerateMultiTexMipmapEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenerateMultiTexMipmapEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenerateMultiTexMipmapEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenerateTextureMipmap {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenerateTextureMipmap.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenerateTextureMipmap = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenerateTextureMipmap", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GenerateTextureMipmapEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GenerateTextureMipmapEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GenerateTextureMipmapEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGenerateTextureMipmapEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveAtomicCounterBufferiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveAtomicCounterBufferiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveAtomicCounterBufferiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveAtomicCounterBufferiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveAttribARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveAttribARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveAttribARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveAttribARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveSubroutineName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveSubroutineName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveSubroutineName = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveSubroutineName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveSubroutineUniformName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveSubroutineUniformName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveSubroutineUniformName = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveSubroutineUniformName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveSubroutineUniformiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveSubroutineUniformiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveSubroutineUniformiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveSubroutineUniformiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniform {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniform.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniform = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniform", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniformARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniformARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniformARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniformARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniformBlockName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniformBlockName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniformBlockName = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniformBlockName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniformBlockiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniformBlockiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniformBlockiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniformBlockiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniformName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniformName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniformName = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniformName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetActiveUniformsiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetActiveUniformsiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetActiveUniformsiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetActiveUniformsiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetAttachedObjectsARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetAttachedObjectsARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetAttachedObjectsARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetAttachedObjectsARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetAttachedShaders {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetAttachedShaders.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetAttachedShaders = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetAttachedShaders", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetAttribLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetAttribLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetAttribLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetAttribLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetAttribLocationARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetAttribLocationARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetAttribLocationARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetAttribLocationARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBooleanIndexedvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBooleanIndexedvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBooleanIndexedvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBooleanIndexedvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBooleani_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBooleani_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBooleani_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBooleani_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBooleanv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBooleanv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBooleanv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBooleanv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferParameteri64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferParameteri64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferParameteri64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferParameteri64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferParameterivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferParameterivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferParameterivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferParameterivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferPointerv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferPointerv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferPointerv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferPointerv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferPointervARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferPointervARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferPointervARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferPointervARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetBufferSubDataARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetBufferSubDataARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetBufferSubDataARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetBufferSubDataARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetClipPlane {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetClipPlane.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetClipPlane = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetClipPlane", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetCompressedMultiTexImageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetCompressedMultiTexImageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetCompressedMultiTexImageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetCompressedMultiTexImageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetCompressedTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetCompressedTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetCompressedTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetCompressedTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetCompressedTextureImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetCompressedTextureImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetCompressedTextureImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetCompressedTextureImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetCompressedTextureImageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetCompressedTextureImageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetCompressedTextureImageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetCompressedTextureImageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetCompressedTextureSubImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetCompressedTextureSubImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetCompressedTextureSubImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetCompressedTextureSubImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDebugMessageLog {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDebugMessageLog.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDebugMessageLog = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDebugMessageLog", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDebugMessageLogARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDebugMessageLogARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDebugMessageLogARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDebugMessageLogARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDebugMessageLogKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDebugMessageLogKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDebugMessageLogKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDebugMessageLogKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDoubleIndexedvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDoubleIndexedvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDoubleIndexedvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDoubleIndexedvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDoublei_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDoublei_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDoublei_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDoublei_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDoublei_vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDoublei_vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDoublei_vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDoublei_vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetDoublev {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetDoublev.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetDoublev = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetDoublev", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetError {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetError.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetError = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetError", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFloatIndexedvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFloatIndexedvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFloatIndexedvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFloatIndexedvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFloati_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFloati_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFloati_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFloati_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFloati_vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFloati_vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFloati_vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFloati_vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFloatv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFloatv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFloatv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFloatv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFragDataIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFragDataIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFragDataIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFragDataIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFragDataLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFragDataLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFragDataLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFragDataLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFragDataLocationEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFragDataLocationEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFragDataLocationEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFragDataLocationEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFramebufferAttachmentParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFramebufferAttachmentParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFramebufferAttachmentParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFramebufferAttachmentParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFramebufferAttachmentParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFramebufferAttachmentParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFramebufferAttachmentParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFramebufferAttachmentParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFramebufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFramebufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFramebufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFramebufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetFramebufferParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetFramebufferParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetFramebufferParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetFramebufferParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetGraphicsResetStatus {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetGraphicsResetStatus.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetGraphicsResetStatus = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetGraphicsResetStatus", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetGraphicsResetStatusARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetGraphicsResetStatusARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetGraphicsResetStatusARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetGraphicsResetStatusARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetGraphicsResetStatusEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetGraphicsResetStatusEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetGraphicsResetStatusEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetGraphicsResetStatusEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetGraphicsResetStatusKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetGraphicsResetStatusKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetGraphicsResetStatusKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetGraphicsResetStatusKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetHandleARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetHandleARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetHandleARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetHandleARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetImageHandleARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetImageHandleARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetImageHandleARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetImageHandleARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInfoLogARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInfoLogARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInfoLogARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInfoLogARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInteger64i_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInteger64i_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInteger64i_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInteger64i_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInteger64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInteger64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInteger64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInteger64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInteger64vAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInteger64vAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInteger64vAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInteger64vAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetIntegerIndexedvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetIntegerIndexedvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetIntegerIndexedvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetIntegerIndexedvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetIntegeri_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetIntegeri_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetIntegeri_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetIntegeri_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetIntegerv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetIntegerv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetIntegerv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetIntegerv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInternalformatSampleivNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInternalformatSampleivNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInternalformatSampleivNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInternalformatSampleivNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInternalformati64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInternalformati64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInternalformati64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInternalformati64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetInternalformativ {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetInternalformativ.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetInternalformativ = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetInternalformativ", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetLightfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetLightfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetLightfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetLightfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetLightiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetLightiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetLightiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetLightiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMapdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMapdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMapdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMapdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMapfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMapfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMapfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMapfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMapiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMapiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMapiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMapiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMaterialfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMaterialfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMaterialfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMaterialfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMaterialiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMaterialiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMaterialiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMaterialiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexEnvfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexEnvfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexEnvfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexEnvfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexEnvivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexEnvivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexEnvivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexEnvivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexGendvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexGendvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexGendvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexGendvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexGenfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexGenfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexGenfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexGenfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexGenivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexGenivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexGenivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexGenivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexImageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexImageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexImageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexImageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexLevelParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexLevelParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexLevelParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexLevelParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexLevelParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexLevelParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexLevelParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexLevelParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultiTexParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultiTexParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultiTexParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultiTexParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetMultisamplefv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetMultisamplefv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetMultisamplefv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetMultisamplefv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferParameteri64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferParameteri64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferParameteri64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferParameteri64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferPointerv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferPointerv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferPointerv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferPointerv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferPointervEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferPointervEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferPointervEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferPointervEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedBufferSubDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedBufferSubDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedBufferSubDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedBufferSubDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedFramebufferAttachmentParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedFramebufferAttachmentParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedFramebufferAttachmentParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedFramebufferAttachmentParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedFramebufferAttachmentParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedFramebufferAttachmentParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedFramebufferAttachmentParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedFramebufferAttachmentParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedFramebufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedFramebufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedFramebufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedFramebufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedFramebufferParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedFramebufferParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedFramebufferParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedFramebufferParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramLocalParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramLocalParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramLocalParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramLocalParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramLocalParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramLocalParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramLocalParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramLocalParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramLocalParameterdvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramLocalParameterdvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramLocalParameterdvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramLocalParameterdvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramLocalParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramLocalParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramLocalParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramLocalParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramStringEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramStringEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramStringEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramStringEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedProgramivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedProgramivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedProgramivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedProgramivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedRenderbufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedRenderbufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedRenderbufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedRenderbufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetNamedRenderbufferParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetNamedRenderbufferParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetNamedRenderbufferParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetNamedRenderbufferParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectLabel {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectLabel.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectLabel = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectLabel", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectLabelKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectLabelKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectLabelKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectLabelKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectParameterfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectParameterfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectParameterfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectParameterfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectParameterivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectParameterivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectParameterivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectParameterivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectPtrLabel {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectPtrLabel.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectPtrLabel = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectPtrLabel", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetObjectPtrLabelKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetObjectPtrLabelKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetObjectPtrLabelKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetObjectPtrLabelKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPixelMapfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPixelMapfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPixelMapfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPixelMapfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPixelMapuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPixelMapuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPixelMapuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPixelMapuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPixelMapusv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPixelMapusv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPixelMapusv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPixelMapusv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPointerIndexedvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPointerIndexedvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPointerIndexedvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPointerIndexedvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPointeri_vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPointeri_vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPointeri_vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPointeri_vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPointerv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPointerv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPointerv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPointerv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPointervKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPointervKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPointervKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPointervKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetPolygonStipple {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetPolygonStipple.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetPolygonStipple = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetPolygonStipple", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramBinary {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramBinary.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramBinary = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramBinary", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramInfoLog {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramInfoLog.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramInfoLog = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramInfoLog", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramInterfaceiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramInterfaceiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramInterfaceiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramInterfaceiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramPipelineInfoLog {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramPipelineInfoLog.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramPipelineInfoLog = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramPipelineInfoLog", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramPipelineiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramPipelineiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramPipelineiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramPipelineiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramResourceIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramResourceIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramResourceIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramResourceIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramResourceLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramResourceLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramResourceLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramResourceLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramResourceLocationIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramResourceLocationIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramResourceLocationIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramResourceLocationIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramResourceName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramResourceName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramResourceName = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramResourceName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramResourceiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramResourceiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramResourceiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramResourceiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramStageiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramStageiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramStageiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramStageiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetProgramiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetProgramiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetProgramiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetProgramiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryBufferObjecti64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryBufferObjecti64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryBufferObjecti64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryBufferObjecti64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryBufferObjectiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryBufferObjectiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryBufferObjectiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryBufferObjectiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryBufferObjectui64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryBufferObjectui64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryBufferObjectui64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryBufferObjectui64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryBufferObjectuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryBufferObjectuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryBufferObjectuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryBufferObjectuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryIndexediv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryIndexediv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryIndexediv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryIndexediv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjecti64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjecti64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjecti64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjecti64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjecti64vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjecti64vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjecti64vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjecti64vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectui64v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectui64v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectui64v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectui64v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectui64vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectui64vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectui64vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectui64vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectuivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectuivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectuivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectuivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryObjectuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryObjectuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryObjectuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryObjectuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetQueryivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetQueryivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetQueryivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetQueryivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetRenderbufferParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetRenderbufferParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetRenderbufferParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetRenderbufferParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetRenderbufferParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetRenderbufferParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetRenderbufferParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetRenderbufferParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSamplerParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSamplerParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSamplerParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSamplerParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSamplerParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSamplerParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSamplerParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSamplerParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSamplerParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSamplerParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSamplerParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSamplerParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSamplerParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSamplerParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSamplerParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSamplerParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetShaderInfoLog {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetShaderInfoLog.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetShaderInfoLog = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetShaderInfoLog", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetShaderPrecisionFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetShaderPrecisionFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetShaderPrecisionFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetShaderPrecisionFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetShaderSource {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetShaderSource.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetShaderSource = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetShaderSource", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetShaderSourceARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetShaderSourceARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetShaderSourceARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetShaderSourceARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetShaderiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetShaderiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetShaderiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetShaderiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetString {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetString.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetString = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetString", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetStringi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetStringi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetStringi = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetStringi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSubroutineIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSubroutineIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSubroutineIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSubroutineIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSubroutineUniformLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSubroutineUniformLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSubroutineUniformLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSubroutineUniformLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSynciv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSynciv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSynciv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSynciv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetSyncivAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetSyncivAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetSyncivAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetSyncivAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexEnvfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexEnvfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexEnvfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexEnvfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexEnviv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexEnviv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexEnviv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexEnviv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexGendv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexGendv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexGendv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexGendv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexGenfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexGenfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexGenfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexGenfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexGeniv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexGeniv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexGeniv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexGeniv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexLevelParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexLevelParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexLevelParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexLevelParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexLevelParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexLevelParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexLevelParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexLevelParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTexParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTexParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTexParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTexParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureHandleARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureHandleARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureHandleARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureHandleARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureImageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureImageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureImageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureImageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureLevelParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureLevelParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureLevelParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureLevelParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureLevelParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureLevelParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureLevelParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureLevelParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureLevelParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureLevelParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureLevelParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureLevelParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureLevelParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureLevelParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureLevelParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureLevelParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureSamplerHandleARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureSamplerHandleARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureSamplerHandleARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureSamplerHandleARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTextureSubImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTextureSubImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTextureSubImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTextureSubImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTransformFeedbackVarying {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTransformFeedbackVarying.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTransformFeedbackVarying = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTransformFeedbackVarying", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTransformFeedbackVaryingEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTransformFeedbackVaryingEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTransformFeedbackVaryingEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTransformFeedbackVaryingEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTransformFeedbacki64_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTransformFeedbacki64_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTransformFeedbacki64_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTransformFeedbacki64_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTransformFeedbacki_v {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTransformFeedbacki_v.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTransformFeedbacki_v = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTransformFeedbacki_v", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetTransformFeedbackiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetTransformFeedbackiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetTransformFeedbackiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetTransformFeedbackiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformBlockIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformBlockIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformBlockIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformBlockIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformIndices {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformIndices.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformIndices = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformIndices", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformLocation {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformLocation.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformLocation = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformLocation", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformLocationARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformLocationARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformLocationARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformLocationARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformSubroutineuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformSubroutineuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformSubroutineuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformSubroutineuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformi64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformi64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformi64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformi64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetUniformuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetUniformuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetUniformuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetUniformuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayIndexed64iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayIndexed64iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayIndexed64iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayIndexed64iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayIndexediv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayIndexediv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayIndexediv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayIndexediv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayIntegeri_vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayIntegeri_vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayIntegeri_vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayIntegeri_vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayIntegervEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayIntegervEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayIntegervEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayIntegervEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayPointeri_vEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayPointeri_vEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayPointeri_vEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayPointeri_vEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayPointervEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayPointervEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayPointervEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayPointervEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexArrayiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexArrayiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexArrayiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexArrayiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribLdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribLdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribLdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribLdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribLi64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribLi64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribLi64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribLi64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribLui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribLui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribLui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribLui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribLui64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribLui64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribLui64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribLui64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribPointerv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribPointerv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribPointerv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribPointerv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribPointervARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribPointervARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribPointervARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribPointervARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribdvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribdvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribdvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribdvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetVertexAttribivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetVertexAttribivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetVertexAttribivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetVertexAttribivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnColorTable {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnColorTable.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnColorTable = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnColorTable", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnColorTableARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnColorTableARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnColorTableARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnColorTableARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnCompressedTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnCompressedTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnCompressedTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnCompressedTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnCompressedTexImageARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnCompressedTexImageARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnCompressedTexImageARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnCompressedTexImageARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnConvolutionFilter {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnConvolutionFilter.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnConvolutionFilter = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnConvolutionFilter", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnConvolutionFilterARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnConvolutionFilterARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnConvolutionFilterARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnConvolutionFilterARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnHistogram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnHistogram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnHistogram = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnHistogram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnHistogramARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnHistogramARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnHistogramARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnHistogramARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapdvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapdvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapdvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapdvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMapivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMapivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMapivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMapivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMinmax {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMinmax.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMinmax = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMinmax", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnMinmaxARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnMinmaxARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnMinmaxARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnMinmaxARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapuivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapuivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapuivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapuivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapusv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapusv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapusv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapusv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPixelMapusvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPixelMapusvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPixelMapusvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPixelMapusvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPolygonStipple {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPolygonStipple.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPolygonStipple = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPolygonStipple", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnPolygonStippleARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnPolygonStippleARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnPolygonStippleARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnPolygonStippleARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnSeparableFilter {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnSeparableFilter.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnSeparableFilter = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnSeparableFilter", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnSeparableFilterARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnSeparableFilterARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnSeparableFilterARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnSeparableFilterARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnTexImageARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnTexImageARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnTexImageARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnTexImageARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformdvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformdvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformdvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformdvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformfvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformfvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformfvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformfvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformfvKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformfvKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformfvKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformfvKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformi64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformi64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformi64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformi64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformivKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformivKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformivKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformivKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformuivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformuivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformuivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformuivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod GetnUniformuivKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::GetnUniformuivKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::GetnUniformuivKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glGetnUniformuivKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Hint {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Hint.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Hint = FnPtr::new(metaloadfn(loadfn, "epoxy_glHint", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IndexMask {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IndexMask.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IndexMask = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexMask", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IndexPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IndexPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IndexPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexd = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexf = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexi = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexs {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexs.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexs = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexs", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexsv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexsv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexsv = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexsv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexub {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexub.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexub = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexub", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Indexubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Indexubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Indexubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glIndexubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InitNames {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InitNames.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InitNames = FnPtr::new(metaloadfn(loadfn, "epoxy_glInitNames", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InterleavedArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InterleavedArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InterleavedArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glInterleavedArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateBufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateBufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateBufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateBufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateNamedFramebufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateNamedFramebufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateNamedFramebufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateNamedFramebufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateNamedFramebufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateNamedFramebufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateNamedFramebufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateNamedFramebufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateSubFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateSubFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateSubFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateSubFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateTexImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateTexImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateTexImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateTexImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod InvalidateTexSubImage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::InvalidateTexSubImage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::InvalidateTexSubImage = FnPtr::new(metaloadfn(loadfn, "epoxy_glInvalidateTexSubImage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsBufferARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsBufferARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsBufferARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsBufferARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsEnabled {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsEnabled.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsEnabled = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsEnabled", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsEnabledIndexedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsEnabledIndexedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsEnabledIndexedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsEnabledIndexedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsEnabledi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsEnabledi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsEnabledi = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsEnabledi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsFramebuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsFramebuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsFramebuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsFramebuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsFramebufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsFramebufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsFramebufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsFramebufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsImageHandleResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsImageHandleResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsImageHandleResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsImageHandleResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsList {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsList.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsList = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsList", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsProgramPipeline {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsProgramPipeline.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsProgramPipeline = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsProgramPipeline", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsQuery {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsQuery.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsQuery = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsQuery", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsQueryARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsQueryARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsQueryARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsQueryARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsQueryEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsQueryEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsQueryEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsQueryEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsRenderbuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsRenderbuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsRenderbuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsRenderbuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsSampler {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsSampler.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsSampler = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsSampler", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsShader {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsShader.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsShader = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsShader", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsSync {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsSync.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsSync = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsSync", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsSyncAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsSyncAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsSyncAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsSyncAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsTextureHandleResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsTextureHandleResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsTextureHandleResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsTextureHandleResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsVertexArray {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsVertexArray.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsVertexArray = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsVertexArray", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsVertexArrayAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsVertexArrayAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsVertexArrayAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsVertexArrayAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod IsVertexArrayOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::IsVertexArrayOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::IsVertexArrayOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glIsVertexArrayOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LightModelf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LightModelf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LightModelf = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightModelf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LightModelfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LightModelfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LightModelfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightModelfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LightModeli {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LightModeli.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LightModeli = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightModeli", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LightModeliv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LightModeliv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LightModeliv = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightModeliv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Lightf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Lightf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Lightf = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Lightfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Lightfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Lightfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Lighti {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Lighti.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Lighti = FnPtr::new(metaloadfn(loadfn, "epoxy_glLighti", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Lightiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Lightiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Lightiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glLightiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LineStipple {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LineStipple.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LineStipple = FnPtr::new(metaloadfn(loadfn, "epoxy_glLineStipple", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LineWidth {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LineWidth.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LineWidth = FnPtr::new(metaloadfn(loadfn, "epoxy_glLineWidth", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LinkProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LinkProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LinkProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glLinkProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LinkProgramARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LinkProgramARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LinkProgramARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glLinkProgramARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ListBase {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ListBase.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ListBase = FnPtr::new(metaloadfn(loadfn, "epoxy_glListBase", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadIdentity {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadIdentity.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadIdentity = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadIdentity", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadMatrixd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadMatrixd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadMatrixd = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadMatrixd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadMatrixf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadMatrixf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadMatrixf = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadMatrixf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadName = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadTransposeMatrixd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadTransposeMatrixd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadTransposeMatrixd = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadTransposeMatrixd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LoadTransposeMatrixf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LoadTransposeMatrixf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LoadTransposeMatrixf = FnPtr::new(metaloadfn(loadfn, "epoxy_glLoadTransposeMatrixf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod LogicOp {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::LogicOp.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::LogicOp = FnPtr::new(metaloadfn(loadfn, "epoxy_glLogicOp", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MakeImageHandleNonResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MakeImageHandleNonResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MakeImageHandleNonResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glMakeImageHandleNonResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MakeImageHandleResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MakeImageHandleResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MakeImageHandleResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glMakeImageHandleResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MakeTextureHandleNonResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MakeTextureHandleNonResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MakeTextureHandleNonResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glMakeTextureHandleNonResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MakeTextureHandleResidentARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MakeTextureHandleResidentARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MakeTextureHandleResidentARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glMakeTextureHandleResidentARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Map1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Map1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Map1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMap1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Map1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Map1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Map1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMap1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Map2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Map2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Map2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMap2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Map2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Map2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Map2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMap2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapBufferARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapBufferARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapBufferARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapBufferARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapGrid1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapGrid1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapGrid1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapGrid1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapGrid1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapGrid1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapGrid1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapGrid1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapGrid2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapGrid2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapGrid2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapGrid2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapGrid2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapGrid2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapGrid2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapGrid2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapNamedBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapNamedBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapNamedBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapNamedBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapNamedBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapNamedBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapNamedBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapNamedBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapNamedBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapNamedBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapNamedBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapNamedBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MapNamedBufferRangeEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MapNamedBufferRangeEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MapNamedBufferRangeEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMapNamedBufferRangeEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Materialf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Materialf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Materialf = FnPtr::new(metaloadfn(loadfn, "epoxy_glMaterialf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Materialfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Materialfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Materialfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMaterialfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Materiali {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Materiali.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Materiali = FnPtr::new(metaloadfn(loadfn, "epoxy_glMateriali", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Materialiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Materialiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Materialiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMaterialiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixFrustumEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixFrustumEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixFrustumEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixFrustumEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixLoadIdentityEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixLoadIdentityEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixLoadIdentityEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixLoadIdentityEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixLoadTransposedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixLoadTransposedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixLoadTransposedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixLoadTransposedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixLoadTransposefEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixLoadTransposefEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixLoadTransposefEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixLoadTransposefEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixLoaddEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixLoaddEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixLoaddEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixLoaddEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixLoadfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixLoadfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixLoadfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixLoadfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixMode {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixMode.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixMode = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixMode", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixMultTransposedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixMultTransposedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixMultTransposedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixMultTransposedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixMultTransposefEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixMultTransposefEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixMultTransposefEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixMultTransposefEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixMultdEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixMultdEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixMultdEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixMultdEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixMultfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixMultfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixMultfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixMultfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixOrthoEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixOrthoEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixOrthoEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixOrthoEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixPopEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixPopEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixPopEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixPopEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixPushEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixPushEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixPushEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixPushEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixRotatedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixRotatedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixRotatedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixRotatedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixRotatefEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixRotatefEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixRotatefEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixRotatefEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixScaledEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixScaledEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixScaledEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixScaledEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixScalefEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixScalefEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixScalefEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixScalefEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixTranslatedEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixTranslatedEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixTranslatedEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixTranslatedEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MatrixTranslatefEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MatrixTranslatefEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MatrixTranslatefEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMatrixTranslatefEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MemoryBarrier {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MemoryBarrier.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MemoryBarrier = FnPtr::new(metaloadfn(loadfn, "epoxy_glMemoryBarrier", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MemoryBarrierByRegion {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MemoryBarrierByRegion.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MemoryBarrierByRegion = FnPtr::new(metaloadfn(loadfn, "epoxy_glMemoryBarrierByRegion", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MinSampleShading {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MinSampleShading.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MinSampleShading = FnPtr::new(metaloadfn(loadfn, "epoxy_glMinSampleShading", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultMatrixd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultMatrixd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultMatrixd = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultMatrixd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultMatrixf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultMatrixf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultMatrixf = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultMatrixf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultTransposeMatrixd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultTransposeMatrixd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultTransposeMatrixd = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultTransposeMatrixd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultTransposeMatrixf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultTransposeMatrixf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultTransposeMatrixf = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultTransposeMatrixf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawArrays {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawArrays.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawArrays = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawArrays", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawArraysIndirect {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawArraysIndirect.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawArraysIndirect = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawArraysIndirect", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawArraysIndirectEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawArraysIndirectEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawArraysIndirectEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawArraysIndirectEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawElements {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawElements.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawElements = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawElements", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawElementsBaseVertex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawElementsBaseVertex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawElementsBaseVertex = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawElementsBaseVertex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawElementsBaseVertexEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawElementsBaseVertexEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawElementsBaseVertexEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawElementsBaseVertexEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawElementsIndirect {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawElementsIndirect.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawElementsIndirect = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawElementsIndirect", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiDrawElementsIndirectEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiDrawElementsIndirectEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiDrawElementsIndirectEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiDrawElementsIndirectEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1i = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1s = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord1sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord1sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord1sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord1sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoord4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoord4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoord4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoord4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordP4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordP4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordP4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordP4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexCoordPointerEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexCoordPointerEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexCoordPointerEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexCoordPointerEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexEnvfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexEnvfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexEnvfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexEnvfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexEnvfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexEnvfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexEnvfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexEnvfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexEnviEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexEnviEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexEnviEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexEnviEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexEnvivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexEnvivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexEnvivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexEnvivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGendEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGendEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGendEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGendEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGendvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGendvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGendvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGendvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGenfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGenfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGenfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGenfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGenfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGenfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGenfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGenfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGeniEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGeniEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGeniEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGeniEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexGenivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexGenivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexGenivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexGenivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameterfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameterfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameterfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameterfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameteriEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameteriEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameteriEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameteriEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod MultiTexSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::MultiTexSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::MultiTexSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glMultiTexSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferData = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferStorage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferStorage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferStorage = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferStorage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferStorageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferStorageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferStorageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferStorageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferSubData {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferSubData.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferSubData = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferSubData", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedBufferSubDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedBufferSubDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedBufferSubDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedBufferSubDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedCopyBufferSubDataEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedCopyBufferSubDataEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedCopyBufferSubDataEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedCopyBufferSubDataEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferDrawBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferDrawBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferDrawBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferDrawBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferDrawBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferDrawBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferDrawBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferDrawBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferParameteriEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferParameteriEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferParameteriEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferParameteriEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferReadBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferReadBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferReadBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferReadBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferRenderbuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferRenderbuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferRenderbuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferRenderbuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTexture {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTexture.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTexture = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTexture", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTexture1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTexture1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTexture1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTexture1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTexture2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTexture2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTexture2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTexture2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTexture3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTexture3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTexture3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTexture3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTextureEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTextureEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTextureEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTextureEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTextureFaceEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTextureFaceEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTextureFaceEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTextureFaceEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTextureLayer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTextureLayer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTextureLayer = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTextureLayer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedFramebufferTextureLayerEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedFramebufferTextureLayerEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedFramebufferTextureLayerEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedFramebufferTextureLayerEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameter4dEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameter4dEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameter4dEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameter4dEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameter4dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameter4dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameter4dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameter4dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameter4fEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameter4fEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameter4fEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameter4fEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameter4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameter4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameter4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameter4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameterI4iEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameterI4iEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameterI4iEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameterI4iEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameterI4ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameterI4ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameterI4ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameterI4ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameterI4uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameterI4uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameterI4uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameterI4uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameterI4uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameterI4uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameterI4uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameterI4uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParameters4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParameters4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParameters4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParameters4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParametersI4ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParametersI4ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParametersI4ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParametersI4ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramLocalParametersI4uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramLocalParametersI4uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramLocalParametersI4uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramLocalParametersI4uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedProgramStringEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedProgramStringEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedProgramStringEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedProgramStringEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedRenderbufferStorage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedRenderbufferStorage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedRenderbufferStorage = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedRenderbufferStorage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedRenderbufferStorageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedRenderbufferStorageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedRenderbufferStorageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedRenderbufferStorageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedRenderbufferStorageMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedRenderbufferStorageMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedRenderbufferStorageMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedRenderbufferStorageMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedRenderbufferStorageMultisampleCoverageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedRenderbufferStorageMultisampleCoverageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedRenderbufferStorageMultisampleCoverageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedRenderbufferStorageMultisampleCoverageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NamedRenderbufferStorageMultisampleEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NamedRenderbufferStorageMultisampleEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NamedRenderbufferStorageMultisampleEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glNamedRenderbufferStorageMultisampleEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NewList {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NewList.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NewList = FnPtr::new(metaloadfn(loadfn, "epoxy_glNewList", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3b {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3b.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3b = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3b", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Normal3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Normal3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Normal3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormal3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NormalP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NormalP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NormalP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormalP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NormalP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NormalP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NormalP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormalP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod NormalPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::NormalPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::NormalPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glNormalPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ObjectLabel {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ObjectLabel.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ObjectLabel = FnPtr::new(metaloadfn(loadfn, "epoxy_glObjectLabel", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ObjectLabelKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ObjectLabelKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ObjectLabelKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glObjectLabelKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ObjectPtrLabel {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ObjectPtrLabel.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ObjectPtrLabel = FnPtr::new(metaloadfn(loadfn, "epoxy_glObjectPtrLabel", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ObjectPtrLabelKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ObjectPtrLabelKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ObjectPtrLabelKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glObjectPtrLabelKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Ortho {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Ortho.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Ortho = FnPtr::new(metaloadfn(loadfn, "epoxy_glOrtho", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PassThrough {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PassThrough.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PassThrough = FnPtr::new(metaloadfn(loadfn, "epoxy_glPassThrough", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PatchParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PatchParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PatchParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPatchParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PatchParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PatchParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PatchParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glPatchParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PauseTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PauseTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PauseTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glPauseTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelMapfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelMapfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelMapfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelMapfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelMapuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelMapuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelMapuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelMapuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelMapusv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelMapusv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelMapusv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelMapusv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelStoref {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelStoref.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelStoref = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelStoref", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelStorei {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelStorei.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelStorei = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelStorei", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelTransferf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelTransferf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelTransferf = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelTransferf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelTransferi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelTransferi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelTransferi = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelTransferi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PixelZoom {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PixelZoom.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PixelZoom = FnPtr::new(metaloadfn(loadfn, "epoxy_glPixelZoom", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PointParameterf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PointParameterf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PointParameterf = FnPtr::new(metaloadfn(loadfn, "epoxy_glPointParameterf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PointParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PointParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PointParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPointParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PointParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PointParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PointParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glPointParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PointParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PointParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PointParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glPointParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PointSize {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PointSize.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PointSize = FnPtr::new(metaloadfn(loadfn, "epoxy_glPointSize", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PolygonMode {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PolygonMode.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PolygonMode = FnPtr::new(metaloadfn(loadfn, "epoxy_glPolygonMode", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PolygonOffset {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PolygonOffset.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PolygonOffset = FnPtr::new(metaloadfn(loadfn, "epoxy_glPolygonOffset", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PolygonStipple {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PolygonStipple.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PolygonStipple = FnPtr::new(metaloadfn(loadfn, "epoxy_glPolygonStipple", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopClientAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopClientAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopClientAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopClientAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopDebugGroup {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopDebugGroup.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopDebugGroup = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopDebugGroup", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopDebugGroupKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopDebugGroupKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopDebugGroupKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopDebugGroupKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopMatrix {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopMatrix.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopMatrix = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopMatrix", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PopName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PopName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PopName = FnPtr::new(metaloadfn(loadfn, "epoxy_glPopName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrimitiveBoundingBox {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrimitiveBoundingBox.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrimitiveBoundingBox = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrimitiveBoundingBox", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrimitiveBoundingBoxARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrimitiveBoundingBoxARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrimitiveBoundingBoxARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrimitiveBoundingBoxARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrimitiveBoundingBoxEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrimitiveBoundingBoxEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrimitiveBoundingBoxEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrimitiveBoundingBoxEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrimitiveBoundingBoxOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrimitiveBoundingBoxOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrimitiveBoundingBoxOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrimitiveBoundingBoxOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrimitiveRestartIndex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrimitiveRestartIndex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrimitiveRestartIndex = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrimitiveRestartIndex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PrioritizeTextures {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PrioritizeTextures.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PrioritizeTextures = FnPtr::new(metaloadfn(loadfn, "epoxy_glPrioritizeTextures", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramBinary {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramBinary.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramBinary = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramBinary", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramParameteriARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramParameteriARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramParameteriARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramParameteriARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1dEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1dEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1dEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1dEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1fEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1fEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1fEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1fEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1i = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1iEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1iEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1iEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1iEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform1uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform1uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform1uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform1uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2dEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2dEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2dEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2dEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2fEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2fEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2fEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2fEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2iEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2iEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2iEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2iEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform2uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform2uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform2uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform2uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3dEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3dEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3dEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3dEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3fEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3fEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3fEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3fEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3iEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3iEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3iEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3iEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform3uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform3uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform3uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform3uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4dEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4dEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4dEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4dEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4fEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4fEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4fEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4fEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4iEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4iEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4iEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4iEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4ivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4ivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4ivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4ivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniform4uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniform4uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniform4uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniform4uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformHandleui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformHandleui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformHandleui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformHandleui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformHandleui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformHandleui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformHandleui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformHandleui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x3dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x3dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x3dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x3dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x3fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x3fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x3fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x3fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x4dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x4dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x4dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x4dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix2x4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix2x4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix2x4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix2x4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x2dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x2dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x2dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x2dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x2fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x2fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x2fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x2fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x4dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x4dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x4dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x4dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix3x4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix3x4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix3x4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix3x4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x2dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x2dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x2dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x2dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x2fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x2fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x2fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x2fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x3dvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x3dvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x3dvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x3dvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProgramUniformMatrix4x3fvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProgramUniformMatrix4x3fvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProgramUniformMatrix4x3fvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProgramUniformMatrix4x3fvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProvokingVertex {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProvokingVertex.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProvokingVertex = FnPtr::new(metaloadfn(loadfn, "epoxy_glProvokingVertex", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ProvokingVertexEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ProvokingVertexEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ProvokingVertexEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glProvokingVertexEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushClientAttrib {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushClientAttrib.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushClientAttrib = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushClientAttrib", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushClientAttribDefaultEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushClientAttribDefaultEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushClientAttribDefaultEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushClientAttribDefaultEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushDebugGroup {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushDebugGroup.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushDebugGroup = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushDebugGroup", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushDebugGroupKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushDebugGroupKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushDebugGroupKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushDebugGroupKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushMatrix {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushMatrix.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushMatrix = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushMatrix", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod PushName {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::PushName.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::PushName = FnPtr::new(metaloadfn(loadfn, "epoxy_glPushName", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod QueryCounter {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::QueryCounter.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::QueryCounter = FnPtr::new(metaloadfn(loadfn, "epoxy_glQueryCounter", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod QueryCounterEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::QueryCounterEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::QueryCounterEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glQueryCounterEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RasterPos4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RasterPos4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RasterPos4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRasterPos4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadPixels {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadPixels.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadPixels = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadPixels", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadnPixels {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadnPixels.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadnPixels = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadnPixels", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadnPixelsARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadnPixelsARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadnPixelsARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadnPixelsARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadnPixelsEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadnPixelsEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadnPixelsEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadnPixelsEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReadnPixelsKHR {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReadnPixelsKHR.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReadnPixelsKHR = FnPtr::new(metaloadfn(loadfn, "epoxy_glReadnPixelsKHR", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectd {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectd.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectd = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectd", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectdv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectdv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectdv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectdv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectf = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Recti {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Recti.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Recti = FnPtr::new(metaloadfn(loadfn, "epoxy_glRecti", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rects {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rects.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rects = FnPtr::new(metaloadfn(loadfn, "epoxy_glRects", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rectsv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rectsv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rectsv = FnPtr::new(metaloadfn(loadfn, "epoxy_glRectsv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ReleaseShaderCompiler {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ReleaseShaderCompiler.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ReleaseShaderCompiler = FnPtr::new(metaloadfn(loadfn, "epoxy_glReleaseShaderCompiler", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderMode {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderMode.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderMode = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderMode", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorage = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageMultisampleANGLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageMultisampleANGLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageMultisampleANGLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageMultisampleANGLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageMultisampleAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageMultisampleAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageMultisampleAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageMultisampleAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageMultisampleEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageMultisampleEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageMultisampleEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageMultisampleEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod RenderbufferStorageMultisampleNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::RenderbufferStorageMultisampleNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::RenderbufferStorageMultisampleNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glRenderbufferStorageMultisampleNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ResolveMultisampleFramebufferAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ResolveMultisampleFramebufferAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ResolveMultisampleFramebufferAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glResolveMultisampleFramebufferAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ResumeTransformFeedback {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ResumeTransformFeedback.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ResumeTransformFeedback = FnPtr::new(metaloadfn(loadfn, "epoxy_glResumeTransformFeedback", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rotated {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rotated.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rotated = FnPtr::new(metaloadfn(loadfn, "epoxy_glRotated", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Rotatef {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Rotatef.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Rotatef = FnPtr::new(metaloadfn(loadfn, "epoxy_glRotatef", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SampleCoverage {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SampleCoverage.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SampleCoverage = FnPtr::new(metaloadfn(loadfn, "epoxy_glSampleCoverage", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SampleMaski {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SampleMaski.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SampleMaski = FnPtr::new(metaloadfn(loadfn, "epoxy_glSampleMaski", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameterf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameterf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameterf = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameterf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SamplerParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SamplerParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SamplerParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSamplerParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Scaled {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Scaled.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Scaled = FnPtr::new(metaloadfn(loadfn, "epoxy_glScaled", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Scalef {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Scalef.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Scalef = FnPtr::new(metaloadfn(loadfn, "epoxy_glScalef", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Scissor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Scissor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Scissor = FnPtr::new(metaloadfn(loadfn, "epoxy_glScissor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ScissorArrayv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ScissorArrayv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ScissorArrayv = FnPtr::new(metaloadfn(loadfn, "epoxy_glScissorArrayv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ScissorIndexed {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ScissorIndexed.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ScissorIndexed = FnPtr::new(metaloadfn(loadfn, "epoxy_glScissorIndexed", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ScissorIndexedv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ScissorIndexedv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ScissorIndexedv = FnPtr::new(metaloadfn(loadfn, "epoxy_glScissorIndexedv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3b {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3b.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3b = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3b", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3ub {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3ub.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3ub = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3ub", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3ubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3ubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3ubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3ubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3us {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3us.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3us = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3us", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColor3usv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColor3usv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColor3usv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColor3usv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColorP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColorP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColorP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColorP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColorP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColorP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColorP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColorP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SecondaryColorPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SecondaryColorPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SecondaryColorPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glSecondaryColorPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod SelectBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::SelectBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::SelectBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glSelectBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ShadeModel {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ShadeModel.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ShadeModel = FnPtr::new(metaloadfn(loadfn, "epoxy_glShadeModel", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ShaderBinary {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ShaderBinary.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ShaderBinary = FnPtr::new(metaloadfn(loadfn, "epoxy_glShaderBinary", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ShaderSource {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ShaderSource.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ShaderSource = FnPtr::new(metaloadfn(loadfn, "epoxy_glShaderSource", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ShaderSourceARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ShaderSourceARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ShaderSourceARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glShaderSourceARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ShaderStorageBlockBinding {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ShaderStorageBlockBinding.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ShaderStorageBlockBinding = FnPtr::new(metaloadfn(loadfn, "epoxy_glShaderStorageBlockBinding", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilFunc {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilFunc.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilFunc = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilFunc", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilFuncSeparate {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilFuncSeparate.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilFuncSeparate = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilFuncSeparate", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilMask {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilMask.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilMask = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilMask", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilMaskSeparate {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilMaskSeparate.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilMaskSeparate = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilMaskSeparate", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilOp {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilOp.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilOp = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilOp", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StencilOpSeparate {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StencilOpSeparate.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StencilOpSeparate = FnPtr::new(metaloadfn(loadfn, "epoxy_glStencilOpSeparate", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod StringMarkerGREMEDY {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::StringMarkerGREMEDY.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::StringMarkerGREMEDY = FnPtr::new(metaloadfn(loadfn, "epoxy_glStringMarkerGREMEDY", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBufferARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBufferARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBufferARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBufferARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBufferOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBufferOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBufferOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBufferOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexBufferRangeOES {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexBufferRangeOES.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexBufferRangeOES = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexBufferRangeOES", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1i = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1s = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord1sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord1sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord1sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord1sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoord4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoord4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoord4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoord4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordP4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordP4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordP4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordP4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexCoordPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexCoordPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexCoordPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexCoordPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexEnvf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexEnvf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexEnvf = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexEnvf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexEnvfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexEnvfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexEnvfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexEnvfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexEnvi {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexEnvi.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexEnvi = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexEnvi", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexEnviv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexEnviv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexEnviv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexEnviv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGend {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGend.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGend = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGend", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGendv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGendv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGendv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGendv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGenf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGenf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGenf = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGenf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGenfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGenfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGenfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGenfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGeni {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGeni.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGeni = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGeni", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexGeniv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexGeniv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexGeniv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexGeniv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexImage2DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexImage2DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexImage2DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexImage2DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexImage3DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexImage3DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexImage3DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexImage3DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterf = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexStorage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexStorage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexStorage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexStorage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexStorage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexStorage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexStorage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexStorage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexStorage2DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexStorage2DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexStorage2DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexStorage2DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexStorage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexStorage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexStorage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexStorage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexStorage3DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexStorage3DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexStorage3DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexStorage3DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureBarrier {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureBarrier.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureBarrier = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureBarrier", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureBufferRangeEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureBufferRangeEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureBufferRangeEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureBufferRangeEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TexturePageCommitmentEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TexturePageCommitmentEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TexturePageCommitmentEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTexturePageCommitmentEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterIiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterIiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterIiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterIiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterIivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterIivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterIivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterIivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterIuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterIuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterIuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterIuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterIuivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterIuivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterIuivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterIuivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterf = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterfEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterfEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterfEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterfEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterfvEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterfvEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterfvEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterfvEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameteri {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameteri.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameteri = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameteri", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameteriEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameteriEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameteriEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameteriEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameteriv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameteriv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameteriv = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameteriv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureParameterivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureParameterivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureParameterivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureParameterivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureRenderbufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureRenderbufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureRenderbufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureRenderbufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage2DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage2DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage2DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage2DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage2DMultisampleEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage2DMultisampleEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage2DMultisampleEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage2DMultisampleEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage3DMultisample {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage3DMultisample.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage3DMultisample = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage3DMultisample", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureStorage3DMultisampleEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureStorage3DMultisampleEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureStorage3DMultisampleEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureStorage3DMultisampleEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage1D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage1D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage1D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage1D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage1DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage1DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage1DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage1DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage2D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage2D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage2D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage2D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage2DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage2DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage2DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage2DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage3D {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage3D.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage3D = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage3D", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureSubImage3DEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureSubImage3DEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureSubImage3DEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureSubImage3DEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TextureView {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TextureView.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TextureView = FnPtr::new(metaloadfn(loadfn, "epoxy_glTextureView", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TransformFeedbackBufferBase {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TransformFeedbackBufferBase.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TransformFeedbackBufferBase = FnPtr::new(metaloadfn(loadfn, "epoxy_glTransformFeedbackBufferBase", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TransformFeedbackBufferRange {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TransformFeedbackBufferRange.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TransformFeedbackBufferRange = FnPtr::new(metaloadfn(loadfn, "epoxy_glTransformFeedbackBufferRange", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TransformFeedbackVaryings {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TransformFeedbackVaryings.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TransformFeedbackVaryings = FnPtr::new(metaloadfn(loadfn, "epoxy_glTransformFeedbackVaryings", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod TransformFeedbackVaryingsEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::TransformFeedbackVaryingsEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::TransformFeedbackVaryingsEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glTransformFeedbackVaryingsEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Translated {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Translated.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Translated = FnPtr::new(metaloadfn(loadfn, "epoxy_glTranslated", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Translatef {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Translatef.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Translatef = FnPtr::new(metaloadfn(loadfn, "epoxy_glTranslatef", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1i = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1iARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1iARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1iARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1iARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1ivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1ivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1ivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1ivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform1uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform1uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform1uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform1uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2iARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2iARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2iARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2iARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2ivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2ivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2ivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2ivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform2uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform2uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform2uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform2uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3iARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3iARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3iARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3iARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3ivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3ivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3ivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3ivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform3uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform3uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform3uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform3uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4i64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4i64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4i64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4i64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4i64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4i64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4i64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4i64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4iARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4iARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4iARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4iARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4ivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4ivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4ivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4ivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4uiEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4uiEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4uiEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4uiEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Uniform4uivEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Uniform4uivEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Uniform4uivEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniform4uivEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformBlockBinding {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformBlockBinding.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformBlockBinding = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformBlockBinding", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformHandleui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformHandleui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformHandleui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformHandleui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformHandleui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformHandleui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformHandleui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformHandleui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2x3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2x3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2x3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2x3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2x3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2x3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2x3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2x3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2x4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2x4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2x4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2x4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix2x4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix2x4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix2x4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix2x4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3x2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3x2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3x2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3x2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3x2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3x2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3x2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3x2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3x4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3x4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3x4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3x4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix3x4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix3x4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix3x4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix3x4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4x2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4x2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4x2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4x2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4x2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4x2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4x2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4x2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4x3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4x3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4x3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4x3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformMatrix4x3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformMatrix4x3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformMatrix4x3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformMatrix4x3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UniformSubroutinesuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UniformSubroutinesuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UniformSubroutinesuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glUniformSubroutinesuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UnmapBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UnmapBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UnmapBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glUnmapBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UnmapBufferARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UnmapBufferARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UnmapBufferARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUnmapBufferARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UnmapNamedBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UnmapNamedBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UnmapNamedBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glUnmapNamedBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UnmapNamedBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UnmapNamedBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UnmapNamedBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glUnmapNamedBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UseProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UseProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UseProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glUseProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UseProgramObjectARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UseProgramObjectARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UseProgramObjectARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glUseProgramObjectARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod UseProgramStages {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::UseProgramStages.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::UseProgramStages = FnPtr::new(metaloadfn(loadfn, "epoxy_glUseProgramStages", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ValidateProgram {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ValidateProgram.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ValidateProgram = FnPtr::new(metaloadfn(loadfn, "epoxy_glValidateProgram", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ValidateProgramARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ValidateProgramARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ValidateProgramARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glValidateProgramARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ValidateProgramPipeline {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ValidateProgramPipeline.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ValidateProgramPipeline = FnPtr::new(metaloadfn(loadfn, "epoxy_glValidateProgramPipeline", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Vertex4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Vertex4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Vertex4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertex4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayAttribBinding {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayAttribBinding.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayAttribBinding = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayAttribBinding", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayAttribFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayAttribFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayAttribFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayAttribFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayAttribIFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayAttribIFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayAttribIFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayAttribIFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayAttribLFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayAttribLFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayAttribLFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayAttribLFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayBindVertexBufferEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayBindVertexBufferEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayBindVertexBufferEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayBindVertexBufferEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayBindingDivisor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayBindingDivisor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayBindingDivisor = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayBindingDivisor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayColorOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayColorOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayColorOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayColorOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayEdgeFlagOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayEdgeFlagOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayEdgeFlagOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayEdgeFlagOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayElementBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayElementBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayElementBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayElementBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayFogCoordOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayFogCoordOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayFogCoordOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayFogCoordOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayIndexOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayIndexOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayIndexOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayIndexOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayMultiTexCoordOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayMultiTexCoordOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayMultiTexCoordOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayMultiTexCoordOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayNormalOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayNormalOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayNormalOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayNormalOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArraySecondaryColorOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArraySecondaryColorOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArraySecondaryColorOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArraySecondaryColorOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayTexCoordOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayTexCoordOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayTexCoordOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayTexCoordOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribBindingEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribBindingEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribBindingEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribBindingEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribDivisorEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribDivisorEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribDivisorEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribDivisorEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribFormatEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribFormatEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribFormatEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribFormatEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribIFormatEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribIFormatEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribIFormatEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribIFormatEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribIOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribIOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribIOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribIOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribLFormatEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribLFormatEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribLFormatEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribLFormatEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribLOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribLOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribLOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribLOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexAttribOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexAttribOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexAttribOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexAttribOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexBindingDivisorEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexBindingDivisorEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexBindingDivisorEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexBindingDivisorEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexBuffer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexBuffer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexBuffer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexBuffer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexBuffers {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexBuffers.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexBuffers = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexBuffers", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexArrayVertexOffsetEXT {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexArrayVertexOffsetEXT.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexArrayVertexOffsetEXT = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexArrayVertexOffsetEXT", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1dARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1dARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1dARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1dARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1dvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1dvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1dvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1dvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1sARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1sARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1sARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1sARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib1svARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib1svARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib1svARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib1svARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2dARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2dARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2dARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2dARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2dvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2dvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2dvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2dvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2sARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2sARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2sARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2sARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib2svARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib2svARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib2svARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib2svARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3dARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3dARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3dARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3dARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3dvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3dvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3dvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3dvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3sARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3sARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3sARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3sARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib3svARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib3svARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib3svARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib3svARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nbv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nbv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nbv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nbv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NbvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NbvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NbvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NbvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Niv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Niv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Niv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Niv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nsv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nsv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nsv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nsv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NsvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NsvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NsvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NsvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nub {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nub.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nub = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nub", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NubARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NubARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NubARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NubARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NubvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NubvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NubvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NubvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nuiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nuiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nuiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nuiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NuivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NuivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NuivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NuivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4Nusv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4Nusv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4Nusv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4Nusv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4NusvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4NusvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4NusvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4NusvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4bvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4bvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4bvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4bvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4dARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4dARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4dARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4dARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4dvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4dvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4dvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4dvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4f = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4fARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4fARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4fARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4fARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4fvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4fvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4fvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4fvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4ivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4ivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4ivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4ivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4s = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4sARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4sARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4sARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4sARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4svARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4svARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4svARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4svARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4ubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4ubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4ubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4ubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4ubvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4ubvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4ubvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4ubvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4uivARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4uivARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4uivARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4uivARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4usv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4usv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4usv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4usv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttrib4usvARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttrib4usvARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttrib4usvARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttrib4usvARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribBinding {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribBinding.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribBinding = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribBinding", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribDivisor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribDivisor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribDivisor = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribDivisor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI1i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI1i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI1i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI1i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI1iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI1iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI1iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI1iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4bv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4bv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4bv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4bv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4i = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4ubv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4ubv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4ubv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4ubv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribI4usv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribI4usv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribI4usv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribI4usv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribIFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribIFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribIFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribIFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribIPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribIPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribIPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribIPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1i64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1i64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1i64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1i64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1i64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1i64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1i64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1i64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1ui64ARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1ui64ARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1ui64ARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1ui64ARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1ui64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1ui64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1ui64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1ui64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1ui64vARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1ui64vARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1ui64vARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1ui64vARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL1ui64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL1ui64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL1ui64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL1ui64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2i64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2i64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2i64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2i64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2i64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2i64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2i64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2i64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2ui64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2ui64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2ui64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2ui64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL2ui64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL2ui64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL2ui64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL2ui64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3i64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3i64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3i64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3i64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3i64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3i64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3i64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3i64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3ui64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3ui64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3ui64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3ui64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL3ui64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL3ui64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL3ui64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL3ui64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4d = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4i64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4i64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4i64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4i64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4i64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4i64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4i64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4i64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4ui64NV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4ui64NV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4ui64NV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4ui64NV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribL4ui64vNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribL4ui64vNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribL4ui64vNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribL4ui64vNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribLFormat {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribLFormat.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribLFormat = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribLFormat", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribLFormatNV {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribLFormatNV.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribLFormatNV = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribLFormatNV", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribLPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribLPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribLPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribLPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP1ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP1ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP1ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP1ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP1uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP1uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP1uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP1uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribP4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribP4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribP4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribP4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexAttribPointerARB {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexAttribPointerARB.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexAttribPointerARB = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexAttribPointerARB", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexBindingDivisor {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexBindingDivisor.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexBindingDivisor = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexBindingDivisor", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP2ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP2ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP2ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP2ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP2uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP2uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP2uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP2uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP3ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP3ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP3ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP3ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP3uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP3uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP3uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP3uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP4ui {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP4ui.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP4ui = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP4ui", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexP4uiv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexP4uiv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexP4uiv = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexP4uiv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod VertexPointer {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::VertexPointer.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::VertexPointer = FnPtr::new(metaloadfn(loadfn, "epoxy_glVertexPointer", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod Viewport {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::Viewport.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::Viewport = FnPtr::new(metaloadfn(loadfn, "epoxy_glViewport", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ViewportArrayv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ViewportArrayv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ViewportArrayv = FnPtr::new(metaloadfn(loadfn, "epoxy_glViewportArrayv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ViewportIndexedf {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ViewportIndexedf.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ViewportIndexedf = FnPtr::new(metaloadfn(loadfn, "epoxy_glViewportIndexedf", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod ViewportIndexedfv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::ViewportIndexedfv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::ViewportIndexedfv = FnPtr::new(metaloadfn(loadfn, "epoxy_glViewportIndexedfv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WaitSync {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WaitSync.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WaitSync = FnPtr::new(metaloadfn(loadfn, "epoxy_glWaitSync", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WaitSyncAPPLE {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WaitSyncAPPLE.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WaitSyncAPPLE = FnPtr::new(metaloadfn(loadfn, "epoxy_glWaitSyncAPPLE", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2d = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2f = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2i = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2s = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos2sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos2sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos2sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos2sv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3d {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3d.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3d = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3d", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3dv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3dv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3dv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3dv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3f {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3f.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3f = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3f", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3fv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3fv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3fv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3fv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3i {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3i.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3i = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3i", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3iv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3iv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3iv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3iv", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3s {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3s.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3s = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3s", &[]))
                    }
                }
            }

            #[allow(non_snake_case)]
            pub mod WindowPos3sv {
                use super::{storage, metaloadfn};
                use super::FnPtr;
                #[inline]
                #[allow(dead_code)]
                pub fn is_loaded() -> bool {
                    unsafe { storage::WindowPos3sv.is_loaded }
                }
                #[allow(dead_code)]
                pub fn load_with<F>(loadfn: F) where F: FnMut(&str) -> *const super::__gl_imports::raw::c_void {
                    unsafe {
                        storage::WindowPos3sv = FnPtr::new(metaloadfn(loadfn, "epoxy_glWindowPos3sv", &[]))
                    }
                }
            }

        #[inline(never)]
        extern fn missing_fn_exit() {
            println!("function was not loaded");
            __gl_imports::exit(1);
        }
        const PMISSING_FN_EXIT: *const __gl_imports::raw::c_void = missing_fn_exit as *const __gl_imports::raw::c_void;

        #[allow(dead_code)]
        pub fn load_with<F>(mut loadfn: F) where F: FnMut(&str) -> *const __gl_imports::raw::c_void {
    
Accum::load_with(|s| loadfn(s));
ActiveShaderProgram::load_with(|s| loadfn(s));
ActiveTexture::load_with(|s| loadfn(s));
AlphaFunc::load_with(|s| loadfn(s));
AreTexturesResident::load_with(|s| loadfn(s));
ArrayElement::load_with(|s| loadfn(s));
AttachObjectARB::load_with(|s| loadfn(s));
AttachShader::load_with(|s| loadfn(s));
Begin::load_with(|s| loadfn(s));
BeginConditionalRender::load_with(|s| loadfn(s));
BeginConditionalRenderNV::load_with(|s| loadfn(s));
BeginQuery::load_with(|s| loadfn(s));
BeginQueryARB::load_with(|s| loadfn(s));
BeginQueryEXT::load_with(|s| loadfn(s));
BeginQueryIndexed::load_with(|s| loadfn(s));
BeginTransformFeedback::load_with(|s| loadfn(s));
BeginTransformFeedbackEXT::load_with(|s| loadfn(s));
BindAttribLocation::load_with(|s| loadfn(s));
BindAttribLocationARB::load_with(|s| loadfn(s));
BindBuffer::load_with(|s| loadfn(s));
BindBufferARB::load_with(|s| loadfn(s));
BindBufferBase::load_with(|s| loadfn(s));
BindBufferBaseEXT::load_with(|s| loadfn(s));
BindBufferOffsetEXT::load_with(|s| loadfn(s));
BindBufferRange::load_with(|s| loadfn(s));
BindBufferRangeEXT::load_with(|s| loadfn(s));
BindBuffersBase::load_with(|s| loadfn(s));
BindBuffersRange::load_with(|s| loadfn(s));
BindFragDataLocation::load_with(|s| loadfn(s));
BindFragDataLocationEXT::load_with(|s| loadfn(s));
BindFragDataLocationIndexed::load_with(|s| loadfn(s));
BindFramebuffer::load_with(|s| loadfn(s));
BindFramebufferEXT::load_with(|s| loadfn(s));
BindImageTexture::load_with(|s| loadfn(s));
BindImageTextures::load_with(|s| loadfn(s));
BindMultiTextureEXT::load_with(|s| loadfn(s));
BindProgramPipeline::load_with(|s| loadfn(s));
BindRenderbuffer::load_with(|s| loadfn(s));
BindRenderbufferEXT::load_with(|s| loadfn(s));
BindSampler::load_with(|s| loadfn(s));
BindSamplers::load_with(|s| loadfn(s));
BindTexture::load_with(|s| loadfn(s));
BindTextureUnit::load_with(|s| loadfn(s));
BindTextures::load_with(|s| loadfn(s));
BindTransformFeedback::load_with(|s| loadfn(s));
BindVertexArray::load_with(|s| loadfn(s));
BindVertexArrayAPPLE::load_with(|s| loadfn(s));
BindVertexArrayOES::load_with(|s| loadfn(s));
BindVertexBuffer::load_with(|s| loadfn(s));
BindVertexBuffers::load_with(|s| loadfn(s));
Bitmap::load_with(|s| loadfn(s));
BlendBarrier::load_with(|s| loadfn(s));
BlendColor::load_with(|s| loadfn(s));
BlendEquation::load_with(|s| loadfn(s));
BlendEquationSeparate::load_with(|s| loadfn(s));
BlendEquationSeparatei::load_with(|s| loadfn(s));
BlendEquationSeparateiARB::load_with(|s| loadfn(s));
BlendEquationi::load_with(|s| loadfn(s));
BlendEquationiARB::load_with(|s| loadfn(s));
BlendFunc::load_with(|s| loadfn(s));
BlendFuncSeparate::load_with(|s| loadfn(s));
BlendFuncSeparatei::load_with(|s| loadfn(s));
BlendFuncSeparateiARB::load_with(|s| loadfn(s));
BlendFunci::load_with(|s| loadfn(s));
BlendFunciARB::load_with(|s| loadfn(s));
BlitFramebuffer::load_with(|s| loadfn(s));
BlitFramebufferEXT::load_with(|s| loadfn(s));
BlitNamedFramebuffer::load_with(|s| loadfn(s));
BufferData::load_with(|s| loadfn(s));
BufferDataARB::load_with(|s| loadfn(s));
BufferStorage::load_with(|s| loadfn(s));
BufferStorageEXT::load_with(|s| loadfn(s));
BufferSubData::load_with(|s| loadfn(s));
BufferSubDataARB::load_with(|s| loadfn(s));
CallList::load_with(|s| loadfn(s));
CallLists::load_with(|s| loadfn(s));
CheckFramebufferStatus::load_with(|s| loadfn(s));
CheckFramebufferStatusEXT::load_with(|s| loadfn(s));
CheckNamedFramebufferStatus::load_with(|s| loadfn(s));
CheckNamedFramebufferStatusEXT::load_with(|s| loadfn(s));
ClampColor::load_with(|s| loadfn(s));
Clear::load_with(|s| loadfn(s));
ClearAccum::load_with(|s| loadfn(s));
ClearBufferData::load_with(|s| loadfn(s));
ClearBufferSubData::load_with(|s| loadfn(s));
ClearBufferfi::load_with(|s| loadfn(s));
ClearBufferfv::load_with(|s| loadfn(s));
ClearBufferiv::load_with(|s| loadfn(s));
ClearBufferuiv::load_with(|s| loadfn(s));
ClearColor::load_with(|s| loadfn(s));
ClearColorIiEXT::load_with(|s| loadfn(s));
ClearColorIuiEXT::load_with(|s| loadfn(s));
ClearDepth::load_with(|s| loadfn(s));
ClearDepthf::load_with(|s| loadfn(s));
ClearIndex::load_with(|s| loadfn(s));
ClearNamedBufferData::load_with(|s| loadfn(s));
ClearNamedBufferDataEXT::load_with(|s| loadfn(s));
ClearNamedBufferSubData::load_with(|s| loadfn(s));
ClearNamedBufferSubDataEXT::load_with(|s| loadfn(s));
ClearNamedFramebufferfi::load_with(|s| loadfn(s));
ClearNamedFramebufferfv::load_with(|s| loadfn(s));
ClearNamedFramebufferiv::load_with(|s| loadfn(s));
ClearNamedFramebufferuiv::load_with(|s| loadfn(s));
ClearStencil::load_with(|s| loadfn(s));
ClearTexImage::load_with(|s| loadfn(s));
ClearTexSubImage::load_with(|s| loadfn(s));
ClientActiveTexture::load_with(|s| loadfn(s));
ClientAttribDefaultEXT::load_with(|s| loadfn(s));
ClientWaitSync::load_with(|s| loadfn(s));
ClientWaitSyncAPPLE::load_with(|s| loadfn(s));
ClipControl::load_with(|s| loadfn(s));
ClipPlane::load_with(|s| loadfn(s));
Color3b::load_with(|s| loadfn(s));
Color3bv::load_with(|s| loadfn(s));
Color3d::load_with(|s| loadfn(s));
Color3dv::load_with(|s| loadfn(s));
Color3f::load_with(|s| loadfn(s));
Color3fv::load_with(|s| loadfn(s));
Color3i::load_with(|s| loadfn(s));
Color3iv::load_with(|s| loadfn(s));
Color3s::load_with(|s| loadfn(s));
Color3sv::load_with(|s| loadfn(s));
Color3ub::load_with(|s| loadfn(s));
Color3ubv::load_with(|s| loadfn(s));
Color3ui::load_with(|s| loadfn(s));
Color3uiv::load_with(|s| loadfn(s));
Color3us::load_with(|s| loadfn(s));
Color3usv::load_with(|s| loadfn(s));
Color4b::load_with(|s| loadfn(s));
Color4bv::load_with(|s| loadfn(s));
Color4d::load_with(|s| loadfn(s));
Color4dv::load_with(|s| loadfn(s));
Color4f::load_with(|s| loadfn(s));
Color4fv::load_with(|s| loadfn(s));
Color4i::load_with(|s| loadfn(s));
Color4iv::load_with(|s| loadfn(s));
Color4s::load_with(|s| loadfn(s));
Color4sv::load_with(|s| loadfn(s));
Color4ub::load_with(|s| loadfn(s));
Color4ubv::load_with(|s| loadfn(s));
Color4ui::load_with(|s| loadfn(s));
Color4uiv::load_with(|s| loadfn(s));
Color4us::load_with(|s| loadfn(s));
Color4usv::load_with(|s| loadfn(s));
ColorMask::load_with(|s| loadfn(s));
ColorMaski::load_with(|s| loadfn(s));
ColorMaterial::load_with(|s| loadfn(s));
ColorP3ui::load_with(|s| loadfn(s));
ColorP3uiv::load_with(|s| loadfn(s));
ColorP4ui::load_with(|s| loadfn(s));
ColorP4uiv::load_with(|s| loadfn(s));
ColorPointer::load_with(|s| loadfn(s));
CompileShader::load_with(|s| loadfn(s));
CompileShaderARB::load_with(|s| loadfn(s));
CompressedMultiTexImage1DEXT::load_with(|s| loadfn(s));
CompressedMultiTexImage2DEXT::load_with(|s| loadfn(s));
CompressedMultiTexImage3DEXT::load_with(|s| loadfn(s));
CompressedMultiTexSubImage1DEXT::load_with(|s| loadfn(s));
CompressedMultiTexSubImage2DEXT::load_with(|s| loadfn(s));
CompressedMultiTexSubImage3DEXT::load_with(|s| loadfn(s));
CompressedTexImage1D::load_with(|s| loadfn(s));
CompressedTexImage2D::load_with(|s| loadfn(s));
CompressedTexImage3D::load_with(|s| loadfn(s));
CompressedTexSubImage1D::load_with(|s| loadfn(s));
CompressedTexSubImage2D::load_with(|s| loadfn(s));
CompressedTexSubImage3D::load_with(|s| loadfn(s));
CompressedTextureImage1DEXT::load_with(|s| loadfn(s));
CompressedTextureImage2DEXT::load_with(|s| loadfn(s));
CompressedTextureImage3DEXT::load_with(|s| loadfn(s));
CompressedTextureSubImage1D::load_with(|s| loadfn(s));
CompressedTextureSubImage1DEXT::load_with(|s| loadfn(s));
CompressedTextureSubImage2D::load_with(|s| loadfn(s));
CompressedTextureSubImage2DEXT::load_with(|s| loadfn(s));
CompressedTextureSubImage3D::load_with(|s| loadfn(s));
CompressedTextureSubImage3DEXT::load_with(|s| loadfn(s));
CopyBufferSubData::load_with(|s| loadfn(s));
CopyBufferSubDataNV::load_with(|s| loadfn(s));
CopyImageSubData::load_with(|s| loadfn(s));
CopyMultiTexImage1DEXT::load_with(|s| loadfn(s));
CopyMultiTexImage2DEXT::load_with(|s| loadfn(s));
CopyMultiTexSubImage1DEXT::load_with(|s| loadfn(s));
CopyMultiTexSubImage2DEXT::load_with(|s| loadfn(s));
CopyMultiTexSubImage3DEXT::load_with(|s| loadfn(s));
CopyNamedBufferSubData::load_with(|s| loadfn(s));
CopyPixels::load_with(|s| loadfn(s));
CopyTexImage1D::load_with(|s| loadfn(s));
CopyTexImage2D::load_with(|s| loadfn(s));
CopyTexSubImage1D::load_with(|s| loadfn(s));
CopyTexSubImage2D::load_with(|s| loadfn(s));
CopyTexSubImage3D::load_with(|s| loadfn(s));
CopyTextureImage1DEXT::load_with(|s| loadfn(s));
CopyTextureImage2DEXT::load_with(|s| loadfn(s));
CopyTextureSubImage1D::load_with(|s| loadfn(s));
CopyTextureSubImage1DEXT::load_with(|s| loadfn(s));
CopyTextureSubImage2D::load_with(|s| loadfn(s));
CopyTextureSubImage2DEXT::load_with(|s| loadfn(s));
CopyTextureSubImage3D::load_with(|s| loadfn(s));
CopyTextureSubImage3DEXT::load_with(|s| loadfn(s));
CreateBuffers::load_with(|s| loadfn(s));
CreateFramebuffers::load_with(|s| loadfn(s));
CreateProgram::load_with(|s| loadfn(s));
CreateProgramObjectARB::load_with(|s| loadfn(s));
CreateProgramPipelines::load_with(|s| loadfn(s));
CreateQueries::load_with(|s| loadfn(s));
CreateRenderbuffers::load_with(|s| loadfn(s));
CreateSamplers::load_with(|s| loadfn(s));
CreateShader::load_with(|s| loadfn(s));
CreateShaderObjectARB::load_with(|s| loadfn(s));
CreateShaderProgramv::load_with(|s| loadfn(s));
CreateTextures::load_with(|s| loadfn(s));
CreateTransformFeedbacks::load_with(|s| loadfn(s));
CreateVertexArrays::load_with(|s| loadfn(s));
CullFace::load_with(|s| loadfn(s));
DebugMessageCallback::load_with(|s| loadfn(s));
DebugMessageCallbackARB::load_with(|s| loadfn(s));
DebugMessageCallbackKHR::load_with(|s| loadfn(s));
DebugMessageControl::load_with(|s| loadfn(s));
DebugMessageControlARB::load_with(|s| loadfn(s));
DebugMessageControlKHR::load_with(|s| loadfn(s));
DebugMessageInsert::load_with(|s| loadfn(s));
DebugMessageInsertARB::load_with(|s| loadfn(s));
DebugMessageInsertKHR::load_with(|s| loadfn(s));
DeleteBuffers::load_with(|s| loadfn(s));
DeleteBuffersARB::load_with(|s| loadfn(s));
DeleteFramebuffers::load_with(|s| loadfn(s));
DeleteFramebuffersEXT::load_with(|s| loadfn(s));
DeleteLists::load_with(|s| loadfn(s));
DeleteObjectARB::load_with(|s| loadfn(s));
DeleteProgram::load_with(|s| loadfn(s));
DeleteProgramPipelines::load_with(|s| loadfn(s));
DeleteQueries::load_with(|s| loadfn(s));
DeleteQueriesARB::load_with(|s| loadfn(s));
DeleteQueriesEXT::load_with(|s| loadfn(s));
DeleteRenderbuffers::load_with(|s| loadfn(s));
DeleteRenderbuffersEXT::load_with(|s| loadfn(s));
DeleteSamplers::load_with(|s| loadfn(s));
DeleteShader::load_with(|s| loadfn(s));
DeleteSync::load_with(|s| loadfn(s));
DeleteSyncAPPLE::load_with(|s| loadfn(s));
DeleteTextures::load_with(|s| loadfn(s));
DeleteTransformFeedbacks::load_with(|s| loadfn(s));
DeleteVertexArrays::load_with(|s| loadfn(s));
DeleteVertexArraysAPPLE::load_with(|s| loadfn(s));
DeleteVertexArraysOES::load_with(|s| loadfn(s));
DepthFunc::load_with(|s| loadfn(s));
DepthMask::load_with(|s| loadfn(s));
DepthRange::load_with(|s| loadfn(s));
DepthRangeArrayv::load_with(|s| loadfn(s));
DepthRangeIndexed::load_with(|s| loadfn(s));
DepthRangef::load_with(|s| loadfn(s));
DetachObjectARB::load_with(|s| loadfn(s));
DetachShader::load_with(|s| loadfn(s));
Disable::load_with(|s| loadfn(s));
DisableClientState::load_with(|s| loadfn(s));
DisableClientStateIndexedEXT::load_with(|s| loadfn(s));
DisableClientStateiEXT::load_with(|s| loadfn(s));
DisableIndexedEXT::load_with(|s| loadfn(s));
DisableVertexArrayAttrib::load_with(|s| loadfn(s));
DisableVertexArrayAttribEXT::load_with(|s| loadfn(s));
DisableVertexArrayEXT::load_with(|s| loadfn(s));
DisableVertexAttribArray::load_with(|s| loadfn(s));
DisableVertexAttribArrayARB::load_with(|s| loadfn(s));
Disablei::load_with(|s| loadfn(s));
DispatchCompute::load_with(|s| loadfn(s));
DispatchComputeIndirect::load_with(|s| loadfn(s));
DrawArrays::load_with(|s| loadfn(s));
DrawArraysIndirect::load_with(|s| loadfn(s));
DrawArraysInstanced::load_with(|s| loadfn(s));
DrawArraysInstancedBaseInstance::load_with(|s| loadfn(s));
DrawBuffer::load_with(|s| loadfn(s));
DrawBuffers::load_with(|s| loadfn(s));
DrawBuffersARB::load_with(|s| loadfn(s));
DrawBuffersATI::load_with(|s| loadfn(s));
DrawElements::load_with(|s| loadfn(s));
DrawElementsBaseVertex::load_with(|s| loadfn(s));
DrawElementsBaseVertexOES::load_with(|s| loadfn(s));
DrawElementsIndirect::load_with(|s| loadfn(s));
DrawElementsInstanced::load_with(|s| loadfn(s));
DrawElementsInstancedBaseInstance::load_with(|s| loadfn(s));
DrawElementsInstancedBaseVertex::load_with(|s| loadfn(s));
DrawElementsInstancedBaseVertexBaseInstance::load_with(|s| loadfn(s));
DrawElementsInstancedBaseVertexOES::load_with(|s| loadfn(s));
DrawPixels::load_with(|s| loadfn(s));
DrawRangeElements::load_with(|s| loadfn(s));
DrawRangeElementsBaseVertex::load_with(|s| loadfn(s));
DrawRangeElementsBaseVertexOES::load_with(|s| loadfn(s));
DrawTransformFeedback::load_with(|s| loadfn(s));
DrawTransformFeedbackInstanced::load_with(|s| loadfn(s));
DrawTransformFeedbackStream::load_with(|s| loadfn(s));
DrawTransformFeedbackStreamInstanced::load_with(|s| loadfn(s));
EdgeFlag::load_with(|s| loadfn(s));
EdgeFlagPointer::load_with(|s| loadfn(s));
EdgeFlagv::load_with(|s| loadfn(s));
Enable::load_with(|s| loadfn(s));
EnableClientState::load_with(|s| loadfn(s));
EnableClientStateIndexedEXT::load_with(|s| loadfn(s));
EnableClientStateiEXT::load_with(|s| loadfn(s));
EnableIndexedEXT::load_with(|s| loadfn(s));
EnableVertexArrayAttrib::load_with(|s| loadfn(s));
EnableVertexArrayAttribEXT::load_with(|s| loadfn(s));
EnableVertexArrayEXT::load_with(|s| loadfn(s));
EnableVertexAttribArray::load_with(|s| loadfn(s));
EnableVertexAttribArrayARB::load_with(|s| loadfn(s));
Enablei::load_with(|s| loadfn(s));
End::load_with(|s| loadfn(s));
EndConditionalRender::load_with(|s| loadfn(s));
EndConditionalRenderNV::load_with(|s| loadfn(s));
EndList::load_with(|s| loadfn(s));
EndQuery::load_with(|s| loadfn(s));
EndQueryARB::load_with(|s| loadfn(s));
EndQueryEXT::load_with(|s| loadfn(s));
EndQueryIndexed::load_with(|s| loadfn(s));
EndTransformFeedback::load_with(|s| loadfn(s));
EndTransformFeedbackEXT::load_with(|s| loadfn(s));
EvalCoord1d::load_with(|s| loadfn(s));
EvalCoord1dv::load_with(|s| loadfn(s));
EvalCoord1f::load_with(|s| loadfn(s));
EvalCoord1fv::load_with(|s| loadfn(s));
EvalCoord2d::load_with(|s| loadfn(s));
EvalCoord2dv::load_with(|s| loadfn(s));
EvalCoord2f::load_with(|s| loadfn(s));
EvalCoord2fv::load_with(|s| loadfn(s));
EvalMesh1::load_with(|s| loadfn(s));
EvalMesh2::load_with(|s| loadfn(s));
EvalPoint1::load_with(|s| loadfn(s));
EvalPoint2::load_with(|s| loadfn(s));
FeedbackBuffer::load_with(|s| loadfn(s));
FenceSync::load_with(|s| loadfn(s));
FenceSyncAPPLE::load_with(|s| loadfn(s));
Finish::load_with(|s| loadfn(s));
Flush::load_with(|s| loadfn(s));
FlushMappedBufferRange::load_with(|s| loadfn(s));
FlushMappedNamedBufferRange::load_with(|s| loadfn(s));
FlushMappedNamedBufferRangeEXT::load_with(|s| loadfn(s));
FogCoordPointer::load_with(|s| loadfn(s));
FogCoordd::load_with(|s| loadfn(s));
FogCoorddv::load_with(|s| loadfn(s));
FogCoordf::load_with(|s| loadfn(s));
FogCoordfv::load_with(|s| loadfn(s));
Fogf::load_with(|s| loadfn(s));
Fogfv::load_with(|s| loadfn(s));
Fogi::load_with(|s| loadfn(s));
Fogiv::load_with(|s| loadfn(s));
FramebufferDrawBufferEXT::load_with(|s| loadfn(s));
FramebufferDrawBuffersEXT::load_with(|s| loadfn(s));
FramebufferParameteri::load_with(|s| loadfn(s));
FramebufferReadBufferEXT::load_with(|s| loadfn(s));
FramebufferRenderbuffer::load_with(|s| loadfn(s));
FramebufferRenderbufferEXT::load_with(|s| loadfn(s));
FramebufferTexture::load_with(|s| loadfn(s));
FramebufferTexture1D::load_with(|s| loadfn(s));
FramebufferTexture1DEXT::load_with(|s| loadfn(s));
FramebufferTexture2D::load_with(|s| loadfn(s));
FramebufferTexture2DEXT::load_with(|s| loadfn(s));
FramebufferTexture2DMultisampleEXT::load_with(|s| loadfn(s));
FramebufferTexture3D::load_with(|s| loadfn(s));
FramebufferTexture3DEXT::load_with(|s| loadfn(s));
FramebufferTextureARB::load_with(|s| loadfn(s));
FramebufferTextureFaceARB::load_with(|s| loadfn(s));
FramebufferTextureLayer::load_with(|s| loadfn(s));
FramebufferTextureLayerARB::load_with(|s| loadfn(s));
FramebufferTextureLayerEXT::load_with(|s| loadfn(s));
FrontFace::load_with(|s| loadfn(s));
Frustum::load_with(|s| loadfn(s));
GenBuffers::load_with(|s| loadfn(s));
GenBuffersARB::load_with(|s| loadfn(s));
GenFramebuffers::load_with(|s| loadfn(s));
GenFramebuffersEXT::load_with(|s| loadfn(s));
GenLists::load_with(|s| loadfn(s));
GenProgramPipelines::load_with(|s| loadfn(s));
GenQueries::load_with(|s| loadfn(s));
GenQueriesARB::load_with(|s| loadfn(s));
GenQueriesEXT::load_with(|s| loadfn(s));
GenRenderbuffers::load_with(|s| loadfn(s));
GenRenderbuffersEXT::load_with(|s| loadfn(s));
GenSamplers::load_with(|s| loadfn(s));
GenTextures::load_with(|s| loadfn(s));
GenTransformFeedbacks::load_with(|s| loadfn(s));
GenVertexArrays::load_with(|s| loadfn(s));
GenVertexArraysAPPLE::load_with(|s| loadfn(s));
GenVertexArraysOES::load_with(|s| loadfn(s));
GenerateMipmap::load_with(|s| loadfn(s));
GenerateMipmapEXT::load_with(|s| loadfn(s));
GenerateMultiTexMipmapEXT::load_with(|s| loadfn(s));
GenerateTextureMipmap::load_with(|s| loadfn(s));
GenerateTextureMipmapEXT::load_with(|s| loadfn(s));
GetActiveAtomicCounterBufferiv::load_with(|s| loadfn(s));
GetActiveAttrib::load_with(|s| loadfn(s));
GetActiveAttribARB::load_with(|s| loadfn(s));
GetActiveSubroutineName::load_with(|s| loadfn(s));
GetActiveSubroutineUniformName::load_with(|s| loadfn(s));
GetActiveSubroutineUniformiv::load_with(|s| loadfn(s));
GetActiveUniform::load_with(|s| loadfn(s));
GetActiveUniformARB::load_with(|s| loadfn(s));
GetActiveUniformBlockName::load_with(|s| loadfn(s));
GetActiveUniformBlockiv::load_with(|s| loadfn(s));
GetActiveUniformName::load_with(|s| loadfn(s));
GetActiveUniformsiv::load_with(|s| loadfn(s));
GetAttachedObjectsARB::load_with(|s| loadfn(s));
GetAttachedShaders::load_with(|s| loadfn(s));
GetAttribLocation::load_with(|s| loadfn(s));
GetAttribLocationARB::load_with(|s| loadfn(s));
GetBooleanIndexedvEXT::load_with(|s| loadfn(s));
GetBooleani_v::load_with(|s| loadfn(s));
GetBooleanv::load_with(|s| loadfn(s));
GetBufferParameteri64v::load_with(|s| loadfn(s));
GetBufferParameteriv::load_with(|s| loadfn(s));
GetBufferParameterivARB::load_with(|s| loadfn(s));
GetBufferPointerv::load_with(|s| loadfn(s));
GetBufferPointervARB::load_with(|s| loadfn(s));
GetBufferSubData::load_with(|s| loadfn(s));
GetBufferSubDataARB::load_with(|s| loadfn(s));
GetClipPlane::load_with(|s| loadfn(s));
GetCompressedMultiTexImageEXT::load_with(|s| loadfn(s));
GetCompressedTexImage::load_with(|s| loadfn(s));
GetCompressedTextureImage::load_with(|s| loadfn(s));
GetCompressedTextureImageEXT::load_with(|s| loadfn(s));
GetCompressedTextureSubImage::load_with(|s| loadfn(s));
GetDebugMessageLog::load_with(|s| loadfn(s));
GetDebugMessageLogARB::load_with(|s| loadfn(s));
GetDebugMessageLogKHR::load_with(|s| loadfn(s));
GetDoubleIndexedvEXT::load_with(|s| loadfn(s));
GetDoublei_v::load_with(|s| loadfn(s));
GetDoublei_vEXT::load_with(|s| loadfn(s));
GetDoublev::load_with(|s| loadfn(s));
GetError::load_with(|s| loadfn(s));
GetFloatIndexedvEXT::load_with(|s| loadfn(s));
GetFloati_v::load_with(|s| loadfn(s));
GetFloati_vEXT::load_with(|s| loadfn(s));
GetFloatv::load_with(|s| loadfn(s));
GetFragDataIndex::load_with(|s| loadfn(s));
GetFragDataLocation::load_with(|s| loadfn(s));
GetFragDataLocationEXT::load_with(|s| loadfn(s));
GetFramebufferAttachmentParameteriv::load_with(|s| loadfn(s));
GetFramebufferAttachmentParameterivEXT::load_with(|s| loadfn(s));
GetFramebufferParameteriv::load_with(|s| loadfn(s));
GetFramebufferParameterivEXT::load_with(|s| loadfn(s));
GetGraphicsResetStatus::load_with(|s| loadfn(s));
GetGraphicsResetStatusARB::load_with(|s| loadfn(s));
GetGraphicsResetStatusEXT::load_with(|s| loadfn(s));
GetGraphicsResetStatusKHR::load_with(|s| loadfn(s));
GetHandleARB::load_with(|s| loadfn(s));
GetImageHandleARB::load_with(|s| loadfn(s));
GetInfoLogARB::load_with(|s| loadfn(s));
GetInteger64i_v::load_with(|s| loadfn(s));
GetInteger64v::load_with(|s| loadfn(s));
GetInteger64vAPPLE::load_with(|s| loadfn(s));
GetIntegerIndexedvEXT::load_with(|s| loadfn(s));
GetIntegeri_v::load_with(|s| loadfn(s));
GetIntegerv::load_with(|s| loadfn(s));
GetInternalformatSampleivNV::load_with(|s| loadfn(s));
GetInternalformati64v::load_with(|s| loadfn(s));
GetInternalformativ::load_with(|s| loadfn(s));
GetLightfv::load_with(|s| loadfn(s));
GetLightiv::load_with(|s| loadfn(s));
GetMapdv::load_with(|s| loadfn(s));
GetMapfv::load_with(|s| loadfn(s));
GetMapiv::load_with(|s| loadfn(s));
GetMaterialfv::load_with(|s| loadfn(s));
GetMaterialiv::load_with(|s| loadfn(s));
GetMultiTexEnvfvEXT::load_with(|s| loadfn(s));
GetMultiTexEnvivEXT::load_with(|s| loadfn(s));
GetMultiTexGendvEXT::load_with(|s| loadfn(s));
GetMultiTexGenfvEXT::load_with(|s| loadfn(s));
GetMultiTexGenivEXT::load_with(|s| loadfn(s));
GetMultiTexImageEXT::load_with(|s| loadfn(s));
GetMultiTexLevelParameterfvEXT::load_with(|s| loadfn(s));
GetMultiTexLevelParameterivEXT::load_with(|s| loadfn(s));
GetMultiTexParameterIivEXT::load_with(|s| loadfn(s));
GetMultiTexParameterIuivEXT::load_with(|s| loadfn(s));
GetMultiTexParameterfvEXT::load_with(|s| loadfn(s));
GetMultiTexParameterivEXT::load_with(|s| loadfn(s));
GetMultisamplefv::load_with(|s| loadfn(s));
GetNamedBufferParameteri64v::load_with(|s| loadfn(s));
GetNamedBufferParameteriv::load_with(|s| loadfn(s));
GetNamedBufferParameterivEXT::load_with(|s| loadfn(s));
GetNamedBufferPointerv::load_with(|s| loadfn(s));
GetNamedBufferPointervEXT::load_with(|s| loadfn(s));
GetNamedBufferSubData::load_with(|s| loadfn(s));
GetNamedBufferSubDataEXT::load_with(|s| loadfn(s));
GetNamedFramebufferAttachmentParameteriv::load_with(|s| loadfn(s));
GetNamedFramebufferAttachmentParameterivEXT::load_with(|s| loadfn(s));
GetNamedFramebufferParameteriv::load_with(|s| loadfn(s));
GetNamedFramebufferParameterivEXT::load_with(|s| loadfn(s));
GetNamedProgramLocalParameterIivEXT::load_with(|s| loadfn(s));
GetNamedProgramLocalParameterIuivEXT::load_with(|s| loadfn(s));
GetNamedProgramLocalParameterdvEXT::load_with(|s| loadfn(s));
GetNamedProgramLocalParameterfvEXT::load_with(|s| loadfn(s));
GetNamedProgramStringEXT::load_with(|s| loadfn(s));
GetNamedProgramivEXT::load_with(|s| loadfn(s));
GetNamedRenderbufferParameteriv::load_with(|s| loadfn(s));
GetNamedRenderbufferParameterivEXT::load_with(|s| loadfn(s));
GetObjectLabel::load_with(|s| loadfn(s));
GetObjectLabelKHR::load_with(|s| loadfn(s));
GetObjectParameterfvARB::load_with(|s| loadfn(s));
GetObjectParameterivARB::load_with(|s| loadfn(s));
GetObjectPtrLabel::load_with(|s| loadfn(s));
GetObjectPtrLabelKHR::load_with(|s| loadfn(s));
GetPixelMapfv::load_with(|s| loadfn(s));
GetPixelMapuiv::load_with(|s| loadfn(s));
GetPixelMapusv::load_with(|s| loadfn(s));
GetPointerIndexedvEXT::load_with(|s| loadfn(s));
GetPointeri_vEXT::load_with(|s| loadfn(s));
GetPointerv::load_with(|s| loadfn(s));
GetPointervKHR::load_with(|s| loadfn(s));
GetPolygonStipple::load_with(|s| loadfn(s));
GetProgramBinary::load_with(|s| loadfn(s));
GetProgramInfoLog::load_with(|s| loadfn(s));
GetProgramInterfaceiv::load_with(|s| loadfn(s));
GetProgramPipelineInfoLog::load_with(|s| loadfn(s));
GetProgramPipelineiv::load_with(|s| loadfn(s));
GetProgramResourceIndex::load_with(|s| loadfn(s));
GetProgramResourceLocation::load_with(|s| loadfn(s));
GetProgramResourceLocationIndex::load_with(|s| loadfn(s));
GetProgramResourceName::load_with(|s| loadfn(s));
GetProgramResourceiv::load_with(|s| loadfn(s));
GetProgramStageiv::load_with(|s| loadfn(s));
GetProgramiv::load_with(|s| loadfn(s));
GetQueryBufferObjecti64v::load_with(|s| loadfn(s));
GetQueryBufferObjectiv::load_with(|s| loadfn(s));
GetQueryBufferObjectui64v::load_with(|s| loadfn(s));
GetQueryBufferObjectuiv::load_with(|s| loadfn(s));
GetQueryIndexediv::load_with(|s| loadfn(s));
GetQueryObjecti64v::load_with(|s| loadfn(s));
GetQueryObjecti64vEXT::load_with(|s| loadfn(s));
GetQueryObjectiv::load_with(|s| loadfn(s));
GetQueryObjectivARB::load_with(|s| loadfn(s));
GetQueryObjectivEXT::load_with(|s| loadfn(s));
GetQueryObjectui64v::load_with(|s| loadfn(s));
GetQueryObjectui64vEXT::load_with(|s| loadfn(s));
GetQueryObjectuiv::load_with(|s| loadfn(s));
GetQueryObjectuivARB::load_with(|s| loadfn(s));
GetQueryObjectuivEXT::load_with(|s| loadfn(s));
GetQueryiv::load_with(|s| loadfn(s));
GetQueryivARB::load_with(|s| loadfn(s));
GetQueryivEXT::load_with(|s| loadfn(s));
GetRenderbufferParameteriv::load_with(|s| loadfn(s));
GetRenderbufferParameterivEXT::load_with(|s| loadfn(s));
GetSamplerParameterIiv::load_with(|s| loadfn(s));
GetSamplerParameterIuiv::load_with(|s| loadfn(s));
GetSamplerParameterfv::load_with(|s| loadfn(s));
GetSamplerParameteriv::load_with(|s| loadfn(s));
GetShaderInfoLog::load_with(|s| loadfn(s));
GetShaderPrecisionFormat::load_with(|s| loadfn(s));
GetShaderSource::load_with(|s| loadfn(s));
GetShaderSourceARB::load_with(|s| loadfn(s));
GetShaderiv::load_with(|s| loadfn(s));
GetString::load_with(|s| loadfn(s));
GetStringi::load_with(|s| loadfn(s));
GetSubroutineIndex::load_with(|s| loadfn(s));
GetSubroutineUniformLocation::load_with(|s| loadfn(s));
GetSynciv::load_with(|s| loadfn(s));
GetSyncivAPPLE::load_with(|s| loadfn(s));
GetTexEnvfv::load_with(|s| loadfn(s));
GetTexEnviv::load_with(|s| loadfn(s));
GetTexGendv::load_with(|s| loadfn(s));
GetTexGenfv::load_with(|s| loadfn(s));
GetTexGeniv::load_with(|s| loadfn(s));
GetTexImage::load_with(|s| loadfn(s));
GetTexLevelParameterfv::load_with(|s| loadfn(s));
GetTexLevelParameteriv::load_with(|s| loadfn(s));
GetTexParameterIiv::load_with(|s| loadfn(s));
GetTexParameterIivEXT::load_with(|s| loadfn(s));
GetTexParameterIuiv::load_with(|s| loadfn(s));
GetTexParameterIuivEXT::load_with(|s| loadfn(s));
GetTexParameterfv::load_with(|s| loadfn(s));
GetTexParameteriv::load_with(|s| loadfn(s));
GetTextureHandleARB::load_with(|s| loadfn(s));
GetTextureImage::load_with(|s| loadfn(s));
GetTextureImageEXT::load_with(|s| loadfn(s));
GetTextureLevelParameterfv::load_with(|s| loadfn(s));
GetTextureLevelParameterfvEXT::load_with(|s| loadfn(s));
GetTextureLevelParameteriv::load_with(|s| loadfn(s));
GetTextureLevelParameterivEXT::load_with(|s| loadfn(s));
GetTextureParameterIiv::load_with(|s| loadfn(s));
GetTextureParameterIivEXT::load_with(|s| loadfn(s));
GetTextureParameterIuiv::load_with(|s| loadfn(s));
GetTextureParameterIuivEXT::load_with(|s| loadfn(s));
GetTextureParameterfv::load_with(|s| loadfn(s));
GetTextureParameterfvEXT::load_with(|s| loadfn(s));
GetTextureParameteriv::load_with(|s| loadfn(s));
GetTextureParameterivEXT::load_with(|s| loadfn(s));
GetTextureSamplerHandleARB::load_with(|s| loadfn(s));
GetTextureSubImage::load_with(|s| loadfn(s));
GetTransformFeedbackVarying::load_with(|s| loadfn(s));
GetTransformFeedbackVaryingEXT::load_with(|s| loadfn(s));
GetTransformFeedbacki64_v::load_with(|s| loadfn(s));
GetTransformFeedbacki_v::load_with(|s| loadfn(s));
GetTransformFeedbackiv::load_with(|s| loadfn(s));
GetUniformBlockIndex::load_with(|s| loadfn(s));
GetUniformIndices::load_with(|s| loadfn(s));
GetUniformLocation::load_with(|s| loadfn(s));
GetUniformLocationARB::load_with(|s| loadfn(s));
GetUniformSubroutineuiv::load_with(|s| loadfn(s));
GetUniformdv::load_with(|s| loadfn(s));
GetUniformfv::load_with(|s| loadfn(s));
GetUniformfvARB::load_with(|s| loadfn(s));
GetUniformi64vARB::load_with(|s| loadfn(s));
GetUniformiv::load_with(|s| loadfn(s));
GetUniformivARB::load_with(|s| loadfn(s));
GetUniformui64vARB::load_with(|s| loadfn(s));
GetUniformuiv::load_with(|s| loadfn(s));
GetUniformuivEXT::load_with(|s| loadfn(s));
GetVertexArrayIndexed64iv::load_with(|s| loadfn(s));
GetVertexArrayIndexediv::load_with(|s| loadfn(s));
GetVertexArrayIntegeri_vEXT::load_with(|s| loadfn(s));
GetVertexArrayIntegervEXT::load_with(|s| loadfn(s));
GetVertexArrayPointeri_vEXT::load_with(|s| loadfn(s));
GetVertexArrayPointervEXT::load_with(|s| loadfn(s));
GetVertexArrayiv::load_with(|s| loadfn(s));
GetVertexAttribIiv::load_with(|s| loadfn(s));
GetVertexAttribIuiv::load_with(|s| loadfn(s));
GetVertexAttribLdv::load_with(|s| loadfn(s));
GetVertexAttribLi64vNV::load_with(|s| loadfn(s));
GetVertexAttribLui64vARB::load_with(|s| loadfn(s));
GetVertexAttribLui64vNV::load_with(|s| loadfn(s));
GetVertexAttribPointerv::load_with(|s| loadfn(s));
GetVertexAttribPointervARB::load_with(|s| loadfn(s));
GetVertexAttribdv::load_with(|s| loadfn(s));
GetVertexAttribdvARB::load_with(|s| loadfn(s));
GetVertexAttribfv::load_with(|s| loadfn(s));
GetVertexAttribfvARB::load_with(|s| loadfn(s));
GetVertexAttribiv::load_with(|s| loadfn(s));
GetVertexAttribivARB::load_with(|s| loadfn(s));
GetnColorTable::load_with(|s| loadfn(s));
GetnColorTableARB::load_with(|s| loadfn(s));
GetnCompressedTexImage::load_with(|s| loadfn(s));
GetnCompressedTexImageARB::load_with(|s| loadfn(s));
GetnConvolutionFilter::load_with(|s| loadfn(s));
GetnConvolutionFilterARB::load_with(|s| loadfn(s));
GetnHistogram::load_with(|s| loadfn(s));
GetnHistogramARB::load_with(|s| loadfn(s));
GetnMapdv::load_with(|s| loadfn(s));
GetnMapdvARB::load_with(|s| loadfn(s));
GetnMapfv::load_with(|s| loadfn(s));
GetnMapfvARB::load_with(|s| loadfn(s));
GetnMapiv::load_with(|s| loadfn(s));
GetnMapivARB::load_with(|s| loadfn(s));
GetnMinmax::load_with(|s| loadfn(s));
GetnMinmaxARB::load_with(|s| loadfn(s));
GetnPixelMapfv::load_with(|s| loadfn(s));
GetnPixelMapfvARB::load_with(|s| loadfn(s));
GetnPixelMapuiv::load_with(|s| loadfn(s));
GetnPixelMapuivARB::load_with(|s| loadfn(s));
GetnPixelMapusv::load_with(|s| loadfn(s));
GetnPixelMapusvARB::load_with(|s| loadfn(s));
GetnPolygonStipple::load_with(|s| loadfn(s));
GetnPolygonStippleARB::load_with(|s| loadfn(s));
GetnSeparableFilter::load_with(|s| loadfn(s));
GetnSeparableFilterARB::load_with(|s| loadfn(s));
GetnTexImage::load_with(|s| loadfn(s));
GetnTexImageARB::load_with(|s| loadfn(s));
GetnUniformdv::load_with(|s| loadfn(s));
GetnUniformdvARB::load_with(|s| loadfn(s));
GetnUniformfv::load_with(|s| loadfn(s));
GetnUniformfvARB::load_with(|s| loadfn(s));
GetnUniformfvEXT::load_with(|s| loadfn(s));
GetnUniformfvKHR::load_with(|s| loadfn(s));
GetnUniformi64vARB::load_with(|s| loadfn(s));
GetnUniformiv::load_with(|s| loadfn(s));
GetnUniformivARB::load_with(|s| loadfn(s));
GetnUniformivEXT::load_with(|s| loadfn(s));
GetnUniformivKHR::load_with(|s| loadfn(s));
GetnUniformui64vARB::load_with(|s| loadfn(s));
GetnUniformuiv::load_with(|s| loadfn(s));
GetnUniformuivARB::load_with(|s| loadfn(s));
GetnUniformuivKHR::load_with(|s| loadfn(s));
Hint::load_with(|s| loadfn(s));
IndexMask::load_with(|s| loadfn(s));
IndexPointer::load_with(|s| loadfn(s));
Indexd::load_with(|s| loadfn(s));
Indexdv::load_with(|s| loadfn(s));
Indexf::load_with(|s| loadfn(s));
Indexfv::load_with(|s| loadfn(s));
Indexi::load_with(|s| loadfn(s));
Indexiv::load_with(|s| loadfn(s));
Indexs::load_with(|s| loadfn(s));
Indexsv::load_with(|s| loadfn(s));
Indexub::load_with(|s| loadfn(s));
Indexubv::load_with(|s| loadfn(s));
InitNames::load_with(|s| loadfn(s));
InterleavedArrays::load_with(|s| loadfn(s));
InvalidateBufferData::load_with(|s| loadfn(s));
InvalidateBufferSubData::load_with(|s| loadfn(s));
InvalidateFramebuffer::load_with(|s| loadfn(s));
InvalidateNamedFramebufferData::load_with(|s| loadfn(s));
InvalidateNamedFramebufferSubData::load_with(|s| loadfn(s));
InvalidateSubFramebuffer::load_with(|s| loadfn(s));
InvalidateTexImage::load_with(|s| loadfn(s));
InvalidateTexSubImage::load_with(|s| loadfn(s));
IsBuffer::load_with(|s| loadfn(s));
IsBufferARB::load_with(|s| loadfn(s));
IsEnabled::load_with(|s| loadfn(s));
IsEnabledIndexedEXT::load_with(|s| loadfn(s));
IsEnabledi::load_with(|s| loadfn(s));
IsFramebuffer::load_with(|s| loadfn(s));
IsFramebufferEXT::load_with(|s| loadfn(s));
IsImageHandleResidentARB::load_with(|s| loadfn(s));
IsList::load_with(|s| loadfn(s));
IsProgram::load_with(|s| loadfn(s));
IsProgramPipeline::load_with(|s| loadfn(s));
IsQuery::load_with(|s| loadfn(s));
IsQueryARB::load_with(|s| loadfn(s));
IsQueryEXT::load_with(|s| loadfn(s));
IsRenderbuffer::load_with(|s| loadfn(s));
IsRenderbufferEXT::load_with(|s| loadfn(s));
IsSampler::load_with(|s| loadfn(s));
IsShader::load_with(|s| loadfn(s));
IsSync::load_with(|s| loadfn(s));
IsSyncAPPLE::load_with(|s| loadfn(s));
IsTexture::load_with(|s| loadfn(s));
IsTextureHandleResidentARB::load_with(|s| loadfn(s));
IsTransformFeedback::load_with(|s| loadfn(s));
IsVertexArray::load_with(|s| loadfn(s));
IsVertexArrayAPPLE::load_with(|s| loadfn(s));
IsVertexArrayOES::load_with(|s| loadfn(s));
LightModelf::load_with(|s| loadfn(s));
LightModelfv::load_with(|s| loadfn(s));
LightModeli::load_with(|s| loadfn(s));
LightModeliv::load_with(|s| loadfn(s));
Lightf::load_with(|s| loadfn(s));
Lightfv::load_with(|s| loadfn(s));
Lighti::load_with(|s| loadfn(s));
Lightiv::load_with(|s| loadfn(s));
LineStipple::load_with(|s| loadfn(s));
LineWidth::load_with(|s| loadfn(s));
LinkProgram::load_with(|s| loadfn(s));
LinkProgramARB::load_with(|s| loadfn(s));
ListBase::load_with(|s| loadfn(s));
LoadIdentity::load_with(|s| loadfn(s));
LoadMatrixd::load_with(|s| loadfn(s));
LoadMatrixf::load_with(|s| loadfn(s));
LoadName::load_with(|s| loadfn(s));
LoadTransposeMatrixd::load_with(|s| loadfn(s));
LoadTransposeMatrixf::load_with(|s| loadfn(s));
LogicOp::load_with(|s| loadfn(s));
MakeImageHandleNonResidentARB::load_with(|s| loadfn(s));
MakeImageHandleResidentARB::load_with(|s| loadfn(s));
MakeTextureHandleNonResidentARB::load_with(|s| loadfn(s));
MakeTextureHandleResidentARB::load_with(|s| loadfn(s));
Map1d::load_with(|s| loadfn(s));
Map1f::load_with(|s| loadfn(s));
Map2d::load_with(|s| loadfn(s));
Map2f::load_with(|s| loadfn(s));
MapBuffer::load_with(|s| loadfn(s));
MapBufferARB::load_with(|s| loadfn(s));
MapBufferRange::load_with(|s| loadfn(s));
MapGrid1d::load_with(|s| loadfn(s));
MapGrid1f::load_with(|s| loadfn(s));
MapGrid2d::load_with(|s| loadfn(s));
MapGrid2f::load_with(|s| loadfn(s));
MapNamedBuffer::load_with(|s| loadfn(s));
MapNamedBufferEXT::load_with(|s| loadfn(s));
MapNamedBufferRange::load_with(|s| loadfn(s));
MapNamedBufferRangeEXT::load_with(|s| loadfn(s));
Materialf::load_with(|s| loadfn(s));
Materialfv::load_with(|s| loadfn(s));
Materiali::load_with(|s| loadfn(s));
Materialiv::load_with(|s| loadfn(s));
MatrixFrustumEXT::load_with(|s| loadfn(s));
MatrixLoadIdentityEXT::load_with(|s| loadfn(s));
MatrixLoadTransposedEXT::load_with(|s| loadfn(s));
MatrixLoadTransposefEXT::load_with(|s| loadfn(s));
MatrixLoaddEXT::load_with(|s| loadfn(s));
MatrixLoadfEXT::load_with(|s| loadfn(s));
MatrixMode::load_with(|s| loadfn(s));
MatrixMultTransposedEXT::load_with(|s| loadfn(s));
MatrixMultTransposefEXT::load_with(|s| loadfn(s));
MatrixMultdEXT::load_with(|s| loadfn(s));
MatrixMultfEXT::load_with(|s| loadfn(s));
MatrixOrthoEXT::load_with(|s| loadfn(s));
MatrixPopEXT::load_with(|s| loadfn(s));
MatrixPushEXT::load_with(|s| loadfn(s));
MatrixRotatedEXT::load_with(|s| loadfn(s));
MatrixRotatefEXT::load_with(|s| loadfn(s));
MatrixScaledEXT::load_with(|s| loadfn(s));
MatrixScalefEXT::load_with(|s| loadfn(s));
MatrixTranslatedEXT::load_with(|s| loadfn(s));
MatrixTranslatefEXT::load_with(|s| loadfn(s));
MemoryBarrier::load_with(|s| loadfn(s));
MemoryBarrierByRegion::load_with(|s| loadfn(s));
MinSampleShading::load_with(|s| loadfn(s));
MultMatrixd::load_with(|s| loadfn(s));
MultMatrixf::load_with(|s| loadfn(s));
MultTransposeMatrixd::load_with(|s| loadfn(s));
MultTransposeMatrixf::load_with(|s| loadfn(s));
MultiDrawArrays::load_with(|s| loadfn(s));
MultiDrawArraysIndirect::load_with(|s| loadfn(s));
MultiDrawArraysIndirectEXT::load_with(|s| loadfn(s));
MultiDrawElements::load_with(|s| loadfn(s));
MultiDrawElementsBaseVertex::load_with(|s| loadfn(s));
MultiDrawElementsBaseVertexEXT::load_with(|s| loadfn(s));
MultiDrawElementsIndirect::load_with(|s| loadfn(s));
MultiDrawElementsIndirectEXT::load_with(|s| loadfn(s));
MultiTexBufferEXT::load_with(|s| loadfn(s));
MultiTexCoord1d::load_with(|s| loadfn(s));
MultiTexCoord1dv::load_with(|s| loadfn(s));
MultiTexCoord1f::load_with(|s| loadfn(s));
MultiTexCoord1fv::load_with(|s| loadfn(s));
MultiTexCoord1i::load_with(|s| loadfn(s));
MultiTexCoord1iv::load_with(|s| loadfn(s));
MultiTexCoord1s::load_with(|s| loadfn(s));
MultiTexCoord1sv::load_with(|s| loadfn(s));
MultiTexCoord2d::load_with(|s| loadfn(s));
MultiTexCoord2dv::load_with(|s| loadfn(s));
MultiTexCoord2f::load_with(|s| loadfn(s));
MultiTexCoord2fv::load_with(|s| loadfn(s));
MultiTexCoord2i::load_with(|s| loadfn(s));
MultiTexCoord2iv::load_with(|s| loadfn(s));
MultiTexCoord2s::load_with(|s| loadfn(s));
MultiTexCoord2sv::load_with(|s| loadfn(s));
MultiTexCoord3d::load_with(|s| loadfn(s));
MultiTexCoord3dv::load_with(|s| loadfn(s));
MultiTexCoord3f::load_with(|s| loadfn(s));
MultiTexCoord3fv::load_with(|s| loadfn(s));
MultiTexCoord3i::load_with(|s| loadfn(s));
MultiTexCoord3iv::load_with(|s| loadfn(s));
MultiTexCoord3s::load_with(|s| loadfn(s));
MultiTexCoord3sv::load_with(|s| loadfn(s));
MultiTexCoord4d::load_with(|s| loadfn(s));
MultiTexCoord4dv::load_with(|s| loadfn(s));
MultiTexCoord4f::load_with(|s| loadfn(s));
MultiTexCoord4fv::load_with(|s| loadfn(s));
MultiTexCoord4i::load_with(|s| loadfn(s));
MultiTexCoord4iv::load_with(|s| loadfn(s));
MultiTexCoord4s::load_with(|s| loadfn(s));
MultiTexCoord4sv::load_with(|s| loadfn(s));
MultiTexCoordP1ui::load_with(|s| loadfn(s));
MultiTexCoordP1uiv::load_with(|s| loadfn(s));
MultiTexCoordP2ui::load_with(|s| loadfn(s));
MultiTexCoordP2uiv::load_with(|s| loadfn(s));
MultiTexCoordP3ui::load_with(|s| loadfn(s));
MultiTexCoordP3uiv::load_with(|s| loadfn(s));
MultiTexCoordP4ui::load_with(|s| loadfn(s));
MultiTexCoordP4uiv::load_with(|s| loadfn(s));
MultiTexCoordPointerEXT::load_with(|s| loadfn(s));
MultiTexEnvfEXT::load_with(|s| loadfn(s));
MultiTexEnvfvEXT::load_with(|s| loadfn(s));
MultiTexEnviEXT::load_with(|s| loadfn(s));
MultiTexEnvivEXT::load_with(|s| loadfn(s));
MultiTexGendEXT::load_with(|s| loadfn(s));
MultiTexGendvEXT::load_with(|s| loadfn(s));
MultiTexGenfEXT::load_with(|s| loadfn(s));
MultiTexGenfvEXT::load_with(|s| loadfn(s));
MultiTexGeniEXT::load_with(|s| loadfn(s));
MultiTexGenivEXT::load_with(|s| loadfn(s));
MultiTexImage1DEXT::load_with(|s| loadfn(s));
MultiTexImage2DEXT::load_with(|s| loadfn(s));
MultiTexImage3DEXT::load_with(|s| loadfn(s));
MultiTexParameterIivEXT::load_with(|s| loadfn(s));
MultiTexParameterIuivEXT::load_with(|s| loadfn(s));
MultiTexParameterfEXT::load_with(|s| loadfn(s));
MultiTexParameterfvEXT::load_with(|s| loadfn(s));
MultiTexParameteriEXT::load_with(|s| loadfn(s));
MultiTexParameterivEXT::load_with(|s| loadfn(s));
MultiTexRenderbufferEXT::load_with(|s| loadfn(s));
MultiTexSubImage1DEXT::load_with(|s| loadfn(s));
MultiTexSubImage2DEXT::load_with(|s| loadfn(s));
MultiTexSubImage3DEXT::load_with(|s| loadfn(s));
NamedBufferData::load_with(|s| loadfn(s));
NamedBufferDataEXT::load_with(|s| loadfn(s));
NamedBufferStorage::load_with(|s| loadfn(s));
NamedBufferStorageEXT::load_with(|s| loadfn(s));
NamedBufferSubData::load_with(|s| loadfn(s));
NamedBufferSubDataEXT::load_with(|s| loadfn(s));
NamedCopyBufferSubDataEXT::load_with(|s| loadfn(s));
NamedFramebufferDrawBuffer::load_with(|s| loadfn(s));
NamedFramebufferDrawBuffers::load_with(|s| loadfn(s));
NamedFramebufferParameteri::load_with(|s| loadfn(s));
NamedFramebufferParameteriEXT::load_with(|s| loadfn(s));
NamedFramebufferReadBuffer::load_with(|s| loadfn(s));
NamedFramebufferRenderbuffer::load_with(|s| loadfn(s));
NamedFramebufferRenderbufferEXT::load_with(|s| loadfn(s));
NamedFramebufferTexture::load_with(|s| loadfn(s));
NamedFramebufferTexture1DEXT::load_with(|s| loadfn(s));
NamedFramebufferTexture2DEXT::load_with(|s| loadfn(s));
NamedFramebufferTexture3DEXT::load_with(|s| loadfn(s));
NamedFramebufferTextureEXT::load_with(|s| loadfn(s));
NamedFramebufferTextureFaceEXT::load_with(|s| loadfn(s));
NamedFramebufferTextureLayer::load_with(|s| loadfn(s));
NamedFramebufferTextureLayerEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameter4dEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameter4dvEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameter4fEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameter4fvEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameterI4iEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameterI4ivEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameterI4uiEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameterI4uivEXT::load_with(|s| loadfn(s));
NamedProgramLocalParameters4fvEXT::load_with(|s| loadfn(s));
NamedProgramLocalParametersI4ivEXT::load_with(|s| loadfn(s));
NamedProgramLocalParametersI4uivEXT::load_with(|s| loadfn(s));
NamedProgramStringEXT::load_with(|s| loadfn(s));
NamedRenderbufferStorage::load_with(|s| loadfn(s));
NamedRenderbufferStorageEXT::load_with(|s| loadfn(s));
NamedRenderbufferStorageMultisample::load_with(|s| loadfn(s));
NamedRenderbufferStorageMultisampleCoverageEXT::load_with(|s| loadfn(s));
NamedRenderbufferStorageMultisampleEXT::load_with(|s| loadfn(s));
NewList::load_with(|s| loadfn(s));
Normal3b::load_with(|s| loadfn(s));
Normal3bv::load_with(|s| loadfn(s));
Normal3d::load_with(|s| loadfn(s));
Normal3dv::load_with(|s| loadfn(s));
Normal3f::load_with(|s| loadfn(s));
Normal3fv::load_with(|s| loadfn(s));
Normal3i::load_with(|s| loadfn(s));
Normal3iv::load_with(|s| loadfn(s));
Normal3s::load_with(|s| loadfn(s));
Normal3sv::load_with(|s| loadfn(s));
NormalP3ui::load_with(|s| loadfn(s));
NormalP3uiv::load_with(|s| loadfn(s));
NormalPointer::load_with(|s| loadfn(s));
ObjectLabel::load_with(|s| loadfn(s));
ObjectLabelKHR::load_with(|s| loadfn(s));
ObjectPtrLabel::load_with(|s| loadfn(s));
ObjectPtrLabelKHR::load_with(|s| loadfn(s));
Ortho::load_with(|s| loadfn(s));
PassThrough::load_with(|s| loadfn(s));
PatchParameterfv::load_with(|s| loadfn(s));
PatchParameteri::load_with(|s| loadfn(s));
PauseTransformFeedback::load_with(|s| loadfn(s));
PixelMapfv::load_with(|s| loadfn(s));
PixelMapuiv::load_with(|s| loadfn(s));
PixelMapusv::load_with(|s| loadfn(s));
PixelStoref::load_with(|s| loadfn(s));
PixelStorei::load_with(|s| loadfn(s));
PixelTransferf::load_with(|s| loadfn(s));
PixelTransferi::load_with(|s| loadfn(s));
PixelZoom::load_with(|s| loadfn(s));
PointParameterf::load_with(|s| loadfn(s));
PointParameterfv::load_with(|s| loadfn(s));
PointParameteri::load_with(|s| loadfn(s));
PointParameteriv::load_with(|s| loadfn(s));
PointSize::load_with(|s| loadfn(s));
PolygonMode::load_with(|s| loadfn(s));
PolygonOffset::load_with(|s| loadfn(s));
PolygonStipple::load_with(|s| loadfn(s));
PopAttrib::load_with(|s| loadfn(s));
PopClientAttrib::load_with(|s| loadfn(s));
PopDebugGroup::load_with(|s| loadfn(s));
PopDebugGroupKHR::load_with(|s| loadfn(s));
PopMatrix::load_with(|s| loadfn(s));
PopName::load_with(|s| loadfn(s));
PrimitiveBoundingBox::load_with(|s| loadfn(s));
PrimitiveBoundingBoxARB::load_with(|s| loadfn(s));
PrimitiveBoundingBoxEXT::load_with(|s| loadfn(s));
PrimitiveBoundingBoxOES::load_with(|s| loadfn(s));
PrimitiveRestartIndex::load_with(|s| loadfn(s));
PrioritizeTextures::load_with(|s| loadfn(s));
ProgramBinary::load_with(|s| loadfn(s));
ProgramParameteri::load_with(|s| loadfn(s));
ProgramParameteriARB::load_with(|s| loadfn(s));
ProgramUniform1d::load_with(|s| loadfn(s));
ProgramUniform1dEXT::load_with(|s| loadfn(s));
ProgramUniform1dv::load_with(|s| loadfn(s));
ProgramUniform1dvEXT::load_with(|s| loadfn(s));
ProgramUniform1f::load_with(|s| loadfn(s));
ProgramUniform1fEXT::load_with(|s| loadfn(s));
ProgramUniform1fv::load_with(|s| loadfn(s));
ProgramUniform1fvEXT::load_with(|s| loadfn(s));
ProgramUniform1i::load_with(|s| loadfn(s));
ProgramUniform1i64ARB::load_with(|s| loadfn(s));
ProgramUniform1i64vARB::load_with(|s| loadfn(s));
ProgramUniform1iEXT::load_with(|s| loadfn(s));
ProgramUniform1iv::load_with(|s| loadfn(s));
ProgramUniform1ivEXT::load_with(|s| loadfn(s));
ProgramUniform1ui::load_with(|s| loadfn(s));
ProgramUniform1ui64ARB::load_with(|s| loadfn(s));
ProgramUniform1ui64vARB::load_with(|s| loadfn(s));
ProgramUniform1uiEXT::load_with(|s| loadfn(s));
ProgramUniform1uiv::load_with(|s| loadfn(s));
ProgramUniform1uivEXT::load_with(|s| loadfn(s));
ProgramUniform2d::load_with(|s| loadfn(s));
ProgramUniform2dEXT::load_with(|s| loadfn(s));
ProgramUniform2dv::load_with(|s| loadfn(s));
ProgramUniform2dvEXT::load_with(|s| loadfn(s));
ProgramUniform2f::load_with(|s| loadfn(s));
ProgramUniform2fEXT::load_with(|s| loadfn(s));
ProgramUniform2fv::load_with(|s| loadfn(s));
ProgramUniform2fvEXT::load_with(|s| loadfn(s));
ProgramUniform2i::load_with(|s| loadfn(s));
ProgramUniform2i64ARB::load_with(|s| loadfn(s));
ProgramUniform2i64vARB::load_with(|s| loadfn(s));
ProgramUniform2iEXT::load_with(|s| loadfn(s));
ProgramUniform2iv::load_with(|s| loadfn(s));
ProgramUniform2ivEXT::load_with(|s| loadfn(s));
ProgramUniform2ui::load_with(|s| loadfn(s));
ProgramUniform2ui64ARB::load_with(|s| loadfn(s));
ProgramUniform2ui64vARB::load_with(|s| loadfn(s));
ProgramUniform2uiEXT::load_with(|s| loadfn(s));
ProgramUniform2uiv::load_with(|s| loadfn(s));
ProgramUniform2uivEXT::load_with(|s| loadfn(s));
ProgramUniform3d::load_with(|s| loadfn(s));
ProgramUniform3dEXT::load_with(|s| loadfn(s));
ProgramUniform3dv::load_with(|s| loadfn(s));
ProgramUniform3dvEXT::load_with(|s| loadfn(s));
ProgramUniform3f::load_with(|s| loadfn(s));
ProgramUniform3fEXT::load_with(|s| loadfn(s));
ProgramUniform3fv::load_with(|s| loadfn(s));
ProgramUniform3fvEXT::load_with(|s| loadfn(s));
ProgramUniform3i::load_with(|s| loadfn(s));
ProgramUniform3i64ARB::load_with(|s| loadfn(s));
ProgramUniform3i64vARB::load_with(|s| loadfn(s));
ProgramUniform3iEXT::load_with(|s| loadfn(s));
ProgramUniform3iv::load_with(|s| loadfn(s));
ProgramUniform3ivEXT::load_with(|s| loadfn(s));
ProgramUniform3ui::load_with(|s| loadfn(s));
ProgramUniform3ui64ARB::load_with(|s| loadfn(s));
ProgramUniform3ui64vARB::load_with(|s| loadfn(s));
ProgramUniform3uiEXT::load_with(|s| loadfn(s));
ProgramUniform3uiv::load_with(|s| loadfn(s));
ProgramUniform3uivEXT::load_with(|s| loadfn(s));
ProgramUniform4d::load_with(|s| loadfn(s));
ProgramUniform4dEXT::load_with(|s| loadfn(s));
ProgramUniform4dv::load_with(|s| loadfn(s));
ProgramUniform4dvEXT::load_with(|s| loadfn(s));
ProgramUniform4f::load_with(|s| loadfn(s));
ProgramUniform4fEXT::load_with(|s| loadfn(s));
ProgramUniform4fv::load_with(|s| loadfn(s));
ProgramUniform4fvEXT::load_with(|s| loadfn(s));
ProgramUniform4i::load_with(|s| loadfn(s));
ProgramUniform4i64ARB::load_with(|s| loadfn(s));
ProgramUniform4i64vARB::load_with(|s| loadfn(s));
ProgramUniform4iEXT::load_with(|s| loadfn(s));
ProgramUniform4iv::load_with(|s| loadfn(s));
ProgramUniform4ivEXT::load_with(|s| loadfn(s));
ProgramUniform4ui::load_with(|s| loadfn(s));
ProgramUniform4ui64ARB::load_with(|s| loadfn(s));
ProgramUniform4ui64vARB::load_with(|s| loadfn(s));
ProgramUniform4uiEXT::load_with(|s| loadfn(s));
ProgramUniform4uiv::load_with(|s| loadfn(s));
ProgramUniform4uivEXT::load_with(|s| loadfn(s));
ProgramUniformHandleui64ARB::load_with(|s| loadfn(s));
ProgramUniformHandleui64vARB::load_with(|s| loadfn(s));
ProgramUniformMatrix2dv::load_with(|s| loadfn(s));
ProgramUniformMatrix2dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix2fv::load_with(|s| loadfn(s));
ProgramUniformMatrix2fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix2x3dv::load_with(|s| loadfn(s));
ProgramUniformMatrix2x3dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix2x3fv::load_with(|s| loadfn(s));
ProgramUniformMatrix2x3fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix2x4dv::load_with(|s| loadfn(s));
ProgramUniformMatrix2x4dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix2x4fv::load_with(|s| loadfn(s));
ProgramUniformMatrix2x4fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3dv::load_with(|s| loadfn(s));
ProgramUniformMatrix3dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3fv::load_with(|s| loadfn(s));
ProgramUniformMatrix3fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3x2dv::load_with(|s| loadfn(s));
ProgramUniformMatrix3x2dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3x2fv::load_with(|s| loadfn(s));
ProgramUniformMatrix3x2fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3x4dv::load_with(|s| loadfn(s));
ProgramUniformMatrix3x4dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix3x4fv::load_with(|s| loadfn(s));
ProgramUniformMatrix3x4fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4dv::load_with(|s| loadfn(s));
ProgramUniformMatrix4dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4fv::load_with(|s| loadfn(s));
ProgramUniformMatrix4fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4x2dv::load_with(|s| loadfn(s));
ProgramUniformMatrix4x2dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4x2fv::load_with(|s| loadfn(s));
ProgramUniformMatrix4x2fvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4x3dv::load_with(|s| loadfn(s));
ProgramUniformMatrix4x3dvEXT::load_with(|s| loadfn(s));
ProgramUniformMatrix4x3fv::load_with(|s| loadfn(s));
ProgramUniformMatrix4x3fvEXT::load_with(|s| loadfn(s));
ProvokingVertex::load_with(|s| loadfn(s));
ProvokingVertexEXT::load_with(|s| loadfn(s));
PushAttrib::load_with(|s| loadfn(s));
PushClientAttrib::load_with(|s| loadfn(s));
PushClientAttribDefaultEXT::load_with(|s| loadfn(s));
PushDebugGroup::load_with(|s| loadfn(s));
PushDebugGroupKHR::load_with(|s| loadfn(s));
PushMatrix::load_with(|s| loadfn(s));
PushName::load_with(|s| loadfn(s));
QueryCounter::load_with(|s| loadfn(s));
QueryCounterEXT::load_with(|s| loadfn(s));
RasterPos2d::load_with(|s| loadfn(s));
RasterPos2dv::load_with(|s| loadfn(s));
RasterPos2f::load_with(|s| loadfn(s));
RasterPos2fv::load_with(|s| loadfn(s));
RasterPos2i::load_with(|s| loadfn(s));
RasterPos2iv::load_with(|s| loadfn(s));
RasterPos2s::load_with(|s| loadfn(s));
RasterPos2sv::load_with(|s| loadfn(s));
RasterPos3d::load_with(|s| loadfn(s));
RasterPos3dv::load_with(|s| loadfn(s));
RasterPos3f::load_with(|s| loadfn(s));
RasterPos3fv::load_with(|s| loadfn(s));
RasterPos3i::load_with(|s| loadfn(s));
RasterPos3iv::load_with(|s| loadfn(s));
RasterPos3s::load_with(|s| loadfn(s));
RasterPos3sv::load_with(|s| loadfn(s));
RasterPos4d::load_with(|s| loadfn(s));
RasterPos4dv::load_with(|s| loadfn(s));
RasterPos4f::load_with(|s| loadfn(s));
RasterPos4fv::load_with(|s| loadfn(s));
RasterPos4i::load_with(|s| loadfn(s));
RasterPos4iv::load_with(|s| loadfn(s));
RasterPos4s::load_with(|s| loadfn(s));
RasterPos4sv::load_with(|s| loadfn(s));
ReadBuffer::load_with(|s| loadfn(s));
ReadPixels::load_with(|s| loadfn(s));
ReadnPixels::load_with(|s| loadfn(s));
ReadnPixelsARB::load_with(|s| loadfn(s));
ReadnPixelsEXT::load_with(|s| loadfn(s));
ReadnPixelsKHR::load_with(|s| loadfn(s));
Rectd::load_with(|s| loadfn(s));
Rectdv::load_with(|s| loadfn(s));
Rectf::load_with(|s| loadfn(s));
Rectfv::load_with(|s| loadfn(s));
Recti::load_with(|s| loadfn(s));
Rectiv::load_with(|s| loadfn(s));
Rects::load_with(|s| loadfn(s));
Rectsv::load_with(|s| loadfn(s));
ReleaseShaderCompiler::load_with(|s| loadfn(s));
RenderMode::load_with(|s| loadfn(s));
RenderbufferStorage::load_with(|s| loadfn(s));
RenderbufferStorageEXT::load_with(|s| loadfn(s));
RenderbufferStorageMultisample::load_with(|s| loadfn(s));
RenderbufferStorageMultisampleANGLE::load_with(|s| loadfn(s));
RenderbufferStorageMultisampleAPPLE::load_with(|s| loadfn(s));
RenderbufferStorageMultisampleEXT::load_with(|s| loadfn(s));
RenderbufferStorageMultisampleNV::load_with(|s| loadfn(s));
ResolveMultisampleFramebufferAPPLE::load_with(|s| loadfn(s));
ResumeTransformFeedback::load_with(|s| loadfn(s));
Rotated::load_with(|s| loadfn(s));
Rotatef::load_with(|s| loadfn(s));
SampleCoverage::load_with(|s| loadfn(s));
SampleMaski::load_with(|s| loadfn(s));
SamplerParameterIiv::load_with(|s| loadfn(s));
SamplerParameterIuiv::load_with(|s| loadfn(s));
SamplerParameterf::load_with(|s| loadfn(s));
SamplerParameterfv::load_with(|s| loadfn(s));
SamplerParameteri::load_with(|s| loadfn(s));
SamplerParameteriv::load_with(|s| loadfn(s));
Scaled::load_with(|s| loadfn(s));
Scalef::load_with(|s| loadfn(s));
Scissor::load_with(|s| loadfn(s));
ScissorArrayv::load_with(|s| loadfn(s));
ScissorIndexed::load_with(|s| loadfn(s));
ScissorIndexedv::load_with(|s| loadfn(s));
SecondaryColor3b::load_with(|s| loadfn(s));
SecondaryColor3bv::load_with(|s| loadfn(s));
SecondaryColor3d::load_with(|s| loadfn(s));
SecondaryColor3dv::load_with(|s| loadfn(s));
SecondaryColor3f::load_with(|s| loadfn(s));
SecondaryColor3fv::load_with(|s| loadfn(s));
SecondaryColor3i::load_with(|s| loadfn(s));
SecondaryColor3iv::load_with(|s| loadfn(s));
SecondaryColor3s::load_with(|s| loadfn(s));
SecondaryColor3sv::load_with(|s| loadfn(s));
SecondaryColor3ub::load_with(|s| loadfn(s));
SecondaryColor3ubv::load_with(|s| loadfn(s));
SecondaryColor3ui::load_with(|s| loadfn(s));
SecondaryColor3uiv::load_with(|s| loadfn(s));
SecondaryColor3us::load_with(|s| loadfn(s));
SecondaryColor3usv::load_with(|s| loadfn(s));
SecondaryColorP3ui::load_with(|s| loadfn(s));
SecondaryColorP3uiv::load_with(|s| loadfn(s));
SecondaryColorPointer::load_with(|s| loadfn(s));
SelectBuffer::load_with(|s| loadfn(s));
ShadeModel::load_with(|s| loadfn(s));
ShaderBinary::load_with(|s| loadfn(s));
ShaderSource::load_with(|s| loadfn(s));
ShaderSourceARB::load_with(|s| loadfn(s));
ShaderStorageBlockBinding::load_with(|s| loadfn(s));
StencilFunc::load_with(|s| loadfn(s));
StencilFuncSeparate::load_with(|s| loadfn(s));
StencilMask::load_with(|s| loadfn(s));
StencilMaskSeparate::load_with(|s| loadfn(s));
StencilOp::load_with(|s| loadfn(s));
StencilOpSeparate::load_with(|s| loadfn(s));
StringMarkerGREMEDY::load_with(|s| loadfn(s));
TexBuffer::load_with(|s| loadfn(s));
TexBufferARB::load_with(|s| loadfn(s));
TexBufferEXT::load_with(|s| loadfn(s));
TexBufferOES::load_with(|s| loadfn(s));
TexBufferRange::load_with(|s| loadfn(s));
TexBufferRangeOES::load_with(|s| loadfn(s));
TexCoord1d::load_with(|s| loadfn(s));
TexCoord1dv::load_with(|s| loadfn(s));
TexCoord1f::load_with(|s| loadfn(s));
TexCoord1fv::load_with(|s| loadfn(s));
TexCoord1i::load_with(|s| loadfn(s));
TexCoord1iv::load_with(|s| loadfn(s));
TexCoord1s::load_with(|s| loadfn(s));
TexCoord1sv::load_with(|s| loadfn(s));
TexCoord2d::load_with(|s| loadfn(s));
TexCoord2dv::load_with(|s| loadfn(s));
TexCoord2f::load_with(|s| loadfn(s));
TexCoord2fv::load_with(|s| loadfn(s));
TexCoord2i::load_with(|s| loadfn(s));
TexCoord2iv::load_with(|s| loadfn(s));
TexCoord2s::load_with(|s| loadfn(s));
TexCoord2sv::load_with(|s| loadfn(s));
TexCoord3d::load_with(|s| loadfn(s));
TexCoord3dv::load_with(|s| loadfn(s));
TexCoord3f::load_with(|s| loadfn(s));
TexCoord3fv::load_with(|s| loadfn(s));
TexCoord3i::load_with(|s| loadfn(s));
TexCoord3iv::load_with(|s| loadfn(s));
TexCoord3s::load_with(|s| loadfn(s));
TexCoord3sv::load_with(|s| loadfn(s));
TexCoord4d::load_with(|s| loadfn(s));
TexCoord4dv::load_with(|s| loadfn(s));
TexCoord4f::load_with(|s| loadfn(s));
TexCoord4fv::load_with(|s| loadfn(s));
TexCoord4i::load_with(|s| loadfn(s));
TexCoord4iv::load_with(|s| loadfn(s));
TexCoord4s::load_with(|s| loadfn(s));
TexCoord4sv::load_with(|s| loadfn(s));
TexCoordP1ui::load_with(|s| loadfn(s));
TexCoordP1uiv::load_with(|s| loadfn(s));
TexCoordP2ui::load_with(|s| loadfn(s));
TexCoordP2uiv::load_with(|s| loadfn(s));
TexCoordP3ui::load_with(|s| loadfn(s));
TexCoordP3uiv::load_with(|s| loadfn(s));
TexCoordP4ui::load_with(|s| loadfn(s));
TexCoordP4uiv::load_with(|s| loadfn(s));
TexCoordPointer::load_with(|s| loadfn(s));
TexEnvf::load_with(|s| loadfn(s));
TexEnvfv::load_with(|s| loadfn(s));
TexEnvi::load_with(|s| loadfn(s));
TexEnviv::load_with(|s| loadfn(s));
TexGend::load_with(|s| loadfn(s));
TexGendv::load_with(|s| loadfn(s));
TexGenf::load_with(|s| loadfn(s));
TexGenfv::load_with(|s| loadfn(s));
TexGeni::load_with(|s| loadfn(s));
TexGeniv::load_with(|s| loadfn(s));
TexImage1D::load_with(|s| loadfn(s));
TexImage2D::load_with(|s| loadfn(s));
TexImage2DMultisample::load_with(|s| loadfn(s));
TexImage3D::load_with(|s| loadfn(s));
TexImage3DMultisample::load_with(|s| loadfn(s));
TexParameterIiv::load_with(|s| loadfn(s));
TexParameterIivEXT::load_with(|s| loadfn(s));
TexParameterIuiv::load_with(|s| loadfn(s));
TexParameterIuivEXT::load_with(|s| loadfn(s));
TexParameterf::load_with(|s| loadfn(s));
TexParameterfv::load_with(|s| loadfn(s));
TexParameteri::load_with(|s| loadfn(s));
TexParameteriv::load_with(|s| loadfn(s));
TexStorage1D::load_with(|s| loadfn(s));
TexStorage2D::load_with(|s| loadfn(s));
TexStorage2DMultisample::load_with(|s| loadfn(s));
TexStorage3D::load_with(|s| loadfn(s));
TexStorage3DMultisample::load_with(|s| loadfn(s));
TexSubImage1D::load_with(|s| loadfn(s));
TexSubImage2D::load_with(|s| loadfn(s));
TexSubImage3D::load_with(|s| loadfn(s));
TextureBarrier::load_with(|s| loadfn(s));
TextureBuffer::load_with(|s| loadfn(s));
TextureBufferEXT::load_with(|s| loadfn(s));
TextureBufferRange::load_with(|s| loadfn(s));
TextureBufferRangeEXT::load_with(|s| loadfn(s));
TextureImage1DEXT::load_with(|s| loadfn(s));
TextureImage2DEXT::load_with(|s| loadfn(s));
TextureImage3DEXT::load_with(|s| loadfn(s));
TexturePageCommitmentEXT::load_with(|s| loadfn(s));
TextureParameterIiv::load_with(|s| loadfn(s));
TextureParameterIivEXT::load_with(|s| loadfn(s));
TextureParameterIuiv::load_with(|s| loadfn(s));
TextureParameterIuivEXT::load_with(|s| loadfn(s));
TextureParameterf::load_with(|s| loadfn(s));
TextureParameterfEXT::load_with(|s| loadfn(s));
TextureParameterfv::load_with(|s| loadfn(s));
TextureParameterfvEXT::load_with(|s| loadfn(s));
TextureParameteri::load_with(|s| loadfn(s));
TextureParameteriEXT::load_with(|s| loadfn(s));
TextureParameteriv::load_with(|s| loadfn(s));
TextureParameterivEXT::load_with(|s| loadfn(s));
TextureRenderbufferEXT::load_with(|s| loadfn(s));
TextureStorage1D::load_with(|s| loadfn(s));
TextureStorage1DEXT::load_with(|s| loadfn(s));
TextureStorage2D::load_with(|s| loadfn(s));
TextureStorage2DEXT::load_with(|s| loadfn(s));
TextureStorage2DMultisample::load_with(|s| loadfn(s));
TextureStorage2DMultisampleEXT::load_with(|s| loadfn(s));
TextureStorage3D::load_with(|s| loadfn(s));
TextureStorage3DEXT::load_with(|s| loadfn(s));
TextureStorage3DMultisample::load_with(|s| loadfn(s));
TextureStorage3DMultisampleEXT::load_with(|s| loadfn(s));
TextureSubImage1D::load_with(|s| loadfn(s));
TextureSubImage1DEXT::load_with(|s| loadfn(s));
TextureSubImage2D::load_with(|s| loadfn(s));
TextureSubImage2DEXT::load_with(|s| loadfn(s));
TextureSubImage3D::load_with(|s| loadfn(s));
TextureSubImage3DEXT::load_with(|s| loadfn(s));
TextureView::load_with(|s| loadfn(s));
TransformFeedbackBufferBase::load_with(|s| loadfn(s));
TransformFeedbackBufferRange::load_with(|s| loadfn(s));
TransformFeedbackVaryings::load_with(|s| loadfn(s));
TransformFeedbackVaryingsEXT::load_with(|s| loadfn(s));
Translated::load_with(|s| loadfn(s));
Translatef::load_with(|s| loadfn(s));
Uniform1d::load_with(|s| loadfn(s));
Uniform1dv::load_with(|s| loadfn(s));
Uniform1f::load_with(|s| loadfn(s));
Uniform1fARB::load_with(|s| loadfn(s));
Uniform1fv::load_with(|s| loadfn(s));
Uniform1fvARB::load_with(|s| loadfn(s));
Uniform1i::load_with(|s| loadfn(s));
Uniform1i64ARB::load_with(|s| loadfn(s));
Uniform1i64vARB::load_with(|s| loadfn(s));
Uniform1iARB::load_with(|s| loadfn(s));
Uniform1iv::load_with(|s| loadfn(s));
Uniform1ivARB::load_with(|s| loadfn(s));
Uniform1ui::load_with(|s| loadfn(s));
Uniform1ui64ARB::load_with(|s| loadfn(s));
Uniform1ui64vARB::load_with(|s| loadfn(s));
Uniform1uiEXT::load_with(|s| loadfn(s));
Uniform1uiv::load_with(|s| loadfn(s));
Uniform1uivEXT::load_with(|s| loadfn(s));
Uniform2d::load_with(|s| loadfn(s));
Uniform2dv::load_with(|s| loadfn(s));
Uniform2f::load_with(|s| loadfn(s));
Uniform2fARB::load_with(|s| loadfn(s));
Uniform2fv::load_with(|s| loadfn(s));
Uniform2fvARB::load_with(|s| loadfn(s));
Uniform2i::load_with(|s| loadfn(s));
Uniform2i64ARB::load_with(|s| loadfn(s));
Uniform2i64vARB::load_with(|s| loadfn(s));
Uniform2iARB::load_with(|s| loadfn(s));
Uniform2iv::load_with(|s| loadfn(s));
Uniform2ivARB::load_with(|s| loadfn(s));
Uniform2ui::load_with(|s| loadfn(s));
Uniform2ui64ARB::load_with(|s| loadfn(s));
Uniform2ui64vARB::load_with(|s| loadfn(s));
Uniform2uiEXT::load_with(|s| loadfn(s));
Uniform2uiv::load_with(|s| loadfn(s));
Uniform2uivEXT::load_with(|s| loadfn(s));
Uniform3d::load_with(|s| loadfn(s));
Uniform3dv::load_with(|s| loadfn(s));
Uniform3f::load_with(|s| loadfn(s));
Uniform3fARB::load_with(|s| loadfn(s));
Uniform3fv::load_with(|s| loadfn(s));
Uniform3fvARB::load_with(|s| loadfn(s));
Uniform3i::load_with(|s| loadfn(s));
Uniform3i64ARB::load_with(|s| loadfn(s));
Uniform3i64vARB::load_with(|s| loadfn(s));
Uniform3iARB::load_with(|s| loadfn(s));
Uniform3iv::load_with(|s| loadfn(s));
Uniform3ivARB::load_with(|s| loadfn(s));
Uniform3ui::load_with(|s| loadfn(s));
Uniform3ui64ARB::load_with(|s| loadfn(s));
Uniform3ui64vARB::load_with(|s| loadfn(s));
Uniform3uiEXT::load_with(|s| loadfn(s));
Uniform3uiv::load_with(|s| loadfn(s));
Uniform3uivEXT::load_with(|s| loadfn(s));
Uniform4d::load_with(|s| loadfn(s));
Uniform4dv::load_with(|s| loadfn(s));
Uniform4f::load_with(|s| loadfn(s));
Uniform4fARB::load_with(|s| loadfn(s));
Uniform4fv::load_with(|s| loadfn(s));
Uniform4fvARB::load_with(|s| loadfn(s));
Uniform4i::load_with(|s| loadfn(s));
Uniform4i64ARB::load_with(|s| loadfn(s));
Uniform4i64vARB::load_with(|s| loadfn(s));
Uniform4iARB::load_with(|s| loadfn(s));
Uniform4iv::load_with(|s| loadfn(s));
Uniform4ivARB::load_with(|s| loadfn(s));
Uniform4ui::load_with(|s| loadfn(s));
Uniform4ui64ARB::load_with(|s| loadfn(s));
Uniform4ui64vARB::load_with(|s| loadfn(s));
Uniform4uiEXT::load_with(|s| loadfn(s));
Uniform4uiv::load_with(|s| loadfn(s));
Uniform4uivEXT::load_with(|s| loadfn(s));
UniformBlockBinding::load_with(|s| loadfn(s));
UniformHandleui64ARB::load_with(|s| loadfn(s));
UniformHandleui64vARB::load_with(|s| loadfn(s));
UniformMatrix2dv::load_with(|s| loadfn(s));
UniformMatrix2fv::load_with(|s| loadfn(s));
UniformMatrix2fvARB::load_with(|s| loadfn(s));
UniformMatrix2x3dv::load_with(|s| loadfn(s));
UniformMatrix2x3fv::load_with(|s| loadfn(s));
UniformMatrix2x4dv::load_with(|s| loadfn(s));
UniformMatrix2x4fv::load_with(|s| loadfn(s));
UniformMatrix3dv::load_with(|s| loadfn(s));
UniformMatrix3fv::load_with(|s| loadfn(s));
UniformMatrix3fvARB::load_with(|s| loadfn(s));
UniformMatrix3x2dv::load_with(|s| loadfn(s));
UniformMatrix3x2fv::load_with(|s| loadfn(s));
UniformMatrix3x4dv::load_with(|s| loadfn(s));
UniformMatrix3x4fv::load_with(|s| loadfn(s));
UniformMatrix4dv::load_with(|s| loadfn(s));
UniformMatrix4fv::load_with(|s| loadfn(s));
UniformMatrix4fvARB::load_with(|s| loadfn(s));
UniformMatrix4x2dv::load_with(|s| loadfn(s));
UniformMatrix4x2fv::load_with(|s| loadfn(s));
UniformMatrix4x3dv::load_with(|s| loadfn(s));
UniformMatrix4x3fv::load_with(|s| loadfn(s));
UniformSubroutinesuiv::load_with(|s| loadfn(s));
UnmapBuffer::load_with(|s| loadfn(s));
UnmapBufferARB::load_with(|s| loadfn(s));
UnmapNamedBuffer::load_with(|s| loadfn(s));
UnmapNamedBufferEXT::load_with(|s| loadfn(s));
UseProgram::load_with(|s| loadfn(s));
UseProgramObjectARB::load_with(|s| loadfn(s));
UseProgramStages::load_with(|s| loadfn(s));
ValidateProgram::load_with(|s| loadfn(s));
ValidateProgramARB::load_with(|s| loadfn(s));
ValidateProgramPipeline::load_with(|s| loadfn(s));
Vertex2d::load_with(|s| loadfn(s));
Vertex2dv::load_with(|s| loadfn(s));
Vertex2f::load_with(|s| loadfn(s));
Vertex2fv::load_with(|s| loadfn(s));
Vertex2i::load_with(|s| loadfn(s));
Vertex2iv::load_with(|s| loadfn(s));
Vertex2s::load_with(|s| loadfn(s));
Vertex2sv::load_with(|s| loadfn(s));
Vertex3d::load_with(|s| loadfn(s));
Vertex3dv::load_with(|s| loadfn(s));
Vertex3f::load_with(|s| loadfn(s));
Vertex3fv::load_with(|s| loadfn(s));
Vertex3i::load_with(|s| loadfn(s));
Vertex3iv::load_with(|s| loadfn(s));
Vertex3s::load_with(|s| loadfn(s));
Vertex3sv::load_with(|s| loadfn(s));
Vertex4d::load_with(|s| loadfn(s));
Vertex4dv::load_with(|s| loadfn(s));
Vertex4f::load_with(|s| loadfn(s));
Vertex4fv::load_with(|s| loadfn(s));
Vertex4i::load_with(|s| loadfn(s));
Vertex4iv::load_with(|s| loadfn(s));
Vertex4s::load_with(|s| loadfn(s));
Vertex4sv::load_with(|s| loadfn(s));
VertexArrayAttribBinding::load_with(|s| loadfn(s));
VertexArrayAttribFormat::load_with(|s| loadfn(s));
VertexArrayAttribIFormat::load_with(|s| loadfn(s));
VertexArrayAttribLFormat::load_with(|s| loadfn(s));
VertexArrayBindVertexBufferEXT::load_with(|s| loadfn(s));
VertexArrayBindingDivisor::load_with(|s| loadfn(s));
VertexArrayColorOffsetEXT::load_with(|s| loadfn(s));
VertexArrayEdgeFlagOffsetEXT::load_with(|s| loadfn(s));
VertexArrayElementBuffer::load_with(|s| loadfn(s));
VertexArrayFogCoordOffsetEXT::load_with(|s| loadfn(s));
VertexArrayIndexOffsetEXT::load_with(|s| loadfn(s));
VertexArrayMultiTexCoordOffsetEXT::load_with(|s| loadfn(s));
VertexArrayNormalOffsetEXT::load_with(|s| loadfn(s));
VertexArraySecondaryColorOffsetEXT::load_with(|s| loadfn(s));
VertexArrayTexCoordOffsetEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribBindingEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribDivisorEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribFormatEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribIFormatEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribIOffsetEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribLFormatEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribLOffsetEXT::load_with(|s| loadfn(s));
VertexArrayVertexAttribOffsetEXT::load_with(|s| loadfn(s));
VertexArrayVertexBindingDivisorEXT::load_with(|s| loadfn(s));
VertexArrayVertexBuffer::load_with(|s| loadfn(s));
VertexArrayVertexBuffers::load_with(|s| loadfn(s));
VertexArrayVertexOffsetEXT::load_with(|s| loadfn(s));
VertexAttrib1d::load_with(|s| loadfn(s));
VertexAttrib1dARB::load_with(|s| loadfn(s));
VertexAttrib1dv::load_with(|s| loadfn(s));
VertexAttrib1dvARB::load_with(|s| loadfn(s));
VertexAttrib1f::load_with(|s| loadfn(s));
VertexAttrib1fARB::load_with(|s| loadfn(s));
VertexAttrib1fv::load_with(|s| loadfn(s));
VertexAttrib1fvARB::load_with(|s| loadfn(s));
VertexAttrib1s::load_with(|s| loadfn(s));
VertexAttrib1sARB::load_with(|s| loadfn(s));
VertexAttrib1sv::load_with(|s| loadfn(s));
VertexAttrib1svARB::load_with(|s| loadfn(s));
VertexAttrib2d::load_with(|s| loadfn(s));
VertexAttrib2dARB::load_with(|s| loadfn(s));
VertexAttrib2dv::load_with(|s| loadfn(s));
VertexAttrib2dvARB::load_with(|s| loadfn(s));
VertexAttrib2f::load_with(|s| loadfn(s));
VertexAttrib2fARB::load_with(|s| loadfn(s));
VertexAttrib2fv::load_with(|s| loadfn(s));
VertexAttrib2fvARB::load_with(|s| loadfn(s));
VertexAttrib2s::load_with(|s| loadfn(s));
VertexAttrib2sARB::load_with(|s| loadfn(s));
VertexAttrib2sv::load_with(|s| loadfn(s));
VertexAttrib2svARB::load_with(|s| loadfn(s));
VertexAttrib3d::load_with(|s| loadfn(s));
VertexAttrib3dARB::load_with(|s| loadfn(s));
VertexAttrib3dv::load_with(|s| loadfn(s));
VertexAttrib3dvARB::load_with(|s| loadfn(s));
VertexAttrib3f::load_with(|s| loadfn(s));
VertexAttrib3fARB::load_with(|s| loadfn(s));
VertexAttrib3fv::load_with(|s| loadfn(s));
VertexAttrib3fvARB::load_with(|s| loadfn(s));
VertexAttrib3s::load_with(|s| loadfn(s));
VertexAttrib3sARB::load_with(|s| loadfn(s));
VertexAttrib3sv::load_with(|s| loadfn(s));
VertexAttrib3svARB::load_with(|s| loadfn(s));
VertexAttrib4Nbv::load_with(|s| loadfn(s));
VertexAttrib4NbvARB::load_with(|s| loadfn(s));
VertexAttrib4Niv::load_with(|s| loadfn(s));
VertexAttrib4NivARB::load_with(|s| loadfn(s));
VertexAttrib4Nsv::load_with(|s| loadfn(s));
VertexAttrib4NsvARB::load_with(|s| loadfn(s));
VertexAttrib4Nub::load_with(|s| loadfn(s));
VertexAttrib4NubARB::load_with(|s| loadfn(s));
VertexAttrib4Nubv::load_with(|s| loadfn(s));
VertexAttrib4NubvARB::load_with(|s| loadfn(s));
VertexAttrib4Nuiv::load_with(|s| loadfn(s));
VertexAttrib4NuivARB::load_with(|s| loadfn(s));
VertexAttrib4Nusv::load_with(|s| loadfn(s));
VertexAttrib4NusvARB::load_with(|s| loadfn(s));
VertexAttrib4bv::load_with(|s| loadfn(s));
VertexAttrib4bvARB::load_with(|s| loadfn(s));
VertexAttrib4d::load_with(|s| loadfn(s));
VertexAttrib4dARB::load_with(|s| loadfn(s));
VertexAttrib4dv::load_with(|s| loadfn(s));
VertexAttrib4dvARB::load_with(|s| loadfn(s));
VertexAttrib4f::load_with(|s| loadfn(s));
VertexAttrib4fARB::load_with(|s| loadfn(s));
VertexAttrib4fv::load_with(|s| loadfn(s));
VertexAttrib4fvARB::load_with(|s| loadfn(s));
VertexAttrib4iv::load_with(|s| loadfn(s));
VertexAttrib4ivARB::load_with(|s| loadfn(s));
VertexAttrib4s::load_with(|s| loadfn(s));
VertexAttrib4sARB::load_with(|s| loadfn(s));
VertexAttrib4sv::load_with(|s| loadfn(s));
VertexAttrib4svARB::load_with(|s| loadfn(s));
VertexAttrib4ubv::load_with(|s| loadfn(s));
VertexAttrib4ubvARB::load_with(|s| loadfn(s));
VertexAttrib4uiv::load_with(|s| loadfn(s));
VertexAttrib4uivARB::load_with(|s| loadfn(s));
VertexAttrib4usv::load_with(|s| loadfn(s));
VertexAttrib4usvARB::load_with(|s| loadfn(s));
VertexAttribBinding::load_with(|s| loadfn(s));
VertexAttribDivisor::load_with(|s| loadfn(s));
VertexAttribFormat::load_with(|s| loadfn(s));
VertexAttribI1i::load_with(|s| loadfn(s));
VertexAttribI1iv::load_with(|s| loadfn(s));
VertexAttribI1ui::load_with(|s| loadfn(s));
VertexAttribI1uiv::load_with(|s| loadfn(s));
VertexAttribI2i::load_with(|s| loadfn(s));
VertexAttribI2iv::load_with(|s| loadfn(s));
VertexAttribI2ui::load_with(|s| loadfn(s));
VertexAttribI2uiv::load_with(|s| loadfn(s));
VertexAttribI3i::load_with(|s| loadfn(s));
VertexAttribI3iv::load_with(|s| loadfn(s));
VertexAttribI3ui::load_with(|s| loadfn(s));
VertexAttribI3uiv::load_with(|s| loadfn(s));
VertexAttribI4bv::load_with(|s| loadfn(s));
VertexAttribI4i::load_with(|s| loadfn(s));
VertexAttribI4iv::load_with(|s| loadfn(s));
VertexAttribI4sv::load_with(|s| loadfn(s));
VertexAttribI4ubv::load_with(|s| loadfn(s));
VertexAttribI4ui::load_with(|s| loadfn(s));
VertexAttribI4uiv::load_with(|s| loadfn(s));
VertexAttribI4usv::load_with(|s| loadfn(s));
VertexAttribIFormat::load_with(|s| loadfn(s));
VertexAttribIPointer::load_with(|s| loadfn(s));
VertexAttribL1d::load_with(|s| loadfn(s));
VertexAttribL1dv::load_with(|s| loadfn(s));
VertexAttribL1i64NV::load_with(|s| loadfn(s));
VertexAttribL1i64vNV::load_with(|s| loadfn(s));
VertexAttribL1ui64ARB::load_with(|s| loadfn(s));
VertexAttribL1ui64NV::load_with(|s| loadfn(s));
VertexAttribL1ui64vARB::load_with(|s| loadfn(s));
VertexAttribL1ui64vNV::load_with(|s| loadfn(s));
VertexAttribL2d::load_with(|s| loadfn(s));
VertexAttribL2dv::load_with(|s| loadfn(s));
VertexAttribL2i64NV::load_with(|s| loadfn(s));
VertexAttribL2i64vNV::load_with(|s| loadfn(s));
VertexAttribL2ui64NV::load_with(|s| loadfn(s));
VertexAttribL2ui64vNV::load_with(|s| loadfn(s));
VertexAttribL3d::load_with(|s| loadfn(s));
VertexAttribL3dv::load_with(|s| loadfn(s));
VertexAttribL3i64NV::load_with(|s| loadfn(s));
VertexAttribL3i64vNV::load_with(|s| loadfn(s));
VertexAttribL3ui64NV::load_with(|s| loadfn(s));
VertexAttribL3ui64vNV::load_with(|s| loadfn(s));
VertexAttribL4d::load_with(|s| loadfn(s));
VertexAttribL4dv::load_with(|s| loadfn(s));
VertexAttribL4i64NV::load_with(|s| loadfn(s));
VertexAttribL4i64vNV::load_with(|s| loadfn(s));
VertexAttribL4ui64NV::load_with(|s| loadfn(s));
VertexAttribL4ui64vNV::load_with(|s| loadfn(s));
VertexAttribLFormat::load_with(|s| loadfn(s));
VertexAttribLFormatNV::load_with(|s| loadfn(s));
VertexAttribLPointer::load_with(|s| loadfn(s));
VertexAttribP1ui::load_with(|s| loadfn(s));
VertexAttribP1uiv::load_with(|s| loadfn(s));
VertexAttribP2ui::load_with(|s| loadfn(s));
VertexAttribP2uiv::load_with(|s| loadfn(s));
VertexAttribP3ui::load_with(|s| loadfn(s));
VertexAttribP3uiv::load_with(|s| loadfn(s));
VertexAttribP4ui::load_with(|s| loadfn(s));
VertexAttribP4uiv::load_with(|s| loadfn(s));
VertexAttribPointer::load_with(|s| loadfn(s));
VertexAttribPointerARB::load_with(|s| loadfn(s));
VertexBindingDivisor::load_with(|s| loadfn(s));
VertexP2ui::load_with(|s| loadfn(s));
VertexP2uiv::load_with(|s| loadfn(s));
VertexP3ui::load_with(|s| loadfn(s));
VertexP3uiv::load_with(|s| loadfn(s));
VertexP4ui::load_with(|s| loadfn(s));
VertexP4uiv::load_with(|s| loadfn(s));
VertexPointer::load_with(|s| loadfn(s));
Viewport::load_with(|s| loadfn(s));
ViewportArrayv::load_with(|s| loadfn(s));
ViewportIndexedf::load_with(|s| loadfn(s));
ViewportIndexedfv::load_with(|s| loadfn(s));
WaitSync::load_with(|s| loadfn(s));
WaitSyncAPPLE::load_with(|s| loadfn(s));
WindowPos2d::load_with(|s| loadfn(s));
WindowPos2dv::load_with(|s| loadfn(s));
WindowPos2f::load_with(|s| loadfn(s));
WindowPos2fv::load_with(|s| loadfn(s));
WindowPos2i::load_with(|s| loadfn(s));
WindowPos2iv::load_with(|s| loadfn(s));
WindowPos2s::load_with(|s| loadfn(s));
WindowPos2sv::load_with(|s| loadfn(s));
WindowPos3d::load_with(|s| loadfn(s));
WindowPos3dv::load_with(|s| loadfn(s));
WindowPos3f::load_with(|s| loadfn(s));
WindowPos3fv::load_with(|s| loadfn(s));
WindowPos3i::load_with(|s| loadfn(s));
WindowPos3iv::load_with(|s| loadfn(s));
WindowPos3s::load_with(|s| loadfn(s));
WindowPos3sv::load_with(|s| loadfn(s));

        }
    

        #[allow(dead_code)]
        pub fn get_proc_addr(symbol: &str) -> *const __gl_imports::raw::c_void {
            match &symbol[..] {
    

            "glAccum" => Accum as *const __gl_imports::raw::c_void,

            "glActiveShaderProgram" => ActiveShaderProgram as *const __gl_imports::raw::c_void,

            "glActiveTexture" => ActiveTexture as *const __gl_imports::raw::c_void,

            "glAlphaFunc" => AlphaFunc as *const __gl_imports::raw::c_void,

            "glAreTexturesResident" => AreTexturesResident as *const __gl_imports::raw::c_void,

            "glArrayElement" => ArrayElement as *const __gl_imports::raw::c_void,

            "glAttachObjectARB" => AttachObjectARB as *const __gl_imports::raw::c_void,

            "glAttachShader" => AttachShader as *const __gl_imports::raw::c_void,

            "glBegin" => Begin as *const __gl_imports::raw::c_void,

            "glBeginConditionalRender" => BeginConditionalRender as *const __gl_imports::raw::c_void,

            "glBeginConditionalRenderNV" => BeginConditionalRenderNV as *const __gl_imports::raw::c_void,

            "glBeginQuery" => BeginQuery as *const __gl_imports::raw::c_void,

            "glBeginQueryARB" => BeginQueryARB as *const __gl_imports::raw::c_void,

            "glBeginQueryEXT" => BeginQueryEXT as *const __gl_imports::raw::c_void,

            "glBeginQueryIndexed" => BeginQueryIndexed as *const __gl_imports::raw::c_void,

            "glBeginTransformFeedback" => BeginTransformFeedback as *const __gl_imports::raw::c_void,

            "glBeginTransformFeedbackEXT" => BeginTransformFeedbackEXT as *const __gl_imports::raw::c_void,

            "glBindAttribLocation" => BindAttribLocation as *const __gl_imports::raw::c_void,

            "glBindAttribLocationARB" => BindAttribLocationARB as *const __gl_imports::raw::c_void,

            "glBindBuffer" => BindBuffer as *const __gl_imports::raw::c_void,

            "glBindBufferARB" => BindBufferARB as *const __gl_imports::raw::c_void,

            "glBindBufferBase" => BindBufferBase as *const __gl_imports::raw::c_void,

            "glBindBufferBaseEXT" => BindBufferBaseEXT as *const __gl_imports::raw::c_void,

            "glBindBufferOffsetEXT" => BindBufferOffsetEXT as *const __gl_imports::raw::c_void,

            "glBindBufferRange" => BindBufferRange as *const __gl_imports::raw::c_void,

            "glBindBufferRangeEXT" => BindBufferRangeEXT as *const __gl_imports::raw::c_void,

            "glBindBuffersBase" => BindBuffersBase as *const __gl_imports::raw::c_void,

            "glBindBuffersRange" => BindBuffersRange as *const __gl_imports::raw::c_void,

            "glBindFragDataLocation" => BindFragDataLocation as *const __gl_imports::raw::c_void,

            "glBindFragDataLocationEXT" => BindFragDataLocationEXT as *const __gl_imports::raw::c_void,

            "glBindFragDataLocationIndexed" => BindFragDataLocationIndexed as *const __gl_imports::raw::c_void,

            "glBindFramebuffer" => BindFramebuffer as *const __gl_imports::raw::c_void,

            "glBindFramebufferEXT" => BindFramebufferEXT as *const __gl_imports::raw::c_void,

            "glBindImageTexture" => BindImageTexture as *const __gl_imports::raw::c_void,

            "glBindImageTextures" => BindImageTextures as *const __gl_imports::raw::c_void,

            "glBindMultiTextureEXT" => BindMultiTextureEXT as *const __gl_imports::raw::c_void,

            "glBindProgramPipeline" => BindProgramPipeline as *const __gl_imports::raw::c_void,

            "glBindRenderbuffer" => BindRenderbuffer as *const __gl_imports::raw::c_void,

            "glBindRenderbufferEXT" => BindRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glBindSampler" => BindSampler as *const __gl_imports::raw::c_void,

            "glBindSamplers" => BindSamplers as *const __gl_imports::raw::c_void,

            "glBindTexture" => BindTexture as *const __gl_imports::raw::c_void,

            "glBindTextureUnit" => BindTextureUnit as *const __gl_imports::raw::c_void,

            "glBindTextures" => BindTextures as *const __gl_imports::raw::c_void,

            "glBindTransformFeedback" => BindTransformFeedback as *const __gl_imports::raw::c_void,

            "glBindVertexArray" => BindVertexArray as *const __gl_imports::raw::c_void,

            "glBindVertexArrayAPPLE" => BindVertexArrayAPPLE as *const __gl_imports::raw::c_void,

            "glBindVertexArrayOES" => BindVertexArrayOES as *const __gl_imports::raw::c_void,

            "glBindVertexBuffer" => BindVertexBuffer as *const __gl_imports::raw::c_void,

            "glBindVertexBuffers" => BindVertexBuffers as *const __gl_imports::raw::c_void,

            "glBitmap" => Bitmap as *const __gl_imports::raw::c_void,

            "glBlendBarrier" => BlendBarrier as *const __gl_imports::raw::c_void,

            "glBlendColor" => BlendColor as *const __gl_imports::raw::c_void,

            "glBlendEquation" => BlendEquation as *const __gl_imports::raw::c_void,

            "glBlendEquationSeparate" => BlendEquationSeparate as *const __gl_imports::raw::c_void,

            "glBlendEquationSeparatei" => BlendEquationSeparatei as *const __gl_imports::raw::c_void,

            "glBlendEquationSeparateiARB" => BlendEquationSeparateiARB as *const __gl_imports::raw::c_void,

            "glBlendEquationi" => BlendEquationi as *const __gl_imports::raw::c_void,

            "glBlendEquationiARB" => BlendEquationiARB as *const __gl_imports::raw::c_void,

            "glBlendFunc" => BlendFunc as *const __gl_imports::raw::c_void,

            "glBlendFuncSeparate" => BlendFuncSeparate as *const __gl_imports::raw::c_void,

            "glBlendFuncSeparatei" => BlendFuncSeparatei as *const __gl_imports::raw::c_void,

            "glBlendFuncSeparateiARB" => BlendFuncSeparateiARB as *const __gl_imports::raw::c_void,

            "glBlendFunci" => BlendFunci as *const __gl_imports::raw::c_void,

            "glBlendFunciARB" => BlendFunciARB as *const __gl_imports::raw::c_void,

            "glBlitFramebuffer" => BlitFramebuffer as *const __gl_imports::raw::c_void,

            "glBlitFramebufferEXT" => BlitFramebufferEXT as *const __gl_imports::raw::c_void,

            "glBlitNamedFramebuffer" => BlitNamedFramebuffer as *const __gl_imports::raw::c_void,

            "glBufferData" => BufferData as *const __gl_imports::raw::c_void,

            "glBufferDataARB" => BufferDataARB as *const __gl_imports::raw::c_void,

            "glBufferStorage" => BufferStorage as *const __gl_imports::raw::c_void,

            "glBufferStorageEXT" => BufferStorageEXT as *const __gl_imports::raw::c_void,

            "glBufferSubData" => BufferSubData as *const __gl_imports::raw::c_void,

            "glBufferSubDataARB" => BufferSubDataARB as *const __gl_imports::raw::c_void,

            "glCallList" => CallList as *const __gl_imports::raw::c_void,

            "glCallLists" => CallLists as *const __gl_imports::raw::c_void,

            "glCheckFramebufferStatus" => CheckFramebufferStatus as *const __gl_imports::raw::c_void,

            "glCheckFramebufferStatusEXT" => CheckFramebufferStatusEXT as *const __gl_imports::raw::c_void,

            "glCheckNamedFramebufferStatus" => CheckNamedFramebufferStatus as *const __gl_imports::raw::c_void,

            "glCheckNamedFramebufferStatusEXT" => CheckNamedFramebufferStatusEXT as *const __gl_imports::raw::c_void,

            "glClampColor" => ClampColor as *const __gl_imports::raw::c_void,

            "glClear" => Clear as *const __gl_imports::raw::c_void,

            "glClearAccum" => ClearAccum as *const __gl_imports::raw::c_void,

            "glClearBufferData" => ClearBufferData as *const __gl_imports::raw::c_void,

            "glClearBufferSubData" => ClearBufferSubData as *const __gl_imports::raw::c_void,

            "glClearBufferfi" => ClearBufferfi as *const __gl_imports::raw::c_void,

            "glClearBufferfv" => ClearBufferfv as *const __gl_imports::raw::c_void,

            "glClearBufferiv" => ClearBufferiv as *const __gl_imports::raw::c_void,

            "glClearBufferuiv" => ClearBufferuiv as *const __gl_imports::raw::c_void,

            "glClearColor" => ClearColor as *const __gl_imports::raw::c_void,

            "glClearColorIiEXT" => ClearColorIiEXT as *const __gl_imports::raw::c_void,

            "glClearColorIuiEXT" => ClearColorIuiEXT as *const __gl_imports::raw::c_void,

            "glClearDepth" => ClearDepth as *const __gl_imports::raw::c_void,

            "glClearDepthf" => ClearDepthf as *const __gl_imports::raw::c_void,

            "glClearIndex" => ClearIndex as *const __gl_imports::raw::c_void,

            "glClearNamedBufferData" => ClearNamedBufferData as *const __gl_imports::raw::c_void,

            "glClearNamedBufferDataEXT" => ClearNamedBufferDataEXT as *const __gl_imports::raw::c_void,

            "glClearNamedBufferSubData" => ClearNamedBufferSubData as *const __gl_imports::raw::c_void,

            "glClearNamedBufferSubDataEXT" => ClearNamedBufferSubDataEXT as *const __gl_imports::raw::c_void,

            "glClearNamedFramebufferfi" => ClearNamedFramebufferfi as *const __gl_imports::raw::c_void,

            "glClearNamedFramebufferfv" => ClearNamedFramebufferfv as *const __gl_imports::raw::c_void,

            "glClearNamedFramebufferiv" => ClearNamedFramebufferiv as *const __gl_imports::raw::c_void,

            "glClearNamedFramebufferuiv" => ClearNamedFramebufferuiv as *const __gl_imports::raw::c_void,

            "glClearStencil" => ClearStencil as *const __gl_imports::raw::c_void,

            "glClearTexImage" => ClearTexImage as *const __gl_imports::raw::c_void,

            "glClearTexSubImage" => ClearTexSubImage as *const __gl_imports::raw::c_void,

            "glClientActiveTexture" => ClientActiveTexture as *const __gl_imports::raw::c_void,

            "glClientAttribDefaultEXT" => ClientAttribDefaultEXT as *const __gl_imports::raw::c_void,

            "glClientWaitSync" => ClientWaitSync as *const __gl_imports::raw::c_void,

            "glClientWaitSyncAPPLE" => ClientWaitSyncAPPLE as *const __gl_imports::raw::c_void,

            "glClipControl" => ClipControl as *const __gl_imports::raw::c_void,

            "glClipPlane" => ClipPlane as *const __gl_imports::raw::c_void,

            "glColor3b" => Color3b as *const __gl_imports::raw::c_void,

            "glColor3bv" => Color3bv as *const __gl_imports::raw::c_void,

            "glColor3d" => Color3d as *const __gl_imports::raw::c_void,

            "glColor3dv" => Color3dv as *const __gl_imports::raw::c_void,

            "glColor3f" => Color3f as *const __gl_imports::raw::c_void,

            "glColor3fv" => Color3fv as *const __gl_imports::raw::c_void,

            "glColor3i" => Color3i as *const __gl_imports::raw::c_void,

            "glColor3iv" => Color3iv as *const __gl_imports::raw::c_void,

            "glColor3s" => Color3s as *const __gl_imports::raw::c_void,

            "glColor3sv" => Color3sv as *const __gl_imports::raw::c_void,

            "glColor3ub" => Color3ub as *const __gl_imports::raw::c_void,

            "glColor3ubv" => Color3ubv as *const __gl_imports::raw::c_void,

            "glColor3ui" => Color3ui as *const __gl_imports::raw::c_void,

            "glColor3uiv" => Color3uiv as *const __gl_imports::raw::c_void,

            "glColor3us" => Color3us as *const __gl_imports::raw::c_void,

            "glColor3usv" => Color3usv as *const __gl_imports::raw::c_void,

            "glColor4b" => Color4b as *const __gl_imports::raw::c_void,

            "glColor4bv" => Color4bv as *const __gl_imports::raw::c_void,

            "glColor4d" => Color4d as *const __gl_imports::raw::c_void,

            "glColor4dv" => Color4dv as *const __gl_imports::raw::c_void,

            "glColor4f" => Color4f as *const __gl_imports::raw::c_void,

            "glColor4fv" => Color4fv as *const __gl_imports::raw::c_void,

            "glColor4i" => Color4i as *const __gl_imports::raw::c_void,

            "glColor4iv" => Color4iv as *const __gl_imports::raw::c_void,

            "glColor4s" => Color4s as *const __gl_imports::raw::c_void,

            "glColor4sv" => Color4sv as *const __gl_imports::raw::c_void,

            "glColor4ub" => Color4ub as *const __gl_imports::raw::c_void,

            "glColor4ubv" => Color4ubv as *const __gl_imports::raw::c_void,

            "glColor4ui" => Color4ui as *const __gl_imports::raw::c_void,

            "glColor4uiv" => Color4uiv as *const __gl_imports::raw::c_void,

            "glColor4us" => Color4us as *const __gl_imports::raw::c_void,

            "glColor4usv" => Color4usv as *const __gl_imports::raw::c_void,

            "glColorMask" => ColorMask as *const __gl_imports::raw::c_void,

            "glColorMaski" => ColorMaski as *const __gl_imports::raw::c_void,

            "glColorMaterial" => ColorMaterial as *const __gl_imports::raw::c_void,

            "glColorP3ui" => ColorP3ui as *const __gl_imports::raw::c_void,

            "glColorP3uiv" => ColorP3uiv as *const __gl_imports::raw::c_void,

            "glColorP4ui" => ColorP4ui as *const __gl_imports::raw::c_void,

            "glColorP4uiv" => ColorP4uiv as *const __gl_imports::raw::c_void,

            "glColorPointer" => ColorPointer as *const __gl_imports::raw::c_void,

            "glCompileShader" => CompileShader as *const __gl_imports::raw::c_void,

            "glCompileShaderARB" => CompileShaderARB as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexImage1DEXT" => CompressedMultiTexImage1DEXT as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexImage2DEXT" => CompressedMultiTexImage2DEXT as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexImage3DEXT" => CompressedMultiTexImage3DEXT as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexSubImage1DEXT" => CompressedMultiTexSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexSubImage2DEXT" => CompressedMultiTexSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glCompressedMultiTexSubImage3DEXT" => CompressedMultiTexSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTexImage1D" => CompressedTexImage1D as *const __gl_imports::raw::c_void,

            "glCompressedTexImage2D" => CompressedTexImage2D as *const __gl_imports::raw::c_void,

            "glCompressedTexImage3D" => CompressedTexImage3D as *const __gl_imports::raw::c_void,

            "glCompressedTexSubImage1D" => CompressedTexSubImage1D as *const __gl_imports::raw::c_void,

            "glCompressedTexSubImage2D" => CompressedTexSubImage2D as *const __gl_imports::raw::c_void,

            "glCompressedTexSubImage3D" => CompressedTexSubImage3D as *const __gl_imports::raw::c_void,

            "glCompressedTextureImage1DEXT" => CompressedTextureImage1DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTextureImage2DEXT" => CompressedTextureImage2DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTextureImage3DEXT" => CompressedTextureImage3DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage1D" => CompressedTextureSubImage1D as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage1DEXT" => CompressedTextureSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage2D" => CompressedTextureSubImage2D as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage2DEXT" => CompressedTextureSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage3D" => CompressedTextureSubImage3D as *const __gl_imports::raw::c_void,

            "glCompressedTextureSubImage3DEXT" => CompressedTextureSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glCopyBufferSubData" => CopyBufferSubData as *const __gl_imports::raw::c_void,

            "glCopyBufferSubDataNV" => CopyBufferSubDataNV as *const __gl_imports::raw::c_void,

            "glCopyImageSubData" => CopyImageSubData as *const __gl_imports::raw::c_void,

            "glCopyMultiTexImage1DEXT" => CopyMultiTexImage1DEXT as *const __gl_imports::raw::c_void,

            "glCopyMultiTexImage2DEXT" => CopyMultiTexImage2DEXT as *const __gl_imports::raw::c_void,

            "glCopyMultiTexSubImage1DEXT" => CopyMultiTexSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glCopyMultiTexSubImage2DEXT" => CopyMultiTexSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glCopyMultiTexSubImage3DEXT" => CopyMultiTexSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glCopyNamedBufferSubData" => CopyNamedBufferSubData as *const __gl_imports::raw::c_void,

            "glCopyPixels" => CopyPixels as *const __gl_imports::raw::c_void,

            "glCopyTexImage1D" => CopyTexImage1D as *const __gl_imports::raw::c_void,

            "glCopyTexImage2D" => CopyTexImage2D as *const __gl_imports::raw::c_void,

            "glCopyTexSubImage1D" => CopyTexSubImage1D as *const __gl_imports::raw::c_void,

            "glCopyTexSubImage2D" => CopyTexSubImage2D as *const __gl_imports::raw::c_void,

            "glCopyTexSubImage3D" => CopyTexSubImage3D as *const __gl_imports::raw::c_void,

            "glCopyTextureImage1DEXT" => CopyTextureImage1DEXT as *const __gl_imports::raw::c_void,

            "glCopyTextureImage2DEXT" => CopyTextureImage2DEXT as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage1D" => CopyTextureSubImage1D as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage1DEXT" => CopyTextureSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage2D" => CopyTextureSubImage2D as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage2DEXT" => CopyTextureSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage3D" => CopyTextureSubImage3D as *const __gl_imports::raw::c_void,

            "glCopyTextureSubImage3DEXT" => CopyTextureSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glCreateBuffers" => CreateBuffers as *const __gl_imports::raw::c_void,

            "glCreateFramebuffers" => CreateFramebuffers as *const __gl_imports::raw::c_void,

            "glCreateProgram" => CreateProgram as *const __gl_imports::raw::c_void,

            "glCreateProgramObjectARB" => CreateProgramObjectARB as *const __gl_imports::raw::c_void,

            "glCreateProgramPipelines" => CreateProgramPipelines as *const __gl_imports::raw::c_void,

            "glCreateQueries" => CreateQueries as *const __gl_imports::raw::c_void,

            "glCreateRenderbuffers" => CreateRenderbuffers as *const __gl_imports::raw::c_void,

            "glCreateSamplers" => CreateSamplers as *const __gl_imports::raw::c_void,

            "glCreateShader" => CreateShader as *const __gl_imports::raw::c_void,

            "glCreateShaderObjectARB" => CreateShaderObjectARB as *const __gl_imports::raw::c_void,

            "glCreateShaderProgramv" => CreateShaderProgramv as *const __gl_imports::raw::c_void,

            "glCreateTextures" => CreateTextures as *const __gl_imports::raw::c_void,

            "glCreateTransformFeedbacks" => CreateTransformFeedbacks as *const __gl_imports::raw::c_void,

            "glCreateVertexArrays" => CreateVertexArrays as *const __gl_imports::raw::c_void,

            "glCullFace" => CullFace as *const __gl_imports::raw::c_void,

            "glDebugMessageCallback" => DebugMessageCallback as *const __gl_imports::raw::c_void,

            "glDebugMessageCallbackARB" => DebugMessageCallbackARB as *const __gl_imports::raw::c_void,

            "glDebugMessageCallbackKHR" => DebugMessageCallbackKHR as *const __gl_imports::raw::c_void,

            "glDebugMessageControl" => DebugMessageControl as *const __gl_imports::raw::c_void,

            "glDebugMessageControlARB" => DebugMessageControlARB as *const __gl_imports::raw::c_void,

            "glDebugMessageControlKHR" => DebugMessageControlKHR as *const __gl_imports::raw::c_void,

            "glDebugMessageInsert" => DebugMessageInsert as *const __gl_imports::raw::c_void,

            "glDebugMessageInsertARB" => DebugMessageInsertARB as *const __gl_imports::raw::c_void,

            "glDebugMessageInsertKHR" => DebugMessageInsertKHR as *const __gl_imports::raw::c_void,

            "glDeleteBuffers" => DeleteBuffers as *const __gl_imports::raw::c_void,

            "glDeleteBuffersARB" => DeleteBuffersARB as *const __gl_imports::raw::c_void,

            "glDeleteFramebuffers" => DeleteFramebuffers as *const __gl_imports::raw::c_void,

            "glDeleteFramebuffersEXT" => DeleteFramebuffersEXT as *const __gl_imports::raw::c_void,

            "glDeleteLists" => DeleteLists as *const __gl_imports::raw::c_void,

            "glDeleteObjectARB" => DeleteObjectARB as *const __gl_imports::raw::c_void,

            "glDeleteProgram" => DeleteProgram as *const __gl_imports::raw::c_void,

            "glDeleteProgramPipelines" => DeleteProgramPipelines as *const __gl_imports::raw::c_void,

            "glDeleteQueries" => DeleteQueries as *const __gl_imports::raw::c_void,

            "glDeleteQueriesARB" => DeleteQueriesARB as *const __gl_imports::raw::c_void,

            "glDeleteQueriesEXT" => DeleteQueriesEXT as *const __gl_imports::raw::c_void,

            "glDeleteRenderbuffers" => DeleteRenderbuffers as *const __gl_imports::raw::c_void,

            "glDeleteRenderbuffersEXT" => DeleteRenderbuffersEXT as *const __gl_imports::raw::c_void,

            "glDeleteSamplers" => DeleteSamplers as *const __gl_imports::raw::c_void,

            "glDeleteShader" => DeleteShader as *const __gl_imports::raw::c_void,

            "glDeleteSync" => DeleteSync as *const __gl_imports::raw::c_void,

            "glDeleteSyncAPPLE" => DeleteSyncAPPLE as *const __gl_imports::raw::c_void,

            "glDeleteTextures" => DeleteTextures as *const __gl_imports::raw::c_void,

            "glDeleteTransformFeedbacks" => DeleteTransformFeedbacks as *const __gl_imports::raw::c_void,

            "glDeleteVertexArrays" => DeleteVertexArrays as *const __gl_imports::raw::c_void,

            "glDeleteVertexArraysAPPLE" => DeleteVertexArraysAPPLE as *const __gl_imports::raw::c_void,

            "glDeleteVertexArraysOES" => DeleteVertexArraysOES as *const __gl_imports::raw::c_void,

            "glDepthFunc" => DepthFunc as *const __gl_imports::raw::c_void,

            "glDepthMask" => DepthMask as *const __gl_imports::raw::c_void,

            "glDepthRange" => DepthRange as *const __gl_imports::raw::c_void,

            "glDepthRangeArrayv" => DepthRangeArrayv as *const __gl_imports::raw::c_void,

            "glDepthRangeIndexed" => DepthRangeIndexed as *const __gl_imports::raw::c_void,

            "glDepthRangef" => DepthRangef as *const __gl_imports::raw::c_void,

            "glDetachObjectARB" => DetachObjectARB as *const __gl_imports::raw::c_void,

            "glDetachShader" => DetachShader as *const __gl_imports::raw::c_void,

            "glDisable" => Disable as *const __gl_imports::raw::c_void,

            "glDisableClientState" => DisableClientState as *const __gl_imports::raw::c_void,

            "glDisableClientStateIndexedEXT" => DisableClientStateIndexedEXT as *const __gl_imports::raw::c_void,

            "glDisableClientStateiEXT" => DisableClientStateiEXT as *const __gl_imports::raw::c_void,

            "glDisableIndexedEXT" => DisableIndexedEXT as *const __gl_imports::raw::c_void,

            "glDisableVertexArrayAttrib" => DisableVertexArrayAttrib as *const __gl_imports::raw::c_void,

            "glDisableVertexArrayAttribEXT" => DisableVertexArrayAttribEXT as *const __gl_imports::raw::c_void,

            "glDisableVertexArrayEXT" => DisableVertexArrayEXT as *const __gl_imports::raw::c_void,

            "glDisableVertexAttribArray" => DisableVertexAttribArray as *const __gl_imports::raw::c_void,

            "glDisableVertexAttribArrayARB" => DisableVertexAttribArrayARB as *const __gl_imports::raw::c_void,

            "glDisablei" => Disablei as *const __gl_imports::raw::c_void,

            "glDispatchCompute" => DispatchCompute as *const __gl_imports::raw::c_void,

            "glDispatchComputeIndirect" => DispatchComputeIndirect as *const __gl_imports::raw::c_void,

            "glDrawArrays" => DrawArrays as *const __gl_imports::raw::c_void,

            "glDrawArraysIndirect" => DrawArraysIndirect as *const __gl_imports::raw::c_void,

            "glDrawArraysInstanced" => DrawArraysInstanced as *const __gl_imports::raw::c_void,

            "glDrawArraysInstancedBaseInstance" => DrawArraysInstancedBaseInstance as *const __gl_imports::raw::c_void,

            "glDrawBuffer" => DrawBuffer as *const __gl_imports::raw::c_void,

            "glDrawBuffers" => DrawBuffers as *const __gl_imports::raw::c_void,

            "glDrawBuffersARB" => DrawBuffersARB as *const __gl_imports::raw::c_void,

            "glDrawBuffersATI" => DrawBuffersATI as *const __gl_imports::raw::c_void,

            "glDrawElements" => DrawElements as *const __gl_imports::raw::c_void,

            "glDrawElementsBaseVertex" => DrawElementsBaseVertex as *const __gl_imports::raw::c_void,

            "glDrawElementsBaseVertexOES" => DrawElementsBaseVertexOES as *const __gl_imports::raw::c_void,

            "glDrawElementsIndirect" => DrawElementsIndirect as *const __gl_imports::raw::c_void,

            "glDrawElementsInstanced" => DrawElementsInstanced as *const __gl_imports::raw::c_void,

            "glDrawElementsInstancedBaseInstance" => DrawElementsInstancedBaseInstance as *const __gl_imports::raw::c_void,

            "glDrawElementsInstancedBaseVertex" => DrawElementsInstancedBaseVertex as *const __gl_imports::raw::c_void,

            "glDrawElementsInstancedBaseVertexBaseInstance" => DrawElementsInstancedBaseVertexBaseInstance as *const __gl_imports::raw::c_void,

            "glDrawElementsInstancedBaseVertexOES" => DrawElementsInstancedBaseVertexOES as *const __gl_imports::raw::c_void,

            "glDrawPixels" => DrawPixels as *const __gl_imports::raw::c_void,

            "glDrawRangeElements" => DrawRangeElements as *const __gl_imports::raw::c_void,

            "glDrawRangeElementsBaseVertex" => DrawRangeElementsBaseVertex as *const __gl_imports::raw::c_void,

            "glDrawRangeElementsBaseVertexOES" => DrawRangeElementsBaseVertexOES as *const __gl_imports::raw::c_void,

            "glDrawTransformFeedback" => DrawTransformFeedback as *const __gl_imports::raw::c_void,

            "glDrawTransformFeedbackInstanced" => DrawTransformFeedbackInstanced as *const __gl_imports::raw::c_void,

            "glDrawTransformFeedbackStream" => DrawTransformFeedbackStream as *const __gl_imports::raw::c_void,

            "glDrawTransformFeedbackStreamInstanced" => DrawTransformFeedbackStreamInstanced as *const __gl_imports::raw::c_void,

            "glEdgeFlag" => EdgeFlag as *const __gl_imports::raw::c_void,

            "glEdgeFlagPointer" => EdgeFlagPointer as *const __gl_imports::raw::c_void,

            "glEdgeFlagv" => EdgeFlagv as *const __gl_imports::raw::c_void,

            "glEnable" => Enable as *const __gl_imports::raw::c_void,

            "glEnableClientState" => EnableClientState as *const __gl_imports::raw::c_void,

            "glEnableClientStateIndexedEXT" => EnableClientStateIndexedEXT as *const __gl_imports::raw::c_void,

            "glEnableClientStateiEXT" => EnableClientStateiEXT as *const __gl_imports::raw::c_void,

            "glEnableIndexedEXT" => EnableIndexedEXT as *const __gl_imports::raw::c_void,

            "glEnableVertexArrayAttrib" => EnableVertexArrayAttrib as *const __gl_imports::raw::c_void,

            "glEnableVertexArrayAttribEXT" => EnableVertexArrayAttribEXT as *const __gl_imports::raw::c_void,

            "glEnableVertexArrayEXT" => EnableVertexArrayEXT as *const __gl_imports::raw::c_void,

            "glEnableVertexAttribArray" => EnableVertexAttribArray as *const __gl_imports::raw::c_void,

            "glEnableVertexAttribArrayARB" => EnableVertexAttribArrayARB as *const __gl_imports::raw::c_void,

            "glEnablei" => Enablei as *const __gl_imports::raw::c_void,

            "glEnd" => End as *const __gl_imports::raw::c_void,

            "glEndConditionalRender" => EndConditionalRender as *const __gl_imports::raw::c_void,

            "glEndConditionalRenderNV" => EndConditionalRenderNV as *const __gl_imports::raw::c_void,

            "glEndList" => EndList as *const __gl_imports::raw::c_void,

            "glEndQuery" => EndQuery as *const __gl_imports::raw::c_void,

            "glEndQueryARB" => EndQueryARB as *const __gl_imports::raw::c_void,

            "glEndQueryEXT" => EndQueryEXT as *const __gl_imports::raw::c_void,

            "glEndQueryIndexed" => EndQueryIndexed as *const __gl_imports::raw::c_void,

            "glEndTransformFeedback" => EndTransformFeedback as *const __gl_imports::raw::c_void,

            "glEndTransformFeedbackEXT" => EndTransformFeedbackEXT as *const __gl_imports::raw::c_void,

            "glEvalCoord1d" => EvalCoord1d as *const __gl_imports::raw::c_void,

            "glEvalCoord1dv" => EvalCoord1dv as *const __gl_imports::raw::c_void,

            "glEvalCoord1f" => EvalCoord1f as *const __gl_imports::raw::c_void,

            "glEvalCoord1fv" => EvalCoord1fv as *const __gl_imports::raw::c_void,

            "glEvalCoord2d" => EvalCoord2d as *const __gl_imports::raw::c_void,

            "glEvalCoord2dv" => EvalCoord2dv as *const __gl_imports::raw::c_void,

            "glEvalCoord2f" => EvalCoord2f as *const __gl_imports::raw::c_void,

            "glEvalCoord2fv" => EvalCoord2fv as *const __gl_imports::raw::c_void,

            "glEvalMesh1" => EvalMesh1 as *const __gl_imports::raw::c_void,

            "glEvalMesh2" => EvalMesh2 as *const __gl_imports::raw::c_void,

            "glEvalPoint1" => EvalPoint1 as *const __gl_imports::raw::c_void,

            "glEvalPoint2" => EvalPoint2 as *const __gl_imports::raw::c_void,

            "glFeedbackBuffer" => FeedbackBuffer as *const __gl_imports::raw::c_void,

            "glFenceSync" => FenceSync as *const __gl_imports::raw::c_void,

            "glFenceSyncAPPLE" => FenceSyncAPPLE as *const __gl_imports::raw::c_void,

            "glFinish" => Finish as *const __gl_imports::raw::c_void,

            "glFlush" => Flush as *const __gl_imports::raw::c_void,

            "glFlushMappedBufferRange" => FlushMappedBufferRange as *const __gl_imports::raw::c_void,

            "glFlushMappedNamedBufferRange" => FlushMappedNamedBufferRange as *const __gl_imports::raw::c_void,

            "glFlushMappedNamedBufferRangeEXT" => FlushMappedNamedBufferRangeEXT as *const __gl_imports::raw::c_void,

            "glFogCoordPointer" => FogCoordPointer as *const __gl_imports::raw::c_void,

            "glFogCoordd" => FogCoordd as *const __gl_imports::raw::c_void,

            "glFogCoorddv" => FogCoorddv as *const __gl_imports::raw::c_void,

            "glFogCoordf" => FogCoordf as *const __gl_imports::raw::c_void,

            "glFogCoordfv" => FogCoordfv as *const __gl_imports::raw::c_void,

            "glFogf" => Fogf as *const __gl_imports::raw::c_void,

            "glFogfv" => Fogfv as *const __gl_imports::raw::c_void,

            "glFogi" => Fogi as *const __gl_imports::raw::c_void,

            "glFogiv" => Fogiv as *const __gl_imports::raw::c_void,

            "glFramebufferDrawBufferEXT" => FramebufferDrawBufferEXT as *const __gl_imports::raw::c_void,

            "glFramebufferDrawBuffersEXT" => FramebufferDrawBuffersEXT as *const __gl_imports::raw::c_void,

            "glFramebufferParameteri" => FramebufferParameteri as *const __gl_imports::raw::c_void,

            "glFramebufferReadBufferEXT" => FramebufferReadBufferEXT as *const __gl_imports::raw::c_void,

            "glFramebufferRenderbuffer" => FramebufferRenderbuffer as *const __gl_imports::raw::c_void,

            "glFramebufferRenderbufferEXT" => FramebufferRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glFramebufferTexture" => FramebufferTexture as *const __gl_imports::raw::c_void,

            "glFramebufferTexture1D" => FramebufferTexture1D as *const __gl_imports::raw::c_void,

            "glFramebufferTexture1DEXT" => FramebufferTexture1DEXT as *const __gl_imports::raw::c_void,

            "glFramebufferTexture2D" => FramebufferTexture2D as *const __gl_imports::raw::c_void,

            "glFramebufferTexture2DEXT" => FramebufferTexture2DEXT as *const __gl_imports::raw::c_void,

            "glFramebufferTexture2DMultisampleEXT" => FramebufferTexture2DMultisampleEXT as *const __gl_imports::raw::c_void,

            "glFramebufferTexture3D" => FramebufferTexture3D as *const __gl_imports::raw::c_void,

            "glFramebufferTexture3DEXT" => FramebufferTexture3DEXT as *const __gl_imports::raw::c_void,

            "glFramebufferTextureARB" => FramebufferTextureARB as *const __gl_imports::raw::c_void,

            "glFramebufferTextureFaceARB" => FramebufferTextureFaceARB as *const __gl_imports::raw::c_void,

            "glFramebufferTextureLayer" => FramebufferTextureLayer as *const __gl_imports::raw::c_void,

            "glFramebufferTextureLayerARB" => FramebufferTextureLayerARB as *const __gl_imports::raw::c_void,

            "glFramebufferTextureLayerEXT" => FramebufferTextureLayerEXT as *const __gl_imports::raw::c_void,

            "glFrontFace" => FrontFace as *const __gl_imports::raw::c_void,

            "glFrustum" => Frustum as *const __gl_imports::raw::c_void,

            "glGenBuffers" => GenBuffers as *const __gl_imports::raw::c_void,

            "glGenBuffersARB" => GenBuffersARB as *const __gl_imports::raw::c_void,

            "glGenFramebuffers" => GenFramebuffers as *const __gl_imports::raw::c_void,

            "glGenFramebuffersEXT" => GenFramebuffersEXT as *const __gl_imports::raw::c_void,

            "glGenLists" => GenLists as *const __gl_imports::raw::c_void,

            "glGenProgramPipelines" => GenProgramPipelines as *const __gl_imports::raw::c_void,

            "glGenQueries" => GenQueries as *const __gl_imports::raw::c_void,

            "glGenQueriesARB" => GenQueriesARB as *const __gl_imports::raw::c_void,

            "glGenQueriesEXT" => GenQueriesEXT as *const __gl_imports::raw::c_void,

            "glGenRenderbuffers" => GenRenderbuffers as *const __gl_imports::raw::c_void,

            "glGenRenderbuffersEXT" => GenRenderbuffersEXT as *const __gl_imports::raw::c_void,

            "glGenSamplers" => GenSamplers as *const __gl_imports::raw::c_void,

            "glGenTextures" => GenTextures as *const __gl_imports::raw::c_void,

            "glGenTransformFeedbacks" => GenTransformFeedbacks as *const __gl_imports::raw::c_void,

            "glGenVertexArrays" => GenVertexArrays as *const __gl_imports::raw::c_void,

            "glGenVertexArraysAPPLE" => GenVertexArraysAPPLE as *const __gl_imports::raw::c_void,

            "glGenVertexArraysOES" => GenVertexArraysOES as *const __gl_imports::raw::c_void,

            "glGenerateMipmap" => GenerateMipmap as *const __gl_imports::raw::c_void,

            "glGenerateMipmapEXT" => GenerateMipmapEXT as *const __gl_imports::raw::c_void,

            "glGenerateMultiTexMipmapEXT" => GenerateMultiTexMipmapEXT as *const __gl_imports::raw::c_void,

            "glGenerateTextureMipmap" => GenerateTextureMipmap as *const __gl_imports::raw::c_void,

            "glGenerateTextureMipmapEXT" => GenerateTextureMipmapEXT as *const __gl_imports::raw::c_void,

            "glGetActiveAtomicCounterBufferiv" => GetActiveAtomicCounterBufferiv as *const __gl_imports::raw::c_void,

            "glGetActiveAttrib" => GetActiveAttrib as *const __gl_imports::raw::c_void,

            "glGetActiveAttribARB" => GetActiveAttribARB as *const __gl_imports::raw::c_void,

            "glGetActiveSubroutineName" => GetActiveSubroutineName as *const __gl_imports::raw::c_void,

            "glGetActiveSubroutineUniformName" => GetActiveSubroutineUniformName as *const __gl_imports::raw::c_void,

            "glGetActiveSubroutineUniformiv" => GetActiveSubroutineUniformiv as *const __gl_imports::raw::c_void,

            "glGetActiveUniform" => GetActiveUniform as *const __gl_imports::raw::c_void,

            "glGetActiveUniformARB" => GetActiveUniformARB as *const __gl_imports::raw::c_void,

            "glGetActiveUniformBlockName" => GetActiveUniformBlockName as *const __gl_imports::raw::c_void,

            "glGetActiveUniformBlockiv" => GetActiveUniformBlockiv as *const __gl_imports::raw::c_void,

            "glGetActiveUniformName" => GetActiveUniformName as *const __gl_imports::raw::c_void,

            "glGetActiveUniformsiv" => GetActiveUniformsiv as *const __gl_imports::raw::c_void,

            "glGetAttachedObjectsARB" => GetAttachedObjectsARB as *const __gl_imports::raw::c_void,

            "glGetAttachedShaders" => GetAttachedShaders as *const __gl_imports::raw::c_void,

            "glGetAttribLocation" => GetAttribLocation as *const __gl_imports::raw::c_void,

            "glGetAttribLocationARB" => GetAttribLocationARB as *const __gl_imports::raw::c_void,

            "glGetBooleanIndexedvEXT" => GetBooleanIndexedvEXT as *const __gl_imports::raw::c_void,

            "glGetBooleani_v" => GetBooleani_v as *const __gl_imports::raw::c_void,

            "glGetBooleanv" => GetBooleanv as *const __gl_imports::raw::c_void,

            "glGetBufferParameteri64v" => GetBufferParameteri64v as *const __gl_imports::raw::c_void,

            "glGetBufferParameteriv" => GetBufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetBufferParameterivARB" => GetBufferParameterivARB as *const __gl_imports::raw::c_void,

            "glGetBufferPointerv" => GetBufferPointerv as *const __gl_imports::raw::c_void,

            "glGetBufferPointervARB" => GetBufferPointervARB as *const __gl_imports::raw::c_void,

            "glGetBufferSubData" => GetBufferSubData as *const __gl_imports::raw::c_void,

            "glGetBufferSubDataARB" => GetBufferSubDataARB as *const __gl_imports::raw::c_void,

            "glGetClipPlane" => GetClipPlane as *const __gl_imports::raw::c_void,

            "glGetCompressedMultiTexImageEXT" => GetCompressedMultiTexImageEXT as *const __gl_imports::raw::c_void,

            "glGetCompressedTexImage" => GetCompressedTexImage as *const __gl_imports::raw::c_void,

            "glGetCompressedTextureImage" => GetCompressedTextureImage as *const __gl_imports::raw::c_void,

            "glGetCompressedTextureImageEXT" => GetCompressedTextureImageEXT as *const __gl_imports::raw::c_void,

            "glGetCompressedTextureSubImage" => GetCompressedTextureSubImage as *const __gl_imports::raw::c_void,

            "glGetDebugMessageLog" => GetDebugMessageLog as *const __gl_imports::raw::c_void,

            "glGetDebugMessageLogARB" => GetDebugMessageLogARB as *const __gl_imports::raw::c_void,

            "glGetDebugMessageLogKHR" => GetDebugMessageLogKHR as *const __gl_imports::raw::c_void,

            "glGetDoubleIndexedvEXT" => GetDoubleIndexedvEXT as *const __gl_imports::raw::c_void,

            "glGetDoublei_v" => GetDoublei_v as *const __gl_imports::raw::c_void,

            "glGetDoublei_vEXT" => GetDoublei_vEXT as *const __gl_imports::raw::c_void,

            "glGetDoublev" => GetDoublev as *const __gl_imports::raw::c_void,

            "glGetError" => GetError as *const __gl_imports::raw::c_void,

            "glGetFloatIndexedvEXT" => GetFloatIndexedvEXT as *const __gl_imports::raw::c_void,

            "glGetFloati_v" => GetFloati_v as *const __gl_imports::raw::c_void,

            "glGetFloati_vEXT" => GetFloati_vEXT as *const __gl_imports::raw::c_void,

            "glGetFloatv" => GetFloatv as *const __gl_imports::raw::c_void,

            "glGetFragDataIndex" => GetFragDataIndex as *const __gl_imports::raw::c_void,

            "glGetFragDataLocation" => GetFragDataLocation as *const __gl_imports::raw::c_void,

            "glGetFragDataLocationEXT" => GetFragDataLocationEXT as *const __gl_imports::raw::c_void,

            "glGetFramebufferAttachmentParameteriv" => GetFramebufferAttachmentParameteriv as *const __gl_imports::raw::c_void,

            "glGetFramebufferAttachmentParameterivEXT" => GetFramebufferAttachmentParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetFramebufferParameteriv" => GetFramebufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetFramebufferParameterivEXT" => GetFramebufferParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetGraphicsResetStatus" => GetGraphicsResetStatus as *const __gl_imports::raw::c_void,

            "glGetGraphicsResetStatusARB" => GetGraphicsResetStatusARB as *const __gl_imports::raw::c_void,

            "glGetGraphicsResetStatusEXT" => GetGraphicsResetStatusEXT as *const __gl_imports::raw::c_void,

            "glGetGraphicsResetStatusKHR" => GetGraphicsResetStatusKHR as *const __gl_imports::raw::c_void,

            "glGetHandleARB" => GetHandleARB as *const __gl_imports::raw::c_void,

            "glGetImageHandleARB" => GetImageHandleARB as *const __gl_imports::raw::c_void,

            "glGetInfoLogARB" => GetInfoLogARB as *const __gl_imports::raw::c_void,

            "glGetInteger64i_v" => GetInteger64i_v as *const __gl_imports::raw::c_void,

            "glGetInteger64v" => GetInteger64v as *const __gl_imports::raw::c_void,

            "glGetInteger64vAPPLE" => GetInteger64vAPPLE as *const __gl_imports::raw::c_void,

            "glGetIntegerIndexedvEXT" => GetIntegerIndexedvEXT as *const __gl_imports::raw::c_void,

            "glGetIntegeri_v" => GetIntegeri_v as *const __gl_imports::raw::c_void,

            "glGetIntegerv" => GetIntegerv as *const __gl_imports::raw::c_void,

            "glGetInternalformatSampleivNV" => GetInternalformatSampleivNV as *const __gl_imports::raw::c_void,

            "glGetInternalformati64v" => GetInternalformati64v as *const __gl_imports::raw::c_void,

            "glGetInternalformativ" => GetInternalformativ as *const __gl_imports::raw::c_void,

            "glGetLightfv" => GetLightfv as *const __gl_imports::raw::c_void,

            "glGetLightiv" => GetLightiv as *const __gl_imports::raw::c_void,

            "glGetMapdv" => GetMapdv as *const __gl_imports::raw::c_void,

            "glGetMapfv" => GetMapfv as *const __gl_imports::raw::c_void,

            "glGetMapiv" => GetMapiv as *const __gl_imports::raw::c_void,

            "glGetMaterialfv" => GetMaterialfv as *const __gl_imports::raw::c_void,

            "glGetMaterialiv" => GetMaterialiv as *const __gl_imports::raw::c_void,

            "glGetMultiTexEnvfvEXT" => GetMultiTexEnvfvEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexEnvivEXT" => GetMultiTexEnvivEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexGendvEXT" => GetMultiTexGendvEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexGenfvEXT" => GetMultiTexGenfvEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexGenivEXT" => GetMultiTexGenivEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexImageEXT" => GetMultiTexImageEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexLevelParameterfvEXT" => GetMultiTexLevelParameterfvEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexLevelParameterivEXT" => GetMultiTexLevelParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexParameterIivEXT" => GetMultiTexParameterIivEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexParameterIuivEXT" => GetMultiTexParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexParameterfvEXT" => GetMultiTexParameterfvEXT as *const __gl_imports::raw::c_void,

            "glGetMultiTexParameterivEXT" => GetMultiTexParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetMultisamplefv" => GetMultisamplefv as *const __gl_imports::raw::c_void,

            "glGetNamedBufferParameteri64v" => GetNamedBufferParameteri64v as *const __gl_imports::raw::c_void,

            "glGetNamedBufferParameteriv" => GetNamedBufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetNamedBufferParameterivEXT" => GetNamedBufferParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedBufferPointerv" => GetNamedBufferPointerv as *const __gl_imports::raw::c_void,

            "glGetNamedBufferPointervEXT" => GetNamedBufferPointervEXT as *const __gl_imports::raw::c_void,

            "glGetNamedBufferSubData" => GetNamedBufferSubData as *const __gl_imports::raw::c_void,

            "glGetNamedBufferSubDataEXT" => GetNamedBufferSubDataEXT as *const __gl_imports::raw::c_void,

            "glGetNamedFramebufferAttachmentParameteriv" => GetNamedFramebufferAttachmentParameteriv as *const __gl_imports::raw::c_void,

            "glGetNamedFramebufferAttachmentParameterivEXT" => GetNamedFramebufferAttachmentParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedFramebufferParameteriv" => GetNamedFramebufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetNamedFramebufferParameterivEXT" => GetNamedFramebufferParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramLocalParameterIivEXT" => GetNamedProgramLocalParameterIivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramLocalParameterIuivEXT" => GetNamedProgramLocalParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramLocalParameterdvEXT" => GetNamedProgramLocalParameterdvEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramLocalParameterfvEXT" => GetNamedProgramLocalParameterfvEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramStringEXT" => GetNamedProgramStringEXT as *const __gl_imports::raw::c_void,

            "glGetNamedProgramivEXT" => GetNamedProgramivEXT as *const __gl_imports::raw::c_void,

            "glGetNamedRenderbufferParameteriv" => GetNamedRenderbufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetNamedRenderbufferParameterivEXT" => GetNamedRenderbufferParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetObjectLabel" => GetObjectLabel as *const __gl_imports::raw::c_void,

            "glGetObjectLabelKHR" => GetObjectLabelKHR as *const __gl_imports::raw::c_void,

            "glGetObjectParameterfvARB" => GetObjectParameterfvARB as *const __gl_imports::raw::c_void,

            "glGetObjectParameterivARB" => GetObjectParameterivARB as *const __gl_imports::raw::c_void,

            "glGetObjectPtrLabel" => GetObjectPtrLabel as *const __gl_imports::raw::c_void,

            "glGetObjectPtrLabelKHR" => GetObjectPtrLabelKHR as *const __gl_imports::raw::c_void,

            "glGetPixelMapfv" => GetPixelMapfv as *const __gl_imports::raw::c_void,

            "glGetPixelMapuiv" => GetPixelMapuiv as *const __gl_imports::raw::c_void,

            "glGetPixelMapusv" => GetPixelMapusv as *const __gl_imports::raw::c_void,

            "glGetPointerIndexedvEXT" => GetPointerIndexedvEXT as *const __gl_imports::raw::c_void,

            "glGetPointeri_vEXT" => GetPointeri_vEXT as *const __gl_imports::raw::c_void,

            "glGetPointerv" => GetPointerv as *const __gl_imports::raw::c_void,

            "glGetPointervKHR" => GetPointervKHR as *const __gl_imports::raw::c_void,

            "glGetPolygonStipple" => GetPolygonStipple as *const __gl_imports::raw::c_void,

            "glGetProgramBinary" => GetProgramBinary as *const __gl_imports::raw::c_void,

            "glGetProgramInfoLog" => GetProgramInfoLog as *const __gl_imports::raw::c_void,

            "glGetProgramInterfaceiv" => GetProgramInterfaceiv as *const __gl_imports::raw::c_void,

            "glGetProgramPipelineInfoLog" => GetProgramPipelineInfoLog as *const __gl_imports::raw::c_void,

            "glGetProgramPipelineiv" => GetProgramPipelineiv as *const __gl_imports::raw::c_void,

            "glGetProgramResourceIndex" => GetProgramResourceIndex as *const __gl_imports::raw::c_void,

            "glGetProgramResourceLocation" => GetProgramResourceLocation as *const __gl_imports::raw::c_void,

            "glGetProgramResourceLocationIndex" => GetProgramResourceLocationIndex as *const __gl_imports::raw::c_void,

            "glGetProgramResourceName" => GetProgramResourceName as *const __gl_imports::raw::c_void,

            "glGetProgramResourceiv" => GetProgramResourceiv as *const __gl_imports::raw::c_void,

            "glGetProgramStageiv" => GetProgramStageiv as *const __gl_imports::raw::c_void,

            "glGetProgramiv" => GetProgramiv as *const __gl_imports::raw::c_void,

            "glGetQueryBufferObjecti64v" => GetQueryBufferObjecti64v as *const __gl_imports::raw::c_void,

            "glGetQueryBufferObjectiv" => GetQueryBufferObjectiv as *const __gl_imports::raw::c_void,

            "glGetQueryBufferObjectui64v" => GetQueryBufferObjectui64v as *const __gl_imports::raw::c_void,

            "glGetQueryBufferObjectuiv" => GetQueryBufferObjectuiv as *const __gl_imports::raw::c_void,

            "glGetQueryIndexediv" => GetQueryIndexediv as *const __gl_imports::raw::c_void,

            "glGetQueryObjecti64v" => GetQueryObjecti64v as *const __gl_imports::raw::c_void,

            "glGetQueryObjecti64vEXT" => GetQueryObjecti64vEXT as *const __gl_imports::raw::c_void,

            "glGetQueryObjectiv" => GetQueryObjectiv as *const __gl_imports::raw::c_void,

            "glGetQueryObjectivARB" => GetQueryObjectivARB as *const __gl_imports::raw::c_void,

            "glGetQueryObjectivEXT" => GetQueryObjectivEXT as *const __gl_imports::raw::c_void,

            "glGetQueryObjectui64v" => GetQueryObjectui64v as *const __gl_imports::raw::c_void,

            "glGetQueryObjectui64vEXT" => GetQueryObjectui64vEXT as *const __gl_imports::raw::c_void,

            "glGetQueryObjectuiv" => GetQueryObjectuiv as *const __gl_imports::raw::c_void,

            "glGetQueryObjectuivARB" => GetQueryObjectuivARB as *const __gl_imports::raw::c_void,

            "glGetQueryObjectuivEXT" => GetQueryObjectuivEXT as *const __gl_imports::raw::c_void,

            "glGetQueryiv" => GetQueryiv as *const __gl_imports::raw::c_void,

            "glGetQueryivARB" => GetQueryivARB as *const __gl_imports::raw::c_void,

            "glGetQueryivEXT" => GetQueryivEXT as *const __gl_imports::raw::c_void,

            "glGetRenderbufferParameteriv" => GetRenderbufferParameteriv as *const __gl_imports::raw::c_void,

            "glGetRenderbufferParameterivEXT" => GetRenderbufferParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetSamplerParameterIiv" => GetSamplerParameterIiv as *const __gl_imports::raw::c_void,

            "glGetSamplerParameterIuiv" => GetSamplerParameterIuiv as *const __gl_imports::raw::c_void,

            "glGetSamplerParameterfv" => GetSamplerParameterfv as *const __gl_imports::raw::c_void,

            "glGetSamplerParameteriv" => GetSamplerParameteriv as *const __gl_imports::raw::c_void,

            "glGetShaderInfoLog" => GetShaderInfoLog as *const __gl_imports::raw::c_void,

            "glGetShaderPrecisionFormat" => GetShaderPrecisionFormat as *const __gl_imports::raw::c_void,

            "glGetShaderSource" => GetShaderSource as *const __gl_imports::raw::c_void,

            "glGetShaderSourceARB" => GetShaderSourceARB as *const __gl_imports::raw::c_void,

            "glGetShaderiv" => GetShaderiv as *const __gl_imports::raw::c_void,

            "glGetString" => GetString as *const __gl_imports::raw::c_void,

            "glGetStringi" => GetStringi as *const __gl_imports::raw::c_void,

            "glGetSubroutineIndex" => GetSubroutineIndex as *const __gl_imports::raw::c_void,

            "glGetSubroutineUniformLocation" => GetSubroutineUniformLocation as *const __gl_imports::raw::c_void,

            "glGetSynciv" => GetSynciv as *const __gl_imports::raw::c_void,

            "glGetSyncivAPPLE" => GetSyncivAPPLE as *const __gl_imports::raw::c_void,

            "glGetTexEnvfv" => GetTexEnvfv as *const __gl_imports::raw::c_void,

            "glGetTexEnviv" => GetTexEnviv as *const __gl_imports::raw::c_void,

            "glGetTexGendv" => GetTexGendv as *const __gl_imports::raw::c_void,

            "glGetTexGenfv" => GetTexGenfv as *const __gl_imports::raw::c_void,

            "glGetTexGeniv" => GetTexGeniv as *const __gl_imports::raw::c_void,

            "glGetTexImage" => GetTexImage as *const __gl_imports::raw::c_void,

            "glGetTexLevelParameterfv" => GetTexLevelParameterfv as *const __gl_imports::raw::c_void,

            "glGetTexLevelParameteriv" => GetTexLevelParameteriv as *const __gl_imports::raw::c_void,

            "glGetTexParameterIiv" => GetTexParameterIiv as *const __gl_imports::raw::c_void,

            "glGetTexParameterIivEXT" => GetTexParameterIivEXT as *const __gl_imports::raw::c_void,

            "glGetTexParameterIuiv" => GetTexParameterIuiv as *const __gl_imports::raw::c_void,

            "glGetTexParameterIuivEXT" => GetTexParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glGetTexParameterfv" => GetTexParameterfv as *const __gl_imports::raw::c_void,

            "glGetTexParameteriv" => GetTexParameteriv as *const __gl_imports::raw::c_void,

            "glGetTextureHandleARB" => GetTextureHandleARB as *const __gl_imports::raw::c_void,

            "glGetTextureImage" => GetTextureImage as *const __gl_imports::raw::c_void,

            "glGetTextureImageEXT" => GetTextureImageEXT as *const __gl_imports::raw::c_void,

            "glGetTextureLevelParameterfv" => GetTextureLevelParameterfv as *const __gl_imports::raw::c_void,

            "glGetTextureLevelParameterfvEXT" => GetTextureLevelParameterfvEXT as *const __gl_imports::raw::c_void,

            "glGetTextureLevelParameteriv" => GetTextureLevelParameteriv as *const __gl_imports::raw::c_void,

            "glGetTextureLevelParameterivEXT" => GetTextureLevelParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetTextureParameterIiv" => GetTextureParameterIiv as *const __gl_imports::raw::c_void,

            "glGetTextureParameterIivEXT" => GetTextureParameterIivEXT as *const __gl_imports::raw::c_void,

            "glGetTextureParameterIuiv" => GetTextureParameterIuiv as *const __gl_imports::raw::c_void,

            "glGetTextureParameterIuivEXT" => GetTextureParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glGetTextureParameterfv" => GetTextureParameterfv as *const __gl_imports::raw::c_void,

            "glGetTextureParameterfvEXT" => GetTextureParameterfvEXT as *const __gl_imports::raw::c_void,

            "glGetTextureParameteriv" => GetTextureParameteriv as *const __gl_imports::raw::c_void,

            "glGetTextureParameterivEXT" => GetTextureParameterivEXT as *const __gl_imports::raw::c_void,

            "glGetTextureSamplerHandleARB" => GetTextureSamplerHandleARB as *const __gl_imports::raw::c_void,

            "glGetTextureSubImage" => GetTextureSubImage as *const __gl_imports::raw::c_void,

            "glGetTransformFeedbackVarying" => GetTransformFeedbackVarying as *const __gl_imports::raw::c_void,

            "glGetTransformFeedbackVaryingEXT" => GetTransformFeedbackVaryingEXT as *const __gl_imports::raw::c_void,

            "glGetTransformFeedbacki64_v" => GetTransformFeedbacki64_v as *const __gl_imports::raw::c_void,

            "glGetTransformFeedbacki_v" => GetTransformFeedbacki_v as *const __gl_imports::raw::c_void,

            "glGetTransformFeedbackiv" => GetTransformFeedbackiv as *const __gl_imports::raw::c_void,

            "glGetUniformBlockIndex" => GetUniformBlockIndex as *const __gl_imports::raw::c_void,

            "glGetUniformIndices" => GetUniformIndices as *const __gl_imports::raw::c_void,

            "glGetUniformLocation" => GetUniformLocation as *const __gl_imports::raw::c_void,

            "glGetUniformLocationARB" => GetUniformLocationARB as *const __gl_imports::raw::c_void,

            "glGetUniformSubroutineuiv" => GetUniformSubroutineuiv as *const __gl_imports::raw::c_void,

            "glGetUniformdv" => GetUniformdv as *const __gl_imports::raw::c_void,

            "glGetUniformfv" => GetUniformfv as *const __gl_imports::raw::c_void,

            "glGetUniformfvARB" => GetUniformfvARB as *const __gl_imports::raw::c_void,

            "glGetUniformi64vARB" => GetUniformi64vARB as *const __gl_imports::raw::c_void,

            "glGetUniformiv" => GetUniformiv as *const __gl_imports::raw::c_void,

            "glGetUniformivARB" => GetUniformivARB as *const __gl_imports::raw::c_void,

            "glGetUniformui64vARB" => GetUniformui64vARB as *const __gl_imports::raw::c_void,

            "glGetUniformuiv" => GetUniformuiv as *const __gl_imports::raw::c_void,

            "glGetUniformuivEXT" => GetUniformuivEXT as *const __gl_imports::raw::c_void,

            "glGetVertexArrayIndexed64iv" => GetVertexArrayIndexed64iv as *const __gl_imports::raw::c_void,

            "glGetVertexArrayIndexediv" => GetVertexArrayIndexediv as *const __gl_imports::raw::c_void,

            "glGetVertexArrayIntegeri_vEXT" => GetVertexArrayIntegeri_vEXT as *const __gl_imports::raw::c_void,

            "glGetVertexArrayIntegervEXT" => GetVertexArrayIntegervEXT as *const __gl_imports::raw::c_void,

            "glGetVertexArrayPointeri_vEXT" => GetVertexArrayPointeri_vEXT as *const __gl_imports::raw::c_void,

            "glGetVertexArrayPointervEXT" => GetVertexArrayPointervEXT as *const __gl_imports::raw::c_void,

            "glGetVertexArrayiv" => GetVertexArrayiv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribIiv" => GetVertexAttribIiv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribIuiv" => GetVertexAttribIuiv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribLdv" => GetVertexAttribLdv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribLi64vNV" => GetVertexAttribLi64vNV as *const __gl_imports::raw::c_void,

            "glGetVertexAttribLui64vARB" => GetVertexAttribLui64vARB as *const __gl_imports::raw::c_void,

            "glGetVertexAttribLui64vNV" => GetVertexAttribLui64vNV as *const __gl_imports::raw::c_void,

            "glGetVertexAttribPointerv" => GetVertexAttribPointerv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribPointervARB" => GetVertexAttribPointervARB as *const __gl_imports::raw::c_void,

            "glGetVertexAttribdv" => GetVertexAttribdv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribdvARB" => GetVertexAttribdvARB as *const __gl_imports::raw::c_void,

            "glGetVertexAttribfv" => GetVertexAttribfv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribfvARB" => GetVertexAttribfvARB as *const __gl_imports::raw::c_void,

            "glGetVertexAttribiv" => GetVertexAttribiv as *const __gl_imports::raw::c_void,

            "glGetVertexAttribivARB" => GetVertexAttribivARB as *const __gl_imports::raw::c_void,

            "glGetnColorTable" => GetnColorTable as *const __gl_imports::raw::c_void,

            "glGetnColorTableARB" => GetnColorTableARB as *const __gl_imports::raw::c_void,

            "glGetnCompressedTexImage" => GetnCompressedTexImage as *const __gl_imports::raw::c_void,

            "glGetnCompressedTexImageARB" => GetnCompressedTexImageARB as *const __gl_imports::raw::c_void,

            "glGetnConvolutionFilter" => GetnConvolutionFilter as *const __gl_imports::raw::c_void,

            "glGetnConvolutionFilterARB" => GetnConvolutionFilterARB as *const __gl_imports::raw::c_void,

            "glGetnHistogram" => GetnHistogram as *const __gl_imports::raw::c_void,

            "glGetnHistogramARB" => GetnHistogramARB as *const __gl_imports::raw::c_void,

            "glGetnMapdv" => GetnMapdv as *const __gl_imports::raw::c_void,

            "glGetnMapdvARB" => GetnMapdvARB as *const __gl_imports::raw::c_void,

            "glGetnMapfv" => GetnMapfv as *const __gl_imports::raw::c_void,

            "glGetnMapfvARB" => GetnMapfvARB as *const __gl_imports::raw::c_void,

            "glGetnMapiv" => GetnMapiv as *const __gl_imports::raw::c_void,

            "glGetnMapivARB" => GetnMapivARB as *const __gl_imports::raw::c_void,

            "glGetnMinmax" => GetnMinmax as *const __gl_imports::raw::c_void,

            "glGetnMinmaxARB" => GetnMinmaxARB as *const __gl_imports::raw::c_void,

            "glGetnPixelMapfv" => GetnPixelMapfv as *const __gl_imports::raw::c_void,

            "glGetnPixelMapfvARB" => GetnPixelMapfvARB as *const __gl_imports::raw::c_void,

            "glGetnPixelMapuiv" => GetnPixelMapuiv as *const __gl_imports::raw::c_void,

            "glGetnPixelMapuivARB" => GetnPixelMapuivARB as *const __gl_imports::raw::c_void,

            "glGetnPixelMapusv" => GetnPixelMapusv as *const __gl_imports::raw::c_void,

            "glGetnPixelMapusvARB" => GetnPixelMapusvARB as *const __gl_imports::raw::c_void,

            "glGetnPolygonStipple" => GetnPolygonStipple as *const __gl_imports::raw::c_void,

            "glGetnPolygonStippleARB" => GetnPolygonStippleARB as *const __gl_imports::raw::c_void,

            "glGetnSeparableFilter" => GetnSeparableFilter as *const __gl_imports::raw::c_void,

            "glGetnSeparableFilterARB" => GetnSeparableFilterARB as *const __gl_imports::raw::c_void,

            "glGetnTexImage" => GetnTexImage as *const __gl_imports::raw::c_void,

            "glGetnTexImageARB" => GetnTexImageARB as *const __gl_imports::raw::c_void,

            "glGetnUniformdv" => GetnUniformdv as *const __gl_imports::raw::c_void,

            "glGetnUniformdvARB" => GetnUniformdvARB as *const __gl_imports::raw::c_void,

            "glGetnUniformfv" => GetnUniformfv as *const __gl_imports::raw::c_void,

            "glGetnUniformfvARB" => GetnUniformfvARB as *const __gl_imports::raw::c_void,

            "glGetnUniformfvEXT" => GetnUniformfvEXT as *const __gl_imports::raw::c_void,

            "glGetnUniformfvKHR" => GetnUniformfvKHR as *const __gl_imports::raw::c_void,

            "glGetnUniformi64vARB" => GetnUniformi64vARB as *const __gl_imports::raw::c_void,

            "glGetnUniformiv" => GetnUniformiv as *const __gl_imports::raw::c_void,

            "glGetnUniformivARB" => GetnUniformivARB as *const __gl_imports::raw::c_void,

            "glGetnUniformivEXT" => GetnUniformivEXT as *const __gl_imports::raw::c_void,

            "glGetnUniformivKHR" => GetnUniformivKHR as *const __gl_imports::raw::c_void,

            "glGetnUniformui64vARB" => GetnUniformui64vARB as *const __gl_imports::raw::c_void,

            "glGetnUniformuiv" => GetnUniformuiv as *const __gl_imports::raw::c_void,

            "glGetnUniformuivARB" => GetnUniformuivARB as *const __gl_imports::raw::c_void,

            "glGetnUniformuivKHR" => GetnUniformuivKHR as *const __gl_imports::raw::c_void,

            "glHint" => Hint as *const __gl_imports::raw::c_void,

            "glIndexMask" => IndexMask as *const __gl_imports::raw::c_void,

            "glIndexPointer" => IndexPointer as *const __gl_imports::raw::c_void,

            "glIndexd" => Indexd as *const __gl_imports::raw::c_void,

            "glIndexdv" => Indexdv as *const __gl_imports::raw::c_void,

            "glIndexf" => Indexf as *const __gl_imports::raw::c_void,

            "glIndexfv" => Indexfv as *const __gl_imports::raw::c_void,

            "glIndexi" => Indexi as *const __gl_imports::raw::c_void,

            "glIndexiv" => Indexiv as *const __gl_imports::raw::c_void,

            "glIndexs" => Indexs as *const __gl_imports::raw::c_void,

            "glIndexsv" => Indexsv as *const __gl_imports::raw::c_void,

            "glIndexub" => Indexub as *const __gl_imports::raw::c_void,

            "glIndexubv" => Indexubv as *const __gl_imports::raw::c_void,

            "glInitNames" => InitNames as *const __gl_imports::raw::c_void,

            "glInterleavedArrays" => InterleavedArrays as *const __gl_imports::raw::c_void,

            "glInvalidateBufferData" => InvalidateBufferData as *const __gl_imports::raw::c_void,

            "glInvalidateBufferSubData" => InvalidateBufferSubData as *const __gl_imports::raw::c_void,

            "glInvalidateFramebuffer" => InvalidateFramebuffer as *const __gl_imports::raw::c_void,

            "glInvalidateNamedFramebufferData" => InvalidateNamedFramebufferData as *const __gl_imports::raw::c_void,

            "glInvalidateNamedFramebufferSubData" => InvalidateNamedFramebufferSubData as *const __gl_imports::raw::c_void,

            "glInvalidateSubFramebuffer" => InvalidateSubFramebuffer as *const __gl_imports::raw::c_void,

            "glInvalidateTexImage" => InvalidateTexImage as *const __gl_imports::raw::c_void,

            "glInvalidateTexSubImage" => InvalidateTexSubImage as *const __gl_imports::raw::c_void,

            "glIsBuffer" => IsBuffer as *const __gl_imports::raw::c_void,

            "glIsBufferARB" => IsBufferARB as *const __gl_imports::raw::c_void,

            "glIsEnabled" => IsEnabled as *const __gl_imports::raw::c_void,

            "glIsEnabledIndexedEXT" => IsEnabledIndexedEXT as *const __gl_imports::raw::c_void,

            "glIsEnabledi" => IsEnabledi as *const __gl_imports::raw::c_void,

            "glIsFramebuffer" => IsFramebuffer as *const __gl_imports::raw::c_void,

            "glIsFramebufferEXT" => IsFramebufferEXT as *const __gl_imports::raw::c_void,

            "glIsImageHandleResidentARB" => IsImageHandleResidentARB as *const __gl_imports::raw::c_void,

            "glIsList" => IsList as *const __gl_imports::raw::c_void,

            "glIsProgram" => IsProgram as *const __gl_imports::raw::c_void,

            "glIsProgramPipeline" => IsProgramPipeline as *const __gl_imports::raw::c_void,

            "glIsQuery" => IsQuery as *const __gl_imports::raw::c_void,

            "glIsQueryARB" => IsQueryARB as *const __gl_imports::raw::c_void,

            "glIsQueryEXT" => IsQueryEXT as *const __gl_imports::raw::c_void,

            "glIsRenderbuffer" => IsRenderbuffer as *const __gl_imports::raw::c_void,

            "glIsRenderbufferEXT" => IsRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glIsSampler" => IsSampler as *const __gl_imports::raw::c_void,

            "glIsShader" => IsShader as *const __gl_imports::raw::c_void,

            "glIsSync" => IsSync as *const __gl_imports::raw::c_void,

            "glIsSyncAPPLE" => IsSyncAPPLE as *const __gl_imports::raw::c_void,

            "glIsTexture" => IsTexture as *const __gl_imports::raw::c_void,

            "glIsTextureHandleResidentARB" => IsTextureHandleResidentARB as *const __gl_imports::raw::c_void,

            "glIsTransformFeedback" => IsTransformFeedback as *const __gl_imports::raw::c_void,

            "glIsVertexArray" => IsVertexArray as *const __gl_imports::raw::c_void,

            "glIsVertexArrayAPPLE" => IsVertexArrayAPPLE as *const __gl_imports::raw::c_void,

            "glIsVertexArrayOES" => IsVertexArrayOES as *const __gl_imports::raw::c_void,

            "glLightModelf" => LightModelf as *const __gl_imports::raw::c_void,

            "glLightModelfv" => LightModelfv as *const __gl_imports::raw::c_void,

            "glLightModeli" => LightModeli as *const __gl_imports::raw::c_void,

            "glLightModeliv" => LightModeliv as *const __gl_imports::raw::c_void,

            "glLightf" => Lightf as *const __gl_imports::raw::c_void,

            "glLightfv" => Lightfv as *const __gl_imports::raw::c_void,

            "glLighti" => Lighti as *const __gl_imports::raw::c_void,

            "glLightiv" => Lightiv as *const __gl_imports::raw::c_void,

            "glLineStipple" => LineStipple as *const __gl_imports::raw::c_void,

            "glLineWidth" => LineWidth as *const __gl_imports::raw::c_void,

            "glLinkProgram" => LinkProgram as *const __gl_imports::raw::c_void,

            "glLinkProgramARB" => LinkProgramARB as *const __gl_imports::raw::c_void,

            "glListBase" => ListBase as *const __gl_imports::raw::c_void,

            "glLoadIdentity" => LoadIdentity as *const __gl_imports::raw::c_void,

            "glLoadMatrixd" => LoadMatrixd as *const __gl_imports::raw::c_void,

            "glLoadMatrixf" => LoadMatrixf as *const __gl_imports::raw::c_void,

            "glLoadName" => LoadName as *const __gl_imports::raw::c_void,

            "glLoadTransposeMatrixd" => LoadTransposeMatrixd as *const __gl_imports::raw::c_void,

            "glLoadTransposeMatrixf" => LoadTransposeMatrixf as *const __gl_imports::raw::c_void,

            "glLogicOp" => LogicOp as *const __gl_imports::raw::c_void,

            "glMakeImageHandleNonResidentARB" => MakeImageHandleNonResidentARB as *const __gl_imports::raw::c_void,

            "glMakeImageHandleResidentARB" => MakeImageHandleResidentARB as *const __gl_imports::raw::c_void,

            "glMakeTextureHandleNonResidentARB" => MakeTextureHandleNonResidentARB as *const __gl_imports::raw::c_void,

            "glMakeTextureHandleResidentARB" => MakeTextureHandleResidentARB as *const __gl_imports::raw::c_void,

            "glMap1d" => Map1d as *const __gl_imports::raw::c_void,

            "glMap1f" => Map1f as *const __gl_imports::raw::c_void,

            "glMap2d" => Map2d as *const __gl_imports::raw::c_void,

            "glMap2f" => Map2f as *const __gl_imports::raw::c_void,

            "glMapBuffer" => MapBuffer as *const __gl_imports::raw::c_void,

            "glMapBufferARB" => MapBufferARB as *const __gl_imports::raw::c_void,

            "glMapBufferRange" => MapBufferRange as *const __gl_imports::raw::c_void,

            "glMapGrid1d" => MapGrid1d as *const __gl_imports::raw::c_void,

            "glMapGrid1f" => MapGrid1f as *const __gl_imports::raw::c_void,

            "glMapGrid2d" => MapGrid2d as *const __gl_imports::raw::c_void,

            "glMapGrid2f" => MapGrid2f as *const __gl_imports::raw::c_void,

            "glMapNamedBuffer" => MapNamedBuffer as *const __gl_imports::raw::c_void,

            "glMapNamedBufferEXT" => MapNamedBufferEXT as *const __gl_imports::raw::c_void,

            "glMapNamedBufferRange" => MapNamedBufferRange as *const __gl_imports::raw::c_void,

            "glMapNamedBufferRangeEXT" => MapNamedBufferRangeEXT as *const __gl_imports::raw::c_void,

            "glMaterialf" => Materialf as *const __gl_imports::raw::c_void,

            "glMaterialfv" => Materialfv as *const __gl_imports::raw::c_void,

            "glMateriali" => Materiali as *const __gl_imports::raw::c_void,

            "glMaterialiv" => Materialiv as *const __gl_imports::raw::c_void,

            "glMatrixFrustumEXT" => MatrixFrustumEXT as *const __gl_imports::raw::c_void,

            "glMatrixLoadIdentityEXT" => MatrixLoadIdentityEXT as *const __gl_imports::raw::c_void,

            "glMatrixLoadTransposedEXT" => MatrixLoadTransposedEXT as *const __gl_imports::raw::c_void,

            "glMatrixLoadTransposefEXT" => MatrixLoadTransposefEXT as *const __gl_imports::raw::c_void,

            "glMatrixLoaddEXT" => MatrixLoaddEXT as *const __gl_imports::raw::c_void,

            "glMatrixLoadfEXT" => MatrixLoadfEXT as *const __gl_imports::raw::c_void,

            "glMatrixMode" => MatrixMode as *const __gl_imports::raw::c_void,

            "glMatrixMultTransposedEXT" => MatrixMultTransposedEXT as *const __gl_imports::raw::c_void,

            "glMatrixMultTransposefEXT" => MatrixMultTransposefEXT as *const __gl_imports::raw::c_void,

            "glMatrixMultdEXT" => MatrixMultdEXT as *const __gl_imports::raw::c_void,

            "glMatrixMultfEXT" => MatrixMultfEXT as *const __gl_imports::raw::c_void,

            "glMatrixOrthoEXT" => MatrixOrthoEXT as *const __gl_imports::raw::c_void,

            "glMatrixPopEXT" => MatrixPopEXT as *const __gl_imports::raw::c_void,

            "glMatrixPushEXT" => MatrixPushEXT as *const __gl_imports::raw::c_void,

            "glMatrixRotatedEXT" => MatrixRotatedEXT as *const __gl_imports::raw::c_void,

            "glMatrixRotatefEXT" => MatrixRotatefEXT as *const __gl_imports::raw::c_void,

            "glMatrixScaledEXT" => MatrixScaledEXT as *const __gl_imports::raw::c_void,

            "glMatrixScalefEXT" => MatrixScalefEXT as *const __gl_imports::raw::c_void,

            "glMatrixTranslatedEXT" => MatrixTranslatedEXT as *const __gl_imports::raw::c_void,

            "glMatrixTranslatefEXT" => MatrixTranslatefEXT as *const __gl_imports::raw::c_void,

            "glMemoryBarrier" => MemoryBarrier as *const __gl_imports::raw::c_void,

            "glMemoryBarrierByRegion" => MemoryBarrierByRegion as *const __gl_imports::raw::c_void,

            "glMinSampleShading" => MinSampleShading as *const __gl_imports::raw::c_void,

            "glMultMatrixd" => MultMatrixd as *const __gl_imports::raw::c_void,

            "glMultMatrixf" => MultMatrixf as *const __gl_imports::raw::c_void,

            "glMultTransposeMatrixd" => MultTransposeMatrixd as *const __gl_imports::raw::c_void,

            "glMultTransposeMatrixf" => MultTransposeMatrixf as *const __gl_imports::raw::c_void,

            "glMultiDrawArrays" => MultiDrawArrays as *const __gl_imports::raw::c_void,

            "glMultiDrawArraysIndirect" => MultiDrawArraysIndirect as *const __gl_imports::raw::c_void,

            "glMultiDrawArraysIndirectEXT" => MultiDrawArraysIndirectEXT as *const __gl_imports::raw::c_void,

            "glMultiDrawElements" => MultiDrawElements as *const __gl_imports::raw::c_void,

            "glMultiDrawElementsBaseVertex" => MultiDrawElementsBaseVertex as *const __gl_imports::raw::c_void,

            "glMultiDrawElementsBaseVertexEXT" => MultiDrawElementsBaseVertexEXT as *const __gl_imports::raw::c_void,

            "glMultiDrawElementsIndirect" => MultiDrawElementsIndirect as *const __gl_imports::raw::c_void,

            "glMultiDrawElementsIndirectEXT" => MultiDrawElementsIndirectEXT as *const __gl_imports::raw::c_void,

            "glMultiTexBufferEXT" => MultiTexBufferEXT as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1d" => MultiTexCoord1d as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1dv" => MultiTexCoord1dv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1f" => MultiTexCoord1f as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1fv" => MultiTexCoord1fv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1i" => MultiTexCoord1i as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1iv" => MultiTexCoord1iv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1s" => MultiTexCoord1s as *const __gl_imports::raw::c_void,

            "glMultiTexCoord1sv" => MultiTexCoord1sv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2d" => MultiTexCoord2d as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2dv" => MultiTexCoord2dv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2f" => MultiTexCoord2f as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2fv" => MultiTexCoord2fv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2i" => MultiTexCoord2i as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2iv" => MultiTexCoord2iv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2s" => MultiTexCoord2s as *const __gl_imports::raw::c_void,

            "glMultiTexCoord2sv" => MultiTexCoord2sv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3d" => MultiTexCoord3d as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3dv" => MultiTexCoord3dv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3f" => MultiTexCoord3f as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3fv" => MultiTexCoord3fv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3i" => MultiTexCoord3i as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3iv" => MultiTexCoord3iv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3s" => MultiTexCoord3s as *const __gl_imports::raw::c_void,

            "glMultiTexCoord3sv" => MultiTexCoord3sv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4d" => MultiTexCoord4d as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4dv" => MultiTexCoord4dv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4f" => MultiTexCoord4f as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4fv" => MultiTexCoord4fv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4i" => MultiTexCoord4i as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4iv" => MultiTexCoord4iv as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4s" => MultiTexCoord4s as *const __gl_imports::raw::c_void,

            "glMultiTexCoord4sv" => MultiTexCoord4sv as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP1ui" => MultiTexCoordP1ui as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP1uiv" => MultiTexCoordP1uiv as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP2ui" => MultiTexCoordP2ui as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP2uiv" => MultiTexCoordP2uiv as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP3ui" => MultiTexCoordP3ui as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP3uiv" => MultiTexCoordP3uiv as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP4ui" => MultiTexCoordP4ui as *const __gl_imports::raw::c_void,

            "glMultiTexCoordP4uiv" => MultiTexCoordP4uiv as *const __gl_imports::raw::c_void,

            "glMultiTexCoordPointerEXT" => MultiTexCoordPointerEXT as *const __gl_imports::raw::c_void,

            "glMultiTexEnvfEXT" => MultiTexEnvfEXT as *const __gl_imports::raw::c_void,

            "glMultiTexEnvfvEXT" => MultiTexEnvfvEXT as *const __gl_imports::raw::c_void,

            "glMultiTexEnviEXT" => MultiTexEnviEXT as *const __gl_imports::raw::c_void,

            "glMultiTexEnvivEXT" => MultiTexEnvivEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGendEXT" => MultiTexGendEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGendvEXT" => MultiTexGendvEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGenfEXT" => MultiTexGenfEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGenfvEXT" => MultiTexGenfvEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGeniEXT" => MultiTexGeniEXT as *const __gl_imports::raw::c_void,

            "glMultiTexGenivEXT" => MultiTexGenivEXT as *const __gl_imports::raw::c_void,

            "glMultiTexImage1DEXT" => MultiTexImage1DEXT as *const __gl_imports::raw::c_void,

            "glMultiTexImage2DEXT" => MultiTexImage2DEXT as *const __gl_imports::raw::c_void,

            "glMultiTexImage3DEXT" => MultiTexImage3DEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameterIivEXT" => MultiTexParameterIivEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameterIuivEXT" => MultiTexParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameterfEXT" => MultiTexParameterfEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameterfvEXT" => MultiTexParameterfvEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameteriEXT" => MultiTexParameteriEXT as *const __gl_imports::raw::c_void,

            "glMultiTexParameterivEXT" => MultiTexParameterivEXT as *const __gl_imports::raw::c_void,

            "glMultiTexRenderbufferEXT" => MultiTexRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glMultiTexSubImage1DEXT" => MultiTexSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glMultiTexSubImage2DEXT" => MultiTexSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glMultiTexSubImage3DEXT" => MultiTexSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glNamedBufferData" => NamedBufferData as *const __gl_imports::raw::c_void,

            "glNamedBufferDataEXT" => NamedBufferDataEXT as *const __gl_imports::raw::c_void,

            "glNamedBufferStorage" => NamedBufferStorage as *const __gl_imports::raw::c_void,

            "glNamedBufferStorageEXT" => NamedBufferStorageEXT as *const __gl_imports::raw::c_void,

            "glNamedBufferSubData" => NamedBufferSubData as *const __gl_imports::raw::c_void,

            "glNamedBufferSubDataEXT" => NamedBufferSubDataEXT as *const __gl_imports::raw::c_void,

            "glNamedCopyBufferSubDataEXT" => NamedCopyBufferSubDataEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferDrawBuffer" => NamedFramebufferDrawBuffer as *const __gl_imports::raw::c_void,

            "glNamedFramebufferDrawBuffers" => NamedFramebufferDrawBuffers as *const __gl_imports::raw::c_void,

            "glNamedFramebufferParameteri" => NamedFramebufferParameteri as *const __gl_imports::raw::c_void,

            "glNamedFramebufferParameteriEXT" => NamedFramebufferParameteriEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferReadBuffer" => NamedFramebufferReadBuffer as *const __gl_imports::raw::c_void,

            "glNamedFramebufferRenderbuffer" => NamedFramebufferRenderbuffer as *const __gl_imports::raw::c_void,

            "glNamedFramebufferRenderbufferEXT" => NamedFramebufferRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTexture" => NamedFramebufferTexture as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTexture1DEXT" => NamedFramebufferTexture1DEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTexture2DEXT" => NamedFramebufferTexture2DEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTexture3DEXT" => NamedFramebufferTexture3DEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTextureEXT" => NamedFramebufferTextureEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTextureFaceEXT" => NamedFramebufferTextureFaceEXT as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTextureLayer" => NamedFramebufferTextureLayer as *const __gl_imports::raw::c_void,

            "glNamedFramebufferTextureLayerEXT" => NamedFramebufferTextureLayerEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameter4dEXT" => NamedProgramLocalParameter4dEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameter4dvEXT" => NamedProgramLocalParameter4dvEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameter4fEXT" => NamedProgramLocalParameter4fEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameter4fvEXT" => NamedProgramLocalParameter4fvEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameterI4iEXT" => NamedProgramLocalParameterI4iEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameterI4ivEXT" => NamedProgramLocalParameterI4ivEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameterI4uiEXT" => NamedProgramLocalParameterI4uiEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameterI4uivEXT" => NamedProgramLocalParameterI4uivEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParameters4fvEXT" => NamedProgramLocalParameters4fvEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParametersI4ivEXT" => NamedProgramLocalParametersI4ivEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramLocalParametersI4uivEXT" => NamedProgramLocalParametersI4uivEXT as *const __gl_imports::raw::c_void,

            "glNamedProgramStringEXT" => NamedProgramStringEXT as *const __gl_imports::raw::c_void,

            "glNamedRenderbufferStorage" => NamedRenderbufferStorage as *const __gl_imports::raw::c_void,

            "glNamedRenderbufferStorageEXT" => NamedRenderbufferStorageEXT as *const __gl_imports::raw::c_void,

            "glNamedRenderbufferStorageMultisample" => NamedRenderbufferStorageMultisample as *const __gl_imports::raw::c_void,

            "glNamedRenderbufferStorageMultisampleCoverageEXT" => NamedRenderbufferStorageMultisampleCoverageEXT as *const __gl_imports::raw::c_void,

            "glNamedRenderbufferStorageMultisampleEXT" => NamedRenderbufferStorageMultisampleEXT as *const __gl_imports::raw::c_void,

            "glNewList" => NewList as *const __gl_imports::raw::c_void,

            "glNormal3b" => Normal3b as *const __gl_imports::raw::c_void,

            "glNormal3bv" => Normal3bv as *const __gl_imports::raw::c_void,

            "glNormal3d" => Normal3d as *const __gl_imports::raw::c_void,

            "glNormal3dv" => Normal3dv as *const __gl_imports::raw::c_void,

            "glNormal3f" => Normal3f as *const __gl_imports::raw::c_void,

            "glNormal3fv" => Normal3fv as *const __gl_imports::raw::c_void,

            "glNormal3i" => Normal3i as *const __gl_imports::raw::c_void,

            "glNormal3iv" => Normal3iv as *const __gl_imports::raw::c_void,

            "glNormal3s" => Normal3s as *const __gl_imports::raw::c_void,

            "glNormal3sv" => Normal3sv as *const __gl_imports::raw::c_void,

            "glNormalP3ui" => NormalP3ui as *const __gl_imports::raw::c_void,

            "glNormalP3uiv" => NormalP3uiv as *const __gl_imports::raw::c_void,

            "glNormalPointer" => NormalPointer as *const __gl_imports::raw::c_void,

            "glObjectLabel" => ObjectLabel as *const __gl_imports::raw::c_void,

            "glObjectLabelKHR" => ObjectLabelKHR as *const __gl_imports::raw::c_void,

            "glObjectPtrLabel" => ObjectPtrLabel as *const __gl_imports::raw::c_void,

            "glObjectPtrLabelKHR" => ObjectPtrLabelKHR as *const __gl_imports::raw::c_void,

            "glOrtho" => Ortho as *const __gl_imports::raw::c_void,

            "glPassThrough" => PassThrough as *const __gl_imports::raw::c_void,

            "glPatchParameterfv" => PatchParameterfv as *const __gl_imports::raw::c_void,

            "glPatchParameteri" => PatchParameteri as *const __gl_imports::raw::c_void,

            "glPauseTransformFeedback" => PauseTransformFeedback as *const __gl_imports::raw::c_void,

            "glPixelMapfv" => PixelMapfv as *const __gl_imports::raw::c_void,

            "glPixelMapuiv" => PixelMapuiv as *const __gl_imports::raw::c_void,

            "glPixelMapusv" => PixelMapusv as *const __gl_imports::raw::c_void,

            "glPixelStoref" => PixelStoref as *const __gl_imports::raw::c_void,

            "glPixelStorei" => PixelStorei as *const __gl_imports::raw::c_void,

            "glPixelTransferf" => PixelTransferf as *const __gl_imports::raw::c_void,

            "glPixelTransferi" => PixelTransferi as *const __gl_imports::raw::c_void,

            "glPixelZoom" => PixelZoom as *const __gl_imports::raw::c_void,

            "glPointParameterf" => PointParameterf as *const __gl_imports::raw::c_void,

            "glPointParameterfv" => PointParameterfv as *const __gl_imports::raw::c_void,

            "glPointParameteri" => PointParameteri as *const __gl_imports::raw::c_void,

            "glPointParameteriv" => PointParameteriv as *const __gl_imports::raw::c_void,

            "glPointSize" => PointSize as *const __gl_imports::raw::c_void,

            "glPolygonMode" => PolygonMode as *const __gl_imports::raw::c_void,

            "glPolygonOffset" => PolygonOffset as *const __gl_imports::raw::c_void,

            "glPolygonStipple" => PolygonStipple as *const __gl_imports::raw::c_void,

            "glPopAttrib" => PopAttrib as *const __gl_imports::raw::c_void,

            "glPopClientAttrib" => PopClientAttrib as *const __gl_imports::raw::c_void,

            "glPopDebugGroup" => PopDebugGroup as *const __gl_imports::raw::c_void,

            "glPopDebugGroupKHR" => PopDebugGroupKHR as *const __gl_imports::raw::c_void,

            "glPopMatrix" => PopMatrix as *const __gl_imports::raw::c_void,

            "glPopName" => PopName as *const __gl_imports::raw::c_void,

            "glPrimitiveBoundingBox" => PrimitiveBoundingBox as *const __gl_imports::raw::c_void,

            "glPrimitiveBoundingBoxARB" => PrimitiveBoundingBoxARB as *const __gl_imports::raw::c_void,

            "glPrimitiveBoundingBoxEXT" => PrimitiveBoundingBoxEXT as *const __gl_imports::raw::c_void,

            "glPrimitiveBoundingBoxOES" => PrimitiveBoundingBoxOES as *const __gl_imports::raw::c_void,

            "glPrimitiveRestartIndex" => PrimitiveRestartIndex as *const __gl_imports::raw::c_void,

            "glPrioritizeTextures" => PrioritizeTextures as *const __gl_imports::raw::c_void,

            "glProgramBinary" => ProgramBinary as *const __gl_imports::raw::c_void,

            "glProgramParameteri" => ProgramParameteri as *const __gl_imports::raw::c_void,

            "glProgramParameteriARB" => ProgramParameteriARB as *const __gl_imports::raw::c_void,

            "glProgramUniform1d" => ProgramUniform1d as *const __gl_imports::raw::c_void,

            "glProgramUniform1dEXT" => ProgramUniform1dEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1dv" => ProgramUniform1dv as *const __gl_imports::raw::c_void,

            "glProgramUniform1dvEXT" => ProgramUniform1dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1f" => ProgramUniform1f as *const __gl_imports::raw::c_void,

            "glProgramUniform1fEXT" => ProgramUniform1fEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1fv" => ProgramUniform1fv as *const __gl_imports::raw::c_void,

            "glProgramUniform1fvEXT" => ProgramUniform1fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1i" => ProgramUniform1i as *const __gl_imports::raw::c_void,

            "glProgramUniform1i64ARB" => ProgramUniform1i64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform1i64vARB" => ProgramUniform1i64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform1iEXT" => ProgramUniform1iEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1iv" => ProgramUniform1iv as *const __gl_imports::raw::c_void,

            "glProgramUniform1ivEXT" => ProgramUniform1ivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1ui" => ProgramUniform1ui as *const __gl_imports::raw::c_void,

            "glProgramUniform1ui64ARB" => ProgramUniform1ui64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform1ui64vARB" => ProgramUniform1ui64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform1uiEXT" => ProgramUniform1uiEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform1uiv" => ProgramUniform1uiv as *const __gl_imports::raw::c_void,

            "glProgramUniform1uivEXT" => ProgramUniform1uivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2d" => ProgramUniform2d as *const __gl_imports::raw::c_void,

            "glProgramUniform2dEXT" => ProgramUniform2dEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2dv" => ProgramUniform2dv as *const __gl_imports::raw::c_void,

            "glProgramUniform2dvEXT" => ProgramUniform2dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2f" => ProgramUniform2f as *const __gl_imports::raw::c_void,

            "glProgramUniform2fEXT" => ProgramUniform2fEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2fv" => ProgramUniform2fv as *const __gl_imports::raw::c_void,

            "glProgramUniform2fvEXT" => ProgramUniform2fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2i" => ProgramUniform2i as *const __gl_imports::raw::c_void,

            "glProgramUniform2i64ARB" => ProgramUniform2i64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform2i64vARB" => ProgramUniform2i64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform2iEXT" => ProgramUniform2iEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2iv" => ProgramUniform2iv as *const __gl_imports::raw::c_void,

            "glProgramUniform2ivEXT" => ProgramUniform2ivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2ui" => ProgramUniform2ui as *const __gl_imports::raw::c_void,

            "glProgramUniform2ui64ARB" => ProgramUniform2ui64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform2ui64vARB" => ProgramUniform2ui64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform2uiEXT" => ProgramUniform2uiEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform2uiv" => ProgramUniform2uiv as *const __gl_imports::raw::c_void,

            "glProgramUniform2uivEXT" => ProgramUniform2uivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3d" => ProgramUniform3d as *const __gl_imports::raw::c_void,

            "glProgramUniform3dEXT" => ProgramUniform3dEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3dv" => ProgramUniform3dv as *const __gl_imports::raw::c_void,

            "glProgramUniform3dvEXT" => ProgramUniform3dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3f" => ProgramUniform3f as *const __gl_imports::raw::c_void,

            "glProgramUniform3fEXT" => ProgramUniform3fEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3fv" => ProgramUniform3fv as *const __gl_imports::raw::c_void,

            "glProgramUniform3fvEXT" => ProgramUniform3fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3i" => ProgramUniform3i as *const __gl_imports::raw::c_void,

            "glProgramUniform3i64ARB" => ProgramUniform3i64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform3i64vARB" => ProgramUniform3i64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform3iEXT" => ProgramUniform3iEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3iv" => ProgramUniform3iv as *const __gl_imports::raw::c_void,

            "glProgramUniform3ivEXT" => ProgramUniform3ivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3ui" => ProgramUniform3ui as *const __gl_imports::raw::c_void,

            "glProgramUniform3ui64ARB" => ProgramUniform3ui64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform3ui64vARB" => ProgramUniform3ui64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform3uiEXT" => ProgramUniform3uiEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform3uiv" => ProgramUniform3uiv as *const __gl_imports::raw::c_void,

            "glProgramUniform3uivEXT" => ProgramUniform3uivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4d" => ProgramUniform4d as *const __gl_imports::raw::c_void,

            "glProgramUniform4dEXT" => ProgramUniform4dEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4dv" => ProgramUniform4dv as *const __gl_imports::raw::c_void,

            "glProgramUniform4dvEXT" => ProgramUniform4dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4f" => ProgramUniform4f as *const __gl_imports::raw::c_void,

            "glProgramUniform4fEXT" => ProgramUniform4fEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4fv" => ProgramUniform4fv as *const __gl_imports::raw::c_void,

            "glProgramUniform4fvEXT" => ProgramUniform4fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4i" => ProgramUniform4i as *const __gl_imports::raw::c_void,

            "glProgramUniform4i64ARB" => ProgramUniform4i64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform4i64vARB" => ProgramUniform4i64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform4iEXT" => ProgramUniform4iEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4iv" => ProgramUniform4iv as *const __gl_imports::raw::c_void,

            "glProgramUniform4ivEXT" => ProgramUniform4ivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4ui" => ProgramUniform4ui as *const __gl_imports::raw::c_void,

            "glProgramUniform4ui64ARB" => ProgramUniform4ui64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniform4ui64vARB" => ProgramUniform4ui64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniform4uiEXT" => ProgramUniform4uiEXT as *const __gl_imports::raw::c_void,

            "glProgramUniform4uiv" => ProgramUniform4uiv as *const __gl_imports::raw::c_void,

            "glProgramUniform4uivEXT" => ProgramUniform4uivEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformHandleui64ARB" => ProgramUniformHandleui64ARB as *const __gl_imports::raw::c_void,

            "glProgramUniformHandleui64vARB" => ProgramUniformHandleui64vARB as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2dv" => ProgramUniformMatrix2dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2dvEXT" => ProgramUniformMatrix2dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2fv" => ProgramUniformMatrix2fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2fvEXT" => ProgramUniformMatrix2fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x3dv" => ProgramUniformMatrix2x3dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x3dvEXT" => ProgramUniformMatrix2x3dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x3fv" => ProgramUniformMatrix2x3fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x3fvEXT" => ProgramUniformMatrix2x3fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x4dv" => ProgramUniformMatrix2x4dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x4dvEXT" => ProgramUniformMatrix2x4dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x4fv" => ProgramUniformMatrix2x4fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix2x4fvEXT" => ProgramUniformMatrix2x4fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3dv" => ProgramUniformMatrix3dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3dvEXT" => ProgramUniformMatrix3dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3fv" => ProgramUniformMatrix3fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3fvEXT" => ProgramUniformMatrix3fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x2dv" => ProgramUniformMatrix3x2dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x2dvEXT" => ProgramUniformMatrix3x2dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x2fv" => ProgramUniformMatrix3x2fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x2fvEXT" => ProgramUniformMatrix3x2fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x4dv" => ProgramUniformMatrix3x4dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x4dvEXT" => ProgramUniformMatrix3x4dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x4fv" => ProgramUniformMatrix3x4fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix3x4fvEXT" => ProgramUniformMatrix3x4fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4dv" => ProgramUniformMatrix4dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4dvEXT" => ProgramUniformMatrix4dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4fv" => ProgramUniformMatrix4fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4fvEXT" => ProgramUniformMatrix4fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x2dv" => ProgramUniformMatrix4x2dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x2dvEXT" => ProgramUniformMatrix4x2dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x2fv" => ProgramUniformMatrix4x2fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x2fvEXT" => ProgramUniformMatrix4x2fvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x3dv" => ProgramUniformMatrix4x3dv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x3dvEXT" => ProgramUniformMatrix4x3dvEXT as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x3fv" => ProgramUniformMatrix4x3fv as *const __gl_imports::raw::c_void,

            "glProgramUniformMatrix4x3fvEXT" => ProgramUniformMatrix4x3fvEXT as *const __gl_imports::raw::c_void,

            "glProvokingVertex" => ProvokingVertex as *const __gl_imports::raw::c_void,

            "glProvokingVertexEXT" => ProvokingVertexEXT as *const __gl_imports::raw::c_void,

            "glPushAttrib" => PushAttrib as *const __gl_imports::raw::c_void,

            "glPushClientAttrib" => PushClientAttrib as *const __gl_imports::raw::c_void,

            "glPushClientAttribDefaultEXT" => PushClientAttribDefaultEXT as *const __gl_imports::raw::c_void,

            "glPushDebugGroup" => PushDebugGroup as *const __gl_imports::raw::c_void,

            "glPushDebugGroupKHR" => PushDebugGroupKHR as *const __gl_imports::raw::c_void,

            "glPushMatrix" => PushMatrix as *const __gl_imports::raw::c_void,

            "glPushName" => PushName as *const __gl_imports::raw::c_void,

            "glQueryCounter" => QueryCounter as *const __gl_imports::raw::c_void,

            "glQueryCounterEXT" => QueryCounterEXT as *const __gl_imports::raw::c_void,

            "glRasterPos2d" => RasterPos2d as *const __gl_imports::raw::c_void,

            "glRasterPos2dv" => RasterPos2dv as *const __gl_imports::raw::c_void,

            "glRasterPos2f" => RasterPos2f as *const __gl_imports::raw::c_void,

            "glRasterPos2fv" => RasterPos2fv as *const __gl_imports::raw::c_void,

            "glRasterPos2i" => RasterPos2i as *const __gl_imports::raw::c_void,

            "glRasterPos2iv" => RasterPos2iv as *const __gl_imports::raw::c_void,

            "glRasterPos2s" => RasterPos2s as *const __gl_imports::raw::c_void,

            "glRasterPos2sv" => RasterPos2sv as *const __gl_imports::raw::c_void,

            "glRasterPos3d" => RasterPos3d as *const __gl_imports::raw::c_void,

            "glRasterPos3dv" => RasterPos3dv as *const __gl_imports::raw::c_void,

            "glRasterPos3f" => RasterPos3f as *const __gl_imports::raw::c_void,

            "glRasterPos3fv" => RasterPos3fv as *const __gl_imports::raw::c_void,

            "glRasterPos3i" => RasterPos3i as *const __gl_imports::raw::c_void,

            "glRasterPos3iv" => RasterPos3iv as *const __gl_imports::raw::c_void,

            "glRasterPos3s" => RasterPos3s as *const __gl_imports::raw::c_void,

            "glRasterPos3sv" => RasterPos3sv as *const __gl_imports::raw::c_void,

            "glRasterPos4d" => RasterPos4d as *const __gl_imports::raw::c_void,

            "glRasterPos4dv" => RasterPos4dv as *const __gl_imports::raw::c_void,

            "glRasterPos4f" => RasterPos4f as *const __gl_imports::raw::c_void,

            "glRasterPos4fv" => RasterPos4fv as *const __gl_imports::raw::c_void,

            "glRasterPos4i" => RasterPos4i as *const __gl_imports::raw::c_void,

            "glRasterPos4iv" => RasterPos4iv as *const __gl_imports::raw::c_void,

            "glRasterPos4s" => RasterPos4s as *const __gl_imports::raw::c_void,

            "glRasterPos4sv" => RasterPos4sv as *const __gl_imports::raw::c_void,

            "glReadBuffer" => ReadBuffer as *const __gl_imports::raw::c_void,

            "glReadPixels" => ReadPixels as *const __gl_imports::raw::c_void,

            "glReadnPixels" => ReadnPixels as *const __gl_imports::raw::c_void,

            "glReadnPixelsARB" => ReadnPixelsARB as *const __gl_imports::raw::c_void,

            "glReadnPixelsEXT" => ReadnPixelsEXT as *const __gl_imports::raw::c_void,

            "glReadnPixelsKHR" => ReadnPixelsKHR as *const __gl_imports::raw::c_void,

            "glRectd" => Rectd as *const __gl_imports::raw::c_void,

            "glRectdv" => Rectdv as *const __gl_imports::raw::c_void,

            "glRectf" => Rectf as *const __gl_imports::raw::c_void,

            "glRectfv" => Rectfv as *const __gl_imports::raw::c_void,

            "glRecti" => Recti as *const __gl_imports::raw::c_void,

            "glRectiv" => Rectiv as *const __gl_imports::raw::c_void,

            "glRects" => Rects as *const __gl_imports::raw::c_void,

            "glRectsv" => Rectsv as *const __gl_imports::raw::c_void,

            "glReleaseShaderCompiler" => ReleaseShaderCompiler as *const __gl_imports::raw::c_void,

            "glRenderMode" => RenderMode as *const __gl_imports::raw::c_void,

            "glRenderbufferStorage" => RenderbufferStorage as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageEXT" => RenderbufferStorageEXT as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageMultisample" => RenderbufferStorageMultisample as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageMultisampleANGLE" => RenderbufferStorageMultisampleANGLE as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageMultisampleAPPLE" => RenderbufferStorageMultisampleAPPLE as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageMultisampleEXT" => RenderbufferStorageMultisampleEXT as *const __gl_imports::raw::c_void,

            "glRenderbufferStorageMultisampleNV" => RenderbufferStorageMultisampleNV as *const __gl_imports::raw::c_void,

            "glResolveMultisampleFramebufferAPPLE" => ResolveMultisampleFramebufferAPPLE as *const __gl_imports::raw::c_void,

            "glResumeTransformFeedback" => ResumeTransformFeedback as *const __gl_imports::raw::c_void,

            "glRotated" => Rotated as *const __gl_imports::raw::c_void,

            "glRotatef" => Rotatef as *const __gl_imports::raw::c_void,

            "glSampleCoverage" => SampleCoverage as *const __gl_imports::raw::c_void,

            "glSampleMaski" => SampleMaski as *const __gl_imports::raw::c_void,

            "glSamplerParameterIiv" => SamplerParameterIiv as *const __gl_imports::raw::c_void,

            "glSamplerParameterIuiv" => SamplerParameterIuiv as *const __gl_imports::raw::c_void,

            "glSamplerParameterf" => SamplerParameterf as *const __gl_imports::raw::c_void,

            "glSamplerParameterfv" => SamplerParameterfv as *const __gl_imports::raw::c_void,

            "glSamplerParameteri" => SamplerParameteri as *const __gl_imports::raw::c_void,

            "glSamplerParameteriv" => SamplerParameteriv as *const __gl_imports::raw::c_void,

            "glScaled" => Scaled as *const __gl_imports::raw::c_void,

            "glScalef" => Scalef as *const __gl_imports::raw::c_void,

            "glScissor" => Scissor as *const __gl_imports::raw::c_void,

            "glScissorArrayv" => ScissorArrayv as *const __gl_imports::raw::c_void,

            "glScissorIndexed" => ScissorIndexed as *const __gl_imports::raw::c_void,

            "glScissorIndexedv" => ScissorIndexedv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3b" => SecondaryColor3b as *const __gl_imports::raw::c_void,

            "glSecondaryColor3bv" => SecondaryColor3bv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3d" => SecondaryColor3d as *const __gl_imports::raw::c_void,

            "glSecondaryColor3dv" => SecondaryColor3dv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3f" => SecondaryColor3f as *const __gl_imports::raw::c_void,

            "glSecondaryColor3fv" => SecondaryColor3fv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3i" => SecondaryColor3i as *const __gl_imports::raw::c_void,

            "glSecondaryColor3iv" => SecondaryColor3iv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3s" => SecondaryColor3s as *const __gl_imports::raw::c_void,

            "glSecondaryColor3sv" => SecondaryColor3sv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3ub" => SecondaryColor3ub as *const __gl_imports::raw::c_void,

            "glSecondaryColor3ubv" => SecondaryColor3ubv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3ui" => SecondaryColor3ui as *const __gl_imports::raw::c_void,

            "glSecondaryColor3uiv" => SecondaryColor3uiv as *const __gl_imports::raw::c_void,

            "glSecondaryColor3us" => SecondaryColor3us as *const __gl_imports::raw::c_void,

            "glSecondaryColor3usv" => SecondaryColor3usv as *const __gl_imports::raw::c_void,

            "glSecondaryColorP3ui" => SecondaryColorP3ui as *const __gl_imports::raw::c_void,

            "glSecondaryColorP3uiv" => SecondaryColorP3uiv as *const __gl_imports::raw::c_void,

            "glSecondaryColorPointer" => SecondaryColorPointer as *const __gl_imports::raw::c_void,

            "glSelectBuffer" => SelectBuffer as *const __gl_imports::raw::c_void,

            "glShadeModel" => ShadeModel as *const __gl_imports::raw::c_void,

            "glShaderBinary" => ShaderBinary as *const __gl_imports::raw::c_void,

            "glShaderSource" => ShaderSource as *const __gl_imports::raw::c_void,

            "glShaderSourceARB" => ShaderSourceARB as *const __gl_imports::raw::c_void,

            "glShaderStorageBlockBinding" => ShaderStorageBlockBinding as *const __gl_imports::raw::c_void,

            "glStencilFunc" => StencilFunc as *const __gl_imports::raw::c_void,

            "glStencilFuncSeparate" => StencilFuncSeparate as *const __gl_imports::raw::c_void,

            "glStencilMask" => StencilMask as *const __gl_imports::raw::c_void,

            "glStencilMaskSeparate" => StencilMaskSeparate as *const __gl_imports::raw::c_void,

            "glStencilOp" => StencilOp as *const __gl_imports::raw::c_void,

            "glStencilOpSeparate" => StencilOpSeparate as *const __gl_imports::raw::c_void,

            "glStringMarkerGREMEDY" => StringMarkerGREMEDY as *const __gl_imports::raw::c_void,

            "glTexBuffer" => TexBuffer as *const __gl_imports::raw::c_void,

            "glTexBufferARB" => TexBufferARB as *const __gl_imports::raw::c_void,

            "glTexBufferEXT" => TexBufferEXT as *const __gl_imports::raw::c_void,

            "glTexBufferOES" => TexBufferOES as *const __gl_imports::raw::c_void,

            "glTexBufferRange" => TexBufferRange as *const __gl_imports::raw::c_void,

            "glTexBufferRangeOES" => TexBufferRangeOES as *const __gl_imports::raw::c_void,

            "glTexCoord1d" => TexCoord1d as *const __gl_imports::raw::c_void,

            "glTexCoord1dv" => TexCoord1dv as *const __gl_imports::raw::c_void,

            "glTexCoord1f" => TexCoord1f as *const __gl_imports::raw::c_void,

            "glTexCoord1fv" => TexCoord1fv as *const __gl_imports::raw::c_void,

            "glTexCoord1i" => TexCoord1i as *const __gl_imports::raw::c_void,

            "glTexCoord1iv" => TexCoord1iv as *const __gl_imports::raw::c_void,

            "glTexCoord1s" => TexCoord1s as *const __gl_imports::raw::c_void,

            "glTexCoord1sv" => TexCoord1sv as *const __gl_imports::raw::c_void,

            "glTexCoord2d" => TexCoord2d as *const __gl_imports::raw::c_void,

            "glTexCoord2dv" => TexCoord2dv as *const __gl_imports::raw::c_void,

            "glTexCoord2f" => TexCoord2f as *const __gl_imports::raw::c_void,

            "glTexCoord2fv" => TexCoord2fv as *const __gl_imports::raw::c_void,

            "glTexCoord2i" => TexCoord2i as *const __gl_imports::raw::c_void,

            "glTexCoord2iv" => TexCoord2iv as *const __gl_imports::raw::c_void,

            "glTexCoord2s" => TexCoord2s as *const __gl_imports::raw::c_void,

            "glTexCoord2sv" => TexCoord2sv as *const __gl_imports::raw::c_void,

            "glTexCoord3d" => TexCoord3d as *const __gl_imports::raw::c_void,

            "glTexCoord3dv" => TexCoord3dv as *const __gl_imports::raw::c_void,

            "glTexCoord3f" => TexCoord3f as *const __gl_imports::raw::c_void,

            "glTexCoord3fv" => TexCoord3fv as *const __gl_imports::raw::c_void,

            "glTexCoord3i" => TexCoord3i as *const __gl_imports::raw::c_void,

            "glTexCoord3iv" => TexCoord3iv as *const __gl_imports::raw::c_void,

            "glTexCoord3s" => TexCoord3s as *const __gl_imports::raw::c_void,

            "glTexCoord3sv" => TexCoord3sv as *const __gl_imports::raw::c_void,

            "glTexCoord4d" => TexCoord4d as *const __gl_imports::raw::c_void,

            "glTexCoord4dv" => TexCoord4dv as *const __gl_imports::raw::c_void,

            "glTexCoord4f" => TexCoord4f as *const __gl_imports::raw::c_void,

            "glTexCoord4fv" => TexCoord4fv as *const __gl_imports::raw::c_void,

            "glTexCoord4i" => TexCoord4i as *const __gl_imports::raw::c_void,

            "glTexCoord4iv" => TexCoord4iv as *const __gl_imports::raw::c_void,

            "glTexCoord4s" => TexCoord4s as *const __gl_imports::raw::c_void,

            "glTexCoord4sv" => TexCoord4sv as *const __gl_imports::raw::c_void,

            "glTexCoordP1ui" => TexCoordP1ui as *const __gl_imports::raw::c_void,

            "glTexCoordP1uiv" => TexCoordP1uiv as *const __gl_imports::raw::c_void,

            "glTexCoordP2ui" => TexCoordP2ui as *const __gl_imports::raw::c_void,

            "glTexCoordP2uiv" => TexCoordP2uiv as *const __gl_imports::raw::c_void,

            "glTexCoordP3ui" => TexCoordP3ui as *const __gl_imports::raw::c_void,

            "glTexCoordP3uiv" => TexCoordP3uiv as *const __gl_imports::raw::c_void,

            "glTexCoordP4ui" => TexCoordP4ui as *const __gl_imports::raw::c_void,

            "glTexCoordP4uiv" => TexCoordP4uiv as *const __gl_imports::raw::c_void,

            "glTexCoordPointer" => TexCoordPointer as *const __gl_imports::raw::c_void,

            "glTexEnvf" => TexEnvf as *const __gl_imports::raw::c_void,

            "glTexEnvfv" => TexEnvfv as *const __gl_imports::raw::c_void,

            "glTexEnvi" => TexEnvi as *const __gl_imports::raw::c_void,

            "glTexEnviv" => TexEnviv as *const __gl_imports::raw::c_void,

            "glTexGend" => TexGend as *const __gl_imports::raw::c_void,

            "glTexGendv" => TexGendv as *const __gl_imports::raw::c_void,

            "glTexGenf" => TexGenf as *const __gl_imports::raw::c_void,

            "glTexGenfv" => TexGenfv as *const __gl_imports::raw::c_void,

            "glTexGeni" => TexGeni as *const __gl_imports::raw::c_void,

            "glTexGeniv" => TexGeniv as *const __gl_imports::raw::c_void,

            "glTexImage1D" => TexImage1D as *const __gl_imports::raw::c_void,

            "glTexImage2D" => TexImage2D as *const __gl_imports::raw::c_void,

            "glTexImage2DMultisample" => TexImage2DMultisample as *const __gl_imports::raw::c_void,

            "glTexImage3D" => TexImage3D as *const __gl_imports::raw::c_void,

            "glTexImage3DMultisample" => TexImage3DMultisample as *const __gl_imports::raw::c_void,

            "glTexParameterIiv" => TexParameterIiv as *const __gl_imports::raw::c_void,

            "glTexParameterIivEXT" => TexParameterIivEXT as *const __gl_imports::raw::c_void,

            "glTexParameterIuiv" => TexParameterIuiv as *const __gl_imports::raw::c_void,

            "glTexParameterIuivEXT" => TexParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glTexParameterf" => TexParameterf as *const __gl_imports::raw::c_void,

            "glTexParameterfv" => TexParameterfv as *const __gl_imports::raw::c_void,

            "glTexParameteri" => TexParameteri as *const __gl_imports::raw::c_void,

            "glTexParameteriv" => TexParameteriv as *const __gl_imports::raw::c_void,

            "glTexStorage1D" => TexStorage1D as *const __gl_imports::raw::c_void,

            "glTexStorage2D" => TexStorage2D as *const __gl_imports::raw::c_void,

            "glTexStorage2DMultisample" => TexStorage2DMultisample as *const __gl_imports::raw::c_void,

            "glTexStorage3D" => TexStorage3D as *const __gl_imports::raw::c_void,

            "glTexStorage3DMultisample" => TexStorage3DMultisample as *const __gl_imports::raw::c_void,

            "glTexSubImage1D" => TexSubImage1D as *const __gl_imports::raw::c_void,

            "glTexSubImage2D" => TexSubImage2D as *const __gl_imports::raw::c_void,

            "glTexSubImage3D" => TexSubImage3D as *const __gl_imports::raw::c_void,

            "glTextureBarrier" => TextureBarrier as *const __gl_imports::raw::c_void,

            "glTextureBuffer" => TextureBuffer as *const __gl_imports::raw::c_void,

            "glTextureBufferEXT" => TextureBufferEXT as *const __gl_imports::raw::c_void,

            "glTextureBufferRange" => TextureBufferRange as *const __gl_imports::raw::c_void,

            "glTextureBufferRangeEXT" => TextureBufferRangeEXT as *const __gl_imports::raw::c_void,

            "glTextureImage1DEXT" => TextureImage1DEXT as *const __gl_imports::raw::c_void,

            "glTextureImage2DEXT" => TextureImage2DEXT as *const __gl_imports::raw::c_void,

            "glTextureImage3DEXT" => TextureImage3DEXT as *const __gl_imports::raw::c_void,

            "glTexturePageCommitmentEXT" => TexturePageCommitmentEXT as *const __gl_imports::raw::c_void,

            "glTextureParameterIiv" => TextureParameterIiv as *const __gl_imports::raw::c_void,

            "glTextureParameterIivEXT" => TextureParameterIivEXT as *const __gl_imports::raw::c_void,

            "glTextureParameterIuiv" => TextureParameterIuiv as *const __gl_imports::raw::c_void,

            "glTextureParameterIuivEXT" => TextureParameterIuivEXT as *const __gl_imports::raw::c_void,

            "glTextureParameterf" => TextureParameterf as *const __gl_imports::raw::c_void,

            "glTextureParameterfEXT" => TextureParameterfEXT as *const __gl_imports::raw::c_void,

            "glTextureParameterfv" => TextureParameterfv as *const __gl_imports::raw::c_void,

            "glTextureParameterfvEXT" => TextureParameterfvEXT as *const __gl_imports::raw::c_void,

            "glTextureParameteri" => TextureParameteri as *const __gl_imports::raw::c_void,

            "glTextureParameteriEXT" => TextureParameteriEXT as *const __gl_imports::raw::c_void,

            "glTextureParameteriv" => TextureParameteriv as *const __gl_imports::raw::c_void,

            "glTextureParameterivEXT" => TextureParameterivEXT as *const __gl_imports::raw::c_void,

            "glTextureRenderbufferEXT" => TextureRenderbufferEXT as *const __gl_imports::raw::c_void,

            "glTextureStorage1D" => TextureStorage1D as *const __gl_imports::raw::c_void,

            "glTextureStorage1DEXT" => TextureStorage1DEXT as *const __gl_imports::raw::c_void,

            "glTextureStorage2D" => TextureStorage2D as *const __gl_imports::raw::c_void,

            "glTextureStorage2DEXT" => TextureStorage2DEXT as *const __gl_imports::raw::c_void,

            "glTextureStorage2DMultisample" => TextureStorage2DMultisample as *const __gl_imports::raw::c_void,

            "glTextureStorage2DMultisampleEXT" => TextureStorage2DMultisampleEXT as *const __gl_imports::raw::c_void,

            "glTextureStorage3D" => TextureStorage3D as *const __gl_imports::raw::c_void,

            "glTextureStorage3DEXT" => TextureStorage3DEXT as *const __gl_imports::raw::c_void,

            "glTextureStorage3DMultisample" => TextureStorage3DMultisample as *const __gl_imports::raw::c_void,

            "glTextureStorage3DMultisampleEXT" => TextureStorage3DMultisampleEXT as *const __gl_imports::raw::c_void,

            "glTextureSubImage1D" => TextureSubImage1D as *const __gl_imports::raw::c_void,

            "glTextureSubImage1DEXT" => TextureSubImage1DEXT as *const __gl_imports::raw::c_void,

            "glTextureSubImage2D" => TextureSubImage2D as *const __gl_imports::raw::c_void,

            "glTextureSubImage2DEXT" => TextureSubImage2DEXT as *const __gl_imports::raw::c_void,

            "glTextureSubImage3D" => TextureSubImage3D as *const __gl_imports::raw::c_void,

            "glTextureSubImage3DEXT" => TextureSubImage3DEXT as *const __gl_imports::raw::c_void,

            "glTextureView" => TextureView as *const __gl_imports::raw::c_void,

            "glTransformFeedbackBufferBase" => TransformFeedbackBufferBase as *const __gl_imports::raw::c_void,

            "glTransformFeedbackBufferRange" => TransformFeedbackBufferRange as *const __gl_imports::raw::c_void,

            "glTransformFeedbackVaryings" => TransformFeedbackVaryings as *const __gl_imports::raw::c_void,

            "glTransformFeedbackVaryingsEXT" => TransformFeedbackVaryingsEXT as *const __gl_imports::raw::c_void,

            "glTranslated" => Translated as *const __gl_imports::raw::c_void,

            "glTranslatef" => Translatef as *const __gl_imports::raw::c_void,

            "glUniform1d" => Uniform1d as *const __gl_imports::raw::c_void,

            "glUniform1dv" => Uniform1dv as *const __gl_imports::raw::c_void,

            "glUniform1f" => Uniform1f as *const __gl_imports::raw::c_void,

            "glUniform1fARB" => Uniform1fARB as *const __gl_imports::raw::c_void,

            "glUniform1fv" => Uniform1fv as *const __gl_imports::raw::c_void,

            "glUniform1fvARB" => Uniform1fvARB as *const __gl_imports::raw::c_void,

            "glUniform1i" => Uniform1i as *const __gl_imports::raw::c_void,

            "glUniform1i64ARB" => Uniform1i64ARB as *const __gl_imports::raw::c_void,

            "glUniform1i64vARB" => Uniform1i64vARB as *const __gl_imports::raw::c_void,

            "glUniform1iARB" => Uniform1iARB as *const __gl_imports::raw::c_void,

            "glUniform1iv" => Uniform1iv as *const __gl_imports::raw::c_void,

            "glUniform1ivARB" => Uniform1ivARB as *const __gl_imports::raw::c_void,

            "glUniform1ui" => Uniform1ui as *const __gl_imports::raw::c_void,

            "glUniform1ui64ARB" => Uniform1ui64ARB as *const __gl_imports::raw::c_void,

            "glUniform1ui64vARB" => Uniform1ui64vARB as *const __gl_imports::raw::c_void,

            "glUniform1uiEXT" => Uniform1uiEXT as *const __gl_imports::raw::c_void,

            "glUniform1uiv" => Uniform1uiv as *const __gl_imports::raw::c_void,

            "glUniform1uivEXT" => Uniform1uivEXT as *const __gl_imports::raw::c_void,

            "glUniform2d" => Uniform2d as *const __gl_imports::raw::c_void,

            "glUniform2dv" => Uniform2dv as *const __gl_imports::raw::c_void,

            "glUniform2f" => Uniform2f as *const __gl_imports::raw::c_void,

            "glUniform2fARB" => Uniform2fARB as *const __gl_imports::raw::c_void,

            "glUniform2fv" => Uniform2fv as *const __gl_imports::raw::c_void,

            "glUniform2fvARB" => Uniform2fvARB as *const __gl_imports::raw::c_void,

            "glUniform2i" => Uniform2i as *const __gl_imports::raw::c_void,

            "glUniform2i64ARB" => Uniform2i64ARB as *const __gl_imports::raw::c_void,

            "glUniform2i64vARB" => Uniform2i64vARB as *const __gl_imports::raw::c_void,

            "glUniform2iARB" => Uniform2iARB as *const __gl_imports::raw::c_void,

            "glUniform2iv" => Uniform2iv as *const __gl_imports::raw::c_void,

            "glUniform2ivARB" => Uniform2ivARB as *const __gl_imports::raw::c_void,

            "glUniform2ui" => Uniform2ui as *const __gl_imports::raw::c_void,

            "glUniform2ui64ARB" => Uniform2ui64ARB as *const __gl_imports::raw::c_void,

            "glUniform2ui64vARB" => Uniform2ui64vARB as *const __gl_imports::raw::c_void,

            "glUniform2uiEXT" => Uniform2uiEXT as *const __gl_imports::raw::c_void,

            "glUniform2uiv" => Uniform2uiv as *const __gl_imports::raw::c_void,

            "glUniform2uivEXT" => Uniform2uivEXT as *const __gl_imports::raw::c_void,

            "glUniform3d" => Uniform3d as *const __gl_imports::raw::c_void,

            "glUniform3dv" => Uniform3dv as *const __gl_imports::raw::c_void,

            "glUniform3f" => Uniform3f as *const __gl_imports::raw::c_void,

            "glUniform3fARB" => Uniform3fARB as *const __gl_imports::raw::c_void,

            "glUniform3fv" => Uniform3fv as *const __gl_imports::raw::c_void,

            "glUniform3fvARB" => Uniform3fvARB as *const __gl_imports::raw::c_void,

            "glUniform3i" => Uniform3i as *const __gl_imports::raw::c_void,

            "glUniform3i64ARB" => Uniform3i64ARB as *const __gl_imports::raw::c_void,

            "glUniform3i64vARB" => Uniform3i64vARB as *const __gl_imports::raw::c_void,

            "glUniform3iARB" => Uniform3iARB as *const __gl_imports::raw::c_void,

            "glUniform3iv" => Uniform3iv as *const __gl_imports::raw::c_void,

            "glUniform3ivARB" => Uniform3ivARB as *const __gl_imports::raw::c_void,

            "glUniform3ui" => Uniform3ui as *const __gl_imports::raw::c_void,

            "glUniform3ui64ARB" => Uniform3ui64ARB as *const __gl_imports::raw::c_void,

            "glUniform3ui64vARB" => Uniform3ui64vARB as *const __gl_imports::raw::c_void,

            "glUniform3uiEXT" => Uniform3uiEXT as *const __gl_imports::raw::c_void,

            "glUniform3uiv" => Uniform3uiv as *const __gl_imports::raw::c_void,

            "glUniform3uivEXT" => Uniform3uivEXT as *const __gl_imports::raw::c_void,

            "glUniform4d" => Uniform4d as *const __gl_imports::raw::c_void,

            "glUniform4dv" => Uniform4dv as *const __gl_imports::raw::c_void,

            "glUniform4f" => Uniform4f as *const __gl_imports::raw::c_void,

            "glUniform4fARB" => Uniform4fARB as *const __gl_imports::raw::c_void,

            "glUniform4fv" => Uniform4fv as *const __gl_imports::raw::c_void,

            "glUniform4fvARB" => Uniform4fvARB as *const __gl_imports::raw::c_void,

            "glUniform4i" => Uniform4i as *const __gl_imports::raw::c_void,

            "glUniform4i64ARB" => Uniform4i64ARB as *const __gl_imports::raw::c_void,

            "glUniform4i64vARB" => Uniform4i64vARB as *const __gl_imports::raw::c_void,

            "glUniform4iARB" => Uniform4iARB as *const __gl_imports::raw::c_void,

            "glUniform4iv" => Uniform4iv as *const __gl_imports::raw::c_void,

            "glUniform4ivARB" => Uniform4ivARB as *const __gl_imports::raw::c_void,

            "glUniform4ui" => Uniform4ui as *const __gl_imports::raw::c_void,

            "glUniform4ui64ARB" => Uniform4ui64ARB as *const __gl_imports::raw::c_void,

            "glUniform4ui64vARB" => Uniform4ui64vARB as *const __gl_imports::raw::c_void,

            "glUniform4uiEXT" => Uniform4uiEXT as *const __gl_imports::raw::c_void,

            "glUniform4uiv" => Uniform4uiv as *const __gl_imports::raw::c_void,

            "glUniform4uivEXT" => Uniform4uivEXT as *const __gl_imports::raw::c_void,

            "glUniformBlockBinding" => UniformBlockBinding as *const __gl_imports::raw::c_void,

            "glUniformHandleui64ARB" => UniformHandleui64ARB as *const __gl_imports::raw::c_void,

            "glUniformHandleui64vARB" => UniformHandleui64vARB as *const __gl_imports::raw::c_void,

            "glUniformMatrix2dv" => UniformMatrix2dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix2fv" => UniformMatrix2fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix2fvARB" => UniformMatrix2fvARB as *const __gl_imports::raw::c_void,

            "glUniformMatrix2x3dv" => UniformMatrix2x3dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix2x3fv" => UniformMatrix2x3fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix2x4dv" => UniformMatrix2x4dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix2x4fv" => UniformMatrix2x4fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3dv" => UniformMatrix3dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3fv" => UniformMatrix3fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3fvARB" => UniformMatrix3fvARB as *const __gl_imports::raw::c_void,

            "glUniformMatrix3x2dv" => UniformMatrix3x2dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3x2fv" => UniformMatrix3x2fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3x4dv" => UniformMatrix3x4dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix3x4fv" => UniformMatrix3x4fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4dv" => UniformMatrix4dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4fv" => UniformMatrix4fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4fvARB" => UniformMatrix4fvARB as *const __gl_imports::raw::c_void,

            "glUniformMatrix4x2dv" => UniformMatrix4x2dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4x2fv" => UniformMatrix4x2fv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4x3dv" => UniformMatrix4x3dv as *const __gl_imports::raw::c_void,

            "glUniformMatrix4x3fv" => UniformMatrix4x3fv as *const __gl_imports::raw::c_void,

            "glUniformSubroutinesuiv" => UniformSubroutinesuiv as *const __gl_imports::raw::c_void,

            "glUnmapBuffer" => UnmapBuffer as *const __gl_imports::raw::c_void,

            "glUnmapBufferARB" => UnmapBufferARB as *const __gl_imports::raw::c_void,

            "glUnmapNamedBuffer" => UnmapNamedBuffer as *const __gl_imports::raw::c_void,

            "glUnmapNamedBufferEXT" => UnmapNamedBufferEXT as *const __gl_imports::raw::c_void,

            "glUseProgram" => UseProgram as *const __gl_imports::raw::c_void,

            "glUseProgramObjectARB" => UseProgramObjectARB as *const __gl_imports::raw::c_void,

            "glUseProgramStages" => UseProgramStages as *const __gl_imports::raw::c_void,

            "glValidateProgram" => ValidateProgram as *const __gl_imports::raw::c_void,

            "glValidateProgramARB" => ValidateProgramARB as *const __gl_imports::raw::c_void,

            "glValidateProgramPipeline" => ValidateProgramPipeline as *const __gl_imports::raw::c_void,

            "glVertex2d" => Vertex2d as *const __gl_imports::raw::c_void,

            "glVertex2dv" => Vertex2dv as *const __gl_imports::raw::c_void,

            "glVertex2f" => Vertex2f as *const __gl_imports::raw::c_void,

            "glVertex2fv" => Vertex2fv as *const __gl_imports::raw::c_void,

            "glVertex2i" => Vertex2i as *const __gl_imports::raw::c_void,

            "glVertex2iv" => Vertex2iv as *const __gl_imports::raw::c_void,

            "glVertex2s" => Vertex2s as *const __gl_imports::raw::c_void,

            "glVertex2sv" => Vertex2sv as *const __gl_imports::raw::c_void,

            "glVertex3d" => Vertex3d as *const __gl_imports::raw::c_void,

            "glVertex3dv" => Vertex3dv as *const __gl_imports::raw::c_void,

            "glVertex3f" => Vertex3f as *const __gl_imports::raw::c_void,

            "glVertex3fv" => Vertex3fv as *const __gl_imports::raw::c_void,

            "glVertex3i" => Vertex3i as *const __gl_imports::raw::c_void,

            "glVertex3iv" => Vertex3iv as *const __gl_imports::raw::c_void,

            "glVertex3s" => Vertex3s as *const __gl_imports::raw::c_void,

            "glVertex3sv" => Vertex3sv as *const __gl_imports::raw::c_void,

            "glVertex4d" => Vertex4d as *const __gl_imports::raw::c_void,

            "glVertex4dv" => Vertex4dv as *const __gl_imports::raw::c_void,

            "glVertex4f" => Vertex4f as *const __gl_imports::raw::c_void,

            "glVertex4fv" => Vertex4fv as *const __gl_imports::raw::c_void,

            "glVertex4i" => Vertex4i as *const __gl_imports::raw::c_void,

            "glVertex4iv" => Vertex4iv as *const __gl_imports::raw::c_void,

            "glVertex4s" => Vertex4s as *const __gl_imports::raw::c_void,

            "glVertex4sv" => Vertex4sv as *const __gl_imports::raw::c_void,

            "glVertexArrayAttribBinding" => VertexArrayAttribBinding as *const __gl_imports::raw::c_void,

            "glVertexArrayAttribFormat" => VertexArrayAttribFormat as *const __gl_imports::raw::c_void,

            "glVertexArrayAttribIFormat" => VertexArrayAttribIFormat as *const __gl_imports::raw::c_void,

            "glVertexArrayAttribLFormat" => VertexArrayAttribLFormat as *const __gl_imports::raw::c_void,

            "glVertexArrayBindVertexBufferEXT" => VertexArrayBindVertexBufferEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayBindingDivisor" => VertexArrayBindingDivisor as *const __gl_imports::raw::c_void,

            "glVertexArrayColorOffsetEXT" => VertexArrayColorOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayEdgeFlagOffsetEXT" => VertexArrayEdgeFlagOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayElementBuffer" => VertexArrayElementBuffer as *const __gl_imports::raw::c_void,

            "glVertexArrayFogCoordOffsetEXT" => VertexArrayFogCoordOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayIndexOffsetEXT" => VertexArrayIndexOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayMultiTexCoordOffsetEXT" => VertexArrayMultiTexCoordOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayNormalOffsetEXT" => VertexArrayNormalOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArraySecondaryColorOffsetEXT" => VertexArraySecondaryColorOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayTexCoordOffsetEXT" => VertexArrayTexCoordOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribBindingEXT" => VertexArrayVertexAttribBindingEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribDivisorEXT" => VertexArrayVertexAttribDivisorEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribFormatEXT" => VertexArrayVertexAttribFormatEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribIFormatEXT" => VertexArrayVertexAttribIFormatEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribIOffsetEXT" => VertexArrayVertexAttribIOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribLFormatEXT" => VertexArrayVertexAttribLFormatEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribLOffsetEXT" => VertexArrayVertexAttribLOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexAttribOffsetEXT" => VertexArrayVertexAttribOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexBindingDivisorEXT" => VertexArrayVertexBindingDivisorEXT as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexBuffer" => VertexArrayVertexBuffer as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexBuffers" => VertexArrayVertexBuffers as *const __gl_imports::raw::c_void,

            "glVertexArrayVertexOffsetEXT" => VertexArrayVertexOffsetEXT as *const __gl_imports::raw::c_void,

            "glVertexAttrib1d" => VertexAttrib1d as *const __gl_imports::raw::c_void,

            "glVertexAttrib1dARB" => VertexAttrib1dARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib1dv" => VertexAttrib1dv as *const __gl_imports::raw::c_void,

            "glVertexAttrib1dvARB" => VertexAttrib1dvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib1f" => VertexAttrib1f as *const __gl_imports::raw::c_void,

            "glVertexAttrib1fARB" => VertexAttrib1fARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib1fv" => VertexAttrib1fv as *const __gl_imports::raw::c_void,

            "glVertexAttrib1fvARB" => VertexAttrib1fvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib1s" => VertexAttrib1s as *const __gl_imports::raw::c_void,

            "glVertexAttrib1sARB" => VertexAttrib1sARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib1sv" => VertexAttrib1sv as *const __gl_imports::raw::c_void,

            "glVertexAttrib1svARB" => VertexAttrib1svARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2d" => VertexAttrib2d as *const __gl_imports::raw::c_void,

            "glVertexAttrib2dARB" => VertexAttrib2dARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2dv" => VertexAttrib2dv as *const __gl_imports::raw::c_void,

            "glVertexAttrib2dvARB" => VertexAttrib2dvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2f" => VertexAttrib2f as *const __gl_imports::raw::c_void,

            "glVertexAttrib2fARB" => VertexAttrib2fARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2fv" => VertexAttrib2fv as *const __gl_imports::raw::c_void,

            "glVertexAttrib2fvARB" => VertexAttrib2fvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2s" => VertexAttrib2s as *const __gl_imports::raw::c_void,

            "glVertexAttrib2sARB" => VertexAttrib2sARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib2sv" => VertexAttrib2sv as *const __gl_imports::raw::c_void,

            "glVertexAttrib2svARB" => VertexAttrib2svARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3d" => VertexAttrib3d as *const __gl_imports::raw::c_void,

            "glVertexAttrib3dARB" => VertexAttrib3dARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3dv" => VertexAttrib3dv as *const __gl_imports::raw::c_void,

            "glVertexAttrib3dvARB" => VertexAttrib3dvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3f" => VertexAttrib3f as *const __gl_imports::raw::c_void,

            "glVertexAttrib3fARB" => VertexAttrib3fARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3fv" => VertexAttrib3fv as *const __gl_imports::raw::c_void,

            "glVertexAttrib3fvARB" => VertexAttrib3fvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3s" => VertexAttrib3s as *const __gl_imports::raw::c_void,

            "glVertexAttrib3sARB" => VertexAttrib3sARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib3sv" => VertexAttrib3sv as *const __gl_imports::raw::c_void,

            "glVertexAttrib3svARB" => VertexAttrib3svARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nbv" => VertexAttrib4Nbv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NbvARB" => VertexAttrib4NbvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Niv" => VertexAttrib4Niv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NivARB" => VertexAttrib4NivARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nsv" => VertexAttrib4Nsv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NsvARB" => VertexAttrib4NsvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nub" => VertexAttrib4Nub as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NubARB" => VertexAttrib4NubARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nubv" => VertexAttrib4Nubv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NubvARB" => VertexAttrib4NubvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nuiv" => VertexAttrib4Nuiv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NuivARB" => VertexAttrib4NuivARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4Nusv" => VertexAttrib4Nusv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4NusvARB" => VertexAttrib4NusvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4bv" => VertexAttrib4bv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4bvARB" => VertexAttrib4bvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4d" => VertexAttrib4d as *const __gl_imports::raw::c_void,

            "glVertexAttrib4dARB" => VertexAttrib4dARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4dv" => VertexAttrib4dv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4dvARB" => VertexAttrib4dvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4f" => VertexAttrib4f as *const __gl_imports::raw::c_void,

            "glVertexAttrib4fARB" => VertexAttrib4fARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4fv" => VertexAttrib4fv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4fvARB" => VertexAttrib4fvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4iv" => VertexAttrib4iv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4ivARB" => VertexAttrib4ivARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4s" => VertexAttrib4s as *const __gl_imports::raw::c_void,

            "glVertexAttrib4sARB" => VertexAttrib4sARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4sv" => VertexAttrib4sv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4svARB" => VertexAttrib4svARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4ubv" => VertexAttrib4ubv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4ubvARB" => VertexAttrib4ubvARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4uiv" => VertexAttrib4uiv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4uivARB" => VertexAttrib4uivARB as *const __gl_imports::raw::c_void,

            "glVertexAttrib4usv" => VertexAttrib4usv as *const __gl_imports::raw::c_void,

            "glVertexAttrib4usvARB" => VertexAttrib4usvARB as *const __gl_imports::raw::c_void,

            "glVertexAttribBinding" => VertexAttribBinding as *const __gl_imports::raw::c_void,

            "glVertexAttribDivisor" => VertexAttribDivisor as *const __gl_imports::raw::c_void,

            "glVertexAttribFormat" => VertexAttribFormat as *const __gl_imports::raw::c_void,

            "glVertexAttribI1i" => VertexAttribI1i as *const __gl_imports::raw::c_void,

            "glVertexAttribI1iv" => VertexAttribI1iv as *const __gl_imports::raw::c_void,

            "glVertexAttribI1ui" => VertexAttribI1ui as *const __gl_imports::raw::c_void,

            "glVertexAttribI1uiv" => VertexAttribI1uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribI2i" => VertexAttribI2i as *const __gl_imports::raw::c_void,

            "glVertexAttribI2iv" => VertexAttribI2iv as *const __gl_imports::raw::c_void,

            "glVertexAttribI2ui" => VertexAttribI2ui as *const __gl_imports::raw::c_void,

            "glVertexAttribI2uiv" => VertexAttribI2uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribI3i" => VertexAttribI3i as *const __gl_imports::raw::c_void,

            "glVertexAttribI3iv" => VertexAttribI3iv as *const __gl_imports::raw::c_void,

            "glVertexAttribI3ui" => VertexAttribI3ui as *const __gl_imports::raw::c_void,

            "glVertexAttribI3uiv" => VertexAttribI3uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4bv" => VertexAttribI4bv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4i" => VertexAttribI4i as *const __gl_imports::raw::c_void,

            "glVertexAttribI4iv" => VertexAttribI4iv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4sv" => VertexAttribI4sv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4ubv" => VertexAttribI4ubv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4ui" => VertexAttribI4ui as *const __gl_imports::raw::c_void,

            "glVertexAttribI4uiv" => VertexAttribI4uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribI4usv" => VertexAttribI4usv as *const __gl_imports::raw::c_void,

            "glVertexAttribIFormat" => VertexAttribIFormat as *const __gl_imports::raw::c_void,

            "glVertexAttribIPointer" => VertexAttribIPointer as *const __gl_imports::raw::c_void,

            "glVertexAttribL1d" => VertexAttribL1d as *const __gl_imports::raw::c_void,

            "glVertexAttribL1dv" => VertexAttribL1dv as *const __gl_imports::raw::c_void,

            "glVertexAttribL1i64NV" => VertexAttribL1i64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL1i64vNV" => VertexAttribL1i64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL1ui64ARB" => VertexAttribL1ui64ARB as *const __gl_imports::raw::c_void,

            "glVertexAttribL1ui64NV" => VertexAttribL1ui64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL1ui64vARB" => VertexAttribL1ui64vARB as *const __gl_imports::raw::c_void,

            "glVertexAttribL1ui64vNV" => VertexAttribL1ui64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL2d" => VertexAttribL2d as *const __gl_imports::raw::c_void,

            "glVertexAttribL2dv" => VertexAttribL2dv as *const __gl_imports::raw::c_void,

            "glVertexAttribL2i64NV" => VertexAttribL2i64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL2i64vNV" => VertexAttribL2i64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL2ui64NV" => VertexAttribL2ui64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL2ui64vNV" => VertexAttribL2ui64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL3d" => VertexAttribL3d as *const __gl_imports::raw::c_void,

            "glVertexAttribL3dv" => VertexAttribL3dv as *const __gl_imports::raw::c_void,

            "glVertexAttribL3i64NV" => VertexAttribL3i64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL3i64vNV" => VertexAttribL3i64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL3ui64NV" => VertexAttribL3ui64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL3ui64vNV" => VertexAttribL3ui64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL4d" => VertexAttribL4d as *const __gl_imports::raw::c_void,

            "glVertexAttribL4dv" => VertexAttribL4dv as *const __gl_imports::raw::c_void,

            "glVertexAttribL4i64NV" => VertexAttribL4i64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL4i64vNV" => VertexAttribL4i64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribL4ui64NV" => VertexAttribL4ui64NV as *const __gl_imports::raw::c_void,

            "glVertexAttribL4ui64vNV" => VertexAttribL4ui64vNV as *const __gl_imports::raw::c_void,

            "glVertexAttribLFormat" => VertexAttribLFormat as *const __gl_imports::raw::c_void,

            "glVertexAttribLFormatNV" => VertexAttribLFormatNV as *const __gl_imports::raw::c_void,

            "glVertexAttribLPointer" => VertexAttribLPointer as *const __gl_imports::raw::c_void,

            "glVertexAttribP1ui" => VertexAttribP1ui as *const __gl_imports::raw::c_void,

            "glVertexAttribP1uiv" => VertexAttribP1uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribP2ui" => VertexAttribP2ui as *const __gl_imports::raw::c_void,

            "glVertexAttribP2uiv" => VertexAttribP2uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribP3ui" => VertexAttribP3ui as *const __gl_imports::raw::c_void,

            "glVertexAttribP3uiv" => VertexAttribP3uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribP4ui" => VertexAttribP4ui as *const __gl_imports::raw::c_void,

            "glVertexAttribP4uiv" => VertexAttribP4uiv as *const __gl_imports::raw::c_void,

            "glVertexAttribPointer" => VertexAttribPointer as *const __gl_imports::raw::c_void,

            "glVertexAttribPointerARB" => VertexAttribPointerARB as *const __gl_imports::raw::c_void,

            "glVertexBindingDivisor" => VertexBindingDivisor as *const __gl_imports::raw::c_void,

            "glVertexP2ui" => VertexP2ui as *const __gl_imports::raw::c_void,

            "glVertexP2uiv" => VertexP2uiv as *const __gl_imports::raw::c_void,

            "glVertexP3ui" => VertexP3ui as *const __gl_imports::raw::c_void,

            "glVertexP3uiv" => VertexP3uiv as *const __gl_imports::raw::c_void,

            "glVertexP4ui" => VertexP4ui as *const __gl_imports::raw::c_void,

            "glVertexP4uiv" => VertexP4uiv as *const __gl_imports::raw::c_void,

            "glVertexPointer" => VertexPointer as *const __gl_imports::raw::c_void,

            "glViewport" => Viewport as *const __gl_imports::raw::c_void,

            "glViewportArrayv" => ViewportArrayv as *const __gl_imports::raw::c_void,

            "glViewportIndexedf" => ViewportIndexedf as *const __gl_imports::raw::c_void,

            "glViewportIndexedfv" => ViewportIndexedfv as *const __gl_imports::raw::c_void,

            "glWaitSync" => WaitSync as *const __gl_imports::raw::c_void,

            "glWaitSyncAPPLE" => WaitSyncAPPLE as *const __gl_imports::raw::c_void,

            "glWindowPos2d" => WindowPos2d as *const __gl_imports::raw::c_void,

            "glWindowPos2dv" => WindowPos2dv as *const __gl_imports::raw::c_void,

            "glWindowPos2f" => WindowPos2f as *const __gl_imports::raw::c_void,

            "glWindowPos2fv" => WindowPos2fv as *const __gl_imports::raw::c_void,

            "glWindowPos2i" => WindowPos2i as *const __gl_imports::raw::c_void,

            "glWindowPos2iv" => WindowPos2iv as *const __gl_imports::raw::c_void,

            "glWindowPos2s" => WindowPos2s as *const __gl_imports::raw::c_void,

            "glWindowPos2sv" => WindowPos2sv as *const __gl_imports::raw::c_void,

            "glWindowPos3d" => WindowPos3d as *const __gl_imports::raw::c_void,

            "glWindowPos3dv" => WindowPos3dv as *const __gl_imports::raw::c_void,

            "glWindowPos3f" => WindowPos3f as *const __gl_imports::raw::c_void,

            "glWindowPos3fv" => WindowPos3fv as *const __gl_imports::raw::c_void,

            "glWindowPos3i" => WindowPos3i as *const __gl_imports::raw::c_void,

            "glWindowPos3iv" => WindowPos3iv as *const __gl_imports::raw::c_void,

            "glWindowPos3s" => WindowPos3s as *const __gl_imports::raw::c_void,

            "glWindowPos3sv" => WindowPos3sv as *const __gl_imports::raw::c_void,

                _ => __gl_imports::ptr::null(),
            }
        }
    
